<?php

/**
 *
 * @package html editorial source														
 * @version  inc_htmlclean.php $Id: beta6 $ 2:12 AM 12/25/2009						
 * @copyright (c)Nukelearn Group  http://www.nukelearn.com											
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 */

if (stristr ( htmlentities ( $_SERVER ['PHP_SELF'] ), "inc_htmlclean.php" )) {
	show_error ( HACKING_ATTEMPT );
}

define ( 'INCLUDES_PATH', 'includes/' );

// DO NOT TOUCH ANYTHING BELOW THIS LINE UNTIL YOU KNOW WHAT YOU'RE DOING
//-----------------------------------------------------------------------
$reasons = array ("As Is", "Offtopic", "Flamebait", "Troll", "Redundant", "Insighful", "Interesting", "Informative", "Funny", "Overrated", "Underrated" );
$badreasons = 4;
$AllowableHTML = array ("a" => array ("href" => 1, "target" => 1, "title" => array ("minlen" => 4, "maxlen" => 120 ) ), "b" => array (), "blockquote" => array ("style" => 1 ), "br" => array (), "center" => array (), "div" => array ("align" => 1, "style" => 1 ), "em" => array (), "font" => array ("face" => 1, "style" => 1, "color" => 1, "size" => array ("minval" => 1, "maxval" => 7 ) ), "h1" => array ("style" => 1 ), "h2" => array ("style" => 1 ), "h3" => array ("style" => 1 ), "h4" => array ("style" => 1 ), "h5" => array ("style" => 1 ), "h6" => array ("style" => 1 ), "hr" => array (), "i" => array ("style" => 1 ), "img" => array ("alt" => 1, "src" => 1, "hspace" => 1, "vspace" => 1, "width" => 1, "height" => 1, "border" => 1, "align" => 1, "style" => 1 ), "li" => array ("style" => 1 ), "ol" => array (), "p" => array ("align" => 1, "style" => 1 ), "pre" => array ("align" => 1 ), "span" => array ("class" => 1, "style" => 1 ), "strong" => array (), "strike" => array (), "sub" => array (), "sup" => array (), "table" => array ("align" => 1, "border" => 1, "cell" => 1, "width" => 1, "cellspacing" => 1, "cellpadding" => 1, "style" => 1 ), "td" => array ("align" => 1, "width" => 1, "valign" => 1, "height" => 1, "rowspan" => 1, "colspan" => 1, "style" => 1 ), "tr" => array ("align" => 1, "style" => 1 ), "tt" => array (), "u" => array (), "ul" => array () );

// Editor Functions
//-----------------------------------------------------------------------


function FixQuotes($what = "") {
	$what = str_replace ( "'", "''", $what );
	while ( stristr ( $what, "\\\\'" ) ) {
		$what = str_replace ( "\\\\'", "'", $what );
	}
	return $what;
}

function check_words($Message) {
	global $CensorMode, $CensorReplace, $EditedMessage, $CensorList;
	include ("config.php");
	$EditedMessage = $Message;
	if ($CensorMode != 0) {
		if (is_array ( $CensorList )) {
			$Replace = $CensorReplace;
			if ($CensorMode == 1) {
				for($i = 0; $i < count ( $CensorList ); $i ++) {
					$EditedMessage = eregi_replace ( "$CensorList[$i]([^a-zA-Z0-9])", "$Replace\\1", $EditedMessage );
				}
			} elseif ($CensorMode == 2) {
				for($i = 0; $i < count ( $CensorList ); $i ++) {
					$EditedMessage = eregi_replace ( "(^|[^[:alnum:]])$CensorList[$i]", "\\1$Replace", $EditedMessage );
				}
			} elseif ($CensorMode == 3) {
				for($i = 0; $i < count ( $CensorList ); $i ++) {
					$EditedMessage = eregi_replace ( $CensorList [$i], $Replace, $EditedMessage );
				}
			}
		}
	}
	return $EditedMessage;
}

function delQuotes($string) {
	/* no recursive function to add quote to an HTML tag if needed */
	/* and delete duplicate spaces between attribs. */
	$tmp = ""; # string buffer
	$result = ""; # result string
	$i = 0;
	$attrib = - 1; # Are us in an HTML attrib ?   -1: no attrib   0: name of the attrib   1: value of the atrib
	$quote = 0; # Is a string quote delimited opened ? 0=no, 1=yes
	$len = strlen ( $string );
	while ( $i < $len ) {
		switch ($string [$i]) { # What car is it in the buffer ?
			case "\"" : #"       # a quote.
				if ($quote == 0) {
					$quote = 1;
				} else {
					$quote = 0;
					if (($attrib > 0) && (isset ( $tmp ))) {
						$result .= "=\"$tmp\"";
					}
					$tmp = "";
					$attrib = - 1;
				}
				break;
			case "=" : # an equal - attrib delimiter
				if ($quote == 0) { # Is it found in a string ?
					$attrib = 1;
					if ($tmp != "")
						$result .= " $tmp";
					$tmp = "";
				} else
					$tmp .= '=';
				break;
			case " " : # a blank ?
				if ($attrib > 0) { # add it to the string, if one opened.
					$tmp .= $string [$i];
				}
				break;
			default : # Other
				if ($attrib < 0) # If we weren't in an attrib, set attrib to 0
					$attrib = 0;
				$tmp .= $string [$i];
				break;
		}
		$i ++;
	}
	if (($quote != 0) && (! empty ( $tmp ))) {
		if ($attrib == 1)
			$result .= "=";
			/* If it is the value of an atrib, add the '=' */
		$result .= "\"$tmp\""; /* Add quote if needed (the reason of the function ;-) */
	}
	return $result;
}

function check_html($string, $allowed_html = '', $allowed_protocols = array('http', 'https', 'ftp', 'news', 'nntp', 'gopher', 'mailto')) {
	$stop = FALSE;
	if (! function_exists ( 'kses_no_null' )) {
		@include_once (INCLUDES_PATH . 'kses/kses.php');
	}
	if (get_magic_quotes_gpc () == 1) {
		$string = stripslashes ( $string );
	}
	$hotHtml = 'nohtml';
	$Zstrip = stripos_clone ( $allowed_html, $hotHtml );
	if ($Zstrip === false) {
		global $AllowableHTML;
		$allowed_html = $AllowableHTML;
	} else {
		$allowed_html = array ('<null>' );
	}
	$string = kses_no_null ( $string );
	$string = kses_js_entities ( $string );
	$string = kses_normalize_entities ( $string );
	$string = kses_hook ( $string );
	$allowed_html_fixed = kses_array_lc ( $allowed_html );
	return kses_split ( $string, $allowed_html_fixed, $allowed_protocols );
}

function wysiwyg_textarea($name, $value, $config = 'NukeUser', $cols = 50, $rows = 10) {
	global $nuke_editor, $admin,$oFCKeditor;
	// Don't waste bandwidth by loading WYSIWYG editor for crawlers
	if ($nuke_editor == 0 or ! isset ( $_COOKIE )) {
		echo '<textarea  name="' . $name . '" cols="' . $cols . '" rows="' . $rows . '" >' . $value . '</textarea>';
	} else {

		include_once ("includes/ckeditor/ckeditor.php");

		echo '<textarea name="' . $name . '" cols="' . $cols . '" rows="' . $rows . '" >' . $value . '</textarea>';

		if ($config == "PHPNuke") {
			echo "<script type=\"text/javascript\">CKEDITOR.replace( '$name',{toolbar : 'Basic'});</script>";
		}

		if (is_admin ( $admin )) {
			echo '<script type="text/javascript">var ckeditor = CKEDITOR.replace("' . $name . '");AjexFileManager.init({returnTo: \'ckeditor\',editor: ckeditor,skin: \'light\'});</script>';
		}
	}
}

function filter_text($Message, $strip = '') {
	global $EditedMessage;
	check_words ( $Message );
	$EditedMessage = check_html ( $EditedMessage, $strip );
	return $EditedMessage;
}

function filter($what, $strip = "", $save = "", $type = "") {
	if ($strip == "nohtml") {
		$what = check_html ( $what, $strip );
		$what = htmlentities ( trim ( $what ), ENT_QUOTES );
		// If the variable $what doesn't comes from a preview screen should be converted
		if ($type != "preview" and $save != 1) {
			$what = html_entity_decode ( $what, ENT_QUOTES );
		}
	}
	if ($save == 1) {
		$what = check_words ( $what );
		$what = check_html ( $what, $strip );
		$what = addslashes ( $what );
	} else {
		$what = stripslashes ( FixQuotes ( $what ) );
		$what = check_words ( $what );
		$what = check_html ( $what, $strip );
	}
	return ($what);
}

//---------------------------SLUG Creator ---------------

function seems_utf8($str) {
	$length = strlen($str);
	for ($i=0; $i < $length; $i++) {
		$c = ord($str[$i]);
		if ($c < 0x80) $n = 0; # 0bbbbbbb
		elseif (($c & 0xE0) == 0xC0) $n=1; # 110bbbbb
		elseif (($c & 0xF0) == 0xE0) $n=2; # 1110bbbb
		elseif (($c & 0xF8) == 0xF0) $n=3; # 11110bbb
		elseif (($c & 0xFC) == 0xF8) $n=4; # 111110bb
		elseif (($c & 0xFE) == 0xFC) $n=5; # 1111110b
		else return false; # Does not match any model
		for ($j=0; $j<$n; $j++) { # n bytes matching 10bbbbbb follow ?
			if ((++$i == $length) || ((ord($str[$i]) & 0xC0) != 0x80))
				return false;
		}
	}
	return true;
}
function utf8_uri_encode( $utf8_string, $length = 0 ) {
	$unicode = '';
	$values = array();
	$num_octets = 1;
	$unicode_length = 0;

	$string_length = strlen( $utf8_string );
	for ($i = 0; $i < $string_length; $i++ ) {

		$value = ord( $utf8_string[ $i ] );

		if ( $value < 128 ) {
			if ( $length && ( $unicode_length >= $length ) )
				break;
			$unicode .= chr($value);
			$unicode_length++;
		} else {
			if ( count( $values ) == 0 ) $num_octets = ( $value < 224 ) ? 2 : 3;

			$values[] = $value;

			if ( $length && ( $unicode_length + ($num_octets * 3) ) > $length )
				break;
			if ( count( $values ) == $num_octets ) {
				if ($num_octets == 3) {
					$unicode .= '%' . dechex($values[0]) . '%' . dechex($values[1]) . '%' . dechex($values[2]);
					$unicode_length += 9;
				} else {
					$unicode .= '%' . dechex($values[0]) . '%' . dechex($values[1]);
					$unicode_length += 6;
				}

				$values = array();
				$num_octets = 1;
			}
		}
	}

	return $unicode;
}
function remove_accents($string) {
	if ( !preg_match('/[\x80-\xff]/', $string) )
		return $string;

	if (seems_utf8($string)) {
		$chars = array(
		// Decompositions for Latin-1 Supplement
		chr(195).chr(128) => 'A', chr(195).chr(129) => 'A',
		chr(195).chr(130) => 'A', chr(195).chr(131) => 'A',
		chr(195).chr(132) => 'A', chr(195).chr(133) => 'A',
		chr(195).chr(135) => 'C', chr(195).chr(136) => 'E',
		chr(195).chr(137) => 'E', chr(195).chr(138) => 'E',
		chr(195).chr(139) => 'E', chr(195).chr(140) => 'I',
		chr(195).chr(141) => 'I', chr(195).chr(142) => 'I',
		chr(195).chr(143) => 'I', chr(195).chr(145) => 'N',
		chr(195).chr(146) => 'O', chr(195).chr(147) => 'O',
		chr(195).chr(148) => 'O', chr(195).chr(149) => 'O',
		chr(195).chr(150) => 'O', chr(195).chr(153) => 'U',
		chr(195).chr(154) => 'U', chr(195).chr(155) => 'U',
		chr(195).chr(156) => 'U', chr(195).chr(157) => 'Y',
		chr(195).chr(159) => 's', chr(195).chr(160) => 'a',
		chr(195).chr(161) => 'a', chr(195).chr(162) => 'a',
		chr(195).chr(163) => 'a', chr(195).chr(164) => 'a',
		chr(195).chr(165) => 'a', chr(195).chr(167) => 'c',
		chr(195).chr(168) => 'e', chr(195).chr(169) => 'e',
		chr(195).chr(170) => 'e', chr(195).chr(171) => 'e',
		chr(195).chr(172) => 'i', chr(195).chr(173) => 'i',
		chr(195).chr(174) => 'i', chr(195).chr(175) => 'i',
		chr(195).chr(177) => 'n', chr(195).chr(178) => 'o',
		chr(195).chr(179) => 'o', chr(195).chr(180) => 'o',
		chr(195).chr(181) => 'o', chr(195).chr(182) => 'o',
		chr(195).chr(182) => 'o', chr(195).chr(185) => 'u',
		chr(195).chr(186) => 'u', chr(195).chr(187) => 'u',
		chr(195).chr(188) => 'u', chr(195).chr(189) => 'y',
		chr(195).chr(191) => 'y',
		// Decompositions for Latin Extended-A
		chr(196).chr(128) => 'A', chr(196).chr(129) => 'a',
		chr(196).chr(130) => 'A', chr(196).chr(131) => 'a',
		chr(196).chr(132) => 'A', chr(196).chr(133) => 'a',
		chr(196).chr(134) => 'C', chr(196).chr(135) => 'c',
		chr(196).chr(136) => 'C', chr(196).chr(137) => 'c',
		chr(196).chr(138) => 'C', chr(196).chr(139) => 'c',
		chr(196).chr(140) => 'C', chr(196).chr(141) => 'c',
		chr(196).chr(142) => 'D', chr(196).chr(143) => 'd',
		chr(196).chr(144) => 'D', chr(196).chr(145) => 'd',
		chr(196).chr(146) => 'E', chr(196).chr(147) => 'e',
		chr(196).chr(148) => 'E', chr(196).chr(149) => 'e',
		chr(196).chr(150) => 'E', chr(196).chr(151) => 'e',
		chr(196).chr(152) => 'E', chr(196).chr(153) => 'e',
		chr(196).chr(154) => 'E', chr(196).chr(155) => 'e',
		chr(196).chr(156) => 'G', chr(196).chr(157) => 'g',
		chr(196).chr(158) => 'G', chr(196).chr(159) => 'g',
		chr(196).chr(160) => 'G', chr(196).chr(161) => 'g',
		chr(196).chr(162) => 'G', chr(196).chr(163) => 'g',
		chr(196).chr(164) => 'H', chr(196).chr(165) => 'h',
		chr(196).chr(166) => 'H', chr(196).chr(167) => 'h',
		chr(196).chr(168) => 'I', chr(196).chr(169) => 'i',
		chr(196).chr(170) => 'I', chr(196).chr(171) => 'i',
		chr(196).chr(172) => 'I', chr(196).chr(173) => 'i',
		chr(196).chr(174) => 'I', chr(196).chr(175) => 'i',
		chr(196).chr(176) => 'I', chr(196).chr(177) => 'i',
		chr(196).chr(178) => 'IJ',chr(196).chr(179) => 'ij',
		chr(196).chr(180) => 'J', chr(196).chr(181) => 'j',
		chr(196).chr(182) => 'K', chr(196).chr(183) => 'k',
		chr(196).chr(184) => 'k', chr(196).chr(185) => 'L',
		chr(196).chr(186) => 'l', chr(196).chr(187) => 'L',
		chr(196).chr(188) => 'l', chr(196).chr(189) => 'L',
		chr(196).chr(190) => 'l', chr(196).chr(191) => 'L',
		chr(197).chr(128) => 'l', chr(197).chr(129) => 'L',
		chr(197).chr(130) => 'l', chr(197).chr(131) => 'N',
		chr(197).chr(132) => 'n', chr(197).chr(133) => 'N',
		chr(197).chr(134) => 'n', chr(197).chr(135) => 'N',
		chr(197).chr(136) => 'n', chr(197).chr(137) => 'N',
		chr(197).chr(138) => 'n', chr(197).chr(139) => 'N',
		chr(197).chr(140) => 'O', chr(197).chr(141) => 'o',
		chr(197).chr(142) => 'O', chr(197).chr(143) => 'o',
		chr(197).chr(144) => 'O', chr(197).chr(145) => 'o',
		chr(197).chr(146) => 'OE',chr(197).chr(147) => 'oe',
		chr(197).chr(148) => 'R',chr(197).chr(149) => 'r',
		chr(197).chr(150) => 'R',chr(197).chr(151) => 'r',
		chr(197).chr(152) => 'R',chr(197).chr(153) => 'r',
		chr(197).chr(154) => 'S',chr(197).chr(155) => 's',
		chr(197).chr(156) => 'S',chr(197).chr(157) => 's',
		chr(197).chr(158) => 'S',chr(197).chr(159) => 's',
		chr(197).chr(160) => 'S', chr(197).chr(161) => 's',
		chr(197).chr(162) => 'T', chr(197).chr(163) => 't',
		chr(197).chr(164) => 'T', chr(197).chr(165) => 't',
		chr(197).chr(166) => 'T', chr(197).chr(167) => 't',
		chr(197).chr(168) => 'U', chr(197).chr(169) => 'u',
		chr(197).chr(170) => 'U', chr(197).chr(171) => 'u',
		chr(197).chr(172) => 'U', chr(197).chr(173) => 'u',
		chr(197).chr(174) => 'U', chr(197).chr(175) => 'u',
		chr(197).chr(176) => 'U', chr(197).chr(177) => 'u',
		chr(197).chr(178) => 'U', chr(197).chr(179) => 'u',
		chr(197).chr(180) => 'W', chr(197).chr(181) => 'w',
		chr(197).chr(182) => 'Y', chr(197).chr(183) => 'y',
		chr(197).chr(184) => 'Y', chr(197).chr(185) => 'Z',
		chr(197).chr(186) => 'z', chr(197).chr(187) => 'Z',
		chr(197).chr(188) => 'z', chr(197).chr(189) => 'Z',
		chr(197).chr(190) => 'z', chr(197).chr(191) => 's',
		// Euro Sign
		chr(226).chr(130).chr(172) => 'E',
		// GBP (Pound) Sign
		chr(194).chr(163) => '');

		$string = strtr($string, $chars);
	} else {
		// Assume ISO-8859-1 if not UTF-8
		$chars['in'] = chr(128).chr(131).chr(138).chr(142).chr(154).chr(158)
			.chr(159).chr(162).chr(165).chr(181).chr(192).chr(193).chr(194)
			.chr(195).chr(196).chr(197).chr(199).chr(200).chr(201).chr(202)
			.chr(203).chr(204).chr(205).chr(206).chr(207).chr(209).chr(210)
			.chr(211).chr(212).chr(213).chr(214).chr(216).chr(217).chr(218)
			.chr(219).chr(220).chr(221).chr(224).chr(225).chr(226).chr(227)
			.chr(228).chr(229).chr(231).chr(232).chr(233).chr(234).chr(235)
			.chr(236).chr(237).chr(238).chr(239).chr(241).chr(242).chr(243)
			.chr(244).chr(245).chr(246).chr(248).chr(249).chr(250).chr(251)
			.chr(252).chr(253).chr(255);

		$chars['out'] = "EfSZszYcYuAAAAAACEEEEIIIINOOOOOOUUUUYaaaaaaceeeeiiiinoooooouuuuyy";

		$string = strtr($string, $chars['in'], $chars['out']);
		$double_chars['in'] = array(chr(140), chr(156), chr(198), chr(208), chr(222), chr(223), chr(230), chr(240), chr(254));
		$double_chars['out'] = array('OE', 'oe', 'AE', 'DH', 'TH', 'ss', 'ae', 'dh', 'th');
		$string = str_replace($double_chars['in'], $double_chars['out'], $string);
	}

	return $string;
}
function Slugit($title) {
	$title = strip_tags($title);
	// Preserve escaped octets.
	$title = preg_replace('|%([a-fA-F0-9][a-fA-F0-9])|', '---$1---', $title);
	// Remove percent signs that are not part of an octet.
	$title = str_replace('%', '', $title);
	// Restore octets.
	$title = preg_replace('|---([a-fA-F0-9][a-fA-F0-9])---|', '%$1', $title);

	$title = remove_accents($title);
	if (seems_utf8($title)) {
		if (function_exists('mb_strtolower')) {
			$title = mb_strtolower($title, 'UTF-8');
		}
		$title = utf8_uri_encode($title, 500);
	}

	$title = strtolower($title);
	$title = preg_replace('/&.+?;/', '', $title); // kill entities
	$title = str_replace('.', '-', $title);
	$title = preg_replace('/[^%a-z0-9 _-]/', '', $title);
	$title = preg_replace('/\s+/', '-', $title);
	$title = preg_replace('|-+|', '-', $title);
	$title = trim($title, '-');

	return $title;
}

?>
