<?php
/**
*
* @package RSS Feed Class														
* @version $Id: 6:23 PM 1/8/2010 Aneeshtan $						
* @copyright (c) Nukelearn Group  http://www.nukelearn.com											
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/#
	class RSS
	{
		

		
		var $title;
		var $link;
		var $description;
		var $language = "fa-IR";
		var $pubDate;
		var $items;
		var $tags;


		function RSS()
		{
			$this->items = array();
			$this->tags  = array();
		}

		function addItem($item)
		{
			$this->items[] = $item;
		}

		function setPubDate($when)
		{
			if(strtotime($when) == false)
				$this->pubDate = date("D, d M Y H:i:s ", $when) . "GMT";
			else
				$this->pubDate = date("D, d M Y H:i:s ", strtotime($when)) . "GMT";
		}

		function getPubDate()
		{
			if(empty($this->pubDate)){
			
    $date = date("Y-m-d\TH:i:s", time());
				return $date;
		}else
				return $this->pubDate;
		}

		function addTag($tag, $value)
		{
			$this->tags[$tag] = $value;
		}

		function out()
		{
			$out  = $this->header();
			$out .= "<channel>\n";
			$out .= "<title>" . $this->title . "</title>\n";
			$out .= "<link>" . $this->link . "</link>\n";
			$out .= "<description>" . $this->description . "</description>\n";
			$out .= "<language>" . $this->language . "</language>\n";
			$out .= "<pubDate>" . $this->getPubDate() . "</pubDate>\n";
			$out .= "<sy:updatePeriod>hourly</sy:updatePeriod>\n";
			$out .= "<sy:updateFrequency>1</sy:updateFrequency>\n";
			foreach($this->tags as $key => $val) $out .= "<$key>$val</$key>\n";
			foreach($this->items as $item) $out .= $item->out();

			$out .= "</channel>\n";
			
			$out .= $this->footer();

			$out = str_replace("&", "&amp;", $out);

			return $out;
		}
		
		function serve($contentType = "application/xml")
		{
			$xml = $this->out();
			header("Content-type: $contentType");
			echo $xml;
		}

		function header()
		{
			$out  = '<?xml version="1.0" encoding="utf-8"?>' . "\n";
			$out .= "<rss version=\"2.0\" \n";
$out .= "  xmlns:dc=\"http://purl.org/dc/elements/1.1/\"\n";
$out .= "  xmlns:sy=\"http://purl.org/rss/1.0/modules/syndication/\"\n";
$out .= "  xmlns:admin=\"http://webns.net/mvcb/\"\n";
$out .= "  xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\">" . "\n";
			return $out;
		}

		function footer()
		{
			return '</rss>';
		}
			

		function main_page(){
			$mainpage  = "<html>\n";
			$mainpage  .= "<head>\n";
			$mainpage  .= "<title>$sitename $pagetitle</title>\n";
			include("includes/meta.php");
			if (file_exists("themes/$ThemeSel/images/favicon.ico")) {
				$mainpage  .= "<link REL=\"shortcut icon\" HREF=\"themes/$ThemeSel/images/favicon.ico\" TYPE=\"image/x-icon\">\n";
			}
			$mainpage  .=  "<center>";
			$mainpage  .=  "<h3>  لیست خوراک های سایت <a href='$nukeurl'>$sitename</a> <br>$slogan</h3>";
			$mainpage  .= "<a href=\"rss.php?mod=News\" target=\"_blank\"><img border=\"0\" src=\"images/rss/news.png\" title=\"RSS اخبار\"></a><br>";
			$mainpage  .= "<a href=\"rss.php?mod=Forums\" target=\"_blank\"><img border=\"0\" src=\"images/rss/forum.png\" title=\"RSS انجمنهاي گفتگو\"></a><br>";
			$mainpage  .= "<a href=\"rss.php?mod=Downloads\" target=\"_blank\"><img border=\"0\" src=\"images/rss/downloads.png\" title=\"RSS دانلودي ها\"></a><br>";
			$mainpage  .= "<a href=\"rss.php?mod=WebLinks\" target=\"_blank\"><img border=\"0\" src=\"images/rss/weblinks.png\" title=\"RSS لينکستان\"></a><br>";
			$mainpage  .= "<a href=\"rss.php?mod=Comment\" target=\"_blank\"><img border=\"0\" src=\"images/rss/comment.png\" title=\"RSS آخرين نظرات\"></a><br>";
			$mainpage  .= "<a href=\"rss.php?mod=Message\" target=\"_blank\"><img border=\"0\" src=\"images/rss/message.png\" title=\"RSS پيامهاي مدير \"></a>";
			$mainpage  .= "</center>";
			die($mainpage) ;

		}
		
	}

	class RSSItem
	{
		var $title;
		var $link;
		var $description;
		var $pubDate;
		var $author;
		var $guid;
		var $tags;
		var $attachment;
		var $length;
		var $mimetype;

		function RSSItem()
		{ 
			$this->tags = array();
		}

		function setPubDate($when)
		{
			if(strtotime($when) == false)
				$this->pubDate = date("D, d M Y H:i:s ", $when) . "GMT";
			else
				$this->pubDate = date("D, d M Y H:i:s ", strtotime($when)) . "GMT";
		}

		function getPubDate()
		{
			if(empty($this->pubDate))
				return date("D, d M Y H:i:s ") . "GMT";
			else
				return $this->pubDate;
		}

		function addTag($tag, $value)
		{
			$this->tags[$tag] = $value;
		}


		function out()
		{
			$out .= "<item>\n";
			$out .= "<title>" . $this->title . "</title>\n";
			$out .= "<link>" . $this->link . "</link>\n";
			$out .= "<description>" . $this->description . "</description>\n";
			$out .= "<pubDate>" . $this->getPubDate() . "</pubDate>\n";
			$out .= "<dc:creator> BY " . $this->author . "</dc:creator>\n";

			if($this->attachment != "")
				$out .= "<enclosure url='{$this->attachment}' length='{$this->length}' type='{$this->mimetype}' />";

			if(empty($this->guid)) $this->guid = $this->link;
			$out .= "<guid>" . $this->guid . "</guid>\n";

			foreach($this->tags as $key => $val) $out .= "<$key>$val</$key\n>";
			$out .= "</item>\n";
			return $out;
		}

		function enclosure($url, $mimetype, $length)
		{
			$this->attachment = $url;
			$this->mimetype   = $mimetype;
			$this->length     = $length;
		}

	
	}
?>