<?php
/**
*
* @package mainfile														
* @version $Id: mainfile.php RC-7 4:09 PM 1/16/2010 $						
* @copyright (c) Nukelearn Group  http://www.nukelearn.com											
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

//===========================================
// PHP  Transaction
//===========================================

if(!defined('END_TRANSACTION')) {
  define('END_TRANSACTION', 2);
}

// Get php version
$phpver = phpversion();

// convert superglobals if php is lower then 4.1.0
if ($phpver < '4.1.0') {
  $_GET = $HTTP_GET_VARS;
  $_POST = $HTTP_POST_VARS;
  $_SERVER = $HTTP_SERVER_VARS;
  $_FILES = $HTTP_POST_FILES;
  $_ENV = $HTTP_ENV_VARS;
  if($_SERVER['REQUEST_METHOD'] == "POST") {
    $_REQUEST = $_POST;
  } elseif($_SERVER['REQUEST_METHOD'] == "GET") {
    $_REQUEST = $_GET;
  }
  if(isset($HTTP_COOKIE_VARS)) {
    $_COOKIE = $HTTP_COOKIE_VARS;
  }
  if(isset($HTTP_SESSION_VARS)) {
    $_SESSION = $HTTP_SESSION_VARS;
  }
}
// override old superglobals if php is higher then 4.1.0
if($phpver >= '4.1.0') {
  $HTTP_GET_VARS = $_GET;
  $HTTP_POST_VARS = $_POST;
  $HTTP_SERVER_VARS = $_SERVER;
  $HTTP_POST_FILES = $_FILES;
  $HTTP_ENV_VARS = $_ENV;
  $PHP_SELF = $_SERVER['PHP_SELF'];
  if(isset($_SESSION)) {
    $HTTP_SESSION_VARS = $_SESSION;
  }
  if(isset($_COOKIE)) {
    $HTTP_COOKIE_VARS= $_COOKIE;
  }
}

// After doing those superglobals we can now use one
// and check if this file isnt being accessed directly
if (stristr(htmlentities($_SERVER['PHP_SELF']), "mainfile.php")) {
    die("Access Denied<br><b>".$_SERVER['PHP_SELF']."</b>");
}
  	 if (!function_exists("floatval")) {
  	     function floatval($inputval) {
  	         return (float)$inputval;
  	     }
  	 }

//===========================================
//Compression Functions
//===========================================
$EnableGZipEncoding = true;
$EnableSourceCompression = false;
function acceptsGZip(){
    $accept = str_replace(" ","",
        strtolower($_SERVER['HTTP_ACCEPT_ENCODING'])
    );
    $accept = explode(",",$accept);
    return in_array("gzip",$accept);
}
function playWithHtml($OutputHtml){
    return preg_replace("/\s+/"," ",$OutputHtml);
}
function obOutputHandler($OutputHtml){
global $EnableGZipEncoding,$EnableSourceCompression;
    if($EnableSourceCompression) {
    	 $OutputHtml = playWithHtml($OutputHtml);
    }
    if(!acceptsGZip() || headers_sent() || !$EnableGZipEncoding) return $OutputHtml;
    header("Content-Encoding: gzip");
    return gzencode($OutputHtml);
}
ob_start(array('obOutputHandler',9));



//===========================================
//global stripos checks
//===========================================

if (!ini_get('register_globals')) {
  @import_request_variables("GPC", "");
}

if(!function_exists('stripos')) {
  function stripos_clone($haystack, $needle, $offset=0) {
    	     $return = strpos(strtoupper($haystack), strtoupper($needle), $offset);
  	   if ($return === false) {
  	     return false;
  	     } else {
  	     return true;
  	     }
  }
} else {
// But when this is PHP5, we use the original function	
  function stripos_clone($haystack, $needle, $offset=0) {
$return = stripos($haystack, $needle, $offset=0);
 if ($return === false) {
    return false;
	   } else {
	return true;
    }
  }
}

//===========================================
//Define CONSTANTS
//===========================================
//Absolute PHP-Nuke directory
define('PHOENIX_BASE_DIR', dirname(__FILE__) . '/');
// Absolute Phoenix Directory And Includes
define('PHOENIX_INCLUDE_DIR', PHOENIX_BASE_DIR.'includes/');

define("IN_USV",true);
define('BASE_PATH', dirname(__FILE__) . '/');
define('INCLUDES_PATH', 'includes/');
define("INCLUDES_UCP", "modules/Your_Account/includes/");
define('INCLUDES_ACP',	INCLUDES_PATH. 'acp/');

define('IMAGES_PATH',   BASE_PATH . 'images/');
define('THEMES_PATH',   BASE_PATH . 'themes/');
define('MODULES_PATH', 	'modules/');
define('ADMIN_PATH',	BASE_PATH . 'admin/');
define('DB_PATH',	 	BASE_PATH . 'db/');
define('JAVASCRIPT_PATH',	 	INCLUDES_PATH. 'javascript/');
define('SCRIPT_PATH',	 	 JAVASCRIPT_PATH. 'jquery/dist/');
define('SCRIPT_PLUGINS_PATH',JAVASCRIPT_PATH. 'jquery/plugins/');
define('SCRIPT_SRC_PATH',JAVASCRIPT_PATH. 'jquery/src/');
define('MODS_PATH',INCLUDES_PATH. 'mods/');
define('LANGUAGE_PATH',			BASE_PATH . 'language/');
define('ADMIN_LANGUAGE_PATH',	BASE_PATH . 'admin/language/');

define("ADMIN_OP", "admin.php?op=");
define('IMAGES_ICON',	IMAGES_PATH. 'icon/');

if(defined('FORUM_ADMIN')) {
  define('INCLUDE_PATH', '../../../');
} elseif(defined('INSIDE_MOD')) {
  define('INCLUDE_PATH', '../../');
} else {
  define('INCLUDE_PATH', './');
}

//===========================================
//Includes
//===========================================

require_once(BASE_PATH."config.php");
require_once(DB_PATH."db.php");
@require_once(INCLUDES_PATH."sql_layer.php");
@require_once(INCLUDES_PATH."ipban.php");
@require_once(INCLUDES_PATH."nukesentinel.php");
//
if (file_exists(INCLUDES_PATH."custom_files/custom_mainfile.php")) {
include_once(INCLUDES_PATH."custom_files/custom_mainfile.php");
}
if (!defined('FORUM_ADMIN')) {
  if(empty($admin_file)) {
    die ("You must set a value for admin_file in config.php");
  } elseif (!empty($admin_file) && !file_exists($admin_file.".php")) {
    die ("The admin_file you defined in config.php does not exist");
  }
}

//===========================================
//Error reporting
//===========================================
// to be set in config.php
  error_reporting(E_ALL^E_NOTICE);
if($display_errors) {
  @ini_set('display_errors', 1);
} else {
 @ini_set('display_errors', 0);
}
//===========================================
// Nuke Editor
//===========================================
list($nuke_editor) = $db->sql_fetchrow($db->sql_query('SELECT `nuke_editor` FROM `'.$prefix.'_config` LIMIT 1'));
//===========================================
// text filters
//===========================================
include_once(INCLUDES_PATH."inc_htmlclean.php");

//===========================================
//CONSTANTS SYSTEM
//===========================================
include_once(INCLUDES_PATH . 'constants.php');
//===========================================
// gfx check
//===========================================
list($gfx_chk) = $db->sql_fetchrow($db->sql_query('SELECT `gfx_chk` FROM `'.$prefix.'_config` LIMIT 1'));
//===========================================
// Cache System
//===========================================
list($CacheSystem) = $db->sql_fetchrow($db->sql_query('SELECT `cache_system` FROM `'.$prefix.'_config` LIMIT 1'));
//===========================================
// Usv Functions
//===========================================
function is_admin($admin) {
	static $adminSave;
	
    if (!$admin) { return 0; }
    if (isset($adminSave)) return $adminSave;
    if (!is_array($admin)) {
        $admin = base64_decode($admin);
        $admin = addslashes($admin);
        $admin = explode(':', $admin);
    }
    $aid = $admin[0];
    $pwd = $admin[1];
    $aid = substr(addslashes($aid), 0, 25);
    if (!empty($aid) && !empty($pwd)) {
        global $prefix, $db;
        $sql = "SELECT pwd FROM ".$prefix."_authors WHERE aid='$aid'";
        $result = $db->sql_query($sql);
        $pass = $db->sql_fetchrow($result);
        $db->sql_freeresult($result);
        if ($pass[0] == $pwd && !empty($pass[0])) {
        	return $adminSave = 1;
        }
    }
    return $adminSave = 0;
}
function get_author($aid) {
global $prefix, $db;
    static $users;
    if (isset($users[$aid]) AND is_array($users[$aid])) {
        $row = $users[$aid];
    } else {
        $sql = "SELECT url, email FROM ".$prefix."_authors WHERE aid='$aid'";
        $result = $db->sql_query($sql);
        $row = $db->sql_fetchrow($result);
        $users[$aid] = $row;
        $db->sql_freeresult($result);
    }
    $aidurl = check_html($row['url'], "nohtml");
    $aidmail = check_html($row['email'], "nohtml");
    if (isset($aidurl) && $aidurl != "http://") {
        $aid = "<a href=\"".$aidurl."\">$aid</a>";
    } elseif (isset($aidmail)) {
        $aid = "<a href=\"mailto:".$aidmail."\">$aid</a>";
    } else {
        $aid = $aid;
    }
    return $aid;
}
function cookiedecode($user) {
    global $cookie, $db, $user_prefix;
    static $pass;
    if(!is_array($user)) {
        $user = base64_decode($user);
        $user = addslashes($user);
        $cookie = explode(":", $user);
    } else {
        $cookie = $user;
    }
    if (!isset($pass) AND isset($cookie[1])) {
       $sql = "SELECT user_password FROM ".$user_prefix."_users WHERE username='$cookie[1]'";
       $result = $db->sql_query($sql);
       list($pass) = $db->sql_fetchrow($result);
       $db->sql_freeresult($result);
    }
   if (isset($cookie[2]) AND ($cookie[2] == $pass) AND (!empty($pass))) { return $cookie; }
}
function getusrinfo($user) {
    global $user_prefix, $db, $userinfo, $cookie;
    if (!$user OR empty($user)) {
      return NULL; 
    }
    cookiedecode($user);
    $user = $cookie;
    if (isset($userrow) AND is_array($userrow)) {
        if ($userrow['username'] == $user[1] && $userrow['user_password'] == $user[2]) {
            return $userrow;
        }
    }
    $sql = "SELECT * FROM ".$user_prefix."_users WHERE username='$user[1]' AND user_password='$user[2]'";
    $result = $db->sql_query($sql);
    if ($db->sql_numrows($result) == 1) {
        static $userrow;
        $userrow = $db->sql_fetchrow($result);
        return $userinfo = $userrow;
    }
    $db->sql_freeresult($result);
    unset($userinfo);
}

include_once(INCLUDES_PATH."inc_functions.php");

//===========================================
// Jalali Date Convertor Functions
//===========================================
include_once(INCLUDES_PATH."inc_JalaliDate.php");


if (defined('FORUM_ADMIN')) { 
    include_once("../../../modules/Your_Account/includes/mainfileend.php"); 
} elseif (defined('INSIDE_MOD')) { 
    include_once("../../modules/Your_Account/includes/mainfileend.php"); 
} else { 
    include_once("modules/Your_Account/includes/mainfileend.php"); 
}

//===========================================
// nextGen Functions
//===========================================

if ($nextg==1) {
$nextGenOb = 1; 
 }else{
$nextGenOb = 0; 
} 
$nextGenDebug = 0;                
$nextGenMainPath = "google";                              
$nextGenBlock = 0;                
$nextGenAdmin = is_admin($admin);    
           
if (!defined("ADMIN_FILE")) {
include_once(INCLUDES_PATH."inc_nextGenTap.php");
}

//===========================================
// Theme Engine
//===========================================
if (!defined("ADMIN_FILE") AND !defined('FORUM_ADMIN')) {
if (!file_exists(THEME_FILE)) {
include(INCLUDES_PATH."template.class.php");
$te_page = new USV_Template;
list($lifetime) = $db->sql_fetchrow($db->sql_query('SELECT `cache_lifetime` FROM `'.$prefix.'_config` LIMIT 1'));
// Set the cache properties
$te_page->setCacheDir('cache');
$te_page->setCacheLifetime($lifetime);
if ($CacheSystem == 1) {
$te_page->setCaching(true); 
}
}
}

//===========================================
// TAGGING SYSTEM
//===========================================
if (defined("TAGS_INC")){
include(INCLUDES_PATH."inc_tags.php");
}
//===========================================
// LOGGING SYSTEM
//===========================================
include(INCLUDES_PATH."inc_logging.php");
$log = new Logging();
//===========================================
// Session SYSTEM
//===========================================
include(INCLUDES_PATH."inc_session.php");
$NK_session = new NK_session();
//===========================================
// END OF CORE
//===========================================
?>
