<?php

/************************************************************************/
/* PHP-NUKE: Web Portal System                                          */
/* ===========================                                          */
/*                                                                      */
/* Copyright (c) 2002 by Francisco Burzi                                */
/* http://phpnuke.org                                                   */
/*                                                                      */
/* mSearch Copyright (c) 2005 by David Karn, All rights reserved        */
/* http://webdever.net/                                                 */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/
/* INP-Nuke : Expect to be impressed                                    */
/* ===========================                                          */
/*                               COPYRIGHT                              */
/*                                                                      */
/* Copyright (c) 2005 - 2006 by http://www.irannuke.net                 */
/*                                                                      */
/*     Iran Nuke Portal                        (info@irannuke.net)      */
/*                                                                      */
/* Refer to irannuke.net for detailed information on INP-Nuke           */
/************************************************************************/

// Utility functions

function formatdateago($olddate){
  // Takes a timestamp and returns a string telling how long ago that timestamp occured
  $date = time();
  $diff = $date - $olddate;
  if ($diff > 365 * 24 * 60 * 60){
    $yrs = floor($diff / (365 * 24 * 60 * 60));}
  if ($diff > 24 * 60 * 60){
    $days = floor($diff / (24 * 60 * 60));}
  if ($diff > 7 * 24 * 60 * 60){
    $weeks = floor($diff / (7 * 24 * 60 * 60));}
  if ($diff > 30 * 24 * 60 * 60){
    $months = floor($diff / ((365 * 24 * 60 * 60) / 12));}
  if ($diff > 60 * 60){
    $hours = floor($diff / (60 * 60));}
  if ($diff > 60){
    $minutes = floor($diff / 60);}
  if ($diff < 60){
    $secs = $diff;}
  if ($yrs){
    $string = "$yrs "._MSYEAR.($yrs == 1 ? '' : ''._MSPLURAL);
    if ($months % 12 > 0){
      $string .= ", ".($months - (12 * $yrs))." "._MSMONTH.(($months - (12 * $yrs)) == 1 ? '' : ''._MSPLURAL)." "._MSAGO;}
    else {
      $string .= ' '._MSAGO;}}
  else if ($months){
    $string = "$months "._MSMONTH.($months == 1 ? '' : ''._MSPLURAL);
    if ($weeks % 4 > 0){
      $string .= ", ".($weeks - (4 * $months))." "._MSWEEK.(($weeks - (4 * $months)) == 1 ? '' : ''._MSPLURAL)." "._MSAGO;}
    else {
      $string .= ' '._MSAGO;}}
  else if ($weeks){
    $string = "$weeks "._MSWEEK.($weeks == 1 ? '' : ''._MSPLURAL);
    if ($days % 7 > 0){
      $string .= ", ".($days - (7 * $weeks))." "._MSDAY.(($days - (7 * $weeks)) == 1 ? '' : ''._MSPLURAL)." "._MSAGO;}
    else {
      $string .= ' '._MSAGO;}}
  else if ($days){
    $string = "$days "._MSDAY.($days == 1 ? '' : ''._MSPLURAL)." "._MSAGO;}
  else if ($hours){
    $string = "$hours "._MSHOUR.($hours == 1 ? '' : ''._MSPLURAL)." "._MSAGO;}
  else if ($minutes){
    $string = "$minutes "._MSMINUTE.($minutes == 1 ? '' : ''._MSPLURAL)." "._MSAGO;}
  else if ($secs){
    $string = "$secs "._MSSECOND.($seconds == 1 ? '' : ''._MSPLURAL)." "._MSAGO;}
  return $string;}

function chopwords($str, $c){
  // Chop a string at a certain length, without cutting off any words.
  $s = explode(' ', $str);
  $x = 0;
  $string = '';
  foreach ($s as $word){
    $x += strlen($word)+1;
    if ($x < $c){
      $string .= $word.' ';}
    else {
      return $string;}}
  return $string;}

function asortbyindex($multiArray, $secondIndex) {
  // Sort a 2-Dimensional array.
  $GLOBALS['secondIndex'] = $secondIndex;
  usort($multiArray, create_function('$a, $b', '
    $secondIndex = $GLOBALS["secondIndex"];
    if ($a[$secondIndex] == $b[$secondIndex]) {
      return 0;}
    return ($a[$secondIndex] < $b[$secondIndex]) ? -1 : 1;'));
  return $multiArray;}

function mt_get_date_format(){
  // Get the date format and timezone from the user's settings.
  global $user, $db, $prefix;
  if(is_user($user)) {
    $cookie = explode(":", addslashes(base64_decode($user)));
    cookiedecode($user);
    $userr = $cookie[0];}
  else {
    $userr=1;}
  $i = $db->sql_fetchrow($db->sql_query('SELECT user_dateformat, user_timezone FROM '.$prefix.'_users WHERE user_id="'.$userr.'" LIMIT 1;'));
  if ($i['user_dateformat']){
    return array($i['user_dateformat'], $i['user_timezone']);}}

function mt_format_date($time){
  // Format a date to fit the user's settings.
  global $user, $db, $prefix;
  $i = mt_get_date_format();
  return gmdate($i[0], $time + ($i[1]*3600));}


// Module Functions

function get_all_results($what){
  // Find all the modules and collect their results into the database.
  global $module_name, $q;
  if ($what == 'all'){
    if ($handle = opendir('modules/'.$module_name.'/modules/')) {
      while (false !== ($file = readdir($handle))) {
        if (!is_dir('modules/'.$module_name.'/modules/'.$file)) {
          include('modules/'.$module_name.'/modules/'.$file);
           $cname = substr($file,0,-4);
          $cname2 = 'mS'.$cname;
          ${$cname} = new $cname2();
          if (${$cname}->useme()){
            $GLOBALS['mSar'][$cname] = ${$cname};
            ${$cname}->addquery('main', $q);
            ${$cname}->getresults();}}}
    closedir($handle);}}
  else {
    $file = addslashes(basename($what)).'.php';
    include('modules/'.$module_name.'/modules/'.$file);
    $cname = substr($file,0,-4);
    $cname2 = 'mS'.$cname;
    ${$cname} = new $cname2();
    $GLOBALS['mSar'][$cname] = ${$cname};
    ${$cname}->addquery('main', $q);
    ${$cname}->getresults();}}

function buildquery($p, $query){
  // Turn the query string entered into the search box into an
  // array, which can be used by the mSearch modules
  if ($p !== false){
    $q = explode('"', ' '.$query);
    $sc = 0;
    $ec = 0;
    if ($query[0] != '"'){
      $q = array_merge(explode(' ', $q[0]), array_slice($q, 1));}
    else{
      array_shift($q);}
    if ($query[strlen($query)-1] != '"'){
      $q = array_merge(explode(' ', $q[count($q)-1]), array_slice($q, 0,-1));}
    else{
      array_pop($q);}
    foreach ($q as $val){
      $val = trim($val);}}
  else {
    $query = $_REQUEST['query'];
    $q = explode(' ', $query);}
  for ($i=0,$x=count($q);$i<$x;$i++){
    if (strstr($q[$i], ' ') == false){
      $q[$i] = trim(str_replace($commonwords, '', ' '.$q[$i].' '));}}
  return $q;}

function showpage($start, $len, $fullen, $func, $pfunc){
  // Display a list of items on a page, using $func to format these
  // items, and $pfunc to show the links to new pages
  global $db;
  function pagenum($ar){
    $c = '';
    if (is_array($ar)){
      foreach($ar as $val){
        $c .= $val.' ';}}
    return $c;}
  $lastpage = 1;
  if ($len > 0){
    for ($x = $start + $len, $i = $start;$i < $x;$i++){
      $content .= $func($i);}
    $page = ($start / $len);
    $pagest = ceil(($fullen / $len));
    if ($page < 2){
      $page = 2;
    } else if ($page > $pagest - 3){
      $page = $pagest -2;
      if ($pagest == 3){
        $page = 2;}}
    $pages = array();
    if ( $fullen > $len){
      for ($x = $fullen / $len, $i = 0;$i < $x;$i++){
        $pages[] = (round($start/$len) != $i ? $pfunc($i*$len, $len) : '<b>'.($i+1).'</b>');}
        $x = 5;
        if ($pagest < 5){
          $x = $pagest;}
        for ($i = 0;$i < $x;$i++){
          $pages2[] = $pages[(($page - 2)+$i)];
          $lastpage = $i;}}}
  $startlen = ($len ? $start/$len : 0);
  return array($content, (round($startlen) > 2 && $pagest > 5 ? $pfunc(0, $len).' '._MSELIPSES.' ' : '').pagenum($pages2).(round($startlen) < $pagest-2 && $pagest > 5 ? ' ... '.$pfunc(($pagest-1)*$len, $len) : ''));}


// Module Code

// Create a list of commonly used words, to be ignored in a search
// query.
$cw = explode(' ', ''._MSCOMMONWORDS);
$commonwords = array();
foreach($cw as $word){
  $commonwords[] = ' '.$word.' ';}

// Get the current url
$url = str_replace('&', '&amp;', 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']);
$url = parse_url($url);

// Create a temporary table to hold the search results
$randkey = rand(0, 10000);
$tblname = $prefix.'_mSearch_'.$randkey;
$db->sql_query('CREATE TEMPORARY TABLE '.$tblname.' (
                `id` VARCHAR(20) NOT NULL ,
                `relevance` INT NOT NULL ,
                `date` INT NOT NULL ,
                `title` TEXT NOT NULL ,
                `rid` INT NOT NULL ,
                `desc` TEXT NOT NULL ,
                `author` TEXT NOT NULL ,
                `searchmodule` TEXT NOT NULL ,
                INDEX ( `relevance` ),
                INDEX ( `date` )
                );');

if (!eregi("modules.php", $_SERVER['PHP_SELF'])) {
    die ("You can't access this file directly...");
}

class searchmodule {
  var $query;
  var $name;
  var $sql_col_time;
  var $sql_col_title;
  var $sql_col_id;
  var $sql_col_desc;
  var $sql_col_author;
  var $sql_table_with_prefix;
  var $sql_where_cols;

  function useme(){
    // Returns true if this module is to be used by mSearch
    global $db, $prefix;
    if ($this->databaseexists()){
      $res = $db->sql_fetchrow($db->sql_query('SELECT `use` FROM '.$prefix.'_msmodules WHERE `name`="'.$this->name.'"'));
      return ($res['use'] == 'no' ? 0 : 1);}
    return 0;}

  function databaseexists(){
    // Returns true if the database for this module is installed
    global $db;
    $res = $db->sql_query('SELECT "1" FROM '.$this->sql_table_with_prefix);
    return ($res ? 1 : 0);}

  function formatrss($result){
    // Format a result for an RSS feed
    global $url;
    return '
    <item>
      <title>'.$this->name.': '.$result['title'].'</title>
      <link>
        '.$url['scheme'].'://'.$url['host'].$url['path'].$this->buildlink($result['rid']).'
      </link>
      <description>
         '.chopwords(strip_tags($result['desc']),192).'
      </description>
    </item>';}

  function formatresult($result){
    // Format a result to be displayed in the module
    return '<b>'.$this->name.':</b> 
        <a href="modules.php'.$this->buildlink($result['rid']).'">
        '.$result['title'].'</a><br /><small>
        '.($result['author'] ? ''._MSBY.' '.$result['author'] : '').($result['date'] ? ', '.formatdateago($result['date']) : '').'
        </small><br />'.chopwords(strip_tags($result['desc']),192);}

  function gformatresult($result){
    // Format a result to be displayed in the group-display page
    return '<a href="modules.php'.$this->buildlink($result['rid']).'">
        '.$result['title'].'</a><br /><small>
        '.($result['author'] ? ''._MSBY.' '.$result['author'] : '').($result['date'] ? ', '.formatdateago($result['date']) : '').'
        </small><br />'.chopwords(strip_tags($result['desc']),192);}

  function doquery(){
    // Insert any results matching the users query into the main database
    global $prefix, $tblname, $db;
    $q = $this->query[0][1];
    foreach ($q as $query){
      $wheretext = '('.$this->sql_where_cols[0].' like \'%'.$query.'%\')';
      for ($i = 1,$x=count($this->sql_where_cols);$i<$x;$i++){
        $wheretext .= ' OR (`'.$this->sql_where_cols[$i].'` like \'%'.$query.'%\')';}
      $db->sql_query('INSERT INTO '.$tblname.' 
                     (`id`, `relevance`, `date`, `title`, `rid`, `desc`, `author`, `searchmodule`)
                     SELECT CONCAT("'.$this->name.'", `'.$this->sql_col_id.'`) AS `id`, \'1\', 
                     '.($this->sql_col_time_unix ? '' : 
                     'UNIX_TIMESTAMP(`').$this->sql_col_time.($this->sql_col_time_unix ? '' : '`)').', 
                     `'.$this->sql_col_title.'`, `'.$this->sql_col_id.'`, `'.$this->sql_col_desc.'`,
                     `'.$this->sql_col_author.'`, "'.$this->name.'" FROM '.$this->sql_table_with_prefix.' 
                     WHERE ('.$wheretext.')');}}

  function addquery($type, $query){
    // Not sure why this is here :/
    $this->query[] = array($type, $query);}

  function getresults(){
    // Not sure why this is here either, but you probably shouldn't mess with these.
    global $db;
    return $this->doquery();}

  function options($var){
    // The html code to be used when a user clicks "More Options >"
    return $var.'[\''.$this->name.'\']=" '._MSWITHINLAST.' <select name=\"when\">\\
      <option value=\"0\">'._MSANYDATE.'</option>\\
      <option value=\"'.(time() - (3 * 24 * 60 * 60)).'\">'._MSTHREEDAYS.'</option>\\
      <option value=\"'.(time() - (7 * 24 * 60 * 60)).'\">'._MSONEWEEK.'</option>\\
      <option value=\"'.(time() - (7 * 4 * 24 * 60 * 60)).'\">'._MSONEMONTH.'</option>\\
      <option value=\"'.(time() - (6 * 7 * 4 * 24 * 60 * 60)).'\">'._MSSIXMONTHS.'</option>\\
      <option value=\"'.(time() - (12 * 7 * 4 * 24 * 60 * 60)).'\">'._MSONEYEAR.'</option>\\
      </select>"';}

  function buildlink($id){
    // Used by the individual modules to define how a link to an item should be built
    }

  function buildquery(){
    // Not sure why this is here either, but it is
    }}

define('INDEX_FILE', true);
require_once("mainfile.php");
$module_name = basename(dirname(__FILE__));
get_lang($module_name);
$pagetitle = "- "._SEARCH."";

if ($_REQUEST['op'] == 'rss' || $_REQUEST['op'] == 'search' || $_REQUEST['op'] == 'gsearch'){
  // Take care of initializations for the rss and search pages,
  // without repitition or running them at the search page.
  $GLOBALS['mSar'] = array();
  if (isset($_GET['query'])){
    $_REQUEST['query'] = str_replace('\\quote', '"', $_REQUEST['query']);}
  $query = stripslashes($_REQUEST['query']);
  $p = strpos($query, '"');
  $q = buildquery($p, $query);
  get_all_results($_REQUEST['what']);}

if ($_REQUEST['op'] != 'rss'){
  // Stuff to do if we are not echoing out an RSS feed
  echo '<script type="text/javascript">
    function changeBoxSize(showhide) {
      document.getElementById(\'msopt_hide\').style.display=\'none\';
      document.getElementById(\'msopt_show\').style.display=\'none\';
      document.getElementById(\'msopt_\'+showhide).style.display=\'block\';
    }
    var msstuff = new Array(20)
    msstuff[\'all\']=" '._MSWITHINLAST.' <select name=\"when\">\\
      <option value=\"0\">'._MSANYDATE.'</option>\\
      <option value=\"'.(time() - (3 * 24 * 60 * 60)).'\">'._MSTHREEDAYS.'</option>\\
      <option value=\"'.(time() - (7 * 24 * 60 * 60)).'\">'._MSONEWEEK.'</option>\\
      <option value=\"'.(time() - (7 * 4 * 24 * 60 * 60)).'\">'._MSONEMONTH.'</option>\\
      <option value=\"'.(time() - (6 * 7 * 4 * 24 * 60 * 60)).'\">'._MSSIXMONTHS.'</option>\\
      <option value=\"'.(time() - (12 * 7 * 4 * 24 * 60 * 60)).'\">'._MSONEYEAR.'</option>\\
      </select>"'."\n\n";
  if ($handle = opendir('modules/'.$module_name.'/modules/')) {
    while (false !== ($file = readdir($handle))) {
      if (!is_dir('modules/'.$module_name.'/modules/'.$file)) {
        include_once('modules/'.$module_name.'/modules/'.$file);
         $cname = substr($file,0,-4);
        $cname2 = 'mS'.$cname;
        ${$cname} = new $cname2();
        if (${$cname}->useme()){
          $GLOBALS['mSar'][$cname] = ${$cname};
          echo ${$cname}->options('msstuff')."\n\n";}}}}
  echo 'function msput(form)
    {
      option=form.what.options[form.what.selectedIndex].value
      txt=msstuff[option]
      document.getElementById(\'msopt\').innerHTML=txt
    }
    </script>';}

switch ($_REQUEST['op']){
  case 'rss':
    global $db, $tblname, $commonwords, $url;
    header('Content-Type:text/xml');
    $rq = $_REQUEST['query'];
    $rw = $_REQUEST['what'];
    echo "<rss>\n
      <channel>\n
      <title>"._MSSRF." $query</title>\n
      <link>\n"
      .'http://'.$url['host'].$url['path'].'?name=mSearch&amp;op=search&amp;query='.$rq.'&amp;what='.$rw."\n
      </link>
      <description>
      "._MSNEWRES."\"".$query."\"
      </description>\n";
    $GLOBALS['mSresult'] = $db->sql_query('SELECT `id`, count(`id`) as `rel`, `date`, `title`, `rid`, `desc`, `author`, `searchmodule` 
                                           FROM '.$tblname.' GROUP BY id ORDER BY `rel` DESC, date DESC LIMIT 20');

    function showresult($x){
      // Temporary function used to define how a search result should
      // be formatted using RSS, passed to showpage().
      global $db;
      if ($i = $db->sql_fetchrow($GLOBALS['mSresult'])){
        return $GLOBALS['mSar'][$i['searchmodule']]->formatrss($i)."\n";}}
      $c = showpage(0, 20, 20, 'showresult', 0);
    echo $c[0]
         ."\n</channel>"
         ."\n</rss>";
    die();
    break;

  case 'search':
    include('header.php');
    global $db, $tblname, $commonwords, $module_name;
    OpenTable();
    echo '<LINK REL="alternate" TITLE="'._MSSEARCHRSS.'" HREF="modules.php?name=mSearch&op=rss&query='.urlencode(stripslashes(str_replace('"', '\\quote', $_REQUEST['query']))).'&what='.$_REQUEST['what'].'" TYPE="application/rss+xml" />
      <form method="get" action="modules.php"><table border="0"><tr valign="center">
      <td><b>'._MSSEARCH.'</b></td><td><select name="what" onchange="msput(this.form)">
      <option value="all">'._MSALL.'</option>';
    if ($handle = opendir('modules/'.$module_name.'/modules/')) {
      while (false !== ($file = readdir($handle))) {
        if (!is_dir('modules/'.$module_name.'/modules/'.$file)) {
          include_once('modules/'.$module_name.'/modules/'.$file);
           $cname = substr($file,0,-4);
          $cname2 = 'mS'.$cname;
          ${$cname} = new $cname2();
          if (${$cname}->useme()){
            echo '<option value="'.str_replace('_', ' ', $cname).'">'.$cname.'</option>'."\n";}}}
      closedir($handle);}
    echo '</select></td><td> '._MSFOR.' </td>
      <td><input type="text" name="query" value="'.htmlspecialchars(stripslashes($_REQUEST['query'])).'" /></td>
      <input type="hidden" name="name" value="'.$module_name.'" />
      <input type="hidden" name="op" value="search" />
      <td><IMG src="images/fa2.gif" align="absbottom" style="CURSOR: hand" onclick=change(query)><input type="submit" value="'._MSGO.'" /></td></tr><tr><td colspan="3">
      <div id="msopt_hide" style="display: block;">
      &nbsp;<span onclick="changeBoxSize (\'show\'); return false;">
      <a href="#">'._MSMOREOPTIONS.'</a></span></div>
      <div id="msopt_show" style="display: none;">
      <table border="0">
      <tr><td id="msopt">
       '._MSWITHINLAST.' <select name="when">
        <option value="0">'._MSANYDATE.'</option>
        <option value="'.(time() - (3 * 24 * 60 * 60)).'">'._MSTHREEDAYS.'</option>
        <option value="'.(time() - (7 * 24 * 60 * 60)).'">'._MSONEWEEK.'</option>
        <option value="'.(time() - (7 * 4 * 24 * 60 * 60)).'">'._MSONEMONTH.'</option>
        <option value="'.(time() - (6 * 7 * 4 * 24 * 60 * 60)).'">'._MSSIXMONTHS.'</option>
        <option value="'.(time() - (12 * 7 * 4 * 24 * 60 * 60)).'">'._MSONEYEAR.'</option>
        </select>
      </td></tr></table>
      <span onclick="changeBoxSize (\'hide\'); return false;">
      <a href="#">'._MSMOREOPTIONSHIDE.'</a></span>
      </div>
      </td></tr></table></form>';
    CloseTable();
    echo '<br />';
    OpenTable();
    echo '<b>'._MSRESULTS.':</b><br /><div style="padding-left:15px">';
    $GLOBALS['mSresult'] = $db->sql_query('SELECT `id`, count(`id`) as `rel`, `date`, `title`, `rid`, `desc`, `author`, `searchmodule` 
                   FROM '.$tblname.' '.($_REQUEST['when'] ? 'WHERE `date`>="'.$_REQUEST['when'].'" ' : '').' GROUP BY id ORDER BY `rel` DESC, date DESC LIMIT 99');

    function showresult($x){
      // Temporary function used to define how a search result should
      // be formatted, passed to showpage().
      global $db, $GLOBALS;
      if ($i = $db->sql_fetchrow($GLOBALS['mSresult'])){
        return '<p>'.$GLOBALS['mSar'][$i['searchmodule']]->formatresult($i).'</p>';}}

    function showpagee($il, $l){
      // Temporary function for formatting the page numbers in the 
      // bottom of the screen, passed to showpage().
      return '<a href="modules.php?name=mSearch&op=search&query='.urlencode(stripslashes(str_replace('"', '\\quote', $_REQUEST['query']))).'&what='.$_REQUEST['what'].'&start='.$il.'">'.(($il/$l)+1).'</a>';}

    $fullen = $db->sql_numrows($GLOBALS['mSresult']);
    $conf = $db->sql_fetchrow($db->sql_query('SELECT `value` FROM '.$prefix.'_msconfig 
                                              WHERE id="results-per-page" LIMIT 1'));
    $conf2 = $db->sql_fetchrow($db->sql_query('SELECT `value` FROM '.$prefix.'_msconfig 
                                               WHERE id="enable-rss" LIMIT 1'));
    if ($_REQUEST['start'] == 0){
      $_REQUEST['start'] = 0;} 
    else {
      for($i=0;$i<$_REQUEST['start'];$i++){
        $j = $db->sql_fetchrow($GLOBALS['mSresult']);}}
    if ($fullen < $conf['value']){
      $len = $fullen;} 
    else {
      $len = $conf['value'];}
    $c = showpage($_REQUEST['start'], $len, $fullen, 'showresult', 'showpagee');
    echo $c[0].'<br /><table width="100%" border="0"><tr><td>
        '.($conf2['value'] == 'on' ? '<a href="modules.php?name=mSearch&op=rss&query='.urlencode(stripslashes(str_replace('"', '\\quote', $_REQUEST['query']))).'&what='.$_REQUEST['what'].'">'._RSS.'</a>' : '').'
        </td><td align="right" width="100%">'.$c[1].'</td></tr></table></div>';
    CloseTable();
    break;

  case 'gsearch':
    include('header.php');
    global $db, $tblname, $commonwords, $module_name;
    $time = time();
    OpenTable();

    echo '<LINK REL="alternate" TITLE="'._MSSEARCHRSS.'" HREF="modules.php?name=mSearch&op=rss&query='.urlencode(stripslashes(str_replace('"', '\\quote', $_REQUEST['query']))).'&what='.$_REQUEST['what'].'" TYPE="application/rss+xml" />
      <form method="get" action="modules.php"><table border="0"><tr valign="center">
      <td><b>'._MSSEARCH.'</b></td><td><select id="what" name="what" onchange="msput(this.form)">
      <option value="all">'._MSALL.'</option>';
    if ($handle = opendir('modules/'.$module_name.'/modules/')) {
      while (false !== ($file = readdir($handle))) {
        if (!is_dir('modules/'.$module_name.'/modules/'.$file)) {
          include_once('modules/'.$module_name.'/modules/'.$file);
           $cname = substr($file,0,-4);
          $cname2 = 'mS'.$cname;
          ${$cname} = new $cname2();
          if (${$cname}->useme()){
            echo '<option value="'.str_replace('_', ' ', $cname).'">'.$cname.'</option>'."\n";}}}
      closedir($handle);}
    echo '</select></td><td> '._MSFOR.' </td>
      <td><input type="text" name="query" value="'.htmlspecialchars(stripslashes($_REQUEST['query'])).'" onkeypress="return farsikey(this,event)" onkeydown=changelang(this) /></td>
      <input type="hidden" name="name" value="'.$module_name.'" />
      <input type="hidden" name="op" value="gsearch" />
      <td><IMG src="images/fa2.gif" align="absbottom" style="CURSOR: hand" onclick=change(query)><input type="submit" value="'._MSGO.'" /></td></tr><tr><td colspan="3">
      <div id="msopt_hide" style="display: block;">
      &nbsp;<span onclick="changeBoxSize (\'show\'); return false;">
      <a href="#">'._MSMOREOPTIONS.'</a></span></div>
      <div id="msopt_show" style="display: none;">
      <table border="0">
      <tr><td id="msopt">
       '._MSWITHINLAST.' <select name="when">
        <option value="0">'._MSANYDATE.'</option>
        <option value="'.(time() - (3 * 24 * 60 * 60)).'">'._MSTHREEDAYS.'</option>
        <option value="'.(time() - (7 * 24 * 60 * 60)).'">'._MSONEWEEK.'</option>
        <option value="'.(time() - (7 * 4 * 24 * 60 * 60)).'">'._MSONEMONTH.'</option>
        <option value="'.(time() - (6 * 7 * 4 * 24 * 60 * 60)).'">'._MSSIXMONTHS.'</option>
        <option value="'.(time() - (12 * 7 * 4 * 24 * 60 * 60)).'">'._MSONEYEAR.'</option>
        </select>
      </td></tr></table>
      <span onclick="changeBoxSize (\'hide\'); return false;">
      <a href="#">'._MSMOREOPTIONSHIDE.'</a></span>
      </div>
      </td></tr></table></form>';
    CloseTable();
    echo '<br />';
    OpenTable();
    echo '<b>'._MSRESULTS.':</b><br /><div style="padding-left:15px">';
    $GLOBALS['mSresult'] = $db->sql_query('SELECT `id`, count(`id`) as `rel`, `date`, `title`, `rid`, `desc`, `author`, `searchmodule` 
                                           FROM '.$tblname.' '.($_REQUEST['when'] ? 'WHERE `date`>="'.$_REQUEST['when'].'" ' : '').' 
                                           GROUP BY id ORDER BY `searchmodule` ASC, `rel` DESC, date DESC');
    $gar = array();
    $lastgroup = '';
    while ($i = $db->sql_fetchrow($GLOBALS['mSresult'])){
      if ($i['searchmodule'] != $lastgroup){
        $lastgroup = $i['searchmodule'];
        $gar[$lastgroup] = array();
        $gar[$lastgroup]['m'] = $lastgroup;
        $gar[$lastgroup]['c'] .= '<h3 style="margin:0">'.$lastgroup.'</h3><hr style="margin:0;padding:0" width="100%"><div style="padding-left:20px;">';}
      $gar[$lastgroup]['n'] += 1;
      $gar[$lastgroup]['r'] = (float)((($gar[$lastgroup]['r'] * ($gar[$lastgroup]['n'] - 1)) + $i['rel']) / $gar[$lastgroup]['n']);
      $gar[$lastgroup]['rn'] = ($gar[$lastgroup]['r'] * 50) + $gar[$lastgroup]['n'];
      if ($gar[$lastgroup]['n'] < 4){
        $gar[$lastgroup]['c'] .= '<p'.($gar[$lastgroup]['n'] ? ' style="padding-top:0;margin-top:3px"' : '').'>'.$GLOBALS['mSar'][$i['searchmodule']]->gformatresult($i).'</p>';}}
    $gar = array_reverse(asortbyindex($gar, 'rn'));
    foreach ($gar as $val){
      echo $val['c'].($val['n'] > 3 ? '<div align="right" width="100%">
          <a href="modules.php?name='.$module_name.'&op=search&what='.$val['m'].'&query='.$_REQUEST['query'].'">'.
          $val['n'].' '._MSRESULTSLCASE.'</a></div></div>' : '</div>');}
    CloseTable();
    break;

  default:
    include('header.php');
    OpenTable();
    $conf = $db->sql_fetchrow($db->sql_query('SELECT `value` FROM '.$prefix.'_msconfig 
                  WHERE id="scope-on-front-page" LIMIT 1'));
    $conf2 = $db->sql_fetchrow($db->sql_query('SELECT `value` FROM '.$prefix.'_msconfig 
                  WHERE id="use-gsearch" LIMIT 1'));
    $str = '<select name="what">
        <option value="all">'._MSALL.'</option>';
    if ($handle = opendir('modules/'.$module_name.'/modules/')) {
      while (false !== ($file = readdir($handle))) {
        if (!is_dir('modules/'.$module_name.'/modules/'.$file)) {
          include_once('modules/'.$module_name.'/modules/'.$file);
           $cname = substr($file,0,-4);
          $cname2 = 'mS'.$cname;
          ${$cname} = new $cname2();
          if (${$cname}->useme()){
            $file = substr($file,0,-4);
            $str .= '<option value="'.str_replace('_', ' ', $file).'">'.$file.'</option>'."\n";}}}
          closedir($handle);}
    $str .= '</select> '._MSFORCOLON;
    echo '<b>'._MSSEARCH.'</b><br /><div style="padding-left:20px;vertical-align:top;">
      <form method="get" action="modules.php">
      '.($conf['value'] == 'on' ? $str : '<input type="hidden" name="what" value="all" />').'
      <input type="text" name="query" onkeypress="return farsikey(this,event)" onkeydown=changelang(this) />
      <input type="hidden" name="name" value="'.$module_name.'" />
      <input type="hidden" name="op" value="'.($conf2['value'] == 'on' ? 'g' : '').'search" />
      <input type="hidden" name="showerrors" value="1" />
	  <input type="submit" value="برو" /><br><IMG src="images/fa.gif" align="absbottom" style="CURSOR: hand" onclick=change(query)></form>';
    CloseTable();
    break;}
echo '</div>';
include('footer.php');

?>
