<?php



//Hijri Date  Functions -== Nukelearn.com

function div($a, $b)
{
   return (int) ($a / $b);
}

$hejri_error = "پارامترهای تابع تاریخ شمسی نادرست می باشد.";
$g_month_name = array("", "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
$g_month_short = array("", "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
$j_month_name = array("","فروردین","اردیبهشت","خرداد","تیر","مرداد","شهریور","مهر","آبان","آذر","دی","بهمن","اسفند");
$g_week_name = array("", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday");
$j_week_name = array("", "شنبه", "یکشنبه", "دوشنبه", "سه شنبه", "چهارشنبه", "پنجشنبه", "جمعه");
$g_days_in_month = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
$j_days_in_month = array(31, 31, 31, 31, 31, 31, 30, 30, 30, 30, 30, 29);

function gregorian_to_jalali($g_y, $g_m, $g_d)
{
   global $g_days_in_month;
   global $j_days_in_month;

   $gy = $g_y-1600;
   $gm = $g_m-1;
   $gd = $g_d-1;

   $g_day_no = 365*$gy+div($gy+3,4)-div($gy+99,100)+div($gy+399,400);

   for ($i=0; $i < $gm; ++$i)
      $g_day_no += $g_days_in_month[$i];
   if ($gm>1 && (($gy%4==0 && $gy%100!=0) || ($gy%400==0)))
      /* leap and after Feb */
      $g_day_no++;
   $g_day_no += $gd;

   $j_day_no = $g_day_no-79;

   $j_np = div($j_day_no, 12053); /* 12053 = 365*33 + 32/4 */
   $j_day_no = $j_day_no % 12053;

   $jy = 979+33*$j_np+4*div($j_day_no,1461); /* 1461 = 365*4 + 4/4 */

   $j_day_no %= 1461;

   if ($j_day_no >= 366) {
      $jy += div($j_day_no-1, 365);
      $j_day_no = ($j_day_no-1)%365;
   }

   for ($i = 0; $i < 11 && $j_day_no >= $j_days_in_month[$i]; ++$i)
      $j_day_no -= $j_days_in_month[$i];
   $jm = $i+1;
   $jd = $j_day_no+1;

   return array($jy, $jm, $jd);
}

function jalali_to_gregorian($j_y, $j_m, $j_d)
{
   global $g_days_in_month;
   global $j_days_in_month;

   $jy = $j_y-979;
   $jm = $j_m-1;
   $jd = $j_d-1;

   $j_day_no = 365*$jy + div($jy, 33)*8 + div($jy%33+3, 4);
   for ($i=0; $i < $jm; ++$i)
      $j_day_no += $j_days_in_month[$i];

   $j_day_no += $jd;

   $g_day_no = $j_day_no+79;

   $gy = 1600 + 400*div($g_day_no, 146097); /* 146097 = 365*400 + 400/4 - 400/100 + 400/400 */
   $g_day_no = $g_day_no % 146097;

   $leap = true;
   if ($g_day_no >= 36525) /* 36525 = 365*100 + 100/4 */
   {
      $g_day_no--;
      $gy += 100*div($g_day_no,  36524); /* 36524 = 365*100 + 100/4 - 100/100 */
      $g_day_no = $g_day_no % 36524;

      if ($g_day_no >= 365)
         $g_day_no++;
      else
         $leap = false;
   }

   $gy += 4*div($g_day_no, 1461); /* 1461 = 365*4 + 4/4 */
   $g_day_no %= 1461;

   if ($g_day_no >= 366) {
      $leap = false;

      $g_day_no--;
      $gy += div($g_day_no, 365);
      $g_day_no = $g_day_no % 365;
   }

   for ($i = 0; $g_day_no >= $g_days_in_month[$i] + ($i == 1 && $leap); $i++)
      $g_day_no -= $g_days_in_month[$i] + ($i == 1 && $leap);
   $gm = $i+1;
   $gd = $g_day_no+1;

   return array($gy, $gm, $gd);
}

function gregorian_week_day($g_y, $g_m, $g_d)
{
   global $g_days_in_month;

   $gy = $g_y-1600;
   $gm = $g_m-1;
   $gd = $g_d-1;

   $g_day_no = 365*$gy+div($gy+3,4)-div($gy+99,100)+div($gy+399,400);

   for ($i=0; $i < $gm; ++$i)
      $g_day_no += $g_days_in_month[$i];
   if ($gm>1 && (($gy%4==0 && $gy%100!=0) || ($gy%400==0)))
      /* leap and after Feb */
      ++$g_day_no;
   $g_day_no += $gd;

   return ($g_day_no + 5) % 7 + 1;
}

function jalali_week_day($j_y, $j_m, $j_d)
{
   global $j_days_in_month;

   $jy = $j_y-979;
   $jm = $j_m-1;
   $jd = $j_d-1;

   $j_day_no = 365*$jy + div($jy, 33)*8 + div($jy%33+3, 4);

   for ($i=0; $i < $jm; ++$i)
      $j_day_no += $j_days_in_month[$i];

   $j_day_no += $jd;

   return ($j_day_no + 2) % 7 + 1;
}


//Base convertor
function hejridate ($date = NULL, $tinput = '4', $toutput = '1') {
        global $hejri_error, $j_month_name, $j_week_name, $locale, $datetime;
        if ($date == NULL) {
           $date = getdate();
           $date = $date['year']."-".$date['mon']."-".$date['mday']." ".$date['hours'].":".$date['minutes'].":".$date['seconds'];
           setlocale (LC_TIME, "$locale");
        }
        switch ($tinput) {
           case '1':
                 $pattern = "([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})";
                 $sort = 1;
                 break;
           case '2':
                 $pattern = "([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})";
                 $sort = 2;
                 break;
           case '3':
                 $pattern = "([0-9]{1,2})-([0-9]{1,2})-([0-9]{4})";
                 $sort = 3;
                 break;
           case '4':
                 $pattern = "([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})";
                 $sort = 1;
                 break;
           case '5':
                 $pattern = "([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})";
                 $sort = 1;
                 break;
           case '6':
                 $pattern = "([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})";
                 $sort = 2;
                 break;
           case '7':
                 $pattern = "([0-9]{1,2})/([0-9]{1,2})/([0-9]{4})";
                 $sort = 3;
                 break;
           case '8':
                 $pattern = "([0-9]{4})/([0-9]{1,2})/([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})";
                 $sort = 1;
                 break;
         }
         if (ereg ($pattern, $date, $datetime)) {
           switch ($sort) {
              case '1':
                    $year = $datetime[1];
                    $month = $datetime[2];
                    $day = $datetime[3];
                    break;
              case '2':
                    $year = $datetime[1];
                    $month = $datetime[3];
                    $day = $datetime[2];
                    break;
              case '3':
                    $year = $datetime[3];
                    $month = $datetime[2];
                    $day = $datetime[1];
                    break;
           }
           $hejriDate = gregorian_to_jalali($year,$month,$day);
           if (!$datetime[4]) $datetime[4] = $datetime[5] = $datetime [6] = '00';
           $tep_hd = jalali_week_day($hejriDate[0],$hejriDate[1],$hejriDate[2]);
           switch ($toutput) {
              case '1':
                    $ehejri = $j_week_name[$tep_hd]."، ".$hejriDate[2]." ".$j_month_name[$hejriDate[1]]."، ".$hejriDate[0];
                    break;
              case '2':
                    $ehejri = $hejriDate[1]."-".$hejriDate[2]."-".$hejriDate[0];
                    break;
              case '3':
                    $ehejri = $hejriDate[0]."/".$hejriDate[1]."/".$hejriDate[2];
                    break;
              case '4':
                    $ehejri = $hejriDate[2]." ".$j_month_name[$hejriDate[1]]." ".$hejriDate[0];
                    break;
              case '5':
                    $ehejri = $j_week_name[$tep_hd]."، ".$hejriDate[2]." ".$j_month_name[$hejriDate[1]];
                    break;
              case '6':
                    $ehejri = $hejriDate[2]." ".$j_month_name[$hejriDate[1]]." ".$hejriDate[0]." @ ".$datetime[4].":".$datetime[5].":".$datetime[6];
                    break;
              case '7':
                    $ehejri = $j_week_name[$tep_hd]." ".$hejriDate[2]." ".$j_month_name[$hejriDate[1]]." ".$hejriDate[0]." ".$datetime[4].":".$datetime[5].":".$datetime[6];
                    break;
              case '8':
                    $ehejri = $hejriDate[0]."-".$hejriDate[1]."-".$hejriDate[2];
                    break;
              case '9':
                    $ehejri = $hejriDate[0]."-".$hejriDate[1]."-".$hejriDate[2]." ".$datetime[4].":".$datetime[5].":".$datetime[6];
                    break;
           }
           return $ehejri;
        } else {
           return $hejri_error;
        }
}
?>
