<?php
/**
*
* @package ucp
* @version $Id: ucp.php 8915 2008-09-23 13:30:52Z acydburn $
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

if ( !defined('MODULE_FILE') )
{
	die("You can't access this file directly...");
}

require_once("mainfile.php");
if ($mode != 'confirm')
{
	include('header.php');
};

$module_name = basename(dirname(__FILE__));
$nuke_account_path = "modules.php?name=Your_Account";
$nuke_root_path = "modules.php?name=".$module_name;
$nuke_file_path = "modules.php?name=".$module_name."&file=";
$phpbb_root_path = "modules/".$module_name."/";

define('IN_PHPBB', true);
$phpEx = substr(strrchr(__FILE__, '.'), 1);
require($phpbb_root_path . 'common.' . $phpEx);
require($phpbb_root_path . 'includes/functions_user.' . $phpEx);
require($phpbb_root_path . 'includes/functions_module.' . $phpEx);

// Basic parameter data
$id 	= request_var('i', '');
$mode	= request_var('mode', '');

if ($mode == 'login' || $mode == 'logout' || $mode == 'confirm')
{
	define('IN_LOGIN', true);
}

// Start session management
$phpBB3user->session_begin();
// ------ BEGIN - HACK: BB3NUKE -----------------
require($phpbb_root_path . 'phpBB3.' . $phpEx);
// ------ END - HACK: BB3NUKE -----------------
$auth->acl($phpBB3user->data);
$phpBB3user->setup('ucp');

// Setting a variable to let the style designer know where he is...
$template->assign_var('S_IN_UCP', true);

$module = new p_master();
$default = false;

// Basic "global" modes
switch ($mode)
{
	case 'activate':
		$module->load('ucp', 'activate');
		$module->display($phpBB3user->lang['UCP_ACTIVATE']);

//		redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
		redirect(append_sid("{$nuke_root_path}"));
	break;

	case 'resend_act':
		$module->load('ucp', 'resend');
		$module->display($phpBB3user->lang['UCP_RESEND']);
	break;

	case 'sendpassword':
		$module->load('ucp', 'remind');
		$module->display($phpBB3user->lang['UCP_REMIND']);
	break;

	case 'register':
		if ($phpBB3user->data['is_registered'] || isset($_REQUEST['not_agreed']))
		{
			echo '<SCRIPT LANGUAGE=javascript>top.location.href="'.$nuke_account_path.'&amp;op=new_user"</SCRIPT>';
		}

		$module->load('ucp', 'register');
		$module->display($phpBB3user->lang['REGISTER']);
	break;

	case 'confirm':
		$module->load('ucp', 'confirm');
	break;

	case 'login':
		if ($phpBB3user->data['is_registered'])
		{
			echo '<SCRIPT LANGUAGE=javascript>top.location.href="'.$nuke_account_path.'"</SCRIPT>';
		}

			echo '<SCRIPT LANGUAGE=javascript>top.location.href="'.$nuke_account_path.'"</SCRIPT>';
	break;

	case 'logout':
		if ($phpBB3user->data['user_id'] != ANONYMOUS && isset($_GET['sid']) && !is_array($_GET['sid']) && $_GET['sid'] === $phpBB3user->session_id)
		{
			$phpBB3user->session_kill();
			$phpBB3user->session_begin();
			$message = $phpBB3user->lang['LOGOUT_REDIRECT'];
		}
		else
		{
			$message = ($phpBB3user->data['user_id'] == ANONYMOUS) ? $phpBB3user->lang['LOGOUT_REDIRECT'] : $phpBB3user->lang['LOGOUT_FAILED'];
		}
		echo '<SCRIPT LANGUAGE=javascript>top.location.href="'.$nuke_account_path.'&op=logout"</SCRIPT>';

		$message = $message . '<br /><br />' . sprintf($phpBB3user->lang['RETURN_INDEX'], '<a href="' . append_sid("{$nuke_account_path}&amp;op=logout") . '">', '</a> ');
		trigger_error($message);

	break;

	case 'terms':
	case 'privacy':

		$message = ($mode == 'terms') ? 'TERMS_OF_USE_CONTENT' : 'PRIVACY_POLICY';
		$title = ($mode == 'terms') ? 'TERMS_USE' : 'PRIVACY';

		if (empty($phpBB3user->lang[$message]))
		{
			if ($phpBB3user->data['is_registered'])
			{
//				redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
				redirect(append_sid("{$nuke_root_path}"));
			}

			echo '<SCRIPT LANGUAGE=javascript>top.location.href="'.$nuke_account_url.'"</SCRIPT>';
		}

		$template->set_filenames(array(
			'body'		=> 'ucp_agreement.html')
		);

		// Disable online list
		page_header($phpBB3user->lang[$title], false);

		$template->assign_vars(array(
			'S_AGREEMENT'			=> true,
			'AGREEMENT_TITLE'		=> $phpBB3user->lang[$title],
			'AGREEMENT_TEXT'		=> sprintf($phpBB3user->lang[$message], $config['sitename'], generate_board_url()),
//			'U_BACK'				=> append_sid("{$phpbb_root_path}ucp.$phpEx", 'mode=login'),
			'U_BACK'				=> append_sid("{$nuke_file_path}ucp", 'mode=login'),
			'L_BACK'				=> $phpBB3user->lang['BACK_TO_LOGIN'])
		);

		page_footer();

	break;

	case 'delete_cookies':

		// Delete Cookies with dynamic names (do NOT delete poll cookies)
		if (confirm_box(true))
		{
			$set_time = time() - 31536000;

			foreach ($_COOKIE as $cookie_name => $cookie_data)
			{
				$cookie_name = str_replace($config['cookie_name'] . '_', '', $cookie_name);

				// Polls are stored as {cookie_name}_poll_{topic_id}, cookie_name_ got removed, therefore checking for poll_
				if (strpos($cookie_name, 'poll_') !== 0)
				{
					$phpBB3user->set_cookie($cookie_name, '', $set_time);
				}
			}

			$phpBB3user->set_cookie('track', '', $set_time);
			$phpBB3user->set_cookie('u', '', $set_time);
			$phpBB3user->set_cookie('k', '', $set_time);
			$phpBB3user->set_cookie('sid', '', $set_time);

			// We destroy the session here, the user will be logged out nevertheless
			$phpBB3user->session_kill();
			$phpBB3user->session_begin();

//			meta_refresh(3, append_sid("{$phpbb_root_path}index.$phpEx"));
			meta_refresh(3, append_sid("{$nuke_root_path}"));

//			$message = $phpBB3user->lang['COOKIES_DELETED'] . '<br /><br />' . sprintf($phpBB3user->lang['RETURN_INDEX'], '<a href="' . append_sid("{$phpbb_root_path}index.$phpEx") . '">', '</a>');
			$message = $phpBB3user->lang['COOKIES_DELETED'] . '<br /><br />' . sprintf($phpBB3user->lang['RETURN_INDEX'], '<a href="' . append_sid("{$nuke_root_path}") . '">', '</a>');
			trigger_error($message);
		}
		else
		{
			confirm_box(false, 'DELETE_COOKIES', '');
		}

//		redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
		redirect(append_sid("{$nuke_root_path}"));

	break;

	case 'switch_perm':

		$user_id = request_var('u', 0);

		$sql = 'SELECT *
			FROM ' . USERS_TABLE . '
			WHERE user_id = ' . (int) $user_id;
		$result = $phpBB3db->sql_query($sql);
		$user_row = $phpBB3db->sql_fetchrow($result);
		$phpBB3db->sql_freeresult($result);

		if (!$auth->acl_get('a_switchperm') || !$user_row || $user_id == $phpBB3user->data['user_id'])
		{
//			redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
			redirect(append_sid("{$nuke_root_path}"));
		}

		include($phpbb_root_path . 'includes/acp/auth.' . $phpEx);

		$auth_admin = new auth_admin();
		if (!$auth_admin->ghost_permissions($user_id, $phpBB3user->data['user_id']))
		{
//			redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
			redirect(append_sid("{$nuke_root_path}"));
		}

		add_log('admin', 'LOG_ACL_TRANSFER_PERMISSIONS', $user_row['username']);

//		$message = sprintf($phpBB3user->lang['PERMISSIONS_TRANSFERRED'], $user_row['username']) . '<br /><br />' . sprintf($phpBB3user->lang['RETURN_INDEX'], '<a href="' . append_sid("{$phpbb_root_path}index.$phpEx") . '">', '</a>');
		$message = sprintf($phpBB3user->lang['PERMISSIONS_TRANSFERRED'], $user_row['username']) . '<br /><br />' . sprintf($phpBB3user->lang['RETURN_INDEX'], '<a href="' . append_sid("{$nuke_root_path}") . '">', '</a>');
		trigger_error($message);

	break;

	case 'restore_perm':

		if (!$phpBB3user->data['user_perm_from'] || !$auth->acl_get('a_switchperm'))
		{
//			redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
			redirect(append_sid("{$nuke_root_path}"));
		}

		$auth->acl_cache($phpBB3user->data);

		$sql = 'UPDATE ' . USERS_TABLE . "
			SET user_perm_from = 0
			WHERE user_id = " . $phpBB3user->data['user_id'];
		$phpBB3db->sql_query($sql);

		$sql = 'SELECT username
			FROM ' . USERS_TABLE . '
			WHERE user_id = ' . $phpBB3user->data['user_perm_from'];
		$result = $phpBB3db->sql_query($sql);
		$username = $phpBB3db->sql_fetchfield('username');
		$phpBB3db->sql_freeresult($result);

		add_log('admin', 'LOG_ACL_RESTORE_PERMISSIONS', $username);

//		$message = $phpBB3user->lang['PERMISSIONS_RESTORED'] . '<br /><br />' . sprintf($phpBB3user->lang['RETURN_INDEX'], '<a href="' . append_sid("{$phpbb_root_path}index.$phpEx") . '">', '</a>');
		$message = $phpBB3user->lang['PERMISSIONS_RESTORED'] . '<br /><br />' . sprintf($phpBB3user->lang['RETURN_INDEX'], '<a href="' . append_sid("{$nuke_root_path}") . '">', '</a>');
		trigger_error($message);

	break;

	default:
		$default = true;
	break;
}

// We use this approach because it does not impose large code changes
if (!$default)
{
	return true;
}

// Only registered users can go beyond this point
if (!$phpBB3user->data['is_registered'])
{
	if ($phpBB3user->data['is_bot'])
	{
//		redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
		redirect(append_sid("{nuke_root_path}"));
	}

	login_box('', $phpBB3user->lang['LOGIN_EXPLAIN_UCP']);
}

// Instantiate module system and generate list of available modules
$module->list_modules('ucp');

// Check if the zebra module is set
if ($module->is_active('zebra', 'friends'))
{
	// Output listing of friends online
	$update_time = $config['load_online_time'] * 60;

	$sql = $phpBB3db->sql_build_query('SELECT_DISTINCT', array(
		'SELECT'	=> 'u.user_id, u.username, u.username_clean, u.user_colour, MAX(s.session_time) as online_time, MIN(s.session_viewonline) AS viewonline',

		'FROM'		=> array(
			USERS_TABLE		=> 'u',
			ZEBRA_TABLE		=> 'z'
		),

		'LEFT_JOIN'	=> array(
			array(
				'FROM'	=> array(SESSIONS_TABLE => 's'),
				'ON'	=> 's.session_user_id = z.zebra_id'
			)
		),

		'WHERE'		=> 'z.user_id = ' . $phpBB3user->data['user_id'] . '
			AND z.friend = 1
			AND u.user_id = z.zebra_id',

		'GROUP_BY'	=> 'z.zebra_id, u.user_id, u.username_clean, u.user_colour, u.username',

		'ORDER_BY'	=> 'u.username_clean ASC',
	));

	$result = $phpBB3db->sql_query($sql);

	while ($row = $phpBB3db->sql_fetchrow($result))
	{
		$which = (time() - $update_time < $row['online_time'] && ($row['viewonline'] || $auth->acl_get('u_viewonline'))) ? 'online' : 'offline';

		$template->assign_block_vars("friends_{$which}", array(
			'USER_ID'		=> $row['user_id'],

			'U_PROFILE'		=> get_username_string('profile', $row['user_id'], $row['username'], $row['user_colour']),
			'USER_COLOUR'	=> get_username_string('colour', $row['user_id'], $row['username'], $row['user_colour']),
			'USERNAME'		=> get_username_string('username', $row['user_id'], $row['username'], $row['user_colour']),
			'USERNAME_FULL'	=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']))
		);
	}
	$phpBB3db->sql_freeresult($result);
}

// Do not display subscribed topics/forums if not allowed
if (!$config['allow_topic_notify'] && !$config['allow_forum_notify'])
{
	$module->set_display('main', 'subscribed', false);
}

// Select the active module
$module->set_active($id, $mode);

// Load and execute the relevant module
$module->load_active();

// Assign data to the template engine for the list of modules
// $module->assign_tpl_vars(append_sid("{$phpbb_root_path}ucp.$phpEx"));
$module->assign_tpl_vars(append_sid("{$nuke_file_path}ucp"));

// Generate the page, do not display/query online list
$module->display($module->get_page_title(), false);

/**
* Function for assigning a template var if the zebra module got included
*/
function _module_zebra($mode, &$module_row)
{
	global $template;

	$template->assign_var('S_ZEBRA_ENABLED', true);

	if ($mode == 'friends')
	{
		$template->assign_var('S_ZEBRA_FRIENDS_ENABLED', true);
	}

	if ($mode == 'foes')
	{
		$template->assign_var('S_ZEBRA_FOES_ENABLED', true);
	}
}

if ($mode != 'confirm')
{
	include('footer.php');
};

?>
