
SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

SET AUTOCOMMIT=0;
START TRANSACTION;


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;




CREATE TABLE IF NOT EXISTS `nuke_authors` (
  `aid` varchar(25) COLLATE utf8_bin NOT NULL,
  `name` varchar(50) COLLATE utf8_bin DEFAULT NULL,
  `url` varchar(255) COLLATE utf8_bin NOT NULL,
  `email` varchar(255) COLLATE utf8_bin NOT NULL,
  `pwd` varchar(40) COLLATE utf8_bin DEFAULT NULL,
  `counter` int(11) NOT NULL DEFAULT '0',
  `radminsuper` tinyint(1) NOT NULL DEFAULT '1',
  `admlanguage` varchar(30) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`aid`),
  KEY `aid` (`aid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_banned_ip` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ip_address` varchar(15) COLLATE utf8_bin NOT NULL,
  `reason` varchar(255) COLLATE utf8_bin NOT NULL,
  `date` date NOT NULL DEFAULT '0000-00-00',
  PRIMARY KEY (`id`),
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_banner` (
  `bid` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `name` varchar(50) COLLATE utf8_bin NOT NULL,
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `imageurl` varchar(100) COLLATE utf8_bin NOT NULL,
  `clickurl` varchar(200) COLLATE utf8_bin NOT NULL,
  `alttext` varchar(255) COLLATE utf8_bin NOT NULL,
  `date` datetime DEFAULT NULL,
  `dateend` datetime DEFAULT NULL,
  `position` int(10) NOT NULL DEFAULT '0',
  `active` tinyint(1) NOT NULL DEFAULT '1',
  `ad_class` varchar(5) COLLATE utf8_bin NOT NULL,
  `ad_code` text COLLATE utf8_bin NOT NULL,
  `ad_width` int(4) DEFAULT '0',
  `ad_height` int(4) DEFAULT '0',
  PRIMARY KEY (`bid`),
  KEY `bid` (`bid`),
  KEY `cid` (`cid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_banner_clients` (
  `cid` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(60) COLLATE utf8_bin NOT NULL,
  `contact` varchar(60) COLLATE utf8_bin NOT NULL,
  `email` varchar(60) COLLATE utf8_bin NOT NULL,
  `login` varchar(10) COLLATE utf8_bin NOT NULL,
  `passwd` varchar(10) COLLATE utf8_bin NOT NULL,
  `extrainfo` text COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`cid`),
  KEY `cid` (`cid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_banner_plans` (
  `pid` int(10) NOT NULL AUTO_INCREMENT,
  `active` tinyint(1) NOT NULL DEFAULT '0',
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `description` text COLLATE utf8_bin NOT NULL,
  `delivery` varchar(10) COLLATE utf8_bin NOT NULL,
  `delivery_type` varchar(25) COLLATE utf8_bin NOT NULL,
  `price` varchar(25) COLLATE utf8_bin NOT NULL DEFAULT '0',
  `buy_links` text COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`pid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_banner_positions` (
  `apid` int(10) NOT NULL AUTO_INCREMENT,
  `position_number` int(5) NOT NULL DEFAULT '0',
  `position_name` varchar(255) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`apid`),
  KEY `position_number` (`position_number`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=3 ;


INSERT INTO `nuke_banner_positions` (`apid`, `position_number`, `position_name`) VALUES
(1, 0, 'Page Top'),
(2, 1, 'Left Block');



CREATE TABLE IF NOT EXISTS `nuke_banner_terms` (
  `terms_body` text COLLATE utf8_bin NOT NULL,
  `country` varchar(255) COLLATE utf8_bin NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3acl_groups` (
  `group_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `forum_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `auth_option_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `auth_role_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `auth_setting` tinyint(2) NOT NULL DEFAULT '0',
  KEY `group_id` (`group_id`),
  KEY `auth_opt_id` (`auth_option_id`),
  KEY `auth_role_id` (`auth_role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_bb3acl_groups` (`group_id`, `forum_id`, `auth_option_id`, `auth_role_id`, `auth_setting`) VALUES
(1, 0, 85, 0, 1),
(1, 0, 93, 0, 1),
(1, 0, 111, 0, 1),
(5, 0, 0, 5, 0),
(5, 0, 0, 1, 0),
(2, 0, 0, 6, 0),
(3, 0, 0, 6, 0),
(4, 0, 0, 5, 0),
(4, 0, 0, 10, 0),
(1, 1, 0, 17, 0),
(2, 1, 0, 17, 0),
(3, 1, 0, 17, 0),
(6, 1, 0, 17, 0),
(1, 2, 0, 17, 0),
(2, 2, 0, 15, 0),
(3, 2, 0, 15, 0),
(4, 2, 0, 21, 0),
(5, 2, 0, 14, 0),
(5, 2, 0, 10, 0),
(6, 2, 0, 19, 0);



CREATE TABLE IF NOT EXISTS `nuke_bb3acl_options` (
  `auth_option_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `auth_option` varchar(50) COLLATE utf8_bin NOT NULL DEFAULT '',
  `is_global` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `is_local` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `founder_only` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`auth_option_id`),
  UNIQUE KEY `auth_option` (`auth_option`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=118 ;


INSERT INTO `nuke_bb3acl_options` (`auth_option_id`, `auth_option`, `is_global`, `is_local`, `founder_only`) VALUES
(1, 'f_', 0, 1, 0),
(2, 'f_announce', 0, 1, 0),
(3, 'f_attach', 0, 1, 0),
(4, 'f_bbcode', 0, 1, 0),
(5, 'f_bump', 0, 1, 0),
(6, 'f_delete', 0, 1, 0),
(7, 'f_download', 0, 1, 0),
(8, 'f_edit', 0, 1, 0),
(9, 'f_email', 0, 1, 0),
(10, 'f_flash', 0, 1, 0),
(11, 'f_icons', 0, 1, 0),
(12, 'f_ignoreflood', 0, 1, 0),
(13, 'f_img', 0, 1, 0),
(14, 'f_list', 0, 1, 0),
(15, 'f_noapprove', 0, 1, 0),
(16, 'f_poll', 0, 1, 0),
(17, 'f_post', 0, 1, 0),
(18, 'f_postcount', 0, 1, 0),
(19, 'f_print', 0, 1, 0),
(20, 'f_read', 0, 1, 0),
(21, 'f_reply', 0, 1, 0),
(22, 'f_report', 0, 1, 0),
(23, 'f_search', 0, 1, 0),
(24, 'f_sigs', 0, 1, 0),
(25, 'f_smilies', 0, 1, 0),
(26, 'f_sticky', 0, 1, 0),
(27, 'f_subscribe', 0, 1, 0),
(28, 'f_user_lock', 0, 1, 0),
(29, 'f_vote', 0, 1, 0),
(30, 'f_votechg', 0, 1, 0),
(31, 'm_', 1, 1, 0),
(32, 'm_approve', 1, 1, 0),
(33, 'm_chgposter', 1, 1, 0),
(34, 'm_delete', 1, 1, 0),
(35, 'm_edit', 1, 1, 0),
(36, 'm_info', 1, 1, 0),
(37, 'm_lock', 1, 1, 0),
(38, 'm_merge', 1, 1, 0),
(39, 'm_move', 1, 1, 0),
(40, 'm_report', 1, 1, 0),
(41, 'm_split', 1, 1, 0),
(42, 'm_ban', 1, 0, 0),
(43, 'm_warn', 1, 0, 0),
(44, 'a_', 1, 0, 0),
(45, 'a_aauth', 1, 0, 0),
(46, 'a_attach', 1, 0, 0),
(47, 'a_authgroups', 1, 0, 0),
(48, 'a_authusers', 1, 0, 0),
(49, 'a_backup', 1, 0, 0),
(50, 'a_ban', 1, 0, 0),
(51, 'a_bbcode', 1, 0, 0),
(52, 'a_board', 1, 0, 0),
(53, 'a_bots', 1, 0, 0),
(54, 'a_clearlogs', 1, 0, 0),
(55, 'a_email', 1, 0, 0),
(56, 'a_fauth', 1, 0, 0),
(57, 'a_forum', 1, 0, 0),
(58, 'a_forumadd', 1, 0, 0),
(59, 'a_forumdel', 1, 0, 0),
(60, 'a_group', 1, 0, 0),
(61, 'a_groupadd', 1, 0, 0),
(62, 'a_groupdel', 1, 0, 0),
(63, 'a_icons', 1, 0, 0),
(64, 'a_jabber', 1, 0, 0),
(65, 'a_language', 1, 0, 0),
(66, 'a_mauth', 1, 0, 0),
(67, 'a_modules', 1, 0, 0),
(68, 'a_names', 1, 0, 0),
(69, 'a_phpinfo', 1, 0, 0),
(70, 'a_profile', 1, 0, 0),
(71, 'a_prune', 1, 0, 0),
(72, 'a_ranks', 1, 0, 0),
(73, 'a_reasons', 1, 0, 0),
(74, 'a_roles', 1, 0, 0),
(75, 'a_search', 1, 0, 0),
(76, 'a_server', 1, 0, 0),
(77, 'a_styles', 1, 0, 0),
(78, 'a_switchperm', 1, 0, 0),
(79, 'a_uauth', 1, 0, 0),
(80, 'a_user', 1, 0, 0),
(81, 'a_userdel', 1, 0, 0),
(82, 'a_viewauth', 1, 0, 0),
(83, 'a_viewlogs', 1, 0, 0),
(84, 'a_words', 1, 0, 0),
(85, 'u_', 1, 0, 0),
(86, 'u_attach', 1, 0, 0),
(87, 'u_chgavatar', 1, 0, 0),
(88, 'u_chgcensors', 1, 0, 0),
(89, 'u_chgemail', 1, 0, 0),
(90, 'u_chggrp', 1, 0, 0),
(91, 'u_chgname', 1, 0, 0),
(92, 'u_chgpasswd', 1, 0, 0),
(93, 'u_download', 1, 0, 0),
(94, 'u_hideonline', 1, 0, 0),
(95, 'u_ignoreflood', 1, 0, 0),
(96, 'u_masspm', 1, 0, 0),
(97, 'u_masspm_group', 1, 0, 0),
(98, 'u_pm_attach', 1, 0, 0),
(99, 'u_pm_bbcode', 1, 0, 0),
(100, 'u_pm_delete', 1, 0, 0),
(101, 'u_pm_download', 1, 0, 0),
(102, 'u_pm_edit', 1, 0, 0),
(103, 'u_pm_emailpm', 1, 0, 0),
(104, 'u_pm_flash', 1, 0, 0),
(105, 'u_pm_forward', 1, 0, 0),
(106, 'u_pm_img', 1, 0, 0),
(107, 'u_pm_printpm', 1, 0, 0),
(108, 'u_pm_smilies', 1, 0, 0),
(109, 'u_readpm', 1, 0, 0),
(110, 'u_savedrafts', 1, 0, 0),
(111, 'u_search', 1, 0, 0),
(112, 'u_sendemail', 1, 0, 0),
(113, 'u_sendim', 1, 0, 0),
(114, 'u_sendpm', 1, 0, 0),
(115, 'u_sig', 1, 0, 0),
(116, 'u_viewonline', 1, 0, 0),
(117, 'u_viewprofile', 1, 0, 0);



CREATE TABLE IF NOT EXISTS `nuke_bb3acl_roles` (
  `role_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `role_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `role_description` text COLLATE utf8_bin NOT NULL,
  `role_type` varchar(10) COLLATE utf8_bin NOT NULL DEFAULT '',
  `role_order` smallint(4) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`role_id`),
  KEY `role_type` (`role_type`),
  KEY `role_order` (`role_order`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=23 ;


INSERT INTO `nuke_bb3acl_roles` (`role_id`, `role_name`, `role_description`, `role_type`, `role_order`) VALUES
(1, 'ROLE_ADMIN_STANDARD', 'ROLE_DESCRIPTION_ADMIN_STANDARD', 'a_', 1),
(2, 'ROLE_ADMIN_FORUM', 'ROLE_DESCRIPTION_ADMIN_FORUM', 'a_', 3),
(3, 'ROLE_ADMIN_USERGROUP', 'ROLE_DESCRIPTION_ADMIN_USERGROUP', 'a_', 4),
(4, 'ROLE_ADMIN_FULL', 'ROLE_DESCRIPTION_ADMIN_FULL', 'a_', 2),
(5, 'ROLE_USER_FULL', 'ROLE_DESCRIPTION_USER_FULL', 'u_', 3),
(6, 'ROLE_USER_STANDARD', 'ROLE_DESCRIPTION_USER_STANDARD', 'u_', 1),
(7, 'ROLE_USER_LIMITED', 'ROLE_DESCRIPTION_USER_LIMITED', 'u_', 2),
(8, 'ROLE_USER_NOPM', 'ROLE_DESCRIPTION_USER_NOPM', 'u_', 4),
(9, 'ROLE_USER_NOAVATAR', 'ROLE_DESCRIPTION_USER_NOAVATAR', 'u_', 5),
(10, 'ROLE_MOD_FULL', 'ROLE_DESCRIPTION_MOD_FULL', 'm_', 3),
(11, 'ROLE_MOD_STANDARD', 'ROLE_DESCRIPTION_MOD_STANDARD', 'm_', 1),
(12, 'ROLE_MOD_SIMPLE', 'ROLE_DESCRIPTION_MOD_SIMPLE', 'm_', 2),
(13, 'ROLE_MOD_QUEUE', 'ROLE_DESCRIPTION_MOD_QUEUE', 'm_', 4),
(14, 'ROLE_FORUM_FULL', 'ROLE_DESCRIPTION_FORUM_FULL', 'f_', 7),
(15, 'ROLE_FORUM_STANDARD', 'ROLE_DESCRIPTION_FORUM_STANDARD', 'f_', 5),
(16, 'ROLE_FORUM_NOACCESS', 'ROLE_DESCRIPTION_FORUM_NOACCESS', 'f_', 1),
(17, 'ROLE_FORUM_READONLY', 'ROLE_DESCRIPTION_FORUM_READONLY', 'f_', 2),
(18, 'ROLE_FORUM_LIMITED', 'ROLE_DESCRIPTION_FORUM_LIMITED', 'f_', 3),
(19, 'ROLE_FORUM_BOT', 'ROLE_DESCRIPTION_FORUM_BOT', 'f_', 9),
(20, 'ROLE_FORUM_ONQUEUE', 'ROLE_DESCRIPTION_FORUM_ONQUEUE', 'f_', 8),
(21, 'ROLE_FORUM_POLLS', 'ROLE_DESCRIPTION_FORUM_POLLS', 'f_', 6),
(22, 'ROLE_FORUM_LIMITED_POLLS', 'ROLE_DESCRIPTION_FORUM_LIMITED_POLLS', 'f_', 4);



CREATE TABLE IF NOT EXISTS `nuke_bb3acl_roles_data` (
  `role_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `auth_option_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `auth_setting` tinyint(2) NOT NULL DEFAULT '0',
  PRIMARY KEY (`role_id`,`auth_option_id`),
  KEY `ath_op_id` (`auth_option_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_bb3acl_roles_data` (`role_id`, `auth_option_id`, `auth_setting`) VALUES
(1, 44, 1),
(1, 46, 1),
(1, 47, 1),
(1, 48, 1),
(1, 50, 1),
(1, 51, 1),
(1, 52, 1),
(1, 56, 1),
(1, 57, 1),
(1, 58, 1),
(1, 59, 1),
(1, 60, 1),
(1, 61, 1),
(1, 62, 1),
(1, 63, 1),
(1, 66, 1),
(1, 68, 1),
(1, 70, 1),
(1, 71, 1),
(1, 72, 1),
(1, 73, 1),
(1, 79, 1),
(1, 80, 1),
(1, 81, 1),
(1, 82, 1),
(1, 83, 1),
(1, 84, 1),
(2, 44, 1),
(2, 47, 1),
(2, 48, 1),
(2, 56, 1),
(2, 57, 1),
(2, 58, 1),
(2, 59, 1),
(2, 66, 1),
(2, 71, 1),
(2, 79, 1),
(2, 82, 1),
(2, 83, 1),
(3, 44, 1),
(3, 47, 1),
(3, 48, 1),
(3, 50, 1),
(3, 60, 1),
(3, 61, 1),
(3, 62, 1),
(3, 72, 1),
(3, 79, 1),
(3, 80, 1),
(3, 82, 1),
(3, 83, 1),
(4, 44, 1),
(4, 45, 1),
(4, 46, 1),
(4, 47, 1),
(4, 48, 1),
(4, 49, 1),
(4, 50, 1),
(4, 51, 1),
(4, 52, 1),
(4, 53, 1),
(4, 54, 1),
(4, 55, 1),
(4, 56, 1),
(4, 57, 1),
(4, 58, 1),
(4, 59, 1),
(4, 60, 1),
(4, 61, 1),
(4, 62, 1),
(4, 63, 1),
(4, 64, 1),
(4, 65, 1),
(4, 66, 1),
(4, 67, 1),
(4, 68, 1),
(4, 69, 1),
(4, 70, 1),
(4, 71, 1),
(4, 72, 1),
(4, 73, 1),
(4, 74, 1),
(4, 75, 1),
(4, 76, 1),
(4, 77, 1),
(4, 78, 1),
(4, 79, 1),
(4, 80, 1),
(4, 81, 1),
(4, 82, 1),
(4, 83, 1),
(4, 84, 1),
(5, 85, 1),
(5, 86, 1),
(5, 87, 1),
(5, 88, 1),
(5, 89, 1),
(5, 90, 1),
(5, 91, 1),
(5, 92, 1),
(5, 93, 1),
(5, 94, 1),
(5, 95, 1),
(5, 96, 1),
(5, 97, 1),
(5, 98, 1),
(5, 99, 1),
(5, 100, 1),
(5, 101, 1),
(5, 102, 1),
(5, 103, 1),
(5, 104, 1),
(5, 105, 1),
(5, 106, 1),
(5, 107, 1),
(5, 108, 1),
(5, 109, 1),
(5, 110, 1),
(5, 111, 1),
(5, 112, 1),
(5, 113, 1),
(5, 114, 1),
(5, 115, 1),
(5, 116, 1),
(5, 117, 1),
(6, 85, 1),
(6, 86, 1),
(6, 87, 1),
(6, 88, 1),
(6, 89, 1),
(6, 92, 1),
(6, 93, 1),
(6, 94, 1),
(6, 96, 1),
(6, 97, 1),
(6, 98, 1),
(6, 99, 1),
(6, 100, 1),
(6, 101, 1),
(6, 102, 1),
(6, 103, 1),
(6, 106, 1),
(6, 107, 1),
(6, 108, 1),
(6, 109, 1),
(6, 110, 1),
(6, 111, 1),
(6, 112, 1),
(6, 113, 1),
(6, 114, 1),
(6, 115, 1),
(6, 117, 1),
(7, 85, 1),
(7, 87, 1),
(7, 88, 1),
(7, 89, 1),
(7, 92, 1),
(7, 93, 1),
(7, 94, 1),
(7, 99, 1),
(7, 100, 1),
(7, 101, 1),
(7, 102, 1),
(7, 105, 1),
(7, 106, 1),
(7, 107, 1),
(7, 108, 1),
(7, 109, 1),
(7, 114, 1),
(7, 115, 1),
(7, 117, 1),
(8, 85, 1),
(8, 87, 1),
(8, 88, 1),
(8, 89, 1),
(8, 92, 1),
(8, 93, 1),
(8, 94, 1),
(8, 96, 0),
(8, 97, 0),
(8, 109, 0),
(8, 114, 0),
(8, 115, 1),
(8, 117, 1),
(9, 85, 1),
(9, 87, 0),
(9, 88, 1),
(9, 89, 1),
(9, 92, 1),
(9, 93, 1),
(9, 94, 1),
(9, 96, 0),
(9, 97, 0),
(9, 99, 1),
(9, 100, 1),
(9, 101, 1),
(9, 102, 1),
(9, 105, 1),
(9, 106, 1),
(9, 107, 1),
(9, 108, 1),
(9, 109, 1),
(9, 114, 1),
(9, 115, 1),
(9, 117, 1),
(10, 31, 1),
(10, 32, 1),
(10, 33, 1),
(10, 34, 1),
(10, 35, 1),
(10, 36, 1),
(10, 37, 1),
(10, 38, 1),
(10, 39, 1),
(10, 40, 1),
(10, 41, 1),
(10, 42, 1),
(10, 43, 1),
(11, 31, 1),
(11, 32, 1),
(11, 34, 1),
(11, 35, 1),
(11, 36, 1),
(11, 37, 1),
(11, 38, 1),
(11, 39, 1),
(11, 40, 1),
(11, 41, 1),
(11, 43, 1),
(12, 31, 1),
(12, 34, 1),
(12, 35, 1),
(12, 36, 1),
(12, 40, 1),
(13, 31, 1),
(13, 32, 1),
(13, 35, 1),
(14, 1, 1),
(14, 2, 1),
(14, 3, 1),
(14, 4, 1),
(14, 5, 1),
(14, 6, 1),
(14, 7, 1),
(14, 8, 1),
(14, 9, 1),
(14, 10, 1),
(14, 11, 1),
(14, 12, 1),
(14, 13, 1),
(14, 14, 1),
(14, 15, 1),
(14, 16, 1),
(14, 17, 1),
(14, 18, 1),
(14, 19, 1),
(14, 20, 1),
(14, 21, 1),
(14, 22, 1),
(14, 23, 1),
(14, 24, 1),
(14, 25, 1),
(14, 26, 1),
(14, 27, 1),
(14, 28, 1),
(14, 29, 1),
(14, 30, 1),
(15, 1, 1),
(15, 3, 1),
(15, 4, 1),
(15, 5, 1),
(15, 6, 1),
(15, 7, 1),
(15, 8, 1),
(15, 9, 1),
(15, 11, 1),
(15, 13, 1),
(15, 14, 1),
(15, 15, 1),
(15, 17, 1),
(15, 18, 1),
(15, 19, 1),
(15, 20, 1),
(15, 21, 1),
(15, 22, 1),
(15, 23, 1),
(15, 24, 1),
(15, 25, 1),
(15, 27, 1),
(15, 29, 1),
(15, 30, 1),
(16, 1, 0),
(17, 1, 1),
(17, 7, 1),
(17, 14, 1),
(17, 19, 1),
(17, 20, 1),
(17, 23, 1),
(17, 27, 1),
(18, 1, 1),
(18, 4, 1),
(18, 7, 1),
(18, 8, 1),
(18, 9, 1),
(18, 13, 1),
(18, 14, 1),
(18, 15, 1),
(18, 17, 1),
(18, 18, 1),
(18, 19, 1),
(18, 20, 1),
(18, 21, 1),
(18, 22, 1),
(18, 23, 1),
(18, 24, 1),
(18, 25, 1),
(18, 27, 1),
(18, 29, 1),
(19, 1, 1),
(19, 7, 1),
(19, 14, 1),
(19, 19, 1),
(19, 20, 1),
(20, 1, 1),
(20, 3, 1),
(20, 4, 1),
(20, 7, 1),
(20, 8, 1),
(20, 9, 1),
(20, 13, 1),
(20, 14, 1),
(20, 15, 0),
(20, 17, 1),
(20, 18, 1),
(20, 19, 1),
(20, 20, 1),
(20, 21, 1),
(20, 22, 1),
(20, 23, 1),
(20, 24, 1),
(20, 25, 1),
(20, 27, 1),
(20, 29, 1),
(21, 1, 1),
(21, 3, 1),
(21, 4, 1),
(21, 5, 1),
(21, 6, 1),
(21, 7, 1),
(21, 8, 1),
(21, 9, 1),
(21, 11, 1),
(21, 13, 1),
(21, 14, 1),
(21, 15, 1),
(21, 16, 1),
(21, 17, 1),
(21, 18, 1),
(21, 19, 1),
(21, 20, 1),
(21, 21, 1),
(21, 22, 1),
(21, 23, 1),
(21, 24, 1),
(21, 25, 1),
(21, 27, 1),
(21, 29, 1),
(21, 30, 1),
(22, 1, 1),
(22, 4, 1),
(22, 7, 1),
(22, 8, 1),
(22, 9, 1),
(22, 13, 1),
(22, 14, 1),
(22, 15, 1),
(22, 16, 1),
(22, 17, 1),
(22, 18, 1),
(22, 19, 1),
(22, 20, 1),
(22, 21, 1),
(22, 22, 1),
(22, 23, 1),
(22, 24, 1),
(22, 25, 1),
(22, 27, 1),
(22, 29, 1);



CREATE TABLE IF NOT EXISTS `nuke_bb3acl_users` (
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `forum_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `auth_option_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `auth_role_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `auth_setting` tinyint(2) NOT NULL DEFAULT '0',
  KEY `user_id` (`user_id`),
  KEY `auth_option_id` (`auth_option_id`),
  KEY `auth_role_id` (`auth_role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_bb3acl_users` (`user_id`, `forum_id`, `auth_option_id`, `auth_role_id`, `auth_setting`) VALUES
(2, 0, 0, 5, 0);



CREATE TABLE IF NOT EXISTS `nuke_bb3attachments` (
  `attach_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `post_msg_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `topic_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `in_message` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `poster_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `is_orphan` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `physical_filename` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `real_filename` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `download_count` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `attach_comment` text COLLATE utf8_bin NOT NULL,
  `extension` varchar(100) COLLATE utf8_bin NOT NULL DEFAULT '',
  `mimetype` varchar(100) COLLATE utf8_bin NOT NULL DEFAULT '',
  `filesize` int(20) unsigned NOT NULL DEFAULT '0',
  `filetime` int(11) unsigned NOT NULL DEFAULT '0',
  `thumbnail` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`attach_id`),
  KEY `filetime` (`filetime`),
  KEY `post_msg_id` (`post_msg_id`),
  KEY `topic_id` (`topic_id`),
  KEY `poster_id` (`poster_id`),
  KEY `is_orphan` (`is_orphan`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_bb3banlist` (
  `ban_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `ban_userid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `ban_ip` varchar(40) COLLATE utf8_bin NOT NULL DEFAULT '',
  `ban_email` varchar(100) COLLATE utf8_bin NOT NULL DEFAULT '',
  `ban_start` int(11) unsigned NOT NULL DEFAULT '0',
  `ban_end` int(11) unsigned NOT NULL DEFAULT '0',
  `ban_exclude` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ban_reason` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `ban_give_reason` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  PRIMARY KEY (`ban_id`),
  KEY `ban_end` (`ban_end`),
  KEY `ban_user` (`ban_userid`,`ban_exclude`),
  KEY `ban_email` (`ban_email`,`ban_exclude`),
  KEY `ban_ip` (`ban_ip`,`ban_exclude`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_bb3bbcodes` (
  `bbcode_id` tinyint(3) NOT NULL DEFAULT '0',
  `bbcode_tag` varchar(16) COLLATE utf8_bin NOT NULL DEFAULT '',
  `bbcode_helpline` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `display_on_posting` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `bbcode_match` text COLLATE utf8_bin NOT NULL,
  `bbcode_tpl` mediumtext COLLATE utf8_bin NOT NULL,
  `first_pass_match` mediumtext COLLATE utf8_bin NOT NULL,
  `first_pass_replace` mediumtext COLLATE utf8_bin NOT NULL,
  `second_pass_match` mediumtext COLLATE utf8_bin NOT NULL,
  `second_pass_replace` mediumtext COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`bbcode_id`),
  KEY `display_on_post` (`display_on_posting`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3bookmarks` (
  `topic_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`topic_id`,`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3bots` (
  `bot_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `bot_active` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `bot_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `bot_agent` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `bot_ip` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  PRIMARY KEY (`bot_id`),
  KEY `bot_active` (`bot_active`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=51 ;


INSERT INTO `nuke_bb3bots` (`bot_id`, `bot_active`, `bot_name`, `user_id`, `bot_agent`, `bot_ip`) VALUES
(1, 1, 'AdsBot [Google]', 3, 'AdsBot-Google', ''),
(2, 1, 'Alexa [Bot]', 4, 'ia_archiver', ''),
(3, 1, 'Alta Vista [Bot]', 5, 'Scooter/', ''),
(4, 1, 'Ask Jeeves [Bot]', 6, 'Ask Jeeves', ''),
(5, 1, 'Baidu [Spider]', 7, 'Baiduspider+(', ''),
(6, 1, 'Exabot [Bot]', 8, 'Exabot/', ''),
(7, 1, 'FAST Enterprise [Crawler]', 9, 'FAST Enterprise Crawler', ''),
(8, 1, 'FAST WebCrawler [Crawler]', 10, 'FAST-WebCrawler/', ''),
(9, 1, 'Francis [Bot]', 11, 'http://www.neomo.de/', ''),
(10, 1, 'Gigabot [Bot]', 12, 'Gigabot/', ''),
(11, 1, 'Google Adsense [Bot]', 13, 'Mediapartners-Google', ''),
(12, 1, 'Google Desktop', 14, 'Google Desktop', ''),
(13, 1, 'Google Feedfetcher', 15, 'Feedfetcher-Google', ''),
(14, 1, 'Google [Bot]', 16, 'Googlebot', ''),
(15, 1, 'Heise IT-Markt [Crawler]', 17, 'heise-IT-Markt-Crawler', ''),
(16, 1, 'Heritrix [Crawler]', 18, 'heritrix/1.', ''),
(17, 1, 'IBM Research [Bot]', 19, 'ibm.com/cs/crawler', ''),
(18, 1, 'ICCrawler - ICjobs', 20, 'ICCrawler - ICjobs', ''),
(19, 1, 'ichiro [Crawler]', 21, 'ichiro/', ''),
(20, 1, 'Majestic-12 [Bot]', 22, 'MJ12bot/', ''),
(21, 1, 'Metager [Bot]', 23, 'MetagerBot/', ''),
(22, 1, 'MSN NewsBlogs', 24, 'msnbot-NewsBlogs/', ''),
(23, 1, 'MSN [Bot]', 25, 'msnbot/', ''),
(24, 1, 'MSNbot Media', 26, 'msnbot-media/', ''),
(25, 1, 'NG-Search [Bot]', 27, 'NG-Search/', ''),
(26, 1, 'Nutch [Bot]', 28, 'http://lucene.apache.org/nutch/', ''),
(27, 1, 'Nutch/CVS [Bot]', 29, 'NutchCVS/', ''),
(28, 1, 'OmniExplorer [Bot]', 30, 'OmniExplorer_Bot/', ''),
(29, 1, 'Online link [Validator]', 31, 'online link validator', ''),
(30, 1, 'psbot [Picsearch]', 32, 'psbot/0', ''),
(31, 1, 'Seekport [Bot]', 33, 'Seekbot/', ''),
(32, 1, 'Sensis [Crawler]', 34, 'Sensis Web Crawler', ''),
(33, 1, 'SEO Crawler', 35, 'SEO search Crawler/', ''),
(34, 1, 'Seoma [Crawler]', 36, 'Seoma [SEO Crawler]', ''),
(35, 1, 'SEOSearch [Crawler]', 37, 'SEOsearch/', ''),
(36, 1, 'Snappy [Bot]', 38, 'Snappy/1.1 ( http://www.urltrends.com/ )', ''),
(37, 1, 'Steeler [Crawler]', 39, 'http://www.tkl.iis.u-tokyo.ac.jp/~crawler/', ''),
(38, 1, 'Synoo [Bot]', 40, 'SynooBot/', ''),
(39, 1, 'Telekom [Bot]', 41, 'crawleradmin.t-info@telekom.de', ''),
(40, 1, 'TurnitinBot [Bot]', 42, 'TurnitinBot/', ''),
(41, 1, 'Voyager [Bot]', 43, 'voyager/1.0', ''),
(42, 1, 'W3 [Sitesearch]', 44, 'W3 SiteSearch Crawler', ''),
(43, 1, 'W3C [Linkcheck]', 45, 'W3C-checklink/', ''),
(44, 1, 'W3C [Validator]', 46, 'W3C_*Validator', ''),
(45, 1, 'WiseNut [Bot]', 47, 'http://www.WISEnutbot.com', ''),
(46, 1, 'YaCy [Bot]', 48, 'yacybot', ''),
(47, 1, 'Yahoo MMCrawler [Bot]', 49, 'Yahoo-MMCrawler/', ''),
(48, 1, 'Yahoo Slurp [Bot]', 50, 'Yahoo! DE Slurp', ''),
(49, 1, 'Yahoo [Bot]', 51, 'Yahoo! Slurp', ''),
(50, 1, 'YahooSeeker [Bot]', 52, 'YahooSeeker/', '');



CREATE TABLE IF NOT EXISTS `nuke_bb3config` (
  `config_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `config_value` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `is_dynamic` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`config_name`),
  KEY `is_dynamic` (`is_dynamic`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_bb3config` (`config_name`, `config_value`, `is_dynamic`) VALUES
('active_sessions', '0', 0),
('allow_attachments', '1', 0),
('allow_autologin', '1', 0),
('allow_avatar_local', '0', 0),
('allow_avatar_remote', '0', 0),
('allow_avatar_upload', '0', 0),
('allow_bbcode', '1', 0),
('allow_birthdays', '1', 0),
('allow_bookmarks', '1', 0),
('allow_emailreuse', '0', 0),
('allow_forum_notify', '1', 0),
('allow_mass_pm', '1', 0),
('allow_name_chars', 'USERNAME_CHARS_ANY', 0),
('allow_namechange', '0', 0),
('allow_nocensors', '0', 0),
('allow_pm_attach', '0', 0),
('allow_post_flash', '1', 0),
('allow_post_links', '1', 0),
('allow_privmsg', '1', 0),
('allow_sig', '1', 0),
('allow_sig_bbcode', '1', 0),
('allow_sig_flash', '0', 0),
('allow_sig_img', '1', 0),
('allow_sig_links', '1', 0),
('allow_sig_pm', '1', 0),
('allow_sig_smilies', '1', 0),
('allow_smilies', '1', 0),
('allow_topic_notify', '1', 0),
('attachment_quota', '52428800', 0),
('auth_bbcode_pm', '1', 0),
('auth_flash_pm', '0', 0),
('auth_img_pm', '1', 0),
('auth_method', 'db', 0),
('auth_smilies_pm', '1', 0),
('avatar_filesize', '6144', 0),
('avatar_gallery_path', 'images/avatars/gallery', 0),
('avatar_max_height', '90', 0),
('avatar_max_width', '90', 0),
('avatar_min_height', '20', 0),
('avatar_min_width', '20', 0),
('avatar_path', 'images/avatars/upload', 0),
('avatar_salt', '16e7acb2f7727c2b0cb1d1d352746fd1', 0),
('board_contact', 'aneeshtan@gmail.com', 0),
('board_disable', '0', 0),
('board_disable_msg', '', 0),
('board_dst', '1', 0),
('board_email', 'aneeshtan@gmail.com', 0),
('board_email_form', '0', 0),
('board_email_sig', 'Thanks, The Management', 0),
('board_hide_emails', '1', 0),
('board_startdate', '1249992268', 0),
('board_timezone', '0', 0),
('browser_check', '1', 0),
('bump_interval', '10', 0),
('bump_type', 'd', 0),
('cache_gc', '7200', 0),
('cache_last_gc', '1260368922', 1),
('captcha_gd', '1', 0),
('captcha_gd_3d_noise', '1', 0),
('captcha_gd_fonts', '1', 0),
('captcha_gd_foreground_noise', '0', 0),
('captcha_gd_wave', '0', 0),
('captcha_gd_x_grid', '25', 0),
('captcha_gd_y_grid', '25', 0),
('check_attachment_content', '1', 0),
('check_dnsbl', '0', 0),
('chg_passforce', '0', 0),
('confirm_refresh', '1', 0),
('cookie_domain', 'localhost', 0),
('cookie_name', 'phpbb3_1f4h9', 0),
('cookie_path', '/', 0),
('cookie_secure', '0', 0),
('coppa_enable', '0', 0),
('coppa_fax', '', 0),
('coppa_mail', '', 0),
('cron_lock', '0', 1),
('database_gc', '604800', 0),
('database_last_gc', '1260051778', 1),
('dbms_version', '5.1.30-community', 0),
('default_dateformat', 'D M d, Y g:i a', 0),
('default_lang', 'persian', 0),
('default_style', '1', 0),
('display_last_edited', '1', 0),
('display_order', '0', 0),
('edit_time', '0', 0),
('email_check_mx', '1', 0),
('email_enable', '1', 0),
('email_function_name', 'mail', 0),
('email_package_size', '50', 0),
('enable_confirm', '1', 0),
('enable_pm_icons', '1', 0),
('enable_post_confirm', '1', 0),
('enable_queue_trigger', '0', 0),
('flood_interval', '15', 0),
('force_server_vars', '0', 0),
('form_token_lifetime', '7200', 0),
('form_token_mintime', '0', 0),
('form_token_sid_guests', '1', 0),
('forward_pm', '1', 0),
('forwarded_for_check', '0', 0),
('full_folder_action', '2', 0),
('fulltext_mysql_max_word_len', '254', 0),
('fulltext_mysql_min_word_len', '4', 0),
('fulltext_native_common_thres', '5', 0),
('fulltext_native_load_upd', '1', 0),
('fulltext_native_max_chars', '14', 0),
('fulltext_native_min_chars', '3', 0),
('gzip_compress', '0', 0),
('hot_threshold', '25', 0),
('icons_path', 'images/icons', 0),
('img_create_thumbnail', '0', 0),
('img_display_inlined', '1', 0),
('img_imagick', '', 0),
('img_link_height', '0', 0),
('img_link_width', '0', 0),
('img_max_height', '0', 0),
('img_max_thumb_width', '400', 0),
('img_max_width', '0', 0),
('img_min_thumb_filesize', '12000', 0),
('ip_check', '3', 0),
('jab_enable', '0', 0),
('jab_host', '', 0),
('jab_package_size', '20', 0),
('jab_password', '', 0),
('jab_port', '5222', 0),
('jab_use_ssl', '0', 0),
('jab_username', '', 0),
('last_queue_run', '0', 1),
('ldap_base_dn', '', 0),
('ldap_email', '', 0),
('ldap_password', '', 0),
('ldap_port', '', 0),
('ldap_server', '', 0),
('ldap_uid', '', 0),
('ldap_user', '', 0),
('ldap_user_filter', '', 0),
('limit_load', '0', 0),
('limit_search_load', '0', 0),
('load_anon_lastread', '0', 0),
('load_birthdays', '1', 0),
('load_cpf_memberlist', '0', 0),
('load_cpf_viewprofile', '1', 0),
('load_cpf_viewtopic', '0', 0),
('load_db_lastread', '1', 0),
('load_db_track', '1', 0),
('load_jumpbox', '1', 0),
('load_moderators', '1', 0),
('load_online', '1', 0),
('load_online_guests', '1', 0),
('load_online_time', '5', 0),
('load_onlinetrack', '1', 0),
('load_search', '1', 0),
('load_tplcompile', '0', 0),
('load_user_activity', '1', 0),
('max_attachments', '3', 0),
('max_attachments_pm', '1', 0),
('max_autologin_time', '0', 0),
('max_filesize', '262144', 0),
('max_filesize_pm', '262144', 0),
('max_login_attempts', '3', 0),
('max_name_chars', '20', 0),
('max_num_search_keywords', '10', 0),
('max_pass_chars', '30', 0),
('max_poll_options', '10', 0),
('max_post_chars', '60000', 0),
('max_post_font_size', '200', 0),
('max_post_img_height', '0', 0),
('max_post_img_width', '0', 0),
('max_post_smilies', '0', 0),
('max_post_urls', '0', 0),
('max_quote_depth', '3', 0),
('max_reg_attempts', '5', 0),
('max_sig_chars', '255', 0),
('max_sig_font_size', '200', 0),
('max_sig_img_height', '0', 0),
('max_sig_img_width', '0', 0),
('max_sig_smilies', '0', 0),
('max_sig_urls', '5', 0),
('mime_triggers', 'body|head|html|img|plaintext|a href|pre|script|table|title', 0),
('min_name_chars', '3', 0),
('min_pass_chars', '6', 0),
('min_search_author_chars', '3', 0),
('newest_user_colour', '', 1),
('newest_user_id', '55', 1),
('newest_username', 'farshad', 1),
('num_files', '0', 1),
('num_posts', '1', 1),
('num_topics', '1', 1),
('num_users', '4', 1),
('override_user_style', '1', 0),
('pass_complex', 'PASS_TYPE_ANY', 0),
('pm_edit_time', '0', 0),
('pm_max_boxes', '4', 0),
('pm_max_msgs', '50', 0),
('pm_max_recipients', '0', 0),
('posts_per_page', '10', 0),
('print_pm', '1', 0),
('queue_interval', '600', 0),
('queue_trigger_posts', '3', 0),
('rand_seed', '7467d86b937f44e4854d6f152b7d050a', 1),
('rand_seed_last_update', '1260371689', 1),
('ranks_path', 'images/ranks', 0),
('record_online_date', '1252653778', 1),
('record_online_users', '3', 1),
('referer_validation', '1', 0),
('reimg_ignore_sig_img', '0', 0),
('reimg_max_height', '480', 0),
('reimg_max_width', '640', 0),
('reimg_rel_width', '0', 0),
('reimg_swap_portrait', '1', 0),
('reimg_zoom', '_litebox', 0),
('require_activation', '0', 0),
('script_path', '/usv/modules/phpBB3', 0),
('search_anonymous_interval', '0', 0),
('search_block_size', '250', 0),
('search_gc', '7200', 0),
('search_indexing_state', '', 1),
('search_interval', '0', 0),
('search_last_gc', '1260368934', 1),
('search_store_results', '1800', 0),
('search_type', 'fulltext_native', 0),
('secure_allow_deny', '1', 0),
('secure_allow_empty_referer', '1', 0),
('secure_downloads', '0', 0),
('server_name', 'localhost', 0),
('server_port', '80', 0),
('server_protocol', 'http://', 0),
('session_gc', '3600', 0),
('session_last_gc', '1260368939', 1),
('session_length', '3600', 0),
('site_desc', 'A short text to describe your forum', 0),
('sitename', 'yourdomain.com', 0),
('smilies_path', 'images/smilies', 0),
('smtp_auth_method', 'PLAIN', 0),
('smtp_delivery', '0', 0),
('smtp_host', '', 0),
('smtp_password', 'password', 0),
('smtp_port', '25', 0),
('smtp_username', 'admin', 0),
('topics_per_page', '25', 0),
('tpl_allow_php', '0', 0),
('upload_dir_size', '0', 1),
('upload_icons_path', 'images/upload_icons', 0),
('upload_path', 'files', 0),
('version', '3.0.5', 0),
('warnings_expire_days', '90', 0),
('warnings_gc', '14400', 0),
('warnings_last_gc', '1260368927', 1);



CREATE TABLE IF NOT EXISTS `nuke_bb3confirm` (
  `confirm_id` char(32) COLLATE utf8_bin NOT NULL DEFAULT '',
  `session_id` char(32) COLLATE utf8_bin NOT NULL DEFAULT '',
  `confirm_type` tinyint(3) NOT NULL DEFAULT '0',
  `code` varchar(8) COLLATE utf8_bin NOT NULL DEFAULT '',
  `seed` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`session_id`,`confirm_id`),
  KEY `confirm_type` (`confirm_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3disallow` (
  `disallow_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `disallow_username` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  PRIMARY KEY (`disallow_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_bb3drafts` (
  `draft_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `topic_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `forum_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `save_time` int(11) unsigned NOT NULL DEFAULT '0',
  `draft_subject` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `draft_message` mediumtext COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`draft_id`),
  KEY `save_time` (`save_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_bb3extensions` (
  `extension_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `group_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `extension` varchar(100) COLLATE utf8_bin NOT NULL DEFAULT '',
  PRIMARY KEY (`extension_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=67 ;


INSERT INTO `nuke_bb3extensions` (`extension_id`, `group_id`, `extension`) VALUES
(1, 1, 'gif'),
(2, 1, 'png'),
(3, 1, 'jpeg'),
(4, 1, 'jpg'),
(5, 1, 'tif'),
(6, 1, 'tiff'),
(7, 1, 'tga'),
(8, 2, 'gtar'),
(9, 2, 'gz'),
(10, 2, 'tar'),
(11, 2, 'zip'),
(12, 2, 'rar'),
(13, 2, 'ace'),
(14, 2, 'torrent'),
(15, 2, 'tgz'),
(16, 2, 'bz2'),
(17, 2, '7z'),
(18, 3, 'txt'),
(19, 3, 'c'),
(20, 3, 'h'),
(21, 3, 'cpp'),
(22, 3, 'hpp'),
(23, 3, 'diz'),
(24, 3, 'csv'),
(25, 3, 'ini'),
(26, 3, 'log'),
(27, 3, 'js'),
(28, 3, 'xml'),
(29, 4, 'xls'),
(30, 4, 'xlsx'),
(31, 4, 'xlsm'),
(32, 4, 'xlsb'),
(33, 4, 'doc'),
(34, 4, 'docx'),
(35, 4, 'docm'),
(36, 4, 'dot'),
(37, 4, 'dotx'),
(38, 4, 'dotm'),
(39, 4, 'pdf'),
(40, 4, 'ai'),
(41, 4, 'ps'),
(42, 4, 'ppt'),
(43, 4, 'pptx'),
(44, 4, 'pptm'),
(45, 4, 'odg'),
(46, 4, 'odp'),
(47, 4, 'ods'),
(48, 4, 'odt'),
(49, 4, 'rtf'),
(50, 5, 'rm'),
(51, 5, 'ram'),
(52, 6, 'wma'),
(53, 6, 'wmv'),
(54, 7, 'swf'),
(55, 8, 'mov'),
(56, 8, 'm4v'),
(57, 8, 'm4a'),
(58, 8, 'mp4'),
(59, 8, '3gp'),
(60, 8, '3g2'),
(61, 8, 'qt'),
(62, 9, 'mpeg'),
(63, 9, 'mpg'),
(64, 9, 'mp3'),
(65, 9, 'ogg'),
(66, 9, 'ogm');



CREATE TABLE IF NOT EXISTS `nuke_bb3extension_groups` (
  `group_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `group_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `cat_id` tinyint(2) NOT NULL DEFAULT '0',
  `allow_group` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `download_mode` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `upload_icon` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `max_filesize` int(20) unsigned NOT NULL DEFAULT '0',
  `allowed_forums` text COLLATE utf8_bin NOT NULL,
  `allow_in_pm` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`group_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=10 ;


INSERT INTO `nuke_bb3extension_groups` (`group_id`, `group_name`, `cat_id`, `allow_group`, `download_mode`, `upload_icon`, `max_filesize`, `allowed_forums`, `allow_in_pm`) VALUES
(1, 'Images', 1, 1, 1, '', 0, '', 0),
(2, 'Archives', 0, 1, 1, '', 0, '', 0),
(3, 'Plain Text', 0, 0, 1, '', 0, '', 0),
(4, 'Documents', 0, 0, 1, '', 0, '', 0),
(5, 'Real Media', 3, 0, 1, '', 0, '', 0),
(6, 'Windows Media', 2, 0, 1, '', 0, '', 0),
(7, 'Flash Files', 5, 0, 1, '', 0, '', 0),
(8, 'Quicktime Media', 6, 0, 1, '', 0, '', 0),
(9, 'Downloadable Files', 0, 0, 1, '', 0, '', 0);



CREATE TABLE IF NOT EXISTS `nuke_bb3forums` (
  `forum_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `left_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `right_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `forum_parents` mediumtext COLLATE utf8_bin NOT NULL,
  `forum_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `forum_desc` text COLLATE utf8_bin NOT NULL,
  `forum_desc_bitfield` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `forum_desc_options` int(11) unsigned NOT NULL DEFAULT '7',
  `forum_desc_uid` varchar(8) COLLATE utf8_bin NOT NULL DEFAULT '',
  `forum_link` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `forum_password` varchar(40) COLLATE utf8_bin NOT NULL DEFAULT '',
  `forum_style` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `forum_image` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `forum_rules` text COLLATE utf8_bin NOT NULL,
  `forum_rules_link` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `forum_rules_bitfield` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `forum_rules_options` int(11) unsigned NOT NULL DEFAULT '7',
  `forum_rules_uid` varchar(8) COLLATE utf8_bin NOT NULL DEFAULT '',
  `forum_topics_per_page` tinyint(4) NOT NULL DEFAULT '0',
  `forum_type` tinyint(4) NOT NULL DEFAULT '0',
  `forum_status` tinyint(4) NOT NULL DEFAULT '0',
  `forum_posts` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `forum_topics` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `forum_topics_real` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `forum_last_post_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `forum_last_poster_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `forum_last_post_subject` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `forum_last_post_time` int(11) unsigned NOT NULL DEFAULT '0',
  `forum_last_poster_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `forum_last_poster_colour` varchar(6) COLLATE utf8_bin NOT NULL DEFAULT '',
  `forum_flags` tinyint(4) NOT NULL DEFAULT '32',
  `display_subforum_list` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `display_on_index` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `enable_indexing` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `enable_icons` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `enable_prune` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `prune_next` int(11) unsigned NOT NULL DEFAULT '0',
  `prune_days` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `prune_viewed` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `prune_freq` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `enable_thanks` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`forum_id`),
  KEY `left_right_id` (`left_id`,`right_id`),
  KEY `forum_lastpost_id` (`forum_last_post_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=3 ;


INSERT INTO `nuke_bb3forums` (`forum_id`, `parent_id`, `left_id`, `right_id`, `forum_parents`, `forum_name`, `forum_desc`, `forum_desc_bitfield`, `forum_desc_options`, `forum_desc_uid`, `forum_link`, `forum_password`, `forum_style`, `forum_image`, `forum_rules`, `forum_rules_link`, `forum_rules_bitfield`, `forum_rules_options`, `forum_rules_uid`, `forum_topics_per_page`, `forum_type`, `forum_status`, `forum_posts`, `forum_topics`, `forum_topics_real`, `forum_last_post_id`, `forum_last_poster_id`, `forum_last_post_subject`, `forum_last_post_time`, `forum_last_poster_name`, `forum_last_poster_colour`, `forum_flags`, `display_subforum_list`, `display_on_index`, `enable_indexing`, `enable_icons`, `enable_prune`, `prune_next`, `prune_days`, `prune_viewed`, `prune_freq`, `enable_thanks`) VALUES
(1, 0, 1, 4, '', 'گفتگوی آزاد', '', '', 7, '', '', '', 0, '', '', '', '', 7, '', 0, 0, 0, 1, 1, 1, 1, 2, '', 1249992268, 'Delta', 'AA0000', 32, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0),
(2, 1, 2, 3, 'a:1:{i:1;a:2:{i:0;s:21:"گفتگوی آزاد";i:1;i:0;}}', 'گفتگوی آزاد', 'مباحث آزاد و عمومی ', '', 7, '', '', '', 0, '', '', '', '', 7, '', 0, 1, 0, 1, 1, 1, 1, 2, 'به پرتال نیوک لرن خوش آمدید', 1249992268, 'Delta', 'AA0000', 32, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0);



CREATE TABLE IF NOT EXISTS `nuke_bb3forums_access` (
  `forum_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `session_id` char(32) COLLATE utf8_bin NOT NULL DEFAULT '',
  PRIMARY KEY (`forum_id`,`user_id`,`session_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3forums_track` (
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `forum_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `mark_time` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`user_id`,`forum_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_bb3forums_track` (`user_id`, `forum_id`, `mark_time`) VALUES
(2, 0, 1252595240),
(2, 2, 1252595240);



CREATE TABLE IF NOT EXISTS `nuke_bb3forums_watch` (
  `forum_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `notify_status` tinyint(1) unsigned NOT NULL DEFAULT '0',
  KEY `forum_id` (`forum_id`),
  KEY `user_id` (`user_id`),
  KEY `notify_stat` (`notify_status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3groups` (
  `group_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `group_type` tinyint(4) NOT NULL DEFAULT '1',
  `group_founder_manage` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `group_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `group_desc` text COLLATE utf8_bin NOT NULL,
  `group_desc_bitfield` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `group_desc_options` int(11) unsigned NOT NULL DEFAULT '7',
  `group_desc_uid` varchar(8) COLLATE utf8_bin NOT NULL DEFAULT '',
  `group_display` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `group_avatar` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `group_avatar_type` tinyint(2) NOT NULL DEFAULT '0',
  `group_avatar_width` smallint(4) unsigned NOT NULL DEFAULT '0',
  `group_avatar_height` smallint(4) unsigned NOT NULL DEFAULT '0',
  `group_rank` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `group_colour` varchar(6) COLLATE utf8_bin NOT NULL DEFAULT '',
  `group_sig_chars` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `group_receive_pm` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `group_message_limit` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `group_max_recipients` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `group_legend` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `point_amount` text COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`group_id`),
  KEY `group_legend_name` (`group_legend`,`group_name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=7 ;


INSERT INTO `nuke_bb3groups` (`group_id`, `group_type`, `group_founder_manage`, `group_name`, `group_desc`, `group_desc_bitfield`, `group_desc_options`, `group_desc_uid`, `group_display`, `group_avatar`, `group_avatar_type`, `group_avatar_width`, `group_avatar_height`, `group_rank`, `group_colour`, `group_sig_chars`, `group_receive_pm`, `group_message_limit`, `group_max_recipients`, `group_legend`, `point_amount`) VALUES
(1, 3, 0, 'GUESTS', '', '', 7, '', 0, '', 0, 0, 0, 0, '', 0, 0, 0, 5, 0, ''),
(2, 3, 0, 'REGISTERED', '', '', 7, '', 0, '', 0, 0, 0, 0, '', 0, 0, 0, 5, 0, ''),
(3, 3, 0, 'REGISTERED_COPPA', '', '', 7, '', 0, '', 0, 0, 0, 0, '', 0, 0, 0, 5, 0, ''),
(4, 3, 0, 'GLOBAL_MODERATORS', '', '', 7, '', 0, '', 0, 0, 0, 0, '00AA00', 0, 0, 0, 0, 1, ''),
(5, 3, 1, 'ADMINISTRATORS', '', '', 7, '', 0, '', 0, 0, 0, 0, 'AA0000', 0, 0, 0, 0, 1, ''),
(6, 3, 0, 'BOTS', '', '', 7, '', 0, '', 0, 0, 0, 0, '9E8DA7', 0, 0, 0, 5, 0, '');



CREATE TABLE IF NOT EXISTS `nuke_bb3icons` (
  `icons_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `icons_url` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `icons_width` tinyint(4) NOT NULL DEFAULT '0',
  `icons_height` tinyint(4) NOT NULL DEFAULT '0',
  `icons_order` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `display_on_posting` tinyint(1) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`icons_id`),
  KEY `display_on_posting` (`display_on_posting`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=11 ;


INSERT INTO `nuke_bb3icons` (`icons_id`, `icons_url`, `icons_width`, `icons_height`, `icons_order`, `display_on_posting`) VALUES
(1, 'misc/fire.gif', 16, 16, 1, 1),
(2, 'smile/redface.gif', 16, 16, 9, 1),
(3, 'smile/mrgreen.gif', 16, 16, 10, 1),
(4, 'misc/heart.gif', 16, 16, 4, 1),
(5, 'misc/star.gif', 16, 16, 2, 1),
(6, 'misc/radioactive.gif', 16, 16, 3, 1),
(7, 'misc/thinking.gif', 16, 16, 5, 1),
(8, 'smile/info.gif', 16, 16, 8, 1),
(9, 'smile/question.gif', 16, 16, 6, 1),
(10, 'smile/alert.gif', 16, 16, 7, 1);



CREATE TABLE IF NOT EXISTS `nuke_bb3lang` (
  `lang_id` tinyint(4) NOT NULL AUTO_INCREMENT,
  `lang_iso` varchar(30) COLLATE utf8_bin NOT NULL DEFAULT '',
  `lang_dir` varchar(30) COLLATE utf8_bin NOT NULL DEFAULT '',
  `lang_english_name` varchar(100) COLLATE utf8_bin NOT NULL DEFAULT '',
  `lang_local_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `lang_author` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  PRIMARY KEY (`lang_id`),
  KEY `lang_iso` (`lang_iso`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=3 ;


INSERT INTO `nuke_bb3lang` (`lang_id`, `lang_iso`, `lang_dir`, `lang_english_name`, `lang_local_name`, `lang_author`) VALUES
(1, 'en_us', 'en_us', 'English (United States)', 'English (United States)', 'Xaph0s'),
(2, 'persian', 'persian', 'Persian', 'Farsi', 'www.Maghsad.com');



CREATE TABLE IF NOT EXISTS `nuke_bb3log` (
  `log_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `log_type` tinyint(4) NOT NULL DEFAULT '0',
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `forum_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `topic_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `reportee_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `log_ip` varchar(40) COLLATE utf8_bin NOT NULL DEFAULT '',
  `log_time` int(11) unsigned NOT NULL DEFAULT '0',
  `log_operation` text COLLATE utf8_bin NOT NULL,
  `log_data` mediumtext COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`log_id`),
  KEY `log_type` (`log_type`),
  KEY `forum_id` (`forum_id`),
  KEY `topic_id` (`topic_id`),
  KEY `reportee_id` (`reportee_id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_bb3moderator_cache` (
  `forum_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `username` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `group_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `group_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `display_on_index` tinyint(1) unsigned NOT NULL DEFAULT '1',
  KEY `disp_idx` (`display_on_index`),
  KEY `forum_id` (`forum_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3modules` (
  `module_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `module_enabled` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `module_display` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `module_basename` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `module_class` varchar(10) COLLATE utf8_bin NOT NULL DEFAULT '',
  `parent_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `left_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `right_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `module_langname` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `module_mode` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `module_auth` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  PRIMARY KEY (`module_id`),
  KEY `left_right_id` (`left_id`,`right_id`),
  KEY `module_enabled` (`module_enabled`),
  KEY `class_left_id` (`module_class`,`left_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=191 ;


INSERT INTO `nuke_bb3modules` (`module_id`, `module_enabled`, `module_display`, `module_basename`, `module_class`, `parent_id`, `left_id`, `right_id`, `module_langname`, `module_mode`, `module_auth`) VALUES
(1, 1, 1, '', 'acp', 0, 1, 60, 'ACP_CAT_GENERAL', '', ''),
(2, 1, 1, '', 'acp', 1, 4, 17, 'ACP_QUICK_ACCESS', '', ''),
(3, 1, 1, '', 'acp', 1, 18, 39, 'ACP_BOARD_CONFIGURATION', '', ''),
(4, 1, 1, '', 'acp', 1, 40, 47, 'ACP_CLIENT_COMMUNICATION', '', ''),
(5, 1, 1, '', 'acp', 1, 48, 59, 'ACP_SERVER_CONFIGURATION', '', ''),
(6, 1, 1, '', 'acp', 0, 61, 78, 'ACP_CAT_FORUMS', '', ''),
(7, 1, 1, '', 'acp', 6, 62, 67, 'ACP_MANAGE_FORUMS', '', ''),
(8, 1, 1, '', 'acp', 6, 68, 77, 'ACP_FORUM_BASED_PERMISSIONS', '', ''),
(9, 1, 1, '', 'acp', 0, 79, 104, 'ACP_CAT_POSTING', '', ''),
(10, 1, 1, '', 'acp', 9, 80, 93, 'ACP_MESSAGES', '', ''),
(11, 1, 1, '', 'acp', 9, 94, 103, 'ACP_ATTACHMENTS', '', ''),
(12, 1, 1, '', 'acp', 0, 105, 158, 'ACP_CAT_USERGROUP', '', ''),
(13, 1, 1, '', 'acp', 12, 106, 137, 'ACP_CAT_USERS', '', ''),
(14, 1, 1, '', 'acp', 12, 138, 145, 'ACP_GROUPS', '', ''),
(15, 1, 1, '', 'acp', 12, 146, 157, 'ACP_USER_SECURITY', '', ''),
(16, 1, 1, '', 'acp', 0, 159, 206, 'ACP_CAT_PERMISSIONS', '', ''),
(17, 1, 1, '', 'acp', 16, 162, 171, 'ACP_GLOBAL_PERMISSIONS', '', ''),
(18, 1, 1, '', 'acp', 16, 172, 181, 'ACP_FORUM_BASED_PERMISSIONS', '', ''),
(19, 1, 1, '', 'acp', 16, 182, 191, 'ACP_PERMISSION_ROLES', '', ''),
(20, 1, 1, '', 'acp', 16, 192, 205, 'ACP_PERMISSION_MASKS', '', ''),
(21, 1, 1, '', 'acp', 0, 207, 220, 'ACP_CAT_STYLES', '', ''),
(22, 1, 1, '', 'acp', 21, 208, 211, 'ACP_STYLE_MANAGEMENT', '', ''),
(23, 1, 1, '', 'acp', 21, 212, 219, 'ACP_STYLE_COMPONENTS', '', ''),
(24, 1, 1, '', 'acp', 0, 221, 240, 'ACP_CAT_MAINTENANCE', '', ''),
(25, 1, 1, '', 'acp', 24, 222, 231, 'ACP_FORUM_LOGS', '', ''),
(26, 1, 1, '', 'acp', 24, 232, 239, 'ACP_CAT_DATABASE', '', ''),
(27, 1, 1, '', 'acp', 0, 241, 266, 'ACP_CAT_SYSTEM', '', ''),
(28, 1, 1, '', 'acp', 27, 242, 245, 'ACP_AUTOMATION', '', ''),
(29, 1, 1, '', 'acp', 27, 246, 257, 'ACP_GENERAL_TASKS', '', ''),
(30, 1, 1, '', 'acp', 27, 258, 265, 'ACP_MODULE_MANAGEMENT', '', ''),
(31, 1, 1, '', 'acp', 0, 267, 268, 'ACP_CAT_DOT_MODS', '', ''),
(32, 1, 1, 'attachments', 'acp', 3, 19, 20, 'ACP_ATTACHMENT_SETTINGS', 'attach', 'acl_a_attach'),
(33, 1, 1, 'attachments', 'acp', 11, 95, 96, 'ACP_ATTACHMENT_SETTINGS', 'attach', 'acl_a_attach'),
(34, 1, 1, 'attachments', 'acp', 11, 97, 98, 'ACP_MANAGE_EXTENSIONS', 'extensions', 'acl_a_attach'),
(35, 1, 1, 'attachments', 'acp', 11, 99, 100, 'ACP_EXTENSION_GROUPS', 'ext_groups', 'acl_a_attach'),
(36, 1, 1, 'attachments', 'acp', 11, 101, 102, 'ACP_ORPHAN_ATTACHMENTS', 'orphan', 'acl_a_attach'),
(37, 1, 1, 'ban', 'acp', 15, 147, 148, 'ACP_BAN_EMAILS', 'email', 'acl_a_ban'),
(38, 1, 1, 'ban', 'acp', 15, 149, 150, 'ACP_BAN_IPS', 'ip', 'acl_a_ban'),
(39, 1, 1, 'ban', 'acp', 15, 151, 152, 'ACP_BAN_USERNAMES', 'user', 'acl_a_ban'),
(40, 1, 1, 'bbcodes', 'acp', 10, 81, 82, 'ACP_BBCODES', 'bbcodes', 'acl_a_bbcode'),
(41, 1, 1, 'board', 'acp', 3, 21, 22, 'ACP_BOARD_SETTINGS', 'settings', 'acl_a_board'),
(42, 1, 1, 'board', 'acp', 3, 23, 24, 'ACP_BOARD_FEATURES', 'features', 'acl_a_board'),
(43, 1, 1, 'board', 'acp', 3, 25, 26, 'ACP_AVATAR_SETTINGS', 'avatar', 'acl_a_board'),
(44, 1, 1, 'board', 'acp', 3, 27, 28, 'ACP_MESSAGE_SETTINGS', 'message', 'acl_a_board'),
(45, 1, 1, 'board', 'acp', 10, 83, 84, 'ACP_MESSAGE_SETTINGS', 'message', 'acl_a_board'),
(46, 1, 1, 'board', 'acp', 3, 29, 30, 'ACP_POST_SETTINGS', 'post', 'acl_a_board'),
(47, 1, 1, 'board', 'acp', 3, 31, 32, 'ACP_SIGNATURE_SETTINGS', 'signature', 'acl_a_board'),
(48, 1, 1, 'board', 'acp', 3, 33, 34, 'ACP_REGISTER_SETTINGS', 'registration', 'acl_a_board'),
(49, 1, 1, 'board', 'acp', 4, 41, 42, 'ACP_AUTH_SETTINGS', 'auth', 'acl_a_server'),
(50, 1, 1, 'board', 'acp', 4, 43, 44, 'ACP_EMAIL_SETTINGS', 'email', 'acl_a_server'),
(51, 1, 1, 'board', 'acp', 5, 49, 50, 'ACP_COOKIE_SETTINGS', 'cookie', 'acl_a_server'),
(52, 1, 1, 'board', 'acp', 5, 51, 52, 'ACP_SERVER_SETTINGS', 'server', 'acl_a_server'),
(53, 1, 1, 'board', 'acp', 5, 53, 54, 'ACP_SECURITY_SETTINGS', 'security', 'acl_a_server'),
(54, 1, 1, 'board', 'acp', 5, 55, 56, 'ACP_LOAD_SETTINGS', 'load', 'acl_a_server'),
(55, 1, 1, 'bots', 'acp', 29, 247, 248, 'ACP_BOTS', 'bots', 'acl_a_bots'),
(56, 1, 1, 'captcha', 'acp', 3, 35, 36, 'ACP_VC_SETTINGS', 'visual', 'acl_a_board'),
(57, 1, 0, 'captcha', 'acp', 3, 37, 38, 'ACP_VC_CAPTCHA_DISPLAY', 'img', 'acl_a_board'),
(58, 1, 1, 'database', 'acp', 26, 233, 234, 'ACP_BACKUP', 'backup', 'acl_a_backup'),
(59, 1, 1, 'database', 'acp', 26, 235, 236, 'ACP_RESTORE', 'restore', 'acl_a_backup'),
(60, 1, 1, 'disallow', 'acp', 15, 153, 154, 'ACP_DISALLOW_USERNAMES', 'usernames', 'acl_a_names'),
(61, 1, 1, 'email', 'acp', 29, 249, 250, 'ACP_MASS_EMAIL', 'email', 'acl_a_email && cfg_email_enable'),
(62, 1, 1, 'forums', 'acp', 7, 63, 64, 'ACP_MANAGE_FORUMS', 'manage', 'acl_a_forum'),
(63, 1, 1, 'groups', 'acp', 14, 139, 140, 'ACP_GROUPS_MANAGE', 'manage', 'acl_a_group'),
(64, 1, 1, 'icons', 'acp', 10, 85, 86, 'ACP_ICONS', 'icons', 'acl_a_icons'),
(65, 1, 1, 'icons', 'acp', 10, 87, 88, 'ACP_SMILIES', 'smilies', 'acl_a_icons'),
(66, 1, 1, 'inactive', 'acp', 13, 109, 110, 'ACP_INACTIVE_USERS', 'list', 'acl_a_user'),
(67, 1, 1, 'jabber', 'acp', 4, 45, 46, 'ACP_JABBER_SETTINGS', 'settings', 'acl_a_jabber'),
(68, 1, 1, 'language', 'acp', 29, 251, 252, 'ACP_LANGUAGE_PACKS', 'lang_packs', 'acl_a_language'),
(69, 1, 1, 'logs', 'acp', 25, 223, 224, 'ACP_ADMIN_LOGS', 'admin', 'acl_a_viewlogs'),
(70, 1, 1, 'logs', 'acp', 25, 225, 226, 'ACP_MOD_LOGS', 'mod', 'acl_a_viewlogs'),
(71, 1, 1, 'logs', 'acp', 25, 227, 228, 'ACP_USERS_LOGS', 'users', 'acl_a_viewlogs'),
(72, 1, 1, 'logs', 'acp', 25, 229, 230, 'ACP_CRITICAL_LOGS', 'critical', 'acl_a_viewlogs'),
(73, 1, 1, 'main', 'acp', 1, 2, 3, 'ACP_INDEX', 'main', ''),
(74, 1, 1, 'modules', 'acp', 30, 259, 260, 'ACP', 'acp', 'acl_a_modules'),
(75, 1, 1, 'modules', 'acp', 30, 261, 262, 'UCP', 'ucp', 'acl_a_modules'),
(76, 1, 1, 'modules', 'acp', 30, 263, 264, 'MCP', 'mcp', 'acl_a_modules'),
(77, 1, 1, 'permission_roles', 'acp', 19, 183, 184, 'ACP_ADMIN_ROLES', 'admin_roles', 'acl_a_roles && acl_a_aauth'),
(78, 1, 1, 'permission_roles', 'acp', 19, 185, 186, 'ACP_USER_ROLES', 'user_roles', 'acl_a_roles && acl_a_uauth'),
(79, 1, 1, 'permission_roles', 'acp', 19, 187, 188, 'ACP_MOD_ROLES', 'mod_roles', 'acl_a_roles && acl_a_mauth'),
(80, 1, 1, 'permission_roles', 'acp', 19, 189, 190, 'ACP_FORUM_ROLES', 'forum_roles', 'acl_a_roles && acl_a_fauth'),
(81, 1, 1, 'permissions', 'acp', 16, 160, 161, 'ACP_PERMISSIONS', 'intro', 'acl_a_authusers || acl_a_authgroups || acl_a_viewauth'),
(82, 1, 0, 'permissions', 'acp', 20, 193, 194, 'ACP_PERMISSION_TRACE', 'trace', 'acl_a_viewauth'),
(83, 1, 1, 'permissions', 'acp', 18, 173, 174, 'ACP_FORUM_PERMISSIONS', 'setting_forum_local', 'acl_a_fauth && (acl_a_authusers || acl_a_authgroups)'),
(84, 1, 1, 'permissions', 'acp', 18, 175, 176, 'ACP_FORUM_MODERATORS', 'setting_mod_local', 'acl_a_mauth && (acl_a_authusers || acl_a_authgroups)'),
(85, 1, 1, 'permissions', 'acp', 17, 163, 164, 'ACP_USERS_PERMISSIONS', 'setting_user_global', 'acl_a_authusers && (acl_a_aauth || acl_a_mauth || acl_a_uauth)'),
(86, 1, 1, 'permissions', 'acp', 13, 111, 112, 'ACP_USERS_PERMISSIONS', 'setting_user_global', 'acl_a_authusers && (acl_a_aauth || acl_a_mauth || acl_a_uauth)'),
(87, 1, 1, 'permissions', 'acp', 18, 177, 178, 'ACP_USERS_FORUM_PERMISSIONS', 'setting_user_local', 'acl_a_authusers && (acl_a_mauth || acl_a_fauth)'),
(88, 1, 1, 'permissions', 'acp', 13, 113, 114, 'ACP_USERS_FORUM_PERMISSIONS', 'setting_user_local', 'acl_a_authusers && (acl_a_mauth || acl_a_fauth)'),
(89, 1, 1, 'permissions', 'acp', 17, 165, 166, 'ACP_GROUPS_PERMISSIONS', 'setting_group_global', 'acl_a_authgroups && (acl_a_aauth || acl_a_mauth || acl_a_uauth)'),
(90, 1, 1, 'permissions', 'acp', 14, 141, 142, 'ACP_GROUPS_PERMISSIONS', 'setting_group_global', 'acl_a_authgroups && (acl_a_aauth || acl_a_mauth || acl_a_uauth)'),
(91, 1, 1, 'permissions', 'acp', 18, 179, 180, 'ACP_GROUPS_FORUM_PERMISSIONS', 'setting_group_local', 'acl_a_authgroups && (acl_a_mauth || acl_a_fauth)'),
(92, 1, 1, 'permissions', 'acp', 14, 143, 144, 'ACP_GROUPS_FORUM_PERMISSIONS', 'setting_group_local', 'acl_a_authgroups && (acl_a_mauth || acl_a_fauth)'),
(93, 1, 1, 'permissions', 'acp', 17, 167, 168, 'ACP_ADMINISTRATORS', 'setting_admin_global', 'acl_a_aauth && (acl_a_authusers || acl_a_authgroups)'),
(94, 1, 1, 'permissions', 'acp', 17, 169, 170, 'ACP_GLOBAL_MODERATORS', 'setting_mod_global', 'acl_a_mauth && (acl_a_authusers || acl_a_authgroups)'),
(95, 1, 1, 'permissions', 'acp', 20, 195, 196, 'ACP_VIEW_ADMIN_PERMISSIONS', 'view_admin_global', 'acl_a_viewauth'),
(96, 1, 1, 'permissions', 'acp', 20, 197, 198, 'ACP_VIEW_USER_PERMISSIONS', 'view_user_global', 'acl_a_viewauth'),
(97, 1, 1, 'permissions', 'acp', 20, 199, 200, 'ACP_VIEW_GLOBAL_MOD_PERMISSIONS', 'view_mod_global', 'acl_a_viewauth'),
(98, 1, 1, 'permissions', 'acp', 20, 201, 202, 'ACP_VIEW_FORUM_MOD_PERMISSIONS', 'view_mod_local', 'acl_a_viewauth'),
(99, 1, 1, 'permissions', 'acp', 20, 203, 204, 'ACP_VIEW_FORUM_PERMISSIONS', 'view_forum_local', 'acl_a_viewauth'),
(100, 1, 1, 'php_info', 'acp', 29, 253, 254, 'ACP_PHP_INFO', 'info', 'acl_a_phpinfo'),
(101, 1, 1, 'profile', 'acp', 13, 115, 116, 'ACP_CUSTOM_PROFILE_FIELDS', 'profile', 'acl_a_profile'),
(102, 1, 1, 'prune', 'acp', 7, 65, 66, 'ACP_PRUNE_FORUMS', 'forums', 'acl_a_prune'),
(103, 1, 1, 'prune', 'acp', 15, 155, 156, 'ACP_PRUNE_USERS', 'users', 'acl_a_userdel'),
(104, 1, 1, 'ranks', 'acp', 13, 117, 118, 'ACP_MANAGE_RANKS', 'ranks', 'acl_a_ranks'),
(105, 1, 1, 'reasons', 'acp', 29, 255, 256, 'ACP_MANAGE_REASONS', 'main', 'acl_a_reasons'),
(106, 1, 1, 'search', 'acp', 5, 57, 58, 'ACP_SEARCH_SETTINGS', 'settings', 'acl_a_search'),
(107, 1, 1, 'search', 'acp', 26, 237, 238, 'ACP_SEARCH_INDEX', 'index', 'acl_a_search'),
(108, 1, 1, 'styles', 'acp', 22, 209, 210, 'ACP_STYLES', 'style', 'acl_a_styles'),
(109, 1, 1, 'styles', 'acp', 23, 213, 214, 'ACP_TEMPLATES', 'template', 'acl_a_styles'),
(110, 1, 1, 'styles', 'acp', 23, 215, 216, 'ACP_THEMES', 'theme', 'acl_a_styles'),
(111, 1, 1, 'styles', 'acp', 23, 217, 218, 'ACP_IMAGESETS', 'imageset', 'acl_a_styles'),
(112, 1, 1, 'thanks', 'acp', 10, 89, 90, 'ACP_THANKS', 'thanks', 'acl_a_board'),
(113, 1, 1, 'update', 'acp', 28, 243, 244, 'ACP_VERSION_CHECK', 'version_check', 'acl_a_board'),
(114, 1, 1, 'users', 'acp', 13, 107, 108, 'ACP_MANAGE_USERS', 'overview', 'acl_a_user'),
(115, 1, 0, 'users', 'acp', 13, 119, 120, 'ACP_USER_FEEDBACK', 'feedback', 'acl_a_user'),
(116, 1, 0, 'users', 'acp', 13, 121, 122, 'ACP_USER_PROFILE', 'profile', 'acl_a_user'),
(117, 1, 0, 'users', 'acp', 13, 123, 124, 'ACP_USER_PREFS', 'prefs', 'acl_a_user'),
(118, 1, 0, 'users', 'acp', 13, 125, 126, 'ACP_USER_AVATAR', 'avatar', 'acl_a_user'),
(119, 1, 0, 'users', 'acp', 13, 127, 128, 'ACP_USER_RANK', 'rank', 'acl_a_user'),
(120, 1, 0, 'users', 'acp', 13, 129, 130, 'ACP_USER_SIG', 'sig', 'acl_a_user'),
(121, 1, 0, 'users', 'acp', 13, 131, 132, 'ACP_USER_GROUPS', 'groups', 'acl_a_user && acl_a_group'),
(122, 1, 0, 'users', 'acp', 13, 133, 134, 'ACP_USER_PERM', 'perm', 'acl_a_user && acl_a_viewauth'),
(123, 1, 0, 'users', 'acp', 13, 135, 136, 'ACP_USER_ATTACH', 'attach', 'acl_a_user'),
(124, 1, 1, 'words', 'acp', 10, 91, 92, 'ACP_WORDS', 'words', 'acl_a_words'),
(125, 1, 1, 'users', 'acp', 2, 5, 6, 'ACP_MANAGE_USERS', 'overview', 'acl_a_user'),
(126, 1, 1, 'groups', 'acp', 2, 7, 8, 'ACP_GROUPS_MANAGE', 'manage', 'acl_a_group'),
(127, 1, 1, 'forums', 'acp', 2, 9, 10, 'ACP_MANAGE_FORUMS', 'manage', 'acl_a_forum'),
(128, 1, 1, 'logs', 'acp', 2, 11, 12, 'ACP_MOD_LOGS', 'mod', 'acl_a_viewlogs'),
(129, 1, 1, 'bots', 'acp', 2, 13, 14, 'ACP_BOTS', 'bots', 'acl_a_bots'),
(130, 1, 1, 'php_info', 'acp', 2, 15, 16, 'ACP_PHP_INFO', 'info', 'acl_a_phpinfo'),
(131, 1, 1, 'permissions', 'acp', 8, 69, 70, 'ACP_FORUM_PERMISSIONS', 'setting_forum_local', 'acl_a_fauth && (acl_a_authusers || acl_a_authgroups)'),
(132, 1, 1, 'permissions', 'acp', 8, 71, 72, 'ACP_FORUM_MODERATORS', 'setting_mod_local', 'acl_a_mauth && (acl_a_authusers || acl_a_authgroups)'),
(133, 1, 1, 'permissions', 'acp', 8, 73, 74, 'ACP_USERS_FORUM_PERMISSIONS', 'setting_user_local', 'acl_a_authusers && (acl_a_mauth || acl_a_fauth)'),
(134, 1, 1, 'permissions', 'acp', 8, 75, 76, 'ACP_GROUPS_FORUM_PERMISSIONS', 'setting_group_local', 'acl_a_authgroups && (acl_a_mauth || acl_a_fauth)'),
(135, 1, 1, '', 'mcp', 0, 1, 10, 'MCP_MAIN', '', ''),
(136, 1, 1, '', 'mcp', 0, 11, 18, 'MCP_QUEUE', '', ''),
(137, 1, 1, '', 'mcp', 0, 19, 26, 'MCP_REPORTS', '', ''),
(138, 1, 1, '', 'mcp', 0, 27, 32, 'MCP_NOTES', '', ''),
(139, 1, 1, '', 'mcp', 0, 33, 42, 'MCP_WARN', '', ''),
(140, 1, 1, '', 'mcp', 0, 43, 50, 'MCP_LOGS', '', ''),
(141, 1, 1, '', 'mcp', 0, 51, 58, 'MCP_BAN', '', ''),
(142, 1, 1, 'ban', 'mcp', 141, 52, 53, 'MCP_BAN_USERNAMES', 'user', 'acl_m_ban'),
(143, 1, 1, 'ban', 'mcp', 141, 54, 55, 'MCP_BAN_IPS', 'ip', 'acl_m_ban'),
(144, 1, 1, 'ban', 'mcp', 141, 56, 57, 'MCP_BAN_EMAILS', 'email', 'acl_m_ban'),
(145, 1, 1, 'logs', 'mcp', 140, 44, 45, 'MCP_LOGS_FRONT', 'front', 'acl_m_ || aclf_m_'),
(146, 1, 1, 'logs', 'mcp', 140, 46, 47, 'MCP_LOGS_FORUM_VIEW', 'forum_logs', 'acl_m_,$id'),
(147, 1, 1, 'logs', 'mcp', 140, 48, 49, 'MCP_LOGS_TOPIC_VIEW', 'topic_logs', 'acl_m_,$id'),
(148, 1, 1, 'main', 'mcp', 135, 2, 3, 'MCP_MAIN_FRONT', 'front', ''),
(149, 1, 1, 'main', 'mcp', 135, 4, 5, 'MCP_MAIN_FORUM_VIEW', 'forum_view', 'acl_m_,$id'),
(150, 1, 1, 'main', 'mcp', 135, 6, 7, 'MCP_MAIN_TOPIC_VIEW', 'topic_view', 'acl_m_,$id'),
(151, 1, 1, 'main', 'mcp', 135, 8, 9, 'MCP_MAIN_POST_DETAILS', 'post_details', 'acl_m_,$id || (!$id && aclf_m_)'),
(152, 1, 1, 'notes', 'mcp', 138, 28, 29, 'MCP_NOTES_FRONT', 'front', ''),
(153, 1, 1, 'notes', 'mcp', 138, 30, 31, 'MCP_NOTES_USER', 'user_notes', ''),
(154, 1, 1, 'queue', 'mcp', 136, 12, 13, 'MCP_QUEUE_UNAPPROVED_TOPICS', 'unapproved_topics', 'aclf_m_approve'),
(155, 1, 1, 'queue', 'mcp', 136, 14, 15, 'MCP_QUEUE_UNAPPROVED_POSTS', 'unapproved_posts', 'aclf_m_approve'),
(156, 1, 1, 'queue', 'mcp', 136, 16, 17, 'MCP_QUEUE_APPROVE_DETAILS', 'approve_details', 'acl_m_approve,$id || (!$id && aclf_m_approve)'),
(157, 1, 1, 'reports', 'mcp', 137, 20, 21, 'MCP_REPORTS_OPEN', 'reports', 'aclf_m_report'),
(158, 1, 1, 'reports', 'mcp', 137, 22, 23, 'MCP_REPORTS_CLOSED', 'reports_closed', 'aclf_m_report'),
(159, 1, 1, 'reports', 'mcp', 137, 24, 25, 'MCP_REPORT_DETAILS', 'report_details', 'acl_m_report,$id || (!$id && aclf_m_report)'),
(160, 1, 1, 'warn', 'mcp', 139, 34, 35, 'MCP_WARN_FRONT', 'front', 'aclf_m_warn'),
(161, 1, 1, 'warn', 'mcp', 139, 36, 37, 'MCP_WARN_LIST', 'list', 'aclf_m_warn'),
(162, 1, 1, 'warn', 'mcp', 139, 38, 39, 'MCP_WARN_USER', 'warn_user', 'aclf_m_warn'),
(163, 1, 1, 'warn', 'mcp', 139, 40, 41, 'MCP_WARN_POST', 'warn_post', 'acl_m_warn && acl_f_read,$id'),
(164, 1, 1, '', 'ucp', 0, 1, 12, 'UCP_MAIN', '', ''),
(165, 1, 1, '', 'ucp', 0, 13, 22, 'UCP_PROFILE', '', ''),
(166, 1, 1, '', 'ucp', 0, 23, 30, 'UCP_PREFS', '', ''),
(167, 1, 1, '', 'ucp', 0, 31, 42, 'UCP_PM', '', ''),
(168, 1, 1, '', 'ucp', 0, 43, 48, 'UCP_USERGROUPS', '', ''),
(169, 1, 1, '', 'ucp', 0, 49, 54, 'UCP_ZEBRA', '', ''),
(170, 1, 1, 'attachments', 'ucp', 164, 10, 11, 'UCP_MAIN_ATTACHMENTS', 'attachments', 'acl_u_attach'),
(171, 1, 1, 'groups', 'ucp', 168, 44, 45, 'UCP_USERGROUPS_MEMBER', 'membership', ''),
(172, 1, 1, 'groups', 'ucp', 168, 46, 47, 'UCP_USERGROUPS_MANAGE', 'manage', ''),
(173, 1, 1, 'main', 'ucp', 164, 2, 3, 'UCP_MAIN_FRONT', 'front', ''),
(174, 1, 1, 'main', 'ucp', 164, 4, 5, 'UCP_MAIN_SUBSCRIBED', 'subscribed', ''),
(175, 1, 1, 'main', 'ucp', 164, 6, 7, 'UCP_MAIN_BOOKMARKS', 'bookmarks', 'cfg_allow_bookmarks'),
(176, 1, 1, 'main', 'ucp', 164, 8, 9, 'UCP_MAIN_DRAFTS', 'drafts', ''),
(177, 1, 0, 'pm', 'ucp', 167, 32, 33, 'UCP_PM_VIEW', 'view', 'cfg_allow_privmsg'),
(178, 1, 1, 'pm', 'ucp', 167, 34, 35, 'UCP_PM_COMPOSE', 'compose', 'cfg_allow_privmsg'),
(179, 1, 1, 'pm', 'ucp', 167, 36, 37, 'UCP_PM_DRAFTS', 'drafts', 'cfg_allow_privmsg'),
(180, 1, 1, 'pm', 'ucp', 167, 38, 39, 'UCP_PM_OPTIONS', 'options', 'cfg_allow_privmsg'),
(181, 1, 0, 'pm', 'ucp', 167, 40, 41, 'UCP_PM_POPUP_TITLE', 'popup', 'cfg_allow_privmsg'),
(182, 1, 1, 'prefs', 'ucp', 166, 24, 25, 'UCP_PREFS_PERSONAL', 'personal', ''),
(183, 1, 1, 'prefs', 'ucp', 166, 26, 27, 'UCP_PREFS_POST', 'post', ''),
(184, 1, 1, 'prefs', 'ucp', 166, 28, 29, 'UCP_PREFS_VIEW', 'view', ''),
(185, 1, 1, 'profile', 'ucp', 165, 14, 15, 'UCP_PROFILE_PROFILE_INFO', 'profile_info', ''),
(186, 1, 1, 'profile', 'ucp', 165, 16, 17, 'UCP_PROFILE_SIGNATURE', 'signature', ''),
(187, 1, 1, 'profile', 'ucp', 165, 18, 19, 'UCP_PROFILE_AVATAR', 'avatar', ''),
(188, 1, 1, 'profile', 'ucp', 165, 20, 21, 'UCP_PROFILE_REG_DETAILS', 'reg_details', ''),
(189, 1, 1, 'zebra', 'ucp', 169, 50, 51, 'UCP_ZEBRA_FRIENDS', 'friends', ''),
(190, 1, 1, 'zebra', 'ucp', 169, 52, 53, 'UCP_ZEBRA_FOES', 'foes', '');



CREATE TABLE IF NOT EXISTS `nuke_bb3poll_options` (
  `poll_option_id` tinyint(4) NOT NULL DEFAULT '0',
  `topic_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `poll_option_text` text COLLATE utf8_bin NOT NULL,
  `poll_option_total` mediumint(8) unsigned NOT NULL DEFAULT '0',
  KEY `poll_opt_id` (`poll_option_id`),
  KEY `topic_id` (`topic_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3poll_votes` (
  `topic_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `poll_option_id` tinyint(4) NOT NULL DEFAULT '0',
  `vote_user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `vote_user_ip` varchar(40) COLLATE utf8_bin NOT NULL DEFAULT '',
  KEY `topic_id` (`topic_id`),
  KEY `vote_user_id` (`vote_user_id`),
  KEY `vote_user_ip` (`vote_user_ip`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3posts` (
  `post_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `topic_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `forum_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `poster_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `icon_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `poster_ip` varchar(40) COLLATE utf8_bin NOT NULL DEFAULT '',
  `post_time` int(11) unsigned NOT NULL DEFAULT '0',
  `post_approved` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `post_reported` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `enable_bbcode` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `enable_smilies` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `enable_magic_url` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `enable_sig` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `post_username` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `post_subject` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `post_text` mediumtext COLLATE utf8_bin NOT NULL,
  `post_checksum` varchar(32) COLLATE utf8_bin NOT NULL DEFAULT '',
  `post_attachment` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `bbcode_bitfield` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `bbcode_uid` varchar(8) COLLATE utf8_bin NOT NULL DEFAULT '',
  `post_postcount` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `post_edit_time` int(11) unsigned NOT NULL DEFAULT '0',
  `post_edit_reason` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `post_edit_user` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `post_edit_count` smallint(4) unsigned NOT NULL DEFAULT '0',
  `post_edit_locked` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `post_thanked` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`post_id`),
  KEY `forum_id` (`forum_id`),
  KEY `topic_id` (`topic_id`),
  KEY `poster_ip` (`poster_ip`),
  KEY `poster_id` (`poster_id`),
  KEY `post_approved` (`post_approved`),
  KEY `tid_post_time` (`topic_id`,`post_time`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=2 ;


INSERT INTO `nuke_bb3posts` (`post_id`, `topic_id`, `forum_id`, `poster_id`, `icon_id`, `poster_ip`, `post_time`, `post_approved`, `post_reported`, `enable_bbcode`, `enable_smilies`, `enable_magic_url`, `enable_sig`, `post_username`, `post_subject`, `post_text`, `post_checksum`, `post_attachment`, `bbcode_bitfield`, `bbcode_uid`, `post_postcount`, `post_edit_time`, `post_edit_reason`, `post_edit_user`, `post_edit_count`, `post_edit_locked`, `post_thanked`) VALUES
(1, 1, 2, 2, 0, '127.0.0.1', 1249992268, 1, 0, 1, 1, 1, 1, '', 'به پرتال نیوک لرن خوش آمدید', 'کپی رایت پرتال  نیوک لرن  با نام  موقت اختصاری USV <br>لزوم  هر سایت حفظ  کپی رایت آن است  . توسعه دهندگان زیادی  بر روی سیستم محتوای نیوک کار کرده اند و  حاصل سال ها رنج آن ها در دستان ما می باشد .<br>قانون کپی رایت  طبق اصل   Open source and copyright law یک حقیت ملزوم برای هر پایگاه  اطلاع رسانی است  و استفاده از نسخه های متن باز  غیر قابل تغییر و استفاده تولیدی است .  تنها در صورتی توزيع مجدد یک بسته تولید شده مجاز می باشد  که از سوی  تولیدکنندگان گذشته آن , اجازه  توسعه و توزیع محصول جدید احذ شود .<br><br>پرتال نیوک لرن  بر اساس  7.8  PHP-Nuke و   بسته محتوای  INP4   خواهد بود , از این رو  احذ مجوز از تولیدکننده و توسعه دهنده این نسخه  حتمی و الزامی است . از آنجایی که نسخه 4  با مدیریت و همکاری تمام اعضای نیوک لرن انجام شده است احذ چنین مجوزی  تعامل یک سویه است . اما  نکته اصلی در این باب  توسعه  4 ساله بسته ایران نیوک است که احذ مجوز از  پیشرو  و مدیر اصلی این سایت الزامی خواهد بود . بهزاد بهزادی عزیز  بیش از 4 سال برای ایران نیوک زحمت کشیدند , وقت گذاشتند  و  سرمایه گذاری کردند .  اخذ رای ایشان  حتمی است .<br><br>پرتال  نیوک لرن  را  نه ادامه پرتال ایران نیوک بخوانید و نه نسخه ای مستقل از آن .  پرتال نیوک لرن  تنها برای استفاده کنندگان از ایران نیوک تولید خواهد شد .<br><br>این بیانیه  به منظور  قانونی کردن  نسخه نخست  پرتال نیوک لرن است . ساختار  پرتال نیوک لرن  بصورت  متن باز و در جهت توسعه همگانی خواهد بود .<br><br>تمامی حقوق توسعه دهندگان گذشته بصورت label های کپی رایت در تمامی فایل های پرتال نیوک لرن قابل مشاهده است و هیچگاه کپی رایت گروهی از  منابع پرتال حذف نخواهد شد .<br><br>سخن آخر : <br><br>با ضمن آگاهی از  به سرقت رفتن  , توزیع  مجدد  و  پایمال کردن  حقوق نیوک لرن  , توسعه دهندگان آن سعی بر ارائه سخه به صورت رایگان برای عموم  خواهند کرد .<br><br>این اقدام  تنها به منظور  تنها  نگذاشتن  ایران نیوکی ها و مدیران سایت های نیوکی است .<br><br>اساس نامه سایت نیوک لرن بر پایه همکاری با دیگر سایت های مرجع نیوک و توسعه دهندگان  می باشد .  امیدواریم روزی شاهد همکاری تمام مراجع فارسی نیوک باشیم.\n', '5dd683b17f641daf84c040bfefc58ce9', 0, '', '', 1, 0, '', 0, 0, 0, 0);



CREATE TABLE IF NOT EXISTS `nuke_bb3privmsgs` (
  `msg_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `root_level` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `author_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `icon_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `author_ip` varchar(40) COLLATE utf8_bin NOT NULL DEFAULT '',
  `message_time` int(11) unsigned NOT NULL DEFAULT '0',
  `enable_bbcode` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `enable_smilies` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `enable_magic_url` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `enable_sig` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `message_subject` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `message_text` mediumtext COLLATE utf8_bin NOT NULL,
  `message_edit_reason` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `message_edit_user` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `message_attachment` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `bbcode_bitfield` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `bbcode_uid` varchar(8) COLLATE utf8_bin NOT NULL DEFAULT '',
  `message_edit_time` int(11) unsigned NOT NULL DEFAULT '0',
  `message_edit_count` smallint(4) unsigned NOT NULL DEFAULT '0',
  `to_address` text COLLATE utf8_bin NOT NULL,
  `bcc_address` text COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`msg_id`),
  KEY `author_ip` (`author_ip`),
  KEY `message_time` (`message_time`),
  KEY `author_id` (`author_id`),
  KEY `root_level` (`root_level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_bb3privmsgs_folder` (
  `folder_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `folder_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `pm_count` mediumint(8) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`folder_id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_bb3privmsgs_rules` (
  `rule_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `rule_check` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `rule_connection` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `rule_string` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `rule_user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `rule_group_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `rule_action` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `rule_folder_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`rule_id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_bb3privmsgs_to` (
  `msg_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `author_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `pm_deleted` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `pm_new` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `pm_unread` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `pm_replied` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `pm_marked` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `pm_forwarded` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `folder_id` int(11) NOT NULL DEFAULT '0',
  KEY `msg_id` (`msg_id`),
  KEY `author_id` (`author_id`),
  KEY `usr_flder_id` (`user_id`,`folder_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3profile_fields` (
  `field_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `field_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `field_type` tinyint(4) NOT NULL DEFAULT '0',
  `field_ident` varchar(20) COLLATE utf8_bin NOT NULL DEFAULT '',
  `field_length` varchar(20) COLLATE utf8_bin NOT NULL DEFAULT '',
  `field_minlen` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `field_maxlen` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `field_novalue` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `field_default_value` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `field_validation` varchar(20) COLLATE utf8_bin NOT NULL DEFAULT '',
  `field_required` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `field_show_on_reg` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `field_show_profile` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `field_hide` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `field_no_view` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `field_active` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `field_order` mediumint(8) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`field_id`),
  KEY `fld_type` (`field_type`),
  KEY `fld_ordr` (`field_order`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_bb3profile_fields_data` (
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3profile_fields_lang` (
  `field_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `lang_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `option_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `field_type` tinyint(4) NOT NULL DEFAULT '0',
  `lang_value` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  PRIMARY KEY (`field_id`,`lang_id`,`option_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3profile_lang` (
  `field_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `lang_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `lang_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `lang_explain` text COLLATE utf8_bin NOT NULL,
  `lang_default_value` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  PRIMARY KEY (`field_id`,`lang_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3ranks` (
  `rank_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `rank_title` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `rank_min` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `rank_special` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `rank_image` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  PRIMARY KEY (`rank_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=2 ;


INSERT INTO `nuke_bb3ranks` (`rank_id`, `rank_title`, `rank_min`, `rank_special`, `rank_image`) VALUES
(1, 'Site Admin', 0, 1, '');



CREATE TABLE IF NOT EXISTS `nuke_bb3reports` (
  `report_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `reason_id` smallint(4) unsigned NOT NULL DEFAULT '0',
  `post_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `user_notify` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `report_closed` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `report_time` int(11) unsigned NOT NULL DEFAULT '0',
  `report_text` mediumtext COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`report_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_bb3reports_reasons` (
  `reason_id` smallint(4) unsigned NOT NULL AUTO_INCREMENT,
  `reason_title` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `reason_description` mediumtext COLLATE utf8_bin NOT NULL,
  `reason_order` smallint(4) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`reason_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=5 ;


INSERT INTO `nuke_bb3reports_reasons` (`reason_id`, `reason_title`, `reason_description`, `reason_order`) VALUES
(1, 'warez', 'The post contains links to illegal or pirated software.', 1),
(2, 'spam', 'The reported post has the only purpose to advertize for a website or another product.', 2),
(3, 'off_topic', 'The reported post is off topic.', 3),
(4, 'other', 'The reported post does not fit into any other category, please use the further information field.', 4);



CREATE TABLE IF NOT EXISTS `nuke_bb3search_results` (
  `search_key` varchar(32) COLLATE utf8_bin NOT NULL DEFAULT '',
  `search_time` int(11) unsigned NOT NULL DEFAULT '0',
  `search_keywords` mediumtext COLLATE utf8_bin NOT NULL,
  `search_authors` mediumtext COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`search_key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3search_wordlist` (
  `word_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `word_text` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `word_common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `word_count` mediumint(8) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`word_id`),
  UNIQUE KEY `wrd_txt` (`word_text`),
  KEY `wrd_cnt` (`word_count`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=59 ;


INSERT INTO `nuke_bb3search_wordlist` (`word_id`, `word_text`, `word_common`, `word_count`) VALUES
(1, 'this', 0, 1),
(2, 'example', 0, 1),
(3, 'post', 0, 1),
(4, 'your', 0, 1),
(5, 'phpbb3', 0, 2),
(6, 'installation', 0, 1),
(7, 'everything', 0, 1),
(8, 'seems', 0, 1),
(9, 'working', 0, 1),
(10, 'you', 0, 1),
(11, 'may', 0, 1),
(12, 'delete', 0, 1),
(13, 'like', 0, 1),
(14, 'and', 0, 1),
(15, 'continue', 0, 1),
(16, 'set', 0, 1),
(17, 'board', 0, 1),
(18, 'during', 0, 1),
(19, 'the', 0, 1),
(20, 'process', 0, 1),
(21, 'first', 0, 1),
(22, 'category', 0, 1),
(23, 'forum', 0, 1),
(24, 'are', 0, 1),
(25, 'assigned', 0, 1),
(26, 'appropriate', 0, 1),
(27, 'permissions', 0, 1),
(28, 'for', 0, 1),
(29, 'predefined', 0, 1),
(30, 'usergroups', 0, 1),
(31, 'administrators', 0, 1),
(32, 'bots', 0, 1),
(33, 'global', 0, 1),
(34, 'moderators', 0, 1),
(35, 'guests', 0, 1),
(36, 'registered', 0, 1),
(37, 'users', 0, 1),
(38, 'coppa', 0, 1),
(39, 'also', 0, 1),
(40, 'choose', 0, 1),
(41, 'not', 0, 1),
(42, 'forget', 0, 1),
(43, 'assign', 0, 1),
(44, 'all', 0, 1),
(45, 'these', 0, 1),
(46, 'new', 0, 1),
(47, 'categories', 0, 1),
(48, 'forums', 0, 1),
(49, 'create', 0, 1),
(50, 'recommended', 0, 1),
(51, 'rename', 0, 1),
(52, 'copy', 0, 1),
(53, 'from', 0, 1),
(54, 'while', 0, 1),
(55, 'creating', 0, 1),
(56, 'have', 0, 1),
(57, 'fun', 0, 1),
(58, 'welcome', 0, 1);



CREATE TABLE IF NOT EXISTS `nuke_bb3search_wordmatch` (
  `post_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `word_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `title_match` tinyint(1) unsigned NOT NULL DEFAULT '0',
  UNIQUE KEY `unq_mtch` (`word_id`,`post_id`,`title_match`),
  KEY `word_id` (`word_id`),
  KEY `post_id` (`post_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_bb3search_wordmatch` (`post_id`, `word_id`, `title_match`) VALUES
(1, 1, 0),
(1, 2, 0),
(1, 3, 0),
(1, 4, 0),
(1, 5, 0),
(1, 5, 1),
(1, 6, 0),
(1, 7, 0),
(1, 8, 0),
(1, 9, 0),
(1, 10, 0),
(1, 11, 0),
(1, 12, 0),
(1, 13, 0),
(1, 14, 0),
(1, 15, 0),
(1, 16, 0),
(1, 17, 0),
(1, 18, 0),
(1, 19, 0),
(1, 20, 0),
(1, 21, 0),
(1, 22, 0),
(1, 23, 0),
(1, 24, 0),
(1, 25, 0),
(1, 26, 0),
(1, 27, 0),
(1, 28, 0),
(1, 29, 0),
(1, 30, 0),
(1, 31, 0),
(1, 32, 0),
(1, 33, 0),
(1, 34, 0),
(1, 35, 0),
(1, 36, 0),
(1, 37, 0),
(1, 38, 0),
(1, 39, 0),
(1, 40, 0),
(1, 41, 0),
(1, 42, 0),
(1, 43, 0),
(1, 44, 0),
(1, 45, 0),
(1, 46, 0),
(1, 47, 0),
(1, 48, 0),
(1, 49, 0),
(1, 50, 0),
(1, 51, 0),
(1, 52, 0),
(1, 53, 0),
(1, 54, 0),
(1, 55, 0),
(1, 56, 0),
(1, 57, 0),
(1, 58, 1);



CREATE TABLE IF NOT EXISTS `nuke_bb3sessions` (
  `session_id` char(32) COLLATE utf8_bin NOT NULL DEFAULT '',
  `session_user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `session_forum_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `session_last_visit` int(11) unsigned NOT NULL DEFAULT '0',
  `session_start` int(11) unsigned NOT NULL DEFAULT '0',
  `session_time` int(11) unsigned NOT NULL DEFAULT '0',
  `session_ip` varchar(40) COLLATE utf8_bin NOT NULL DEFAULT '',
  `session_browser` varchar(150) COLLATE utf8_bin NOT NULL DEFAULT '',
  `session_forwarded_for` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `session_page` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `session_viewonline` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `session_autologin` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `session_admin` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`session_id`),
  KEY `session_time` (`session_time`),
  KEY `session_user_id` (`session_user_id`),
  KEY `session_fid` (`session_forum_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3sessions_keys` (
  `key_id` char(32) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `last_ip` varchar(40) COLLATE utf8_bin NOT NULL DEFAULT '',
  `last_login` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`key_id`,`user_id`),
  KEY `last_login` (`last_login`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3sitelist` (
  `site_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `site_ip` varchar(40) COLLATE utf8_bin NOT NULL DEFAULT '',
  `site_hostname` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `ip_exclude` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`site_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_bb3smilies` (
  `smiley_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `code` varchar(50) COLLATE utf8_bin NOT NULL DEFAULT '',
  `emotion` varchar(50) COLLATE utf8_bin NOT NULL DEFAULT '',
  `smiley_url` varchar(50) COLLATE utf8_bin NOT NULL DEFAULT '',
  `smiley_width` smallint(4) unsigned NOT NULL DEFAULT '0',
  `smiley_height` smallint(4) unsigned NOT NULL DEFAULT '0',
  `smiley_order` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `display_on_posting` tinyint(1) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`smiley_id`),
  KEY `display_on_post` (`display_on_posting`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=43 ;


INSERT INTO `nuke_bb3smilies` (`smiley_id`, `code`, `emotion`, `smiley_url`, `smiley_width`, `smiley_height`, `smiley_order`, `display_on_posting`) VALUES
(1, ':D', 'Very Happy', 'icon_e_biggrin.gif', 15, 17, 1, 1),
(2, ':-D', 'Very Happy', 'icon_e_biggrin.gif', 15, 17, 2, 1),
(3, ':grin:', 'Very Happy', 'icon_e_biggrin.gif', 15, 17, 3, 1),
(4, ':)', 'Smile', 'icon_e_smile.gif', 15, 17, 4, 1),
(5, ':-)', 'Smile', 'icon_e_smile.gif', 15, 17, 5, 1),
(6, ':smile:', 'Smile', 'icon_e_smile.gif', 15, 17, 6, 1),
(7, ';)', 'Wink', 'icon_e_wink.gif', 15, 17, 7, 1),
(8, ';-)', 'Wink', 'icon_e_wink.gif', 15, 17, 8, 1),
(9, ':wink:', 'Wink', 'icon_e_wink.gif', 15, 17, 9, 1),
(10, ':(', 'Sad', 'icon_e_sad.gif', 15, 17, 10, 1),
(11, ':-(', 'Sad', 'icon_e_sad.gif', 15, 17, 11, 1),
(12, ':sad:', 'Sad', 'icon_e_sad.gif', 15, 17, 12, 1),
(13, ':o', 'Surprized', 'icon_e_surprised.gif', 15, 17, 13, 1),
(14, ':-o', 'Surprized', 'icon_e_surprised.gif', 15, 17, 14, 1),
(15, ':eek:', 'Surprized', 'icon_e_surprised.gif', 15, 17, 15, 1),
(16, ':shock:', 'Shocked', 'icon_eek.gif', 15, 17, 16, 1),
(17, ':?', 'Confused', 'icon_e_confused.gif', 15, 17, 17, 1),
(18, ':-?', 'Confused', 'icon_e_confused.gif', 15, 17, 18, 1),
(19, ':???:', 'Confused', 'icon_e_confused.gif', 15, 17, 19, 1),
(20, '8-)', 'Cool', 'icon_cool.gif', 15, 17, 20, 1),
(21, ':cool:', 'Cool', 'icon_cool.gif', 15, 17, 21, 1),
(22, ':lol:', 'Laughing', 'icon_lol.gif', 15, 17, 22, 1),
(23, ':x', 'Mad', 'icon_mad.gif', 15, 17, 23, 1),
(24, ':-x', 'Mad', 'icon_mad.gif', 15, 17, 24, 1),
(25, ':mad:', 'Mad', 'icon_mad.gif', 15, 17, 25, 1),
(26, ':P', 'Razz', 'icon_razz.gif', 15, 17, 26, 1),
(27, ':-P', 'Razz', 'icon_razz.gif', 15, 17, 27, 1),
(28, ':razz:', 'Razz', 'icon_razz.gif', 15, 17, 28, 1),
(29, ':oops:', 'Embarrassed', 'icon_redface.gif', 15, 17, 29, 1),
(30, ':cry:', 'Crying or Very Sad', 'icon_cry.gif', 15, 17, 30, 1),
(31, ':evil:', 'Evil or Very Mad', 'icon_evil.gif', 15, 17, 31, 1),
(32, ':twisted:', 'Twisted Evil', 'icon_twisted.gif', 15, 17, 32, 1),
(33, ':roll:', 'Rolling Eyes', 'icon_rolleyes.gif', 15, 17, 33, 1),
(34, ':!:', 'Exclamation', 'icon_exclaim.gif', 15, 17, 34, 1),
(35, ':?:', 'Question', 'icon_question.gif', 15, 17, 35, 1),
(36, ':idea:', 'Idea', 'icon_idea.gif', 15, 17, 36, 1),
(37, ':arrow:', 'Arrow', 'icon_arrow.gif', 15, 17, 37, 1),
(38, ':|', 'Neutral', 'icon_neutral.gif', 15, 17, 38, 1),
(39, ':-|', 'Neutral', 'icon_neutral.gif', 15, 17, 39, 1),
(40, ':mrgreen:', 'Mr. Green', 'icon_mrgreen.gif', 15, 17, 40, 1),
(41, ':geek:', 'Geek', 'icon_e_geek.gif', 17, 17, 41, 1),
(42, ':ugeek:', 'Uber Geek', 'icon_e_ugeek.gif', 17, 18, 42, 1);



CREATE TABLE IF NOT EXISTS `nuke_bb3styles` (
  `style_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `style_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `style_copyright` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `style_active` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `template_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `theme_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `imageset_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`style_id`),
  UNIQUE KEY `style_name` (`style_name`),
  KEY `template_id` (`template_id`),
  KEY `theme_id` (`theme_id`),
  KEY `imageset_id` (`imageset_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=2 ;


INSERT INTO `nuke_bb3styles` (`style_id`, `style_name`, `style_copyright`, `style_active`, `template_id`, `theme_id`, `imageset_id`) VALUES
(1, 'prosilver', '&copy; phpBB Group', 1, 1, 1, 1);



CREATE TABLE IF NOT EXISTS `nuke_bb3styles_imageset` (
  `imageset_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `imageset_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `imageset_copyright` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `imageset_path` varchar(100) COLLATE utf8_bin NOT NULL DEFAULT '',
  PRIMARY KEY (`imageset_id`),
  UNIQUE KEY `imgset_nm` (`imageset_name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=2 ;


INSERT INTO `nuke_bb3styles_imageset` (`imageset_id`, `imageset_name`, `imageset_copyright`, `imageset_path`) VALUES
(1, 'prosilver', '&copy; phpBB Group', 'prosilver');



CREATE TABLE IF NOT EXISTS `nuke_bb3styles_imageset_data` (
  `image_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `image_name` varchar(200) COLLATE utf8_bin NOT NULL DEFAULT '',
  `image_filename` varchar(200) COLLATE utf8_bin NOT NULL DEFAULT '',
  `image_lang` varchar(30) COLLATE utf8_bin NOT NULL DEFAULT '',
  `image_height` smallint(4) unsigned NOT NULL DEFAULT '0',
  `image_width` smallint(4) unsigned NOT NULL DEFAULT '0',
  `imageset_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`image_id`),
  KEY `i_d` (`imageset_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=541 ;


INSERT INTO `nuke_bb3styles_imageset_data` (`image_id`, `image_name`, `image_filename`, `image_lang`, `image_height`, `image_width`, `imageset_id`) VALUES
(451, 'site_logo', 'site_logo.gif', '', 52, 139, 1),
(452, 'forum_link', 'forum_link.gif', '', 27, 27, 1),
(453, 'forum_read', 'forum_read.gif', '', 27, 27, 1),
(454, 'forum_read_locked', 'forum_read_locked.gif', '', 27, 27, 1),
(455, 'forum_read_subforum', 'forum_read_subforum.gif', '', 27, 27, 1),
(456, 'forum_unread', 'forum_unread.gif', '', 27, 27, 1),
(457, 'forum_unread_locked', 'forum_unread_locked.gif', '', 27, 27, 1),
(458, 'forum_unread_subforum', 'forum_unread_subforum.gif', '', 27, 27, 1),
(459, 'topic_moved', 'topic_moved.gif', '', 27, 27, 1),
(460, 'topic_read', 'topic_read.gif', '', 27, 27, 1),
(461, 'topic_read_mine', 'topic_read_mine.gif', '', 27, 27, 1),
(462, 'topic_read_hot', 'topic_read_hot.gif', '', 27, 27, 1),
(463, 'topic_read_hot_mine', 'topic_read_hot_mine.gif', '', 27, 27, 1),
(464, 'topic_read_locked', 'topic_read_locked.gif', '', 27, 27, 1),
(465, 'topic_read_locked_mine', 'topic_read_locked_mine.gif', '', 27, 27, 1),
(466, 'topic_unread', 'topic_unread.gif', '', 27, 27, 1),
(467, 'topic_unread_mine', 'topic_unread_mine.gif', '', 27, 27, 1),
(468, 'topic_unread_hot', 'topic_unread_hot.gif', '', 27, 27, 1),
(469, 'topic_unread_hot_mine', 'topic_unread_hot_mine.gif', '', 27, 27, 1),
(470, 'topic_unread_locked', 'topic_unread_locked.gif', '', 27, 27, 1),
(471, 'topic_unread_locked_mine', 'topic_unread_locked_mine.gif', '', 27, 27, 1),
(472, 'sticky_read', 'sticky_read.gif', '', 27, 27, 1),
(473, 'sticky_read_mine', 'sticky_read_mine.gif', '', 27, 27, 1),
(474, 'sticky_read_locked', 'sticky_read_locked.gif', '', 27, 27, 1),
(475, 'sticky_read_locked_mine', 'sticky_read_locked_mine.gif', '', 27, 27, 1),
(476, 'sticky_unread', 'sticky_unread.gif', '', 27, 27, 1),
(477, 'sticky_unread_mine', 'sticky_unread_mine.gif', '', 27, 27, 1),
(478, 'sticky_unread_locked', 'sticky_unread_locked.gif', '', 27, 27, 1),
(479, 'sticky_unread_locked_mine', 'sticky_unread_locked_mine.gif', '', 27, 27, 1),
(480, 'announce_read', 'announce_read.gif', '', 27, 27, 1),
(481, 'announce_read_mine', 'announce_read_mine.gif', '', 27, 27, 1),
(482, 'announce_read_locked', 'announce_read_locked.gif', '', 27, 27, 1),
(483, 'announce_read_locked_mine', 'announce_read_locked_mine.gif', '', 27, 27, 1),
(484, 'announce_unread', 'announce_unread.gif', '', 27, 27, 1),
(485, 'announce_unread_mine', 'announce_unread_mine.gif', '', 27, 27, 1),
(486, 'announce_unread_locked', 'announce_unread_locked.gif', '', 27, 27, 1),
(487, 'announce_unread_locked_mine', 'announce_unread_locked_mine.gif', '', 27, 27, 1),
(488, 'global_read', 'announce_read.gif', '', 27, 27, 1),
(489, 'global_read_mine', 'announce_read_mine.gif', '', 27, 27, 1),
(490, 'global_read_locked', 'announce_read_locked.gif', '', 27, 27, 1),
(491, 'global_read_locked_mine', 'announce_read_locked_mine.gif', '', 27, 27, 1),
(492, 'global_unread', 'announce_unread.gif', '', 27, 27, 1),
(493, 'global_unread_mine', 'announce_unread_mine.gif', '', 27, 27, 1),
(494, 'global_unread_locked', 'announce_unread_locked.gif', '', 27, 27, 1),
(495, 'global_unread_locked_mine', 'announce_unread_locked_mine.gif', '', 27, 27, 1),
(496, 'subforum_read', 'subforum_read.gif', '', 9, 11, 1),
(497, 'subforum_unread', 'subforum_unread.gif', '', 9, 11, 1),
(498, 'pm_read', 'topic_read.gif', '', 27, 27, 1),
(499, 'pm_unread', 'topic_unread.gif', '', 27, 27, 1),
(500, 'icon_back_top', 'icon_back_top.gif', '', 11, 11, 1),
(501, 'icon_contact_aim', 'icon_contact_aim.gif', '', 20, 20, 1),
(502, 'icon_contact_email', 'icon_contact_email.gif', '', 20, 20, 1),
(503, 'icon_contact_icq', 'icon_contact_icq.gif', '', 20, 20, 1),
(504, 'icon_contact_jabber', 'icon_contact_jabber.gif', '', 20, 20, 1),
(505, 'icon_contact_msnm', 'icon_contact_msnm.gif', '', 20, 20, 1),
(506, 'icon_contact_www', 'icon_contact_www.gif', '', 20, 20, 1),
(507, 'icon_contact_yahoo', 'icon_contact_yahoo.gif', '', 20, 20, 1),
(508, 'icon_post_delete', 'icon_post_delete.gif', '', 20, 20, 1),
(509, 'icon_post_info', 'icon_post_info.gif', '', 20, 20, 1),
(510, 'icon_post_report', 'icon_post_report.gif', '', 20, 20, 1),
(511, 'icon_post_target', 'icon_post_target.gif', '', 9, 11, 1),
(512, 'icon_post_target_unread', 'icon_post_target_unread.gif', '', 9, 11, 1),
(513, 'icon_topic_attach', 'icon_topic_attach.gif', '', 10, 7, 1),
(514, 'icon_topic_latest', 'icon_topic_latest.gif', '', 9, 11, 1),
(515, 'icon_topic_newest', 'icon_topic_newest.gif', '', 9, 11, 1),
(516, 'icon_topic_reported', 'icon_topic_reported.gif', '', 14, 16, 1),
(517, 'icon_topic_unapproved', 'icon_topic_unapproved.gif', '', 14, 16, 1),
(518, 'icon_user_warn', 'icon_user_warn.gif', '', 20, 20, 1),
(519, 'icon_reimg_zoom_in', 'icon_reimg_zoom_in.gif', '', 20, 20, 1),
(520, 'icon_reimg_zoom_out', 'icon_reimg_zoom_out.gif', '', 20, 20, 1),
(521, 'icon_contact_pm', 'icon_contact_pm.gif', 'en_us', 20, 28, 1),
(522, 'icon_post_edit', 'icon_post_edit.gif', 'en_us', 20, 42, 1),
(523, 'icon_post_quote', 'icon_post_quote.gif', 'en_us', 20, 54, 1),
(524, 'icon_user_online', 'icon_user_online.gif', 'en_us', 58, 58, 1),
(525, 'button_pm_forward', 'button_pm_forward.gif', 'en_us', 25, 96, 1),
(526, 'button_pm_new', 'button_pm_new.gif', 'en_us', 25, 84, 1),
(527, 'button_pm_reply', 'button_pm_reply.gif', 'en_us', 25, 96, 1),
(528, 'button_topic_locked', 'button_topic_locked.gif', 'en_us', 25, 88, 1),
(529, 'button_topic_new', 'button_topic_new.gif', 'en_us', 25, 96, 1),
(530, 'button_topic_reply', 'button_topic_reply.gif', 'en_us', 25, 96, 1),
(531, 'icon_contact_pm', 'icon_contact_pm.gif', 'persian', 20, 28, 1),
(532, 'icon_post_edit', 'icon_post_edit.gif', 'persian', 20, 42, 1),
(533, 'icon_post_quote', 'icon_post_quote.gif', 'persian', 20, 54, 1),
(534, 'icon_user_online', 'icon_user_online.gif', 'persian', 58, 58, 1),
(535, 'button_pm_forward', 'button_pm_forward.gif', 'persian', 25, 96, 1),
(536, 'button_pm_new', 'button_pm_new.gif', 'persian', 25, 84, 1),
(537, 'button_pm_reply', 'button_pm_reply.gif', 'persian', 25, 96, 1),
(538, 'button_topic_locked', 'button_topic_locked.gif', 'persian', 25, 88, 1),
(539, 'button_topic_new', 'button_topic_new.gif', 'persian', 25, 96, 1),
(540, 'button_topic_reply', 'button_topic_reply.gif', 'persian', 25, 96, 1);



CREATE TABLE IF NOT EXISTS `nuke_bb3styles_template` (
  `template_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `template_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `template_copyright` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `template_path` varchar(100) COLLATE utf8_bin NOT NULL DEFAULT '',
  `bbcode_bitfield` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT 'kNg=',
  `template_storedb` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `template_inherits_id` int(4) unsigned NOT NULL DEFAULT '0',
  `template_inherit_path` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  PRIMARY KEY (`template_id`),
  UNIQUE KEY `tmplte_nm` (`template_name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=2 ;


INSERT INTO `nuke_bb3styles_template` (`template_id`, `template_name`, `template_copyright`, `template_path`, `bbcode_bitfield`, `template_storedb`, `template_inherits_id`, `template_inherit_path`) VALUES
(1, 'prosilver', '&copy; phpBB Group', 'prosilver', 'lNg=', 0, 0, '');



CREATE TABLE IF NOT EXISTS `nuke_bb3styles_template_data` (
  `template_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `template_filename` varchar(100) COLLATE utf8_bin NOT NULL DEFAULT '',
  `template_included` text COLLATE utf8_bin NOT NULL,
  `template_mtime` int(11) unsigned NOT NULL DEFAULT '0',
  `template_data` mediumtext COLLATE utf8_bin NOT NULL,
  KEY `tid` (`template_id`),
  KEY `tfn` (`template_filename`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3styles_theme` (
  `theme_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `theme_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `theme_copyright` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `theme_path` varchar(100) COLLATE utf8_bin NOT NULL DEFAULT '',
  `theme_storedb` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `theme_mtime` int(11) unsigned NOT NULL DEFAULT '0',
  `theme_data` mediumtext COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`theme_id`),
  UNIQUE KEY `theme_name` (`theme_name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=2 ;


INSERT INTO `nuke_bb3styles_theme` (`theme_id`, `theme_name`, `theme_copyright`, `theme_path`, `theme_storedb`, `theme_mtime`, `theme_data`) VALUES
(1, 'prosilver', '&copy; phpBB Group', 'prosilver', 1, 1244972988, '/*  phpBB 3.0 Style Sheet\r\n    --------------------------------------------------------------\r\n	Style name:		proSilver\r\n	Based on style:	proSilver (this is the default phpBB 3 style)\r\n	Original author:	subBlue ( http://www.subBlue.com/ )\r\n	Modified by:		\r\n	\r\n	Copyright 2006 phpBB Group ( http://www.phpbb.com/ )\r\n    --------------------------------------------------------------\r\n*/\r\n\r\n/* General proSilver Markup Styles\r\n---------------------------------------- */\r\n\r\n* {\r\n	/* Reset browsers default margin, padding and font sizes */\r\n	margin: 0;\r\n	padding: 0;\r\n}\r\n\r\nhtml {\r\n	font-size: 100%;\r\n	/* Always show a scrollbar for short pages - stops the jump when the scrollbar appears. non-IE browsers */\r\n	height: 100%;\r\n	margin-bottom: 1px;\r\n}\r\n\r\nbody {\r\n	/* Text-Sizing with ems: http://www.clagnut.com/blog/348/ */\r\n	font-family: Tahoma, Verdana, Helvetica, Arial, sans-serif;\r\n	color: #828282;\r\n	background-color: #FFFFFF;\r\n	/*font-size: 62.5%;			 This sets the default font size to be equivalent to 10px */\r\n	font-size: 11px;\r\n	margin: 0;\r\n	padding: 12px 0;\r\n}\r\n\r\nh1 {\r\n	/* Forum name */\r\n	font-family: Tahoma, "Trebuchet MS", Arial, Helvetica, sans-serif;\r\n	margin-right: 200px;\r\n	color: #FFFFFF;\r\n	margin-top: 15px;\r\n	font-weight: bold;\r\n	font-size: 11px;\r\n}\r\n\r\nh2 {\r\n	/* Forum header titles */\r\n	font-family: Tahoma, "Trebuchet MS", Arial, Helvetica, sans-serif;\r\n	font-weight: normal;\r\n	color: #3f3f3f;\r\n	font-size: 11px;\r\n	margin: 0.8em 0 0.2em 0;\r\n}\r\n\r\nh2.solo {\r\n	margin-bottom: 1em;\r\n}\r\n\r\nh3 {\r\n	/* Sub-headers (also used as post headers, but defined later) */\r\n	font-family: Arial, Helvetica, sans-serif;\r\n	font-weight: bold;\r\n	text-transform: uppercase;\r\n	border-bottom: 1px solid #CCCCCC;\r\n	margin-bottom: 3px;\r\n	padding-bottom: 2px;\r\n	font-size: 1.05em;\r\n	color: #989898;\r\n	margin-top: 20px;\r\n}\r\n\r\nh4 {\r\n	/* Forum and topic list titles */\r\n	font-family: Tahoma, "Trebuchet MS", Verdana, Helvetica, Arial, Sans-serif;\r\n	font-size: 11px;\r\n}\r\n\r\np {\r\n	line-height: 1.3em;\r\n	font-size: 11px;\r\n	margin-bottom: 1.5em;\r\n}\r\n\r\nimg {\r\n	border-width: 0;\r\n}\r\n\r\nhr {\r\n	/* Also see tweaks.css */\r\n	border: 0 none #FFFFFF;\r\n	border-top: 1px solid #CCCCCC;\r\n	height: 1px;\r\n	margin: 5px 0;\r\n	display: block;\r\n	clear: both;\r\n}\r\n\r\nhr.dashed {\r\n	border-top: 1px dashed #CCCCCC;\r\n	margin: 10px 0;\r\n}\r\n\r\nhr.divider {\r\n	display: none;\r\n}\r\n\r\np.right {\r\n	text-align: right;\r\n}\r\n\r\n/* Main blocks\r\n---------------------------------------- */\r\n#wrap {\r\n	padding: 0 20px;\r\n	min-width: 650px;\r\n}\r\n\r\n#simple-wrap {\r\n	padding: 6px 10px;\r\n}\r\n\r\n#page-body {\r\n	margin: 4px 0;\r\n	clear: both;\r\n}\r\n\r\n#page-footer {\r\n	clear: both;\r\n}\r\n\r\n#page-footer h3 {\r\n	margin-top: 20px;\r\n}\r\n\r\n#logo {\r\n	float: left;\r\n	width: auto;\r\n	padding: 10px 13px 0 10px;\r\n}\r\n\r\na#logo:hover {\r\n	text-decoration: none;\r\n}\r\n\r\n/* Search box\r\n--------------------------------------------- */\r\n#search-box {\r\n	color: #FFFFFF;\r\n	position: relative;\r\n	margin-top: 30px;\r\n	margin-right: 5px;\r\n	display: block;\r\n	float: right;\r\n	text-align: right;\r\n	white-space: nowrap; /* For Opera */\r\n}\r\n\r\n#search-box #keywords {\r\n	width: 95px;\r\n	background-color: #FFF;\r\n}\r\n\r\n#search-box input {\r\n	border: 1px solid #b0b0b0;\r\n}\r\n\r\n/* .button1 style defined later, just a few tweaks for the search button version */\r\n#search-box input.button1 {\r\n	padding: 1px 5px;\r\n}\r\n\r\n#search-box li {\r\n	text-align: right;\r\n	margin-top: 4px;\r\n}\r\n\r\n#search-box img {\r\n	vertical-align: middle;\r\n	margin-right: 3px;\r\n}\r\n\r\n/* Site description and logo */\r\n#site-description {\r\n	float: left;\r\n	width: 70%;\r\n}\r\n\r\n#site-description h1 {\r\n	margin-right: 0;\r\n}\r\n\r\n/* Round cornered boxes and backgrounds\r\n---------------------------------------- */\r\n.headerbar {\r\n	background: #ebebeb none repeat-x 0 0;\r\n	color: #FFFFFF;\r\n	margin-bottom: 4px;\r\n	padding: 0 5px;\r\n}\r\n\r\n.navbar {\r\n	background-color: #ebebeb;\r\n	padding: 0 10px;\r\n}\r\n\r\n.forabg {\r\n	background: #b1b1b1 none repeat-x 0 0;\r\n	margin-bottom: 4px;\r\n	padding: 0 5px;\r\n	clear: both;\r\n}\r\n\r\n.forumbg {\r\n	background: #ebebeb none repeat-x 0 0;\r\n	margin-bottom: 4px;\r\n	padding: 0 5px;\r\n	clear: both;\r\n}\r\n\r\n.panel {\r\n	margin-bottom: 4px;\r\n	padding: 0 10px;\r\n	background-color: #f3f3f3;\r\n	color: #3f3f3f;\r\n}\r\n\r\n.post {\r\n	padding: 0 10px;\r\n	margin-bottom: 4px;\r\n	background-repeat: no-repeat;\r\n	background-position: 100% 0;\r\n}\r\n\r\n.post:target .content {\r\n	color: #000000;\r\n}\r\n\r\n.post:target h3 a {\r\n	color: #000000;\r\n}\r\n\r\n.bg1	{ background-color: #f7f7f7;}\r\n.bg2	{ background-color: #f2f2f2; }\r\n.bg3	{ background-color: #ebebeb; }\r\n\r\n.rowbg {\r\n	margin: 5px 5px 2px 5px;\r\n}\r\n\r\n.ucprowbg {\r\n	background-color: #e2e2e2;\r\n}\r\n\r\n.fieldsbg {\r\n	/*border: 1px #DBDEE2 solid;*/\r\n	background-color: #eaeaea;\r\n}\r\n\r\nspan.corners-top, span.corners-bottom, span.corners-top span, span.corners-bottom span {\r\n	font-size: 1px;\r\n	line-height: 1px;\r\n	display: block;\r\n	height: 5px;\r\n	background-repeat: no-repeat;\r\n}\r\n\r\nspan.corners-top {\r\n	background-image: none;\r\n	background-position: 0 0;\r\n	margin: 0 -5px;\r\n}\r\n\r\nspan.corners-top span {\r\n	background-image: none;\r\n	background-position: 100% 0;\r\n}\r\n\r\nspan.corners-bottom {\r\n	background-image: none;\r\n	background-position: 0 100%;\r\n	margin: 0 -5px;\r\n	clear: both;\r\n}\r\n\r\nspan.corners-bottom span {\r\n	background-image: none;\r\n	background-position: 100% 100%;\r\n}\r\n\r\n.headbg span.corners-bottom {\r\n	margin-bottom: -1px;\r\n}\r\n\r\n.post span.corners-top, .post span.corners-bottom, .panel span.corners-top, .panel span.corners-bottom, .navbar span.corners-top, .navbar span.corners-bottom {\r\n	margin: 0 -10px;\r\n}\r\n\r\n.rules span.corners-top {\r\n	margin: 0 -10px 5px -10px;\r\n}\r\n\r\n.rules span.corners-bottom {\r\n	margin: 5px -10px 0 -10px;\r\n}\r\n\r\n/* Horizontal lists\r\n----------------------------------------*/\r\nul.linklist {\r\n	display: block;\r\n	margin: 0;\r\n}\r\n\r\nul.linklist li {\r\n	display: block;\r\n	list-style-type: none;\r\n	float: left;\r\n	width: auto;\r\n	margin-right: 5px;\r\n	font-size: 11px;\r\n	line-height: 2.2em;\r\n}\r\n\r\nul.linklist li.rightside, p.rightside {\r\n	float: right;\r\n	margin-right: 0;\r\n	margin-left: 5px;\r\n	text-align: right;\r\n}\r\n\r\nul.navlinks {\r\n	padding-bottom: 1px;\r\n	margin-bottom: 1px;\r\n	border-bottom: 1px solid #FFFFFF;\r\n	font-weight: bold;\r\n}\r\n\r\nul.leftside {\r\n	float: left;\r\n	margin-left: 0;\r\n	margin-right: 5px;\r\n	text-align: left;\r\n}\r\n\r\nul.rightside {\r\n	float: right;\r\n	margin-left: 5px;\r\n	margin-right: -5px;\r\n	text-align: right;\r\n}\r\n\r\n/* Table styles\r\n----------------------------------------*/\r\ntable.table1 {\r\n	/* See tweaks.css */\r\n}\r\n\r\n#ucp-main table.table1 {\r\n	padding: 2px;\r\n}\r\n\r\ntable.table1 thead th {\r\n	font-weight: normal;\r\n	text-transform: uppercase;\r\n	color: #FFFFFF;\r\n	line-height: 1.3em;\r\n	font-size: 11px;\r\n	padding: 0 0 4px 3px;\r\n}\r\n\r\ntable.table1 thead th span {\r\n	padding-left: 7px;\r\n}\r\n\r\ntable.table1 tbody tr {\r\n	border: 1px solid #cfcfcf;\r\n}\r\n\r\ntable.table1 tbody tr:hover, table.table1 tbody tr.hover {\r\n	background-color: #f6f6f6;\r\n	color: #000;\r\n}\r\n\r\ntable.table1 td {\r\n	color: #6a6a6a;\r\n	font-size: 11px;\r\n}\r\n\r\ntable.table1 tbody td {\r\n	padding: 5px;\r\n	border-top: 1px solid #FAFAFA;\r\n}\r\n\r\ntable.table1 tbody th {\r\n	padding: 5px;\r\n	border-bottom: 1px solid #000000;\r\n	text-align: left;\r\n	color: #333333;\r\n	background-color: #FFFFFF;\r\n}\r\n\r\n/* Specific column styles */\r\ntable.table1 .name		{ text-align: left; }\r\ntable.table1 .posts		{ text-align: center !important; width: 7%; }\r\ntable.table1 .joined	{ text-align: left; width: 15%; }\r\ntable.table1 .active	{ text-align: left; width: 15%; }\r\ntable.table1 .mark		{ text-align: center; width: 7%; }\r\ntable.table1 .info		{ text-align: left; width: 30%; }\r\ntable.table1 .info div	{ width: 100%; white-space: nowrap; overflow: hidden; }\r\ntable.table1 .autocol	{ line-height: 2em; white-space: nowrap; }\r\ntable.table1 thead .autocol { padding-left: 1em; }\r\n\r\ntable.table1 span.rank-img {\r\n	float: right;\r\n	width: auto;\r\n}\r\n\r\ntable.info td {\r\n	padding: 3px;\r\n}\r\n\r\ntable.info tbody th {\r\n	padding: 3px;\r\n	text-align: right;\r\n	vertical-align: top;\r\n	color: #000000;\r\n	font-weight: normal;\r\n}\r\n\r\n.forumbg table.table1 {\r\n	margin: 0 -2px -1px -1px;\r\n}\r\n\r\n/* Misc layout styles\r\n---------------------------------------- */\r\n/* column[1-2] styles are containers for two column layouts \r\n   Also see tweaks.css */\r\n.column1 {\r\n	float: left;\r\n	clear: left;\r\n	width: 49%;\r\n}\r\n\r\n.column2 {\r\n	float: right;\r\n	clear: right;\r\n	width: 49%;\r\n}\r\n\r\n/* General classes for placing floating blocks */\r\n.left-box {\r\n	float: left;\r\n	width: auto;\r\n	text-align: left;\r\n}\r\n\r\n.right-box {\r\n	float: right;\r\n	width: auto;\r\n	text-align: right;\r\n}\r\n\r\ndl.details {\r\n	/*font-family: Tahoma, "Lucida Grande", Verdana, Helvetica, Arial, sans-serif;*/\r\n	font-size: 11px;\r\n}\r\n\r\ndl.details dt {\r\n	float: left;\r\n	clear: left;\r\n	width: 30%;\r\n	text-align: right;\r\n	color: #000000;\r\n	display: block;\r\n}\r\n\r\ndl.details dd {\r\n	margin-left: 0;\r\n	padding-left: 5px;\r\n	margin-bottom: 5px;\r\n	color: #828282;\r\n	float: left;\r\n	width: 65%;\r\n}\r\n\r\n/* Pagination\r\n---------------------------------------- */\r\n.pagination {\r\n	height: 1%; /* IE tweak (holly hack) */\r\n	width: auto;\r\n	text-align: right;\r\n	margin-top: 5px;\r\n	float: right;\r\n}\r\n\r\n.pagination span.page-sep {\r\n	display: none;\r\n}\r\n\r\nli.pagination {\r\n	margin-top: 0;\r\n}\r\n\r\n.pagination strong, .pagination b {\r\n	font-weight: normal;\r\n}\r\n\r\n.pagination span strong {\r\n	padding: 0 2px;\r\n	margin: 0 2px;\r\n	font-weight: normal;\r\n	color: #FFFFFF;\r\n	background-color: #bfbfbf;\r\n	border: 1px solid #bfbfbf;\r\n	font-size: 0.9em;\r\n}\r\n\r\n.pagination span a, .pagination span a:link, .pagination span a:visited, .pagination span a:active {\r\n	font-weight: normal;\r\n	text-decoration: none;\r\n	color: #747474;\r\n	margin: 0 2px;\r\n	padding: 0 2px;\r\n	background-color: #eeeeee;\r\n	border: 1px solid #bababa;\r\n	font-size: 0.9em;\r\n	line-height: 1.5em;\r\n}\r\n\r\n.pagination span a:hover {\r\n	border-color: #d2d2d2;\r\n	background-color: #d2d2d2;\r\n	color: #FFF;\r\n	text-decoration: none;\r\n}\r\n\r\n.pagination img {\r\n	vertical-align: middle;\r\n}\r\n\r\n/* Pagination in viewforum for multipage topics */\r\n.row .pagination {\r\n	display: block;\r\n	float: right;\r\n	width: auto;\r\n	margin-top: 0;\r\n	padding: 1px 0 1px 15px;\r\n	font-size: 0.9em;\r\n	background: none 0 50% no-repeat;\r\n}\r\n\r\n.row .pagination span a, li.pagination span a {\r\n	background-color: #FFFFFF;\r\n}\r\n\r\n.row .pagination span a:hover, li.pagination span a:hover {\r\n	background-color: #d2d2d2;\r\n}\r\n\r\n/* Miscellaneous styles\r\n---------------------------------------- */\r\n#forum-permissions {\r\n	float: right;\r\n	width: auto;\r\n	padding-left: 5px;\r\n	margin-left: 5px;\r\n	margin-top: 10px;\r\n	text-align: right;\r\n}\r\n\r\n.copyright {\r\n	padding: 5px;\r\n	text-align: center;\r\n	color: #555555;\r\n}\r\n\r\n.small {\r\n	font-size: 0.9em !important;\r\n}\r\n\r\n.titlespace {\r\n	margin-bottom: 15px;\r\n}\r\n\r\n.headerspace {\r\n	margin-top: 20px;\r\n}\r\n\r\n.error {\r\n	color: #bcbcbc;\r\n	font-weight: bold;\r\n	font-size: 11px;\r\n}\r\n\r\n.reported {\r\n	background-color: #f7f7f7;\r\n}\r\n\r\nli.reported:hover {\r\n	background-color: #ececec;\r\n}\r\n\r\ndiv.rules {\r\n	background-color: #ececec;\r\n	color: #bcbcbc;\r\n	padding: 0 10px;\r\n	margin: 10px 0;\r\n	font-size: 11px;\r\n}\r\n\r\ndiv.rules ul {\r\n	margin-left: 20px;\r\n}\r\n\r\np.rules {\r\n	background-color: #ececec;\r\n	background-image: none;\r\n	padding: 5px;\r\n}\r\n\r\np.rules img {\r\n	vertical-align: middle;\r\n}\r\n\r\np.rules a {\r\n	vertical-align: middle;\r\n	clear: both;\r\n}\r\n\r\n#top {\r\n	position: absolute;\r\n	top: -20px;\r\n}\r\n\r\n.clear {\r\n	display: block;\r\n	clear: both;\r\n	font-size: 1px;\r\n	line-height: 1px;\r\n	background: transparent;\r\n}\r\n\r\n.title_txt{\r\npadding:10px;font-weight:bold;font-size:13px;float:right;text-align:right;display:block;\r\n}\r\n/* proSilver Link Styles\r\n---------------------------------------- */\r\n\r\na:link	{ color: #898989; text-decoration: none; }\r\na:visited	{ color: #898989; text-decoration: none; }\r\na:hover	{ color: #d3d3d3; text-decoration: underline; }\r\na:active	{ color: #d2d2d2; text-decoration: none; }\r\n\r\n/* Coloured usernames */\r\n.username-coloured {\r\n	font-weight: bold;\r\n	display: inline !important;\r\n	padding: 0 !important;\r\n}\r\n\r\n/* Links on gradient backgrounds */\r\n#search-box a:link, .navbg a:link, .forumbg .header a:link, .forabg .header a:link, th a:link {\r\n	color: #FFFFFF;\r\n	text-decoration: none;\r\n}\r\n\r\n#search-box a:visited, .navbg a:visited, .forumbg .header a:visited, .forabg .header a:visited, th a:visited {\r\n	color: #FFFFFF;\r\n	text-decoration: none;\r\n}\r\n\r\n#search-box a:hover, .navbg a:hover, .forumbg .header a:hover, .forabg .header a:hover, th a:hover {\r\n	color: #ffffff;\r\n	text-decoration: underline;\r\n}\r\n\r\n#search-box a:active, .navbg a:active, .forumbg .header a:active, .forabg .header a:active, th a:active {\r\n	color: #ffffff;\r\n	text-decoration: none;\r\n}\r\n\r\n/* Links for forum/topic lists */\r\na.forumtitle {\r\n	font-family: "Trebuchet MS", Helvetica, Arial, Sans-serif;\r\n	font-size: 1.2em;\r\n	font-weight: bold;\r\n	color: #898989;\r\n	text-decoration: none;\r\n}\r\n\r\n/* a.forumtitle:visited { color: #898989; } */\r\n\r\na.forumtitle:hover {\r\n	color: #bcbcbc;\r\n	text-decoration: underline;\r\n}\r\n\r\na.forumtitle:active {\r\n	color: #898989;\r\n}\r\n\r\na.topictitle {\r\n	font-family: "Trebuchet MS", Helvetica, Arial, Sans-serif;\r\n	font-size: 1.2em;\r\n	font-weight: bold;\r\n	color: #898989;\r\n	text-decoration: none;\r\n}\r\n\r\n/* a.topictitle:visited { color: #d2d2d2; } */\r\n\r\na.topictitle:hover {\r\n	color: #bcbcbc;\r\n	text-decoration: underline;\r\n}\r\n\r\na.topictitle:active {\r\n	color: #898989;\r\n}\r\n\r\n/* Post body links */\r\n.postlink {\r\n	text-decoration: none;\r\n	color: #d2d2d2;\r\n	border-bottom: 1px solid #d2d2d2;\r\n	padding-bottom: 0;\r\n}\r\n\r\n.postlink:visited {\r\n	color: #bdbdbd;\r\n	border-bottom-style: dotted;\r\n	border-bottom-color: #666666;\r\n}\r\n\r\n.postlink:active {\r\n	color: #d2d2d2;\r\n}\r\n\r\n.postlink:hover {\r\n	background-color: #f6f6f6;\r\n	text-decoration: none;\r\n	color: #404040;\r\n}\r\n\r\n.signature a, .signature a:visited, .signature a:active, .signature a:hover {\r\n	border: none;\r\n	text-decoration: underline;\r\n	background-color: transparent;\r\n}\r\n\r\n/* Profile links */\r\n.postprofile a:link, .postprofile a:active, .postprofile a:visited, .postprofile dt.author a {\r\n	font-weight: bold;\r\n	color: #898989;\r\n	text-decoration: none;\r\n}\r\n\r\n.postprofile a:hover, .postprofile dt.author a:hover {\r\n	text-decoration: underline;\r\n	color: #d3d3d3;\r\n}\r\n\r\n\r\n/* Profile searchresults */	\r\n.search .postprofile a {\r\n	color: #898989;\r\n	text-decoration: none; \r\n	font-weight: normal;\r\n}\r\n\r\n.search .postprofile a:hover {\r\n	color: #d3d3d3;\r\n	text-decoration: underline; \r\n}\r\n\r\n/* Back to top of page */\r\n.back2top {\r\n	clear: both;\r\n	height: 11px;\r\n	text-align: right;\r\n}\r\n\r\na.top {\r\n	background: none no-repeat top left;\r\n	text-decoration: none;\r\n	width: {IMG_ICON_BACK_TOP_WIDTH}px;\r\n	height: {IMG_ICON_BACK_TOP_HEIGHT}px;\r\n	display: block;\r\n	float: right;\r\n	overflow: hidden;\r\n	letter-spacing: 1000px;\r\n	text-indent: 11px;\r\n}\r\n\r\na.top2 {\r\n	background: none no-repeat 0 50%;\r\n	text-decoration: none;\r\n	padding-left: 15px;\r\n}\r\n\r\n/* Arrow links  */\r\na.up		{ background: none no-repeat left center; }\r\na.down		{ background: none no-repeat right center; }\r\na.left		{ background: none no-repeat 3px 60%; }\r\na.right		{ background: none no-repeat 95% 60%; }\r\n\r\na.up, a.up:link, a.up:active, a.up:visited {\r\n	padding-left: 10px;\r\n	text-decoration: none;\r\n	border-bottom-width: 0;\r\n}\r\n\r\na.up:hover {\r\n	background-position: left top;\r\n	background-color: transparent;\r\n}\r\n\r\na.down, a.down:link, a.down:active, a.down:visited {\r\n	padding-right: 10px;\r\n}\r\n\r\na.down:hover {\r\n	background-position: right bottom;\r\n	text-decoration: none;\r\n}\r\n\r\na.left, a.left:active, a.left:visited {\r\n	padding-left: 12px;\r\n}\r\n\r\na.left:hover {\r\n	color: #d2d2d2;\r\n	text-decoration: none;\r\n	background-position: 0 60%;\r\n}\r\n\r\na.right, a.right:active, a.right:visited {\r\n	padding-right: 12px;\r\n}\r\n\r\na.right:hover {\r\n	color: #d2d2d2;\r\n	text-decoration: none;\r\n	background-position: 100% 60%;\r\n}\r\n/* proSilver Content Styles\r\n---------------------------------------- */\r\n\r\nul.topiclist {\r\n	display: block;\r\n	list-style-type: none;\r\n	margin: 0;\r\n}\r\n\r\nul.forums {\r\n	background: #f9f9f9 none repeat-x 0 0;\r\n}\r\n\r\nul.topiclist li {\r\n	display: block;\r\n	list-style-type: none;\r\n	color: #777777;\r\n	margin: 0;\r\n}\r\n\r\nul.topiclist dl {\r\n	position: relative;\r\n}\r\n\r\nul.topiclist li.row dl {\r\n	padding: 2px 0;\r\n}\r\n\r\nul.topiclist dt {\r\n	display: block;\r\n	float: left;\r\n	width: 50%;\r\n	font-size: 11px;\r\n	padding-left: 5px;\r\n	padding-right: 5px;\r\n}\r\n\r\nul.topiclist dd {\r\n	display: block;\r\n	float: left;\r\n	border-left: 1px solid #FFFFFF;\r\n	padding: 4px 0;\r\n}\r\n\r\nul.topiclist dfn {\r\n	/* Labels for post/view counts */\r\n	display: none;\r\n}\r\n\r\nul.topiclist li.row dt a.subforum {\r\n	background-image: none;\r\n	background-position: 0 50%;\r\n	background-repeat: no-repeat;\r\n	position: relative;\r\n	white-space: nowrap;\r\n	padding: 0 0 0 12px;\r\n}\r\n\r\n.forum-image {\r\n	float: left;\r\n	padding-top: 5px;\r\n	margin-right: 5px;\r\n}\r\n\r\nli.row {\r\n	border-top: 1px solid #FFFFFF;\r\n	border-bottom: 1px solid #8f8f8f;\r\n}\r\n\r\nli.row strong {\r\n	font-weight: normal;\r\n	color: #000000;\r\n}\r\n\r\nli.row:hover {\r\n	background-color: #f6f6f6;\r\n}\r\n\r\nli.row:hover dd {\r\n	border-left-color: #CCCCCC;\r\n}\r\n\r\nli.header dt, li.header dd {\r\n	line-height: 1em;\r\n	border-left-width: 0;\r\n	margin: 2px 0 4px 0;\r\n	color: #FFFFFF;\r\n	padding-top: 2px;\r\n	padding-bottom: 2px;\r\n	font-size: 11px;\r\n	font-family: Tahoma, Arial, Helvetica, sans-serif;\r\n	text-transform: uppercase;\r\n}\r\n\r\nli.header dt {\r\n	font-weight: bold;\r\n}\r\n\r\nli.header dd {\r\n	margin-left: 1px;\r\n}\r\n\r\nli.header dl.icon {\r\n	min-height: 0;\r\n}\r\n\r\nli.header dl.icon dt {\r\n	/* Tweak for headers alignment when folder icon used */\r\n	padding-left: 0;\r\n	padding-right: 50px;\r\n}\r\n\r\n/* Forum list column styles */\r\ndl.icon {\r\n	min-height: 35px;\r\n	background-position: 10px 50%;		/* Position of folder icon */\r\n	background-repeat: no-repeat;\r\n}\r\n\r\ndl.icon dt {\r\n	padding-left: 45px;					/* Space for folder icon */\r\n	background-repeat: no-repeat;\r\n	background-position: 5px 95%;		/* Position of topic icon */\r\n}\r\n\r\ndd.posts, dd.topics, dd.views {\r\n	width: 8%;\r\n	text-align: center;\r\n	line-height: 2.2em;\r\n	font-size: 11px;\r\n}\r\n\r\ndd.lastpost {\r\n	width: 25%;\r\n	font-size: 11px;\r\n}\r\n\r\ndd.redirect {\r\n	font-size: 11px;\r\n	line-height: 2.5em;\r\n}\r\n\r\ndd.moderation {\r\n	font-size: 11px;\r\n}\r\n\r\ndd.lastpost span, ul.topiclist dd.searchby span, ul.topiclist dd.info span, ul.topiclist dd.time span, dd.redirect span, dd.moderation span {\r\n	display: block;\r\n	padding-left: 5px;\r\n}\r\n\r\ndd.time {\r\n	width: auto;\r\n	line-height: 200%;\r\n	font-size: 11px;\r\n}\r\n\r\ndd.extra {\r\n	width: 12%;\r\n	line-height: 200%;\r\n	text-align: center;\r\n	font-size: 11px;\r\n}\r\n\r\ndd.mark {\r\n	float: right !important;\r\n	width: 9%;\r\n	text-align: center;\r\n	line-height: 200%;\r\n	font-size: 11px;\r\n}\r\n\r\ndd.info {\r\n	width: 30%;\r\n}\r\n\r\ndd.option {\r\n	width: 15%;\r\n	line-height: 200%;\r\n	text-align: center;\r\n	font-size: 11px;\r\n}\r\n\r\ndd.searchby {\r\n	width: 47%;\r\n	font-size: 11px;\r\n	line-height: 1em;\r\n}\r\n\r\nul.topiclist dd.searchextra {\r\n	margin-left: 5px;\r\n	padding: 0.2em 0;\r\n	font-size: 11px;\r\n	color: #333333;\r\n	border-left: none;\r\n	clear: both;\r\n	width: 98%;\r\n	overflow: hidden;\r\n}\r\n\r\n/* Container for post/reply buttons and pagination */\r\n.topic-actions {\r\n	margin-bottom: 3px;\r\n	font-size: 11px;\r\n	height: 28px;\r\n	min-height: 28px;\r\n}\r\ndiv[class].topic-actions {\r\n	height: auto;\r\n}\r\n\r\n/* Post body styles\r\n----------------------------------------*/\r\n.postbody {\r\n	padding: 0;\r\n	line-height: 1.48em;\r\n	color: #333333;\r\n	width: 76%;\r\n	float: left;\r\n	clear: both;\r\n}\r\n\r\n.postbody .ignore {\r\n	font-size: 11px;\r\n}\r\n\r\n.postbody h3.first {\r\n	/* The first post on the page uses this */\r\n	font-size: 11px;\r\n}\r\n\r\n.postbody h3 {\r\n	/* Postbody requires a different h3 format - so change it here */\r\n	font-size: 11px;\r\n	padding: 2px 0 0 0;\r\n	margin: 0 0 0.3em 0 !important;\r\n	text-transform: none;\r\n	border: none;\r\n	font-family: Tahoma, "Trebuchet MS", Verdana, Helvetica, Arial, sans-serif;\r\n	line-height: 125%;\r\n}\r\n\r\n.postbody h3 img {\r\n	/* Also see tweaks.css */\r\n	vertical-align: bottom;\r\n}\r\n\r\n.postbody .content {\r\n	font-size: 11px;\r\n}\r\n\r\n.search .postbody {\r\n	width: 68%\r\n}\r\n\r\n/* Topic review panel\r\n----------------------------------------*/\r\n#review {\r\n	margin-top: 2em;\r\n}\r\n\r\n#topicreview {\r\n	padding-right: 5px;\r\n	overflow: auto;\r\n	height: 300px;\r\n}\r\n\r\n#topicreview .postbody {\r\n	width: auto;\r\n	float: none;\r\n	margin: 0;\r\n	height: auto;\r\n}\r\n\r\n#topicreview .post {\r\n	height: auto;\r\n}\r\n\r\n#topicreview h2 {\r\n	border-bottom-width: 0;\r\n}\r\n\r\n/* Content container styles\r\n----------------------------------------*/\r\n.content {\r\n	min-height: 3em;\r\n	overflow: hidden;\r\n	line-height: 1.4em;\r\n	font-family: Tahoma, "Lucida Grande", "Trebuchet MS", Verdana, Helvetica, Arial, sans-serif;\r\n	font-size: 11px;\r\n	color: #333333;\r\n}\r\n\r\n.content h2, .panel h2 {\r\n	font-weight: normal;\r\n	color: #989898;\r\n	border-bottom: 1px solid #CCCCCC;\r\n	font-size: 1.6em;\r\n	margin-top: 0.5em;\r\n	margin-bottom: 0.5em;\r\n	padding-bottom: 0.5em;\r\n}\r\n\r\n.panel h3 {\r\n	margin: 0.5em 0;\r\n}\r\n\r\n.panel p {\r\n	font-size: 11px;\r\n	margin-bottom: 1em;\r\n	line-height: 1.4em;\r\n}\r\n\r\n.content p {\r\n	font-family: Tahoma, "Lucida Grande", "Trebuchet MS", Verdana, Helvetica, Arial, sans-serif;\r\n	font-size: 11px;\r\n	margin-bottom: 1em;\r\n	line-height: 1.4em;\r\n}\r\n\r\ndl.faq {\r\n	font-family: Tahoma, "Lucida Grande", Verdana, Helvetica, Arial, sans-serif;\r\n	font-size: 11px;\r\n	margin-top: 1em;\r\n	margin-bottom: 2em;\r\n	line-height: 1.4em;\r\n}\r\n\r\ndl.faq dt {\r\n	font-weight: bold;\r\n	color: #333333;\r\n}\r\n\r\n.content dl.faq {\r\n	font-size: 11px;\r\n	margin-bottom: 0.5em;\r\n}\r\n\r\n.content li {\r\n	list-style-type: inherit;\r\n}\r\n\r\n.content ul, .content ol {\r\n	margin-bottom: 1em;\r\n	margin-left: 3em;\r\n}\r\n\r\n.posthilit {\r\n	background-color: #f3f3f3;\r\n	color: #BCBCBC;\r\n	padding: 0 2px 1px 2px;\r\n}\r\n\r\n.announce, .unreadpost {\r\n	/* Highlight the announcements & unread posts box */\r\n	border-left-color: #BCBCBC;\r\n	border-right-color: #BCBCBC;\r\n}\r\n\r\n/* Post author */\r\np.author {\r\n	margin: 0 15em 0.6em 0;\r\n	padding: 0 0 5px 0;\r\n	font-family: Tahoma, Verdana, Helvetica, Arial, sans-serif;\r\n	font-size: 11px;\r\n	line-height: 1.2em;\r\n}\r\n\r\n/* Post signature */\r\n.signature {\r\n	margin-top: 1.5em;\r\n	padding-top: 0.2em;\r\n	font-size: 11px;\r\n	border-top: 1px solid #CCCCCC;\r\n	clear: left;\r\n	line-height: 140%;\r\n	overflow: hidden;\r\n	width: 100%;\r\n}\r\n\r\ndd .signature {\r\n	margin: 0;\r\n	padding: 0;\r\n	clear: none;\r\n	border: none;\r\n}\r\n\r\n/* Post noticies */\r\n.notice {\r\n	font-family: Tahoma, "Lucida Grande", Verdana, Helvetica, Arial, sans-serif;\r\n	width: auto;\r\n	margin-top: 1.5em;\r\n	padding-top: 0.2em;\r\n	font-size: 11px;\r\n	border-top: 1px dashed #CCCCCC;\r\n	clear: left;\r\n	line-height: 130%;\r\n}\r\n\r\n/* Jump to post link for now */\r\nul.searchresults {\r\n	list-style: none;\r\n	text-align: right;\r\n	clear: both;\r\n}\r\n\r\n/* BB Code styles\r\n----------------------------------------*/\r\n/* Quote block */\r\nblockquote {\r\n	background: #ebebeb none 6px 8px no-repeat;\r\n	border: 1px solid #dbdbdb;\r\n	font-size: 0.95em;\r\n	margin: 0.5em 1px 0 25px;\r\n	overflow: hidden;\r\n	padding: 5px;\r\n}\r\n\r\nblockquote blockquote {\r\n	/* Nested quotes */\r\n	background-color: #bababa;\r\n	font-size: 11px;\r\n	margin: 0.5em 1px 0 15px;	\r\n}\r\n\r\nblockquote blockquote blockquote {\r\n	/* Nested quotes */\r\n	background-color: #e4e4e4;\r\n}\r\n\r\nblockquote cite {\r\n	/* Username/source of quoter */\r\n	font-style: normal;\r\n	font-weight: bold;\r\n	margin-left: 20px;\r\n	display: block;\r\n	font-size: 0.9em;\r\n}\r\n\r\nblockquote cite cite {\r\n	font-size: 11px;\r\n}\r\n\r\nblockquote.uncited {\r\n	padding-top: 25px;\r\n}\r\n\r\n/* Code block */\r\ndl.codebox {\r\n	padding: 3px;\r\n	background-color: #FFFFFF;\r\n	border: 1px solid #d8d8d8;\r\n	font-size: 11px;\r\n}\r\n\r\ndl.codebox dt {\r\n	text-transform: uppercase;\r\n	border-bottom: 1px solid #CCCCCC;\r\n	margin-bottom: 3px;\r\n	font-size: 0.8em;\r\n	font-weight: bold;\r\n	display: block;\r\n}\r\n\r\nblockquote dl.codebox {\r\n	margin-left: 0;\r\n}\r\n\r\ndl.codebox code {\r\n	/* Also see tweaks.css */\r\n	overflow: auto;\r\n	display: block;\r\n	height: auto;\r\n	max-height: 200px;\r\n	white-space: normal;\r\n	padding-top: 5px;\r\n	font: 0.9em Monaco, "Andale Mono","Courier New", Courier, mono;\r\n	line-height: 1.3em;\r\n	color: #8b8b8b;\r\n	margin: 2px 0;\r\n}\r\n\r\n.syntaxbg		{ color: #FFFFFF; }\r\n.syntaxcomment	{ color: #000000; }\r\n.syntaxdefault	{ color: #bcbcbc; }\r\n.syntaxhtml		{ color: #000000; }\r\n.syntaxkeyword	{ color: #585858; }\r\n.syntaxstring	{ color: #a7a7a7; }\r\n\r\n/* Attachments\r\n----------------------------------------*/\r\n.attachbox {\r\n	float: left;\r\n	width: auto; \r\n	margin: 5px 5px 5px 0;\r\n	padding: 6px;\r\n	background-color: #FFFFFF;\r\n	border: 1px dashed #d8d8d8;\r\n	clear: left;\r\n}\r\n\r\n.pm-message .attachbox {\r\n	background-color: #f3f3f3;\r\n}\r\n\r\n.attachbox dt {\r\n	font-family: Tahoma, Arial, Helvetica, sans-serif;\r\n	text-transform: uppercase;\r\n}\r\n\r\n.attachbox dd {\r\n	margin-top: 4px;\r\n	padding-top: 4px;\r\n	clear: left;\r\n	border-top: 1px solid #d8d8d8;\r\n}\r\n\r\n.attachbox dd dd {\r\n	border: none;\r\n}\r\n\r\n.attachbox p {\r\n	line-height: 110%;\r\n	color: #666666;\r\n	font-weight: normal;\r\n	clear: left;\r\n}\r\n\r\n.attachbox p.stats\r\n{\r\n	line-height: 110%;\r\n	color: #666666;\r\n	font-weight: normal;\r\n	clear: left;\r\n}\r\n\r\n.attach-image {\r\n	margin: 3px 0;\r\n	width: 100%;\r\n	max-height: 350px;\r\n	overflow: auto;\r\n}\r\n\r\n.attach-image img {\r\n	border: 1px solid #999999;\r\n/*	cursor: move; */\r\n	cursor: default;\r\n}\r\n\r\n/* Inline image thumbnails */\r\ndiv.inline-attachment dl.thumbnail, div.inline-attachment dl.file {\r\n	display: block;\r\n	margin-bottom: 4px;\r\n}\r\n\r\ndiv.inline-attachment p {\r\n	font-size: 100%;\r\n}\r\n\r\ndl.file {\r\n	font-family: Tahoma, Verdana, Arial, Helvetica, sans-serif;\r\n	display: block;\r\n}\r\n\r\ndl.file dt {\r\n	text-transform: none;\r\n	margin: 0;\r\n	padding: 0;\r\n	font-weight: bold;\r\n	font-family: Tahoma, Verdana, Arial, Helvetica, sans-serif;\r\n}\r\n\r\ndl.file dd {\r\n	color: #666666;\r\n	margin: 0;\r\n	padding: 0;	\r\n}\r\n\r\ndl.thumbnail img {\r\n	padding: 3px;\r\n	border: 1px solid #666666;\r\n	background-color: #FFF;\r\n}\r\n\r\ndl.thumbnail dd {\r\n	color: #666666;\r\n	font-style: italic;\r\n	font-family: Tahoma, Verdana, Arial, Helvetica, sans-serif;\r\n}\r\n\r\n.attachbox dl.thumbnail dd {\r\n	font-size: 100%;\r\n}\r\n\r\ndl.thumbnail dt a:hover {\r\n	background-color: #EEEEEE;\r\n}\r\n\r\ndl.thumbnail dt a:hover img {\r\n	border: 1px solid #d2d2d2;\r\n}\r\n\r\n/* Post poll styles\r\n----------------------------------------*/\r\nfieldset.polls {\r\n	font-family: Tahoma, "Trebuchet MS", Verdana, Helvetica, Arial, sans-serif;\r\n}\r\n\r\nfieldset.polls dl {\r\n	margin-top: 5px;\r\n	border-top: 1px solid #e2e2e2;\r\n	padding: 5px 0 0 0;\r\n	line-height: 120%;\r\n	color: #666666;\r\n}\r\n\r\nfieldset.polls dl.voted {\r\n	font-weight: bold;\r\n	color: #000000;\r\n}\r\n\r\nfieldset.polls dt {\r\n	text-align: left;\r\n	float: left;\r\n	display: block;\r\n	width: 30%;\r\n	border-right: none;\r\n	padding: 0;\r\n	margin: 0;\r\n	font-size: 11px;\r\n}\r\n\r\nfieldset.polls dd {\r\n	float: left;\r\n	width: 10%;\r\n	border-left: none;\r\n	padding: 0 5px;\r\n	margin-left: 0;\r\n	font-size: 11px;\r\n}\r\n\r\nfieldset.polls dd.resultbar {\r\n	width: 50%;\r\n}\r\n\r\nfieldset.polls dd input {\r\n	margin: 2px 0;\r\n}\r\n\r\nfieldset.polls dd div {\r\n	text-align: right;\r\n	font-family: Tahoma, Arial, Helvetica, sans-serif;\r\n	color: #FFFFFF;\r\n	font-weight: bold;\r\n	padding: 0 2px;\r\n	overflow: visible;\r\n	min-width: 2%;\r\n}\r\n\r\n.pollbar1 {\r\n	background-color: #aaaaaa;\r\n	border-bottom: 1px solid #747474;\r\n	border-right: 1px solid #747474;\r\n}\r\n\r\n.pollbar2 {\r\n	background-color: #bebebe;\r\n	border-bottom: 1px solid #8c8c8c;\r\n	border-right: 1px solid #8c8c8c;\r\n}\r\n\r\n.pollbar3 {\r\n	background-color: #D1D1D1;\r\n	border-bottom: 1px solid #aaaaaa;\r\n	border-right: 1px solid #aaaaaa;\r\n}\r\n\r\n.pollbar4 {\r\n	background-color: #e4e4e4;\r\n	border-bottom: 1px solid #bebebe;\r\n	border-right: 1px solid #bebebe;\r\n}\r\n\r\n.pollbar5 {\r\n	background-color: #f8f8f8;\r\n	border-bottom: 1px solid #D1D1D1;\r\n	border-right: 1px solid #D1D1D1;\r\n}\r\n\r\n/* Poster profile block\r\n----------------------------------------*/\r\n.postprofile {\r\n	/* Also see tweaks.css */\r\n	margin: 5px 0 10px 0;\r\n	min-height: 80px;\r\n	color: #666666;\r\n	border-left: 1px solid #FFFFFF;\r\n	width: 22%;\r\n	float: right;\r\n	display: inline;\r\n}\r\n.pm .postprofile {\r\n	border-left: 1px solid #DDDDDD;\r\n}\r\n\r\n.postprofile dd, .postprofile dt {\r\n	line-height: 1.2em;\r\n	margin-left: 8px;\r\n}\r\n\r\n.postprofile strong {\r\n	font-weight: normal;\r\n	color: #000000;\r\n}\r\n\r\n.avatar {\r\n	border: none;\r\n	margin-bottom: 3px;\r\n}\r\n\r\n.online {\r\n	background-image: none;\r\n	background-position: 100% 0;\r\n	background-repeat: no-repeat;\r\n}\r\n\r\n/* Poster profile used by search*/\r\n.search .postprofile {\r\n	width: 30%;\r\n}\r\n\r\n/* pm list in compose message if mass pm is enabled */\r\ndl.pmlist dt {\r\n	width: 60% !important;\r\n}\r\n\r\ndl.pmlist dt textarea {\r\n	width: 95%;\r\n}\r\n\r\ndl.pmlist dd {\r\n	margin-left: 61% !important;\r\n	margin-bottom: 2px;\r\n}\r\n/* proSilver Button Styles\r\n---------------------------------------- */\r\n\r\n/* Rollover buttons\r\n   Based on: http://wellstyled.com/css-nopreload-rollovers.html\r\n----------------------------------------*/\r\n.buttons {\r\n	float: left;\r\n	width: auto;\r\n	height: auto;\r\n}\r\n\r\n/* Rollover state */\r\n.buttons div {\r\n	float: left;\r\n	margin: 0 5px 0 0;\r\n	background-position: 0 100%;\r\n}\r\n\r\n/* Rolloff state */\r\n.buttons div a {\r\n	display: block;\r\n	width: 100%;\r\n	height: 100%;\r\n	background-position: 0 0;\r\n	position: relative;\r\n	overflow: hidden;\r\n}\r\n\r\n/* Hide <a> text and hide off-state image when rolling over (prevents flicker in IE) */\r\n/*.buttons div span		{ display: none; }*/\r\n/*.buttons div a:hover	{ background-image: none; }*/\r\n.buttons div span			{ position: absolute; width: 100%; height: 100%; cursor: pointer;}\r\n.buttons div a:hover span	{ background-position: 0 100%; }\r\n\r\n/* Big button images */\r\n.reply-icon span	{ background: transparent none 0 0 no-repeat; }\r\n.quick-reply-icon span	{ background: transparent none 0 0 no-repeat; }\r\n\r\n.post-icon span		{ background: transparent none 0 0 no-repeat; }\r\n.locked-icon span	{ background: transparent none 0 0 no-repeat; }\r\n.pmreply-icon span	{ background: none 0 0 no-repeat; }\r\n.newpm-icon span 	{ background: none 0 0 no-repeat; }\r\n.forwardpm-icon span 	{ background: none 0 0 no-repeat; }\r\n\r\n/* Set big button dimensions */\r\n.buttons div.reply-icon		{ width: {IMG_BUTTON_TOPIC_REPLY_WIDTH}px; height: {IMG_BUTTON_TOPIC_REPLY_HEIGHT}px; }\r\n.buttons div.quick-reply-icon	{ width: {IMG_BUTTON_QUICK_REPLY_WIDTH}px; height: {IMG_BUTTON_QUICK_REPLY_HEIGHT}px; }\r\n\r\n.buttons div.post-icon		{ width: {IMG_BUTTON_TOPIC_NEW_WIDTH}px; height: {IMG_BUTTON_TOPIC_NEW_HEIGHT}px; }\r\n.buttons div.locked-icon	{ width: {IMG_BUTTON_TOPIC_LOCKED_WIDTH}px; height: {IMG_BUTTON_TOPIC_LOCKED_HEIGHT}px; }\r\n.buttons div.pmreply-icon	{ width: {IMG_BUTTON_PM_REPLY_WIDTH}px; height: {IMG_BUTTON_PM_REPLY_HEIGHT}px; }\r\n.buttons div.newpm-icon		{ width: {IMG_BUTTON_PM_NEW_WIDTH}px; height: {IMG_BUTTON_PM_NEW_HEIGHT}px; }\r\n.buttons div.forwardpm-icon	{ width: {IMG_BUTTON_PM_FORWARD_WIDTH}px; height: {IMG_BUTTON_PM_FORWARD_HEIGHT}px; }\r\n\r\n/* Sub-header (navigation bar)\r\n--------------------------------------------- */\r\na.print, a.sendemail, a.fontsize {\r\n	display: block;\r\n	overflow: hidden;\r\n	height: 18px;\r\n	text-indent: -5000px;\r\n	text-align: left;\r\n	background-repeat: no-repeat;\r\n}\r\n\r\na.print {\r\n	background-image: none;\r\n	width: 22px;\r\n}\r\n\r\na.sendemail {\r\n	background-image: none;\r\n	width: 22px;\r\n}\r\n\r\na.fontsize {\r\n	background-image: none;\r\n	background-position: 0 -1px;\r\n	width: 29px;\r\n}\r\n\r\na.fontsize:hover {\r\n	background-position: 0 -20px;\r\n	text-decoration: none;\r\n}\r\n\r\n/* Icon images\r\n---------------------------------------- */\r\n.sitehome, .icon-faq, .icon-members, .icon-home, .icon-ucp, .icon-register, .icon-logout,\r\n.icon-bookmark, .icon-bump, .icon-subscribe, .icon-unsubscribe, .icon-pages, .icon-search {\r\n	background-position: 0 50%;\r\n	background-repeat: no-repeat;\r\n	background-image: none;\r\n	padding: 1px 0 0 17px;\r\n}\r\n\r\n/* Poster profile icons\r\n----------------------------------------*/\r\nul.profile-icons {\r\n	padding-top: 10px;\r\n	list-style: none;\r\n}\r\n\r\n/* Rollover state */\r\nul.profile-icons li {\r\n	float: left;\r\n	margin: 0 6px 3px 0;\r\n	background-position: 0 100%;\r\n}\r\n\r\n/* Rolloff state */\r\nul.profile-icons li a {\r\n	display: block;\r\n	width: 100%;\r\n	height: 100%;\r\n	background-position: 0 0;\r\n}\r\n\r\n/* Hide <a> text and hide off-state image when rolling over (prevents flicker in IE) */\r\nul.profile-icons li span { display:none; }\r\nul.profile-icons li a:hover { background: none; }\r\n\r\n/* Positioning of moderator icons */\r\n.postbody ul.profile-icons {\r\n	float: right;\r\n	width: auto;\r\n	padding: 0;\r\n}\r\n\r\n.postbody ul.profile-icons li {\r\n	margin: 0 3px;\r\n}\r\n\r\n/* Profile & navigation icons */\r\n.email-icon, .email-icon a		{ background: none top left no-repeat; }\r\n.aim-icon, .aim-icon a			{ background: none top left no-repeat; }\r\n.yahoo-icon, .yahoo-icon a		{ background: none top left no-repeat; }\r\n.web-icon, .web-icon a			{ background: none top left no-repeat; }\r\n.msnm-icon, .msnm-icon a			{ background: none top left no-repeat; }\r\n.icq-icon, .icq-icon a			{ background: none top left no-repeat; }\r\n.jabber-icon, .jabber-icon a		{ background: none top left no-repeat; }\r\n.pm-icon, .pm-icon a				{ background: none top left no-repeat; }\r\n.quote-icon, .quote-icon a		{ background: none top left no-repeat; }\r\n\r\n/* Moderator icons */\r\n.report-icon, .report-icon a		{ background: none top left no-repeat; }\r\n.warn-icon, .warn-icon a			{ background: none top left no-repeat; }\r\n.edit-icon, .edit-icon a			{ background: none top left no-repeat; }\r\n.delete-icon, .delete-icon a		{ background: none top left no-repeat; }\r\n.info-icon, .info-icon a			{ background: none top left no-repeat; }\r\n\r\n/* Set profile icon dimensions */\r\nul.profile-icons li.email-icon		{ width: {IMG_ICON_CONTACT_EMAIL_WIDTH}px; height: {IMG_ICON_CONTACT_EMAIL_HEIGHT}px; }\r\nul.profile-icons li.aim-icon	{ width: {IMG_ICON_CONTACT_AIM_WIDTH}px; height: {IMG_ICON_CONTACT_AIM_HEIGHT}px; }\r\nul.profile-icons li.yahoo-icon	{ width: {IMG_ICON_CONTACT_YAHOO_WIDTH}px; height: {IMG_ICON_CONTACT_YAHOO_HEIGHT}px; }\r\nul.profile-icons li.web-icon	{ width: {IMG_ICON_CONTACT_WWW_WIDTH}px; height: {IMG_ICON_CONTACT_WWW_HEIGHT}px; }\r\nul.profile-icons li.msnm-icon	{ width: {IMG_ICON_CONTACT_MSNM_WIDTH}px; height: {IMG_ICON_CONTACT_MSNM_HEIGHT}px; }\r\nul.profile-icons li.icq-icon	{ width: {IMG_ICON_CONTACT_ICQ_WIDTH}px; height: {IMG_ICON_CONTACT_ICQ_HEIGHT}px; }\r\nul.profile-icons li.jabber-icon	{ width: {IMG_ICON_CONTACT_JABBER_WIDTH}px; height: {IMG_ICON_CONTACT_JABBER_HEIGHT}px; }\r\nul.profile-icons li.pm-icon		{ width: {IMG_ICON_CONTACT_PM_WIDTH}px; height: {IMG_ICON_CONTACT_PM_HEIGHT}px; }\r\nul.profile-icons li.quote-icon	{ width: {IMG_ICON_POST_QUOTE_WIDTH}px; height: {IMG_ICON_POST_QUOTE_HEIGHT}px; }\r\nul.profile-icons li.report-icon	{ width: {IMG_ICON_POST_REPORT_WIDTH}px; height: {IMG_ICON_POST_REPORT_HEIGHT}px; }\r\nul.profile-icons li.edit-icon	{ width: {IMG_ICON_POST_EDIT_WIDTH}px; height: {IMG_ICON_POST_EDIT_HEIGHT}px; }\r\nul.profile-icons li.delete-icon	{ width: {IMG_ICON_POST_DELETE_WIDTH}px; height: {IMG_ICON_POST_DELETE_HEIGHT}px; }\r\nul.profile-icons li.info-icon	{ width: {IMG_ICON_POST_INFO_WIDTH}px; height: {IMG_ICON_POST_INFO_HEIGHT}px; }\r\nul.profile-icons li.warn-icon	{ width: {IMG_ICON_USER_WARN_WIDTH}px; height: {IMG_ICON_USER_WARN_HEIGHT}px; }\r\n\r\n/* Fix profile icon default margins */\r\nul.profile-icons li.edit-icon	{ margin: 0 0 0 3px; }\r\nul.profile-icons li.quote-icon	{ margin: 0 0 0 10px; }\r\nul.profile-icons li.info-icon, ul.profile-icons li.report-icon	{ margin: 0 3px 0 0; }\r\n/* proSilver Control Panel Styles\r\n---------------------------------------- */\r\n\r\n\r\n/* Main CP box\r\n----------------------------------------*/\r\n#cp-menu {\r\n	float:left;\r\n	width: 19%;\r\n	margin-top: 1em;\r\n	margin-bottom: 5px;\r\n}\r\n\r\n#cp-main {\r\n	float: left;\r\n	width: 81%;\r\n}\r\n\r\n#cp-main .content {\r\n	padding: 0;\r\n}\r\n\r\n#cp-main h3, #cp-main hr, #cp-menu hr {\r\n	border-color: #bfbfbf;\r\n}\r\n\r\n#cp-main .panel p {\r\n	font-size: 1.1em;\r\n}\r\n\r\n#cp-main .panel ol {\r\n	margin-left: 2em;\r\n	font-size: 1.1em;\r\n}\r\n\r\n#cp-main .panel li.row {\r\n	border-bottom: 1px solid #cbcbcb;\r\n	border-top: 1px solid #F9F9F9;\r\n}\r\n\r\nul.cplist {\r\n	margin-bottom: 5px;\r\n	border-top: 1px solid #cbcbcb;\r\n}\r\n\r\n#cp-main .panel li.header dd, #cp-main .panel li.header dt {\r\n	color: #000000;\r\n	margin-bottom: 2px;\r\n}\r\n\r\n#cp-main table.table1 {\r\n	margin-bottom: 1em;\r\n}\r\n\r\n#cp-main table.table1 thead th {\r\n	color: #333333;\r\n	font-weight: bold;\r\n	border-bottom: 1px solid #333333;\r\n	padding: 5px;\r\n}\r\n\r\n#cp-main table.table1 tbody th {\r\n	font-style: italic;\r\n	background-color: transparent !important;\r\n	border-bottom: none;\r\n}\r\n\r\n#cp-main .pagination {\r\n	float: right;\r\n	width: auto;\r\n	padding-top: 1px;\r\n}\r\n\r\n#cp-main .postbody p {\r\n	font-size: 1.1em;\r\n}\r\n\r\n#cp-main .pm-message {\r\n	border: 1px solid #e2e2e2;\r\n	margin: 10px 0;\r\n	background-color: #FFFFFF;\r\n	width: auto;\r\n	float: none;\r\n}\r\n\r\n.pm-message h2 {\r\n	padding-bottom: 5px;\r\n}\r\n\r\n#cp-main .postbody h3, #cp-main .box2 h3 {\r\n	margin-top: 0;\r\n}\r\n\r\n#cp-main .buttons {\r\n	margin-left: 0;\r\n}\r\n\r\n#cp-main ul.linklist {\r\n	margin: 0;\r\n}\r\n\r\n/* MCP Specific tweaks */\r\n.mcp-main .postbody {\r\n	width: 100%;\r\n}\r\n\r\n/* CP tabbed menu\r\n----------------------------------------*/\r\n#tabs {\r\n	line-height: normal;\r\n	margin: 20px 0 -1px 7px;\r\n	min-width: 570px;\r\n}\r\n\r\n#tabs ul {\r\n	margin:0;\r\n	padding: 0;\r\n	list-style: none;\r\n}\r\n\r\n#tabs li {\r\n	display: inline;\r\n	margin: 0;\r\n	padding: 0;\r\n	font-size: 1em;\r\n	font-weight: bold;\r\n}\r\n\r\n#tabs a {\r\n	float: left;\r\n	background: none no-repeat 0% -35px;\r\n	margin: 0 1px 0 0;\r\n	padding: 0 0 0 5px;\r\n	text-decoration: none;\r\n	position: relative;\r\n	cursor: pointer;\r\n}\r\n\r\n#tabs a span {\r\n	float: left;\r\n	display: block;\r\n	background: none no-repeat 100% -35px;\r\n	padding: 6px 10px 6px 5px;\r\n	color: #828282;\r\n	white-space: nowrap;\r\n}\r\n\r\n#tabs a:hover span {\r\n	color: #bcbcbc;\r\n}\r\n\r\n#tabs .activetab a {\r\n	background-position: 0 0;\r\n	border-bottom: 1px solid #ebebeb;\r\n}\r\n\r\n#tabs .activetab a span {\r\n	background-position: 100% 0;\r\n	padding-bottom: 7px;\r\n	color: #333333;\r\n}\r\n\r\n#tabs a:hover {\r\n	background-position: 0 -70px;\r\n}\r\n\r\n#tabs a:hover span {\r\n	background-position:100% -70px;\r\n}\r\n\r\n#tabs .activetab a:hover {\r\n	background-position: 0 0;\r\n}\r\n\r\n#tabs .activetab a:hover span {\r\n	color: #000000;\r\n	background-position: 100% 0;\r\n}\r\n\r\n/* Mini tabbed menu used in MCP\r\n----------------------------------------*/\r\n#minitabs {\r\n	line-height: normal;\r\n	margin: -20px 7px 0 0;\r\n}\r\n\r\n#minitabs ul {\r\n	margin:0;\r\n	padding: 0;\r\n	list-style: none;\r\n}\r\n\r\n#minitabs li {\r\n	display: block;\r\n	float: right;\r\n	padding: 0 10px 4px 10px;\r\n	font-size: 1em;\r\n	font-weight: bold;\r\n	background-color: #f2f2f2;\r\n	margin-left: 2px;\r\n}\r\n\r\n#minitabs a {\r\n}\r\n\r\n#minitabs a:hover {\r\n	text-decoration: none;\r\n}\r\n\r\n#minitabs li.activetab {\r\n	background-color: #F9F9F9;\r\n}\r\n\r\n#minitabs li.activetab a, #minitabs li.activetab a:hover {\r\n	color: #333333;\r\n}\r\n\r\n/* UCP navigation menu\r\n----------------------------------------*/\r\n/* Container for sub-navigation list */\r\n#navigation {\r\n	width: 100%;\r\n	padding-top: 36px;\r\n}\r\n\r\n#navigation ul {\r\n	list-style:none;\r\n}\r\n\r\n/* Default list state */\r\n#navigation li {\r\n	margin: 1px 0;\r\n	padding: 0;\r\n	font-weight: bold;\r\n	display: inline;\r\n}\r\n\r\n/* Link styles for the sub-section links */\r\n#navigation a {\r\n	display: block;\r\n	padding: 5px;\r\n	margin: 1px 0;\r\n	text-decoration: none;\r\n	font-weight: bold;\r\n	color: #333;\r\n	background: #cfcfcf none repeat-y 100% 0;\r\n}\r\n\r\n#navigation a:hover {\r\n	text-decoration: none;\r\n	background-color: #c6c6c6;\r\n	color: #bcbcbc;\r\n	background-image: none;\r\n}\r\n\r\n#navigation #active-subsection a {\r\n	display: block;\r\n	color: #d3d3d3;\r\n	background-color: #F9F9F9;\r\n	background-image: none;\r\n}\r\n\r\n#navigation #active-subsection a:hover {\r\n	color: #d3d3d3;\r\n}\r\n\r\n/* Preferences pane layout\r\n----------------------------------------*/\r\n#cp-main h2 {\r\n	border-bottom: none;\r\n	padding: 0;\r\n	margin-left: 10px;\r\n	color: #333333;\r\n}\r\n\r\n#cp-main .panel {\r\n	background-color: #F9F9F9;\r\n}\r\n\r\n#cp-main .pm {\r\n	background-color: #FFFFFF;\r\n}\r\n\r\n#cp-main span.corners-top, #cp-menu span.corners-top {\r\n	background-image: none;\r\n}\r\n\r\n#cp-main span.corners-top span, #cp-menu span.corners-top span {\r\n	background-image: none;\r\n}\r\n\r\n#cp-main span.corners-bottom, #cp-menu span.corners-bottom {\r\n	background-image: none;\r\n}\r\n\r\n#cp-main span.corners-bottom span, #cp-menu span.corners-bottom span {\r\n	background-image: none;\r\n}\r\n\r\n/* Topicreview */\r\n#cp-main .panel #topicreview span.corners-top, #cp-menu .panel #topicreview span.corners-top {\r\n	background-image: none;\r\n}\r\n\r\n#cp-main .panel #topicreview span.corners-top span, #cp-menu .panel #topicreview span.corners-top span {\r\n	background-image: none;\r\n}\r\n\r\n#cp-main .panel #topicreview span.corners-bottom, #cp-menu .panel #topicreview span.corners-bottom {\r\n	background-image: none;\r\n}\r\n\r\n#cp-main .panel #topicreview span.corners-bottom span, #cp-menu .panel #topicreview span.corners-bottom span {\r\n	background-image: none;\r\n}\r\n\r\n/* Friends list */\r\n.cp-mini {\r\n	background-color: #f9f9f9;\r\n	padding: 0 5px;\r\n	margin: 10px 15px 10px 5px;\r\n}\r\n\r\n.cp-mini span.corners-top, .cp-mini span.corners-bottom {\r\n	margin: 0 -5px;\r\n}\r\n\r\ndl.mini dt {\r\n	font-weight: bold;\r\n	color: #676767;\r\n}\r\n\r\ndl.mini dd {\r\n	padding-top: 4px;\r\n}\r\n\r\n.friend-online {\r\n	font-weight: bold;\r\n}\r\n\r\n.friend-offline {\r\n	font-style: italic;\r\n}\r\n\r\n/* PM Styles\r\n----------------------------------------*/\r\n#pm-menu {\r\n	line-height: 2.5em;\r\n}\r\n\r\n/* PM Message history */\r\n.current {\r\n	color: #999999;\r\n}\r\n\r\n/* Defined rules list for PM options */\r\nol.def-rules {\r\n	padding-left: 0;\r\n}\r\n\r\nol.def-rules li {\r\n	line-height: 180%;\r\n	padding: 1px;\r\n}\r\n\r\n/* PM marking colours */\r\n.pmlist li.bg1 {\r\n	border: solid 3px transparent;\r\n	border-width: 0 3px;\r\n}\r\n\r\n.pmlist li.bg2 {\r\n	border: solid 3px transparent;\r\n	border-width: 0 3px;\r\n}\r\n\r\n.pmlist li.pm_message_reported_colour, .pm_message_reported_colour {\r\n	border-left-color: #bcbcbc;\r\n	border-right-color: #bcbcbc;\r\n}\r\n\r\n.pmlist li.pm_marked_colour, .pm_marked_colour {\r\n	border: solid 3px #ffffff;\r\n	border-width: 0 3px;\r\n}\r\n\r\n.pmlist li.pm_replied_colour, .pm_replied_colour {\r\n	border: solid 3px #c2c2c2;\r\n	border-width: 0 3px;	\r\n}\r\n\r\n.pmlist li.pm_friend_colour, .pm_friend_colour {\r\n	border: solid 3px #bdbdbd;\r\n	border-width: 0 3px;\r\n}\r\n\r\n.pmlist li.pm_foe_colour, .pm_foe_colour {\r\n	border: solid 3px #000000;\r\n	border-width: 0 3px;\r\n}\r\n\r\n.pm-legend {\r\n	border-left-width: 10px;\r\n	border-left-style: solid;\r\n	border-right-width: 0;\r\n	margin-bottom: 3px;\r\n	padding-left: 3px;\r\n}\r\n\r\n/* Avatar gallery */\r\n#gallery label {\r\n	position: relative;\r\n	float: left;\r\n	margin: 10px;\r\n	padding: 5px;\r\n	width: auto;\r\n	background: #FFFFFF;\r\n	border: 1px solid #CCC;\r\n	text-align: center;\r\n}\r\n\r\n#gallery label:hover {\r\n	background-color: #EEE;\r\n}\r\n/* proSilver Form Styles\r\n---------------------------------------- */\r\n\r\n/* General form styles\r\n----------------------------------------*/\r\nfieldset {\r\n	border-width: 0;\r\n	font-family: Verdana, Helvetica, Arial, sans-serif;\r\n	font-size: 1.0em;\r\n}\r\n\r\ninput {\r\n	font-weight: normal;\r\n	cursor: pointer;\r\n	vertical-align: middle;\r\n	padding: 0 3px;\r\n	font-size: 1em;\r\n	font-family: Verdana, Helvetica, Arial, sans-serif;\r\n}\r\n\r\nselect {\r\n	font-family: Verdana, Helvetica, Arial, sans-serif;\r\n	font-weight: normal;\r\n	cursor: pointer;\r\n	vertical-align: middle;\r\n	border: 1px solid #666666;\r\n	padding: 1px;\r\n	background-color: #FAFAFA;\r\n}\r\n\r\noption {\r\n	padding-right: 1em;\r\n}\r\n\r\noption.disabled-option {\r\n	color: graytext;\r\n}\r\n\r\ntextarea {\r\n	font-family: "Lucida Grande", Verdana, Helvetica, Arial, sans-serif;\r\n	width: 90%;\r\n	padding: 2px;\r\n	font-size: 1em;\r\n	line-height: 1.4em;\r\n}\r\n\r\nlabel {\r\n	cursor: default;\r\n	padding-right: 5px;\r\n	color: #676767;\r\n}\r\n\r\nlabel input {\r\n	vertical-align: middle;\r\n}\r\n\r\nlabel img {\r\n	vertical-align: middle;\r\n}\r\n\r\n/* Definition list layout for forms\r\n---------------------------------------- */\r\nfieldset dl {\r\n	padding: 4px 0;\r\n}\r\n\r\nfieldset dt {\r\n	float: left;	\r\n	width: 40%;\r\n	text-align: left;\r\n	display: block;\r\n}\r\n\r\nfieldset dd {\r\n	margin-left: 41%;\r\n	vertical-align: top;\r\n	margin-bottom: 3px;\r\n}\r\n\r\n/* Specific layout 1 */\r\nfieldset.fields1 dt {\r\n	width: 15em;\r\n	border-right-width: 0;\r\n}\r\n\r\nfieldset.fields1 dd {\r\n	margin-left: 15em;\r\n	border-left-width: 0;\r\n}\r\n\r\nfieldset.fields1 {\r\n	background-color: transparent;\r\n}\r\n\r\nfieldset.fields1 div {\r\n	margin-bottom: 3px;\r\n}\r\n\r\n/* Specific layout 2 */\r\nfieldset.fields2 dt {\r\n	width: 15em;\r\n	border-right-width: 0;\r\n}\r\n\r\nfieldset.fields2 dd {\r\n	margin-left: 16em;\r\n	border-left-width: 0;\r\n}\r\n\r\n/* Form elements */\r\ndt label {\r\n	font-weight: bold;\r\n	text-align: left;\r\n}\r\n\r\ndd label {\r\n	white-space: nowrap;\r\n	color: #333;\r\n}\r\n\r\ndd input, dd textarea {\r\n	margin-right: 3px;\r\n}\r\n\r\ndd select {\r\n	width: auto;\r\n}\r\n\r\ndd textarea {\r\n	width: 85%;\r\n}\r\n\r\n/* Hover effects */\r\nfieldset dl:hover dt label {\r\n	color: #000000;\r\n}\r\n\r\nfieldset.fields2 dl:hover dt label {\r\n	color: inherit;\r\n}\r\n\r\n#timezone {\r\n	width: 95%;\r\n}\r\n\r\n* html #timezone {\r\n	width: 50%;\r\n}\r\n\r\n/* Quick-login on index page */\r\nfieldset.quick-login {\r\n	margin-top: 5px;\r\n}\r\n\r\nfieldset.quick-login input {\r\n	width: auto;\r\n}\r\n\r\nfieldset.quick-login input.inputbox {\r\n	width: 15%;\r\n	vertical-align: middle;\r\n	margin-right: 5px;\r\n	background-color: #f3f3f3;\r\n}\r\n\r\nfieldset.quick-login label {\r\n	white-space: nowrap;\r\n	padding-right: 2px;\r\n}\r\n\r\n/* Display options on viewtopic/viewforum pages  */\r\nfieldset.display-options {\r\n	text-align: center;\r\n	margin: 3px 0 5px 0;\r\n}\r\n\r\nfieldset.display-options label {\r\n	white-space: nowrap;\r\n	padding-right: 2px;\r\n}\r\n\r\nfieldset.display-options a {\r\n	margin-top: 3px;\r\n}\r\n\r\n/* Display actions for ucp and mcp pages */\r\nfieldset.display-actions {\r\n	text-align: right;\r\n	line-height: 2em;\r\n	white-space: nowrap;\r\n	padding-right: 1em;\r\n}\r\n\r\nfieldset.display-actions label {\r\n	white-space: nowrap;\r\n	padding-right: 2px;\r\n}\r\n\r\nfieldset.sort-options {\r\n	line-height: 2em;\r\n}\r\n\r\n/* MCP forum selection*/\r\nfieldset.forum-selection {\r\n	margin: 5px 0 3px 0;\r\n	float: right;\r\n}\r\n\r\nfieldset.forum-selection2 {\r\n	margin: 13px 0 3px 0;\r\n	float: right;\r\n}\r\n\r\n/* Jumpbox */\r\nfieldset.jumpbox {\r\n	text-align: right;\r\n	margin-top: 15px;\r\n	height: 2.5em;\r\n}\r\n\r\nfieldset.quickmod {\r\n	width: 50%;\r\n	float: right;\r\n	text-align: right;\r\n	height: 2.5em;\r\n}\r\n\r\n/* Submit button fieldset */\r\nfieldset.submit-buttons {\r\n	text-align: center;\r\n	vertical-align: middle;\r\n	margin: 5px 0;\r\n}\r\n\r\nfieldset.submit-buttons input {\r\n	vertical-align: middle;\r\n	padding-top: 3px;\r\n	padding-bottom: 3px;\r\n}\r\n\r\n/* Posting page styles\r\n----------------------------------------*/\r\n\r\n/* Buttons used in the editor */\r\n#format-buttons {\r\n	margin: 15px 0 2px 0;\r\n}\r\n\r\n#format-buttons input, #format-buttons select {\r\n	vertical-align: middle;\r\n}\r\n\r\n/* Main message box */\r\n#message-box {\r\n	width: 80%;\r\n}\r\n\r\n#message-box textarea {\r\n	font-family: "Trebuchet MS", Verdana, Helvetica, Arial, sans-serif;\r\n	width: 100%;\r\n	font-size: 1em;\r\n	color: #333333;\r\n}\r\n\r\n/* Emoticons panel */\r\n#smiley-box {\r\n	width: 18%;\r\n	float: right;\r\n}\r\n\r\n#smiley-box img {\r\n	margin: 3px;\r\n}\r\n\r\n/* Input field styles\r\n---------------------------------------- */\r\n.inputbox {\r\n	background-color: #FFFFFF;\r\n	border: 1px solid #c0c0c0;\r\n	color: #333333;\r\n	padding: 2px;\r\n	cursor: text;\r\n}\r\n\r\n.inputbox:hover {\r\n	border: 1px solid #eaeaea;\r\n}\r\n\r\n.inputbox:focus {\r\n	border: 1px solid #eaeaea;\r\n	color: #4b4b4b;\r\n}\r\n\r\ninput.inputbox	{ width: 85%; }\r\ninput.medium	{ width: 50%; }\r\ninput.narrow	{ width: 25%; }\r\ninput.tiny		{ width: 125px; }\r\n\r\ntextarea.inputbox {\r\n	width: 85%;\r\n}\r\n\r\n.autowidth {\r\n	width: auto !important;\r\n}\r\n\r\n/* Form button styles\r\n---------------------------------------- */\r\ninput.button1, input.button2 {\r\n	font-size: 1em;\r\n}\r\n\r\na.button1, input.button1, input.button3, a.button2, input.button2 {\r\n	width: auto !important;\r\n	padding-top: 1px;\r\n	padding-bottom: 1px;\r\n	font-family: "Lucida Grande", Verdana, Helvetica, Arial, sans-serif;\r\n	color: #000;\r\n	background: #FAFAFA none repeat-x top;\r\n}\r\n\r\na.button1, input.button1 {\r\n	font-weight: bold;\r\n	border: 1px solid #666666;\r\n}\r\n\r\ninput.button3 {\r\n	padding: 0;\r\n	margin: 0;\r\n	line-height: 5px;\r\n	height: 12px;\r\n	background-image: none;\r\n	font-variant: small-caps;\r\n}\r\n\r\n/* Alternative button */\r\na.button2, input.button2, input.button3 {\r\n	border: 1px solid #666666;\r\n}\r\n\r\n/* <a> button in the style of the form buttons */\r\na.button1, a.button1:link, a.button1:visited, a.button1:active, a.button2, a.button2:link, a.button2:visited, a.button2:active {\r\n	text-decoration: none;\r\n	color: #000000;\r\n	padding: 2px 8px;\r\n	line-height: 250%;\r\n	vertical-align: text-bottom;\r\n	background-position: 0 1px;\r\n}\r\n\r\n/* Hover states */\r\na.button1:hover, input.button1:hover, a.button2:hover, input.button2:hover, input.button3:hover {\r\n	border: 1px solid #BCBCBC;\r\n	background-position: 0 100%;\r\n	color: #BCBCBC;\r\n}\r\n\r\ninput.disabled {\r\n	font-weight: normal;\r\n	color: #666666;\r\n}\r\n\r\n/* Topic and forum Search */\r\n.search-box {\r\n	margin-top: 3px;\r\n	margin-left: 5px;\r\n	float: left;\r\n}\r\n\r\n.search-box input {\r\n}\r\n\r\ninput.search {\r\n	background-image: none;\r\n	background-repeat: no-repeat;\r\n	background-position: left 1px;\r\n	padding-left: 17px;\r\n}\r\n\r\n.full { width: 95%; }\r\n.medium { width: 50%;}\r\n.narrow { width: 25%;}\r\n.tiny { width: 10%;}\r\n/* proSilver Style Sheet Tweaks\r\n\r\nThese style definitions are mainly IE specific \r\ntweaks required due to its poor CSS support.\r\n-------------------------------------------------*/\r\n\r\n* html table, * html select, * html input { font-size: 100%; }\r\n* html hr { margin: 0; }\r\n* html span.corners-top, * html span.corners-bottom { background-image: url("{T_THEME_PATH}/images/corners_left.gif"); }\r\n* html span.corners-top span, * html span.corners-bottom span { background-image: url("{T_THEME_PATH}/images/corners_right.gif"); }\r\n\r\ntable.table1 {\r\n	width: 99%;		/* IE < 6 browsers */\r\n	/* Tantek hack */\r\n	voice-family: "\\"}\\"";\r\n	voice-family: inherit;\r\n	width: 100%;\r\n}\r\nhtml>body table.table1 { width: 100%; }	/* Reset 100% for opera */\r\n\r\n* html ul.topiclist li { position: relative; }\r\n* html .postbody h3 img { vertical-align: middle; }\r\n\r\n/* Form styles */\r\nhtml>body dd label input { vertical-align: text-bottom; }	/* Align checkboxes/radio buttons nicely */\r\n\r\n* html input.button1, * html input.button2 {\r\n	padding-bottom: 0;\r\n	margin-bottom: 1px;\r\n}\r\n\r\n/* Misc layout styles */\r\n* html .column1, * html .column2 { width: 45%; }\r\n\r\n/* Nice method for clearing floated blocks without having to insert any extra markup (like spacer above)\r\n   From http://www.positioniseverything.net/easyclearing.html \r\n#tabs:after, #minitabs:after, .post:after, .navbar:after, fieldset dl:after, ul.topiclist dl:after, ul.linklist:after, dl.polls:after {\r\n	content: "."; \r\n	display: block; \r\n	height: 0; \r\n	clear: both; \r\n	visibility: hidden;\r\n}*/\r\n\r\n.clearfix, #tabs, #minitabs, fieldset dl, ul.topiclist dl, dl.polls {\r\n	height: 1%;\r\n	overflow: hidden;\r\n}\r\n\r\n/* viewtopic fix */\r\n* html .post {\r\n	height: 25%;\r\n	overflow: hidden;\r\n}\r\n\r\n/* navbar fix */\r\n* html .clearfix, * html .navbar, ul.linklist {\r\n	height: 4%;\r\n	overflow: hidden;\r\n}\r\n\r\n/* Simple fix so forum and topic lists always have a min-height set, even in IE6\r\n	From http://www.dustindiaz.com/min-height-fast-hack */\r\ndl.icon {\r\n	min-height: 35px;\r\n	height: auto !important;\r\n	height: 35px;\r\n}\r\n\r\n* html #search-box {\r\n	width: 25%;\r\n}\r\n\r\n/* Correctly clear floating for details on profile view */\r\n*:first-child+html dl.details dd {\r\n	margin-left: 30%;\r\n	float: none;\r\n}\r\n\r\n* html dl.details dd {\r\n	margin-left: 30%;\r\n	float: none;\r\n}\r\n/*  	\r\n--------------------------------------------------------------\r\nColours and backgrounds for common.css\r\n-------------------------------------------------------------- */\r\n\r\nhtml, body {\r\n	color: #536482;\r\n	background-color: #FFFFFF;\r\n}\r\n\r\nh1 {\r\n	color: #FFFFFF;\r\n}\r\n\r\nh2 {\r\n	color: #28313F;\r\n}\r\n\r\nh3 {\r\n	border-bottom-color: #CCCCCC;\r\n	color: #115098;\r\n}\r\n\r\nhr {\r\n	border-color: #FFFFFF;\r\n	border-top-color: #CCCCCC;\r\n}\r\n\r\nhr.dashed {\r\n	border-top-color: #CCCCCC;\r\n}\r\n\r\n/* Search box\r\n--------------------------------------------- */\r\n\r\n#search-box {\r\n	color: #FFFFFF;\r\n}\r\n\r\n#search-box #keywords {\r\n	background-color: #FFF;\r\n}\r\n\r\n#search-box input {\r\n	border-color: #0075B0;\r\n}\r\n\r\n/* Round cornered boxes and backgrounds\r\n---------------------------------------- */\r\n.headerbar {\r\n	background-color: #12A3EB;\r\n	background-image: url("{T_THEME_PATH}/images/bg_header.gif");\r\n	color: #FFFFFF;\r\n}\r\n\r\n.navbar {\r\n	background-color: #cadceb;\r\n}\r\n\r\n.forabg {\r\n	background-color: #0076b1;\r\n	background-image: url("{T_THEME_PATH}/images/bg_list.gif");\r\n}\r\n\r\n.forumbg {\r\n	background-color: #12A3EB;\r\n	background-image: url("{T_THEME_PATH}/images/bg_header.gif");\r\n}\r\n\r\n.panel {\r\n	background-color: #ECF1F3;\r\n	color: #28313F;\r\n}\r\n\r\n.post:target .content {\r\n	color: #000000;\r\n}\r\n\r\n.post:target h3 a {\r\n	color: #000000;\r\n}\r\n\r\n.bg1	{ background-color: #ECF3F7; }\r\n.bg2	{ background-color: #e1ebf2;  }\r\n.bg3	{ background-color: #cadceb; }\r\n\r\n.ucprowbg {\r\n	background-color: #DCDEE2;\r\n}\r\n\r\n.fieldsbg {\r\n	background-color: #E7E8EA;\r\n}\r\n\r\nspan.corners-top {\r\n	background-image: url("{T_THEME_PATH}/images/corners_left.png");\r\n}\r\n\r\nspan.corners-top span {\r\n	background-image: url("{T_THEME_PATH}/images/corners_right.png");\r\n}\r\n\r\nspan.corners-bottom {\r\n	background-image: url("{T_THEME_PATH}/images/corners_left.png");\r\n}\r\n\r\nspan.corners-bottom span {\r\n	background-image: url("{T_THEME_PATH}/images/corners_right.png");\r\n}\r\n\r\n/* Horizontal lists\r\n----------------------------------------*/\r\n\r\nul.navlinks {\r\n	border-bottom-color: #FFFFFF;\r\n}\r\n\r\n/* Table styles\r\n----------------------------------------*/\r\ntable.table1 thead th {\r\n	color: #FFFFFF;\r\n}\r\n\r\ntable.table1 tbody tr {\r\n	border-color: #BFC1CF;\r\n}\r\n\r\ntable.table1 tbody tr:hover, table.table1 tbody tr.hover {\r\n	background-color: #CFE1F6;\r\n	color: #000;\r\n}\r\n\r\ntable.table1 td {\r\n	color: #536482;\r\n}\r\n\r\ntable.table1 tbody td {\r\n	border-top-color: #FAFAFA;\r\n}\r\n\r\ntable.table1 tbody th {\r\n	border-bottom-color: #000000;\r\n	color: #333333;\r\n	background-color: #FFFFFF;\r\n}\r\n\r\ntable.info tbody th {\r\n	color: #000000;\r\n}\r\n\r\n/* Misc layout styles\r\n---------------------------------------- */\r\ndl.details dt {\r\n	color: #000000;\r\n}\r\n\r\ndl.details dd {\r\n	color: #536482;\r\n}\r\n\r\n.sep {\r\n	color: #1198D9;\r\n}\r\n\r\n/* Pagination\r\n---------------------------------------- */\r\n\r\n.pagination span strong {\r\n	color: #FFFFFF;\r\n	background-color: #4692BF;\r\n	border-color: #4692BF;\r\n}\r\n\r\n.pagination span a, .pagination span a:link, .pagination span a:visited, .pagination span a:active {\r\n	color: #5C758C;\r\n	background-color: #ECEDEE;\r\n	border-color: #B4BAC0;\r\n}\r\n\r\n.pagination span a:hover {\r\n	border-color: #368AD2;\r\n	background-color: #368AD2;\r\n	color: #FFF;\r\n}\r\n\r\n/* Pagination in viewforum for multipage topics */\r\n.row .pagination {\r\n	background-image: url("{T_THEME_PATH}/images/icon_pages.gif");\r\n}\r\n\r\n.row .pagination span a, li.pagination span a {\r\n	background-color: #FFFFFF;\r\n}\r\n\r\n.row .pagination span a:hover, li.pagination span a:hover {\r\n	background-color: #368AD2;\r\n}\r\n\r\n/* Miscellaneous styles\r\n---------------------------------------- */\r\n\r\n.copyright {\r\n	color: #555555;\r\n}\r\n\r\n.error {\r\n	color: #BC2A4D;\r\n}\r\n\r\n.reported {\r\n	background-color: #F7ECEF;\r\n}\r\n\r\nli.reported:hover {\r\n	background-color: #ECD5D8 !important;\r\n}\r\n.sticky, .announce {\r\n	/* you can add a background for stickies and announcements*/\r\n}\r\n\r\ndiv.rules {\r\n	background-color: #ECD5D8;\r\n	color: #BC2A4D;\r\n}\r\n\r\np.rules {\r\n	background-color: #ECD5D8;\r\n	background-image: none;\r\n}\r\n\r\n/*  	\r\n--------------------------------------------------------------\r\nColours and backgrounds for links.css\r\n-------------------------------------------------------------- */\r\n\r\na:link	{ color: #105289; }\r\na:visited	{ color: #105289; }\r\na:hover	{ color: #D31141; }\r\na:active	{ color: #368AD2; }\r\n\r\n/* Links on gradient backgrounds */\r\n#search-box a:link, .navbg a:link, .forumbg .header a:link, .forabg .header a:link, th a:link {\r\n	color: #FFFFFF;\r\n}\r\n\r\n#search-box a:visited, .navbg a:visited, .forumbg .header a:visited, .forabg .header a:visited, th a:visited {\r\n	color: #FFFFFF;\r\n}\r\n\r\n#search-box a:hover, .navbg a:hover, .forumbg .header a:hover, .forabg .header a:hover, th a:hover {\r\n	color: #A8D8FF;\r\n}\r\n\r\n#search-box a:active, .navbg a:active, .forumbg .header a:active, .forabg .header a:active, th a:active {\r\n	color: #C8E6FF;\r\n}\r\n\r\n/* Links for forum/topic lists */\r\na.forumtitle {\r\n	color: #105289;\r\n}\r\n\r\n/* a.forumtitle:visited { color: #105289; } */\r\n\r\na.forumtitle:hover {\r\n	color: #BC2A4D;\r\n}\r\n\r\na.forumtitle:active {\r\n	color: #105289;\r\n}\r\n\r\na.topictitle {\r\n	color: #105289;\r\n}\r\n\r\n/* a.topictitle:visited { color: #368AD2; } */\r\n\r\na.topictitle:hover {\r\n	color: #BC2A4D;\r\n}\r\n\r\na.topictitle:active {\r\n	color: #105289;\r\n}\r\n\r\n/* Post body links */\r\n.postlink {\r\n	color: #368AD2;\r\n	border-bottom-color: #368AD2;\r\n}\r\n\r\n.postlink:visited {\r\n	color: #5D8FBD;\r\n	border-bottom-color: #666666;\r\n}\r\n\r\n.postlink:active {\r\n	color: #368AD2;\r\n}\r\n\r\n.postlink:hover {\r\n	background-color: #D0E4F6;\r\n	color: #0D4473;\r\n}\r\n\r\n.signature a, .signature a:visited, .signature a:active, .signature a:hover {\r\n	background-color: transparent;\r\n}\r\n\r\n/* Profile links */\r\n.postprofile a:link, .postprofile a:active, .postprofile a:visited, .postprofile dt.author a {\r\n	color: #105289;\r\n}\r\n\r\n.postprofile a:hover, .postprofile dt.author a:hover {\r\n	color: #D31141;\r\n}\r\n\r\n/* Profile searchresults */	\r\n.search .postprofile a {\r\n	color: #105289;\r\n}\r\n\r\n.search .postprofile a:hover {\r\n	color: #D31141;\r\n}\r\n\r\n/* Back to top of page */\r\na.top {\r\n	background-image: url("{IMG_ICON_BACK_TOP_SRC}");\r\n}\r\n\r\na.top2 {\r\n	background-image: url("{IMG_ICON_BACK_TOP_SRC}");\r\n}\r\n\r\n/* Arrow links  */\r\na.up		{ background-image: url("{T_THEME_PATH}/images/arrow_up.gif") }\r\na.down		{ background-image: url("{T_THEME_PATH}/images/arrow_down.gif") }\r\na.left		{ background-image: url("{T_THEME_PATH}/images/arrow_left.gif") }\r\na.right		{ background-image: url("{T_THEME_PATH}/images/arrow_right.gif") }\r\n\r\na.up:hover {\r\n	background-color: transparent;\r\n}\r\n\r\na.left:hover {\r\n	color: #368AD2;\r\n}\r\n\r\na.right:hover {\r\n	color: #368AD2;\r\n}\r\n\r\n\r\n/*  	\r\n--------------------------------------------------------------\r\nColours and backgrounds for content.css\r\n-------------------------------------------------------------- */\r\n\r\nul.forums {\r\n	background-color: #eef5f9;\r\n	background-image: url("{T_THEME_PATH}/images/gradient.gif");\r\n}\r\n\r\nul.topiclist li {\r\n	color: #4C5D77;\r\n}\r\n\r\nul.topiclist dd {\r\n	border-left-color: #FFFFFF;\r\n}\r\n\r\n.rtl ul.topiclist dd {\r\n	border-right-color: #fff;\r\n	border-left-color: transparent;\r\n}\r\n\r\nul.topiclist li.row dt a.subforum.read {\r\n	background-image: url("{IMG_SUBFORUM_READ_SRC}");\r\n}\r\n\r\nul.topiclist li.row dt a.subforum.unread {\r\n	background-image: url("{IMG_SUBFORUM_UNREAD_SRC}");\r\n}\r\n\r\nli.row {\r\n	border-top-color:  #FFFFFF;\r\n	border-bottom-color: #00608F;\r\n}\r\n\r\nli.row strong {\r\n	color: #000000;\r\n}\r\n\r\nli.row:hover {\r\n	background-color: #F6F4D0;\r\n}\r\n\r\nli.row:hover dd {\r\n	border-left-color: #CCCCCC;\r\n}\r\n\r\n.rtl li.row:hover dd {\r\n	border-right-color: #CCCCCC;\r\n	border-left-color: transparent;\r\n}\r\n\r\nli.header dt, li.header dd {\r\n	color: #FFFFFF;\r\n}\r\n\r\n/* Forum list column styles */\r\nul.topiclist dd.searchextra {\r\n	color: #333333;\r\n}\r\n\r\n/* Post body styles\r\n----------------------------------------*/\r\n.postbody {\r\n	color: #333333;\r\n}\r\n\r\n/* Content container styles\r\n----------------------------------------*/\r\n.content {\r\n	color: #333333;\r\n}\r\n\r\n.content h2, .panel h2 {\r\n	color: #115098;\r\n	border-bottom-color:  #CCCCCC;\r\n}\r\n\r\ndl.faq dt {\r\n	color: #333333;\r\n}\r\n\r\n.posthilit {\r\n	background-color: #F3BFCC;\r\n	color: #BC2A4D;\r\n}\r\n\r\n/* Post signature */\r\n.signature {\r\n	border-top-color: #CCCCCC;\r\n}\r\n\r\n/* Post noticies */\r\n.notice {\r\n	border-top-color:  #CCCCCC;\r\n}\r\n\r\n/* BB Code styles\r\n----------------------------------------*/\r\n/* Quote block */\r\nblockquote {\r\n	background-color: #EBEADD;\r\n	background-image: url("{T_THEME_PATH}/images/quote.gif");\r\n	border-color:#DBDBCE;\r\n}\r\n\r\nblockquote blockquote {\r\n	/* Nested quotes */\r\n	background-color:#EFEED9;\r\n}\r\n\r\nblockquote blockquote blockquote {\r\n	/* Nested quotes */\r\n	background-color: #EBEADD;\r\n}\r\n\r\n/* Code block */\r\ndl.codebox {\r\n	background-color: #FFFFFF;\r\n	border-color: #C9D2D8;\r\n}\r\n\r\ndl.codebox dt {\r\n	border-bottom-color:  #CCCCCC;\r\n}\r\n\r\ndl.codebox code {\r\n	color: #2E8B57;\r\n}\r\n\r\n.syntaxbg		{ color: #FFFFFF; }\r\n.syntaxcomment	{ color: #FF8000; }\r\n.syntaxdefault	{ color: #0000BB; }\r\n.syntaxhtml		{ color: #000000; }\r\n.syntaxkeyword	{ color: #007700; }\r\n.syntaxstring	{ color: #DD0000; }\r\n\r\n/* Attachments\r\n----------------------------------------*/\r\n.attachbox {\r\n	background-color: #FFFFFF;\r\n	border-color:  #C9D2D8;\r\n}\r\n\r\n.pm-message .attachbox {\r\n	background-color: #F2F3F3;\r\n}\r\n\r\n.attachbox dd {\r\n	border-top-color: #C9D2D8;\r\n}\r\n\r\n.attachbox p {\r\n	color: #666666;\r\n}\r\n\r\n.attachbox p.stats {\r\n	color: #666666;\r\n}\r\n\r\n.attach-image img {\r\n	border-color: #999999;\r\n}\r\n\r\n/* Inline image thumbnails */\r\n\r\ndl.file dd {\r\n	color: #666666;\r\n}\r\n\r\ndl.thumbnail img {\r\n	border-color: #666666;\r\n	background-color: #FFFFFF;\r\n}\r\n\r\ndl.thumbnail dd {\r\n	color: #666666;\r\n}\r\n\r\ndl.thumbnail dt a:hover {\r\n	background-color: #EEEEEE;\r\n}\r\n\r\ndl.thumbnail dt a:hover img {\r\n	border-color: #368AD2;\r\n}\r\n\r\n/* Post poll styles\r\n----------------------------------------*/\r\n\r\nfieldset.polls dl {\r\n	border-top-color: #DCDEE2;\r\n	color: #666666;\r\n}\r\n\r\nfieldset.polls dl.voted {\r\n	color: #000000;\r\n}\r\n\r\nfieldset.polls dd div {\r\n	color: #FFFFFF;\r\n}\r\n\r\n.rtl .pollbar1, .rtl .pollbar2, .rtl .pollbar3, .rtl .pollbar4, .rtl .pollbar5 {\r\n	border-right-color: transparent;\r\n}\r\n\r\n.pollbar1 {\r\n	background-color: #AA2346;\r\n	border-bottom-color: #74162C;\r\n	border-right-color: #74162C;\r\n}\r\n\r\n.rtl .pollbar1 {\r\n	border-left-color: #74162C;\r\n}\r\n\r\n.pollbar2 {\r\n	background-color: #BE1E4A;\r\n	border-bottom-color: #8C1C38;\r\n	border-right-color: #8C1C38;\r\n}\r\n\r\n.rtl .pollbar2 {\r\n	border-left-color: #8C1C38;\r\n}\r\n\r\n.pollbar3 {\r\n	background-color: #D11A4E;\r\n	border-bottom-color: #AA2346;\r\n	border-right-color: #AA2346;\r\n}\r\n\r\n.rtl .pollbar3 {\r\n	border-left-color: #AA2346;\r\n}\r\n\r\n.pollbar4 {\r\n	background-color: #E41653;\r\n	border-bottom-color: #BE1E4A;\r\n	border-right-color: #BE1E4A;\r\n}\r\n\r\n.rtl .pollbar4 {\r\n	border-left-color: #BE1E4A;\r\n}\r\n\r\n.pollbar5 {\r\n	background-color: #F81157;\r\n	border-bottom-color: #D11A4E;\r\n	border-right-color: #D11A4E;\r\n}\r\n\r\n.rtl .pollbar5 {\r\n	border-left-color: #D11A4E;\r\n}\r\n\r\n/* Poster profile block\r\n----------------------------------------*/\r\n.postprofile {\r\n	color: #666666;\r\n	border-left-color: #FFFFFF;\r\n}\r\n\r\n.rtl .postprofile {\r\n	border-right-color: #FFFFFF;\r\n	border-left-color: transparent;\r\n}\r\n\r\n.pm .postprofile {\r\n	border-left-color: #DDDDDD;\r\n}\r\n\r\n.rtl .pm .postprofile {\r\n	border-right-color: #DDDDDD;\r\n	border-left-color: transparent;\r\n}\r\n\r\n.postprofile strong {\r\n	color: #000000;\r\n}\r\n\r\n.online {\r\n	background-image: url("{T_IMAGESET_LANG_PATH}/icon_user_online.gif");\r\n}\r\n\r\n/*  	\r\n--------------------------------------------------------------\r\nColours and backgrounds for buttons.css\r\n-------------------------------------------------------------- */\r\n\r\n/* Big button images */\r\n.reply-icon span	{ background-image: url("{IMG_BUTTON_TOPIC_REPLY_SRC}"); }\r\n.quick-reply-icon span	{ background-image: url("{IMG_BUTTON_QUICK_REPLY_SRC}"); }\r\n\r\n.post-icon span		{ background-image: url("{IMG_BUTTON_TOPIC_NEW_SRC}"); }\r\n.locked-icon span	{ background-image: url("{IMG_BUTTON_TOPIC_LOCKED_SRC}"); }\r\n.pmreply-icon span	{ background-image: url("{IMG_BUTTON_PM_REPLY_SRC}") ;}\r\n.newpm-icon span 	{ background-image: url("{IMG_BUTTON_PM_NEW_SRC}") ;}\r\n.forwardpm-icon span	{ background-image: url("{IMG_BUTTON_PM_FORWARD_SRC}") ;}\r\n\r\na.print {\r\n	background-image: url("{T_THEME_PATH}/images/icon_print.gif");\r\n}\r\n\r\na.sendemail {\r\n	background-image: url("{T_THEME_PATH}/images/icon_sendemail.gif");\r\n}\r\n\r\na.fontsize {\r\n	background-image: url("{T_THEME_PATH}/images/icon_fontsize.gif");\r\n}\r\n\r\n/* Icon images\r\n---------------------------------------- */\r\n.sitehome						{ background-image: url("{T_THEME_PATH}/images/icon_home.gif"); }\r\n.icon-faq						{ background-image: url("{T_THEME_PATH}/images/icon_faq.gif"); }\r\n.icon-members					{ background-image: url("{T_THEME_PATH}/images/icon_members.gif"); }\r\n.icon-home						{ background-image: url("{T_THEME_PATH}/images/icon_home.gif"); }\r\n.icon-ucp						{ background-image: url("{T_THEME_PATH}/images/icon_ucp.gif"); }\r\n.icon-register					{ background-image: url("{T_THEME_PATH}/images/icon_register.gif"); }\r\n.icon-logout					{ background-image: url("{T_THEME_PATH}/images/icon_logout.gif"); }\r\n.icon-bookmark					{ background-image: url("{T_THEME_PATH}/images/icon_bookmark.gif"); }\r\n.icon-bump						{ background-image: url("{T_THEME_PATH}/images/icon_bump.gif"); }\r\n.icon-subscribe					{ background-image: url("{T_THEME_PATH}/images/icon_subscribe.gif"); }\r\n.icon-unsubscribe				{ background-image: url("{T_THEME_PATH}/images/icon_unsubscribe.gif"); }\r\n.icon-pages						{ background-image: url("{T_THEME_PATH}/images/icon_pages.gif"); }\r\n.icon-search					{ background-image: url("{T_THEME_PATH}/images/icon_search.gif"); }\r\n\r\n/* Profile & navigation icons */\r\n.email-icon, .email-icon a		{ background-image: url("{IMG_ICON_CONTACT_EMAIL_SRC}"); }\r\n.aim-icon, .aim-icon a			{ background-image: url("{IMG_ICON_CONTACT_AIM_SRC}"); }\r\n.yahoo-icon, .yahoo-icon a		{ background-image: url("{IMG_ICON_CONTACT_YAHOO_SRC}"); }\r\n.web-icon, .web-icon a			{ background-image: url("{IMG_ICON_CONTACT_WWW_SRC}"); }\r\n.msnm-icon, .msnm-icon a			{ background-image: url("{IMG_ICON_CONTACT_MSNM_SRC}"); }\r\n.icq-icon, .icq-icon a			{ background-image: url("{IMG_ICON_CONTACT_ICQ_SRC}"); }\r\n.jabber-icon, .jabber-icon a		{ background-image: url("{IMG_ICON_CONTACT_JABBER_SRC}"); }\r\n.pm-icon, .pm-icon a				{ background-image: url("{IMG_ICON_CONTACT_PM_SRC}"); }\r\n.quote-icon, .quote-icon a		{ background-image: url("{IMG_ICON_POST_QUOTE_SRC}"); }\r\n\r\n/* Moderator icons */\r\n.report-icon, .report-icon a		{ background-image: url("{IMG_ICON_POST_REPORT_SRC}"); }\r\n.edit-icon, .edit-icon a			{ background-image: url("{IMG_ICON_POST_EDIT_SRC}"); }\r\n.delete-icon, .delete-icon a		{ background-image: url("{IMG_ICON_POST_DELETE_SRC}"); }\r\n.info-icon, .info-icon a			{ background-image: url("{IMG_ICON_POST_INFO_SRC}"); }\r\n.warn-icon, .warn-icon a			{ background-image: url("{IMG_ICON_USER_WARN_SRC}"); } /* Need updated warn icon */\r\n\r\n/*  	\r\n--------------------------------------------------------------\r\nColours and backgrounds for cp.css\r\n-------------------------------------------------------------- */\r\n\r\n/* Main CP box\r\n----------------------------------------*/\r\n\r\n#cp-main h3, #cp-main hr, #cp-menu hr {\r\n	border-color: #A4B3BF;\r\n}\r\n\r\n#cp-main .panel li.row {\r\n	border-bottom-color: #B5C1CB;\r\n	border-top-color: #F9F9F9;\r\n}\r\n\r\nul.cplist {\r\n	border-top-color: #B5C1CB;\r\n}\r\n\r\n#cp-main .panel li.header dd, #cp-main .panel li.header dt {\r\n	color: #000000;\r\n}\r\n\r\n#cp-main table.table1 thead th {\r\n	color: #333333;\r\n	border-bottom-color: #333333;\r\n}\r\n\r\n#cp-main .pm-message {\r\n	border-color: #DBDEE2;\r\n	background-color: #FFFFFF;\r\n}\r\n\r\n/* CP tabbed menu\r\n----------------------------------------*/\r\n#tabs a {\r\n	background-image: url("{T_THEME_PATH}/images/bg_tabs1.gif");\r\n}\r\n\r\n#tabs a span {\r\n	background-image: url("{T_THEME_PATH}/images/bg_tabs2.gif");\r\n	color: #536482;\r\n}\r\n\r\n#tabs a:hover span {\r\n	color: #BC2A4D;\r\n}\r\n\r\n#tabs .activetab a {\r\n	border-bottom-color: #CADCEB;\r\n}\r\n\r\n#tabs .activetab a span {\r\n	color: #333333;\r\n}\r\n\r\n#tabs .activetab a:hover span {\r\n	color: #000000;\r\n}\r\n\r\n/* Mini tabbed menu used in MCP\r\n----------------------------------------*/\r\n#minitabs li {\r\n	background-color: #E1EBF2;\r\n}\r\n\r\n#minitabs li.activetab {\r\n	background-color: #F9F9F9;\r\n}\r\n\r\n#minitabs li.activetab a, #minitabs li.activetab a:hover {\r\n	color: #333333;\r\n}\r\n\r\n/* UCP navigation menu\r\n----------------------------------------*/\r\n\r\n/* Link styles for the sub-section links */\r\n#navigation a {\r\n	color: #333;\r\n	background-color: #B2C2CF;\r\n	background-image: url("{T_THEME_PATH}/images/bg_menu.gif");\r\n}\r\n\r\n#navigation a:hover {\r\n	background-color: #aabac6;\r\n	color: #BC2A4D;\r\n}\r\n\r\n#navigation #active-subsection a {\r\n	color: #D31141;\r\n	background-color: #F9F9F9;\r\n	background-image: none;\r\n}\r\n\r\n#navigation #active-subsection a:hover {\r\n	color: #D31141;\r\n}\r\n\r\n/* Preferences pane layout\r\n----------------------------------------*/\r\n#cp-main h2 {\r\n	color: #333333;\r\n}\r\n\r\n#cp-main .panel {\r\n	background-color: #F9F9F9;\r\n}\r\n\r\n#cp-main .pm {\r\n	background-color: #FFFFFF;\r\n}\r\n\r\n#cp-main span.corners-top, #cp-menu span.corners-top {\r\n	background-image: url("{T_THEME_PATH}/images/corners_left2.gif");\r\n}\r\n\r\n#cp-main span.corners-top span, #cp-menu span.corners-top span {\r\n	background-image: url("{T_THEME_PATH}/images/corners_right2.gif");\r\n}\r\n\r\n#cp-main span.corners-bottom, #cp-menu span.corners-bottom {\r\n	background-image: url("{T_THEME_PATH}/images/corners_left2.gif");\r\n}\r\n\r\n#cp-main span.corners-bottom span, #cp-menu span.corners-bottom span {\r\n	background-image: url("{T_THEME_PATH}/images/corners_right2.gif");\r\n}\r\n\r\n/* Topicreview */\r\n#cp-main .panel #topicreview span.corners-top, #cp-menu .panel #topicreview span.corners-top {\r\n	background-image: url("{T_THEME_PATH}/images/corners_left.gif");\r\n}\r\n\r\n#cp-main .panel #topicreview span.corners-top span, #cp-menu .panel #topicreview span.corners-top span {\r\n	background-image: url("{T_THEME_PATH}/images/corners_right.gif");\r\n}\r\n\r\n#cp-main .panel #topicreview span.corners-bottom, #cp-menu .panel #topicreview span.corners-bottom {\r\n	background-image: url("{T_THEME_PATH}/images/corners_left.gif");\r\n}\r\n\r\n#cp-main .panel #topicreview span.corners-bottom span, #cp-menu .panel #topicreview span.corners-bottom span {\r\n	background-image: url("{T_THEME_PATH}/images/corners_right.gif");\r\n}\r\n\r\n/* Friends list */\r\n.cp-mini {\r\n	background-color: #eef5f9;\r\n}\r\n\r\ndl.mini dt {\r\n	color: #425067;\r\n}\r\n\r\n/* PM Styles\r\n----------------------------------------*/\r\n/* PM Message history */\r\n.current {\r\n	color: #999999 !important;\r\n}\r\n\r\n/* PM marking colours */\r\n.pmlist li.pm_message_reported_colour, .pm_message_reported_colour {\r\n	border-left-color: #BC2A4D;\r\n	border-right-color: #BC2A4D;\r\n}\r\n\r\n.pmlist li.pm_marked_colour, .pm_marked_colour {\r\n	border-color: #FF6600;\r\n}\r\n\r\n.pmlist li.pm_replied_colour, .pm_replied_colour {\r\n	border-color: #A9B8C2;\r\n}\r\n\r\n.pmlist li.pm_friend_colour, .pm_friend_colour {\r\n	border-color: #5D8FBD;\r\n}\r\n\r\npmlist li.pm_foe_colour, .pm_foe_colour {\r\n	border-color: #000000;\r\n}\r\n\r\n/* Avatar gallery */\r\n#gallery label {\r\n	background-color: #FFFFFF;\r\n	border-color: #CCC;\r\n}\r\n\r\n#gallery label:hover {\r\n	background-color: #EEE;\r\n}\r\n\r\n/*  	\r\n--------------------------------------------------------------\r\nColours and backgrounds for forms.css\r\n-------------------------------------------------------------- */\r\n\r\n/* General form styles\r\n----------------------------------------*/\r\nselect {\r\n	border-color: #666666;\r\n	background-color: #FAFAFA;\r\n}\r\n\r\nlabel {\r\n	color: #425067;\r\n}\r\n\r\noption.disabled-option {\r\n	color: graytext;\r\n}\r\n\r\n/* Definition list layout for forms\r\n---------------------------------------- */\r\ndd label {\r\n	color: #333;\r\n}\r\n\r\n/* Hover effects */\r\nfieldset dl:hover dt label {\r\n	color: #000000;\r\n}\r\n\r\nfieldset.fields2 dl:hover dt label {\r\n	color: inherit;\r\n}\r\n\r\n/* Quick-login on index page */\r\nfieldset.quick-login input.inputbox {\r\n	background-color: #F2F3F3;\r\n}\r\n\r\n/* Posting page styles\r\n----------------------------------------*/\r\n\r\n#message-box textarea {\r\n	color: #333333;\r\n}\r\n\r\n/* Input field styles\r\n---------------------------------------- */\r\n.inputbox {\r\n	background-color: #FFFFFF; \r\n	border-color: #B4BAC0;\r\n	color: #333333;\r\n}\r\n\r\n.inputbox:hover {\r\n	border-color: #11A3EA;\r\n}\r\n\r\n.inputbox:focus {\r\n	border-color: #11A3EA;\r\n	color: #0F4987;\r\n}\r\n\r\n/* Form button styles\r\n---------------------------------------- */\r\n\r\na.button1, input.button1, input.button3, a.button2, input.button2 {\r\n	color: #000;\r\n	background-color: #FAFAFA;\r\n	background-image: url("{T_THEME_PATH}/images/bg_button.gif");\r\n}\r\n\r\na.button1, input.button1 {\r\n	border-color: #666666;\r\n}\r\n\r\ninput.button3 {\r\n	background-image: none;\r\n}\r\n\r\n/* Alternative button */\r\na.button2, input.button2, input.button3 {\r\n	border-color: #666666;\r\n}\r\n\r\n/* <a> button in the style of the form buttons */\r\na.button1, a.button1:link, a.button1:visited, a.button1:active, a.button2, a.button2:link, a.button2:visited, a.button2:active {\r\n	color: #000000;\r\n}\r\n\r\n/* Hover states */\r\na.button1:hover, input.button1:hover, a.button2:hover, input.button2:hover, input.button3:hover {\r\n	border-color: #BC2A4D;\r\n	color: #BC2A4D;\r\n}\r\n\r\ninput.search {\r\n	background-image: url("{T_THEME_PATH}/images/icon_textbox_search.gif");\r\n}\r\n\r\ninput.disabled {\r\n	color: #666666;\r\n}\r\n');



CREATE TABLE IF NOT EXISTS `nuke_bb3thanks` (
  `thanks_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `thanks_from` mediumint(8) unsigned NOT NULL,
  `thanks_to` mediumint(8) unsigned NOT NULL,
  `post_id` mediumint(8) unsigned NOT NULL,
  PRIMARY KEY (`thanks_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_bb3topics` (
  `topic_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `forum_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `icon_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `topic_attachment` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `topic_approved` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `topic_reported` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `topic_title` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `topic_poster` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `topic_time` int(11) unsigned NOT NULL DEFAULT '0',
  `topic_time_limit` int(11) unsigned NOT NULL DEFAULT '0',
  `topic_views` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `topic_replies` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `topic_replies_real` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `topic_status` tinyint(3) NOT NULL DEFAULT '0',
  `topic_type` tinyint(3) NOT NULL DEFAULT '0',
  `topic_first_post_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `topic_first_poster_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `topic_first_poster_colour` varchar(6) COLLATE utf8_bin NOT NULL DEFAULT '',
  `topic_last_post_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `topic_last_poster_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `topic_last_poster_name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `topic_last_poster_colour` varchar(6) COLLATE utf8_bin NOT NULL DEFAULT '',
  `topic_last_post_subject` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `topic_last_post_time` int(11) unsigned NOT NULL DEFAULT '0',
  `topic_last_view_time` int(11) unsigned NOT NULL DEFAULT '0',
  `topic_moved_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `topic_bumped` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `topic_bumper` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `poll_title` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `poll_start` int(11) unsigned NOT NULL DEFAULT '0',
  `poll_length` int(11) unsigned NOT NULL DEFAULT '0',
  `poll_max_options` tinyint(4) NOT NULL DEFAULT '1',
  `poll_last_vote` int(11) unsigned NOT NULL DEFAULT '0',
  `poll_vote_change` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`topic_id`),
  KEY `forum_id` (`forum_id`),
  KEY `forum_id_type` (`forum_id`,`topic_type`),
  KEY `last_post_time` (`topic_last_post_time`),
  KEY `topic_approved` (`topic_approved`),
  KEY `forum_appr_last` (`forum_id`,`topic_approved`,`topic_last_post_id`),
  KEY `fid_time_moved` (`forum_id`,`topic_last_post_time`,`topic_moved_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=2 ;


INSERT INTO `nuke_bb3topics` (`topic_id`, `forum_id`, `icon_id`, `topic_attachment`, `topic_approved`, `topic_reported`, `topic_title`, `topic_poster`, `topic_time`, `topic_time_limit`, `topic_views`, `topic_replies`, `topic_replies_real`, `topic_status`, `topic_type`, `topic_first_post_id`, `topic_first_poster_name`, `topic_first_poster_colour`, `topic_last_post_id`, `topic_last_poster_id`, `topic_last_poster_name`, `topic_last_poster_colour`, `topic_last_post_subject`, `topic_last_post_time`, `topic_last_view_time`, `topic_moved_id`, `topic_bumped`, `topic_bumper`, `poll_title`, `poll_start`, `poll_length`, `poll_max_options`, `poll_last_vote`, `poll_vote_change`) VALUES
(1, 2, 0, 0, 1, 0, 'به پرتال نیوک لرن خوش آمدید', 2, 1249992268, 0, 39, 0, 0, 0, 0, 1, 'admin', 'AA0000', 1, 2, 'Delta', 'AA0000', 'به پرتال نیوک لرن خوش آمدید', 1249992268, 1260259026, 0, 0, 0, '', 0, 0, 1, 0, 0);



CREATE TABLE IF NOT EXISTS `nuke_bb3topics_posted` (
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `topic_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `topic_posted` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`user_id`,`topic_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_bb3topics_posted` (`user_id`, `topic_id`, `topic_posted`) VALUES
(2, 1, 1);



CREATE TABLE IF NOT EXISTS `nuke_bb3topics_track` (
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `topic_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `forum_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `mark_time` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`user_id`,`topic_id`),
  KEY `forum_id` (`forum_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3topics_watch` (
  `topic_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `notify_status` tinyint(1) unsigned NOT NULL DEFAULT '0',
  KEY `topic_id` (`topic_id`),
  KEY `user_id` (`user_id`),
  KEY `notify_stat` (`notify_status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_bb3users` (
  `user_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `user_type` tinyint(2) NOT NULL DEFAULT '0',
  `group_id` mediumint(8) unsigned NOT NULL DEFAULT '3',
  `user_permissions` mediumtext COLLATE utf8_bin NOT NULL,
  `user_perm_from` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `user_ip` varchar(40) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_regdate` int(11) unsigned NOT NULL DEFAULT '0',
  `username` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `username_clean` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_password` varchar(40) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_passchg` int(11) unsigned NOT NULL DEFAULT '0',
  `user_pass_convert` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `user_email` varchar(100) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_email_hash` bigint(20) NOT NULL DEFAULT '0',
  `user_birthday` varchar(10) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_lastvisit` int(11) unsigned NOT NULL DEFAULT '0',
  `user_lastmark` int(11) unsigned NOT NULL DEFAULT '0',
  `user_lastpost_time` int(11) unsigned NOT NULL DEFAULT '0',
  `user_lastpage` varchar(200) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_last_confirm_key` varchar(10) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_last_search` int(11) unsigned NOT NULL DEFAULT '0',
  `user_warnings` tinyint(4) NOT NULL DEFAULT '0',
  `user_last_warning` int(11) unsigned NOT NULL DEFAULT '0',
  `user_login_attempts` tinyint(4) NOT NULL DEFAULT '0',
  `user_inactive_reason` tinyint(2) NOT NULL DEFAULT '0',
  `user_inactive_time` int(11) unsigned NOT NULL DEFAULT '0',
  `user_posts` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `user_lang` varchar(30) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_timezone` decimal(5,2) NOT NULL DEFAULT '0.00',
  `user_dst` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `user_dateformat` varchar(30) COLLATE utf8_bin NOT NULL DEFAULT 'd M Y H:i',
  `user_style` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `user_rank` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `user_colour` varchar(6) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_new_privmsg` int(4) NOT NULL DEFAULT '0',
  `user_unread_privmsg` int(4) NOT NULL DEFAULT '0',
  `user_last_privmsg` int(11) unsigned NOT NULL DEFAULT '0',
  `user_message_rules` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `user_full_folder` int(11) NOT NULL DEFAULT '-3',
  `user_emailtime` int(11) unsigned NOT NULL DEFAULT '0',
  `user_topic_show_days` smallint(4) unsigned NOT NULL DEFAULT '0',
  `user_topic_sortby_type` varchar(1) COLLATE utf8_bin NOT NULL DEFAULT 't',
  `user_topic_sortby_dir` varchar(1) COLLATE utf8_bin NOT NULL DEFAULT 'd',
  `user_post_show_days` smallint(4) unsigned NOT NULL DEFAULT '0',
  `user_post_sortby_type` varchar(1) COLLATE utf8_bin NOT NULL DEFAULT 't',
  `user_post_sortby_dir` varchar(1) COLLATE utf8_bin NOT NULL DEFAULT 'a',
  `user_notify` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `user_notify_pm` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `user_notify_type` tinyint(4) NOT NULL DEFAULT '0',
  `user_allow_pm` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `user_allow_viewonline` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `user_allow_viewemail` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `user_allow_massemail` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `user_options` int(11) unsigned NOT NULL DEFAULT '895',
  `user_avatar` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_avatar_type` tinyint(2) NOT NULL DEFAULT '0',
  `user_avatar_width` smallint(4) unsigned NOT NULL DEFAULT '0',
  `user_avatar_height` smallint(4) unsigned NOT NULL DEFAULT '0',
  `user_sig` mediumtext COLLATE utf8_bin NOT NULL,
  `user_sig_bbcode_uid` varchar(8) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_sig_bbcode_bitfield` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_from` varchar(100) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_icq` varchar(15) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_aim` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_yim` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_msnm` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_jabber` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_website` varchar(200) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_occ` text COLLATE utf8_bin NOT NULL,
  `user_interests` text COLLATE utf8_bin NOT NULL,
  `user_actkey` varchar(32) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_newpasswd` varchar(40) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_form_salt` varchar(32) COLLATE utf8_bin NOT NULL DEFAULT '',
  `user_thanked` int(11) unsigned NOT NULL DEFAULT '0',
  `user_thanks` int(11) unsigned NOT NULL DEFAULT '0',
  `user_thanks_post` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`user_id`),
  UNIQUE KEY `username_clean` (`username_clean`),
  KEY `user_birthday` (`user_birthday`),
  KEY `user_email_hash` (`user_email_hash`),
  KEY `user_type` (`user_type`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=56 ;


INSERT INTO `nuke_bb3users` (`user_id`, `user_type`, `group_id`, `user_permissions`, `user_perm_from`, `user_ip`, `user_regdate`, `username`, `username_clean`, `user_password`, `user_passchg`, `user_pass_convert`, `user_email`, `user_email_hash`, `user_birthday`, `user_lastvisit`, `user_lastmark`, `user_lastpost_time`, `user_lastpage`, `user_last_confirm_key`, `user_last_search`, `user_warnings`, `user_last_warning`, `user_login_attempts`, `user_inactive_reason`, `user_inactive_time`, `user_posts`, `user_lang`, `user_timezone`, `user_dst`, `user_dateformat`, `user_style`, `user_rank`, `user_colour`, `user_new_privmsg`, `user_unread_privmsg`, `user_last_privmsg`, `user_message_rules`, `user_full_folder`, `user_emailtime`, `user_topic_show_days`, `user_topic_sortby_type`, `user_topic_sortby_dir`, `user_post_show_days`, `user_post_sortby_type`, `user_post_sortby_dir`, `user_notify`, `user_notify_pm`, `user_notify_type`, `user_allow_pm`, `user_allow_viewonline`, `user_allow_viewemail`, `user_allow_massemail`, `user_options`, `user_avatar`, `user_avatar_type`, `user_avatar_width`, `user_avatar_height`, `user_sig`, `user_sig_bbcode_uid`, `user_sig_bbcode_bitfield`, `user_from`, `user_icq`, `user_aim`, `user_yim`, `user_msnm`, `user_jabber`, `user_website`, `user_occ`, `user_interests`, `user_actkey`, `user_newpasswd`, `user_form_salt`, `user_thanked`, `user_thanks`, `user_thanks_post`) VALUES
(1, 2, 1, '00000000003khra3nk\ni1cjyo000000\ni1cjyo000000', 0, '', 1249992268, 'Anonymous', 'anonymous', '', 0, 0, '', 0, '', 0, 0, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'd M Y H:i', 1, 0, '', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'd745cbcb92f78735', 0, 0, 0),
(2, 3, 5, 'zik0zjzik0zjzik0xs\ni1cjyo000000\nzik0zjzhb2tc', 0, '127.0.0.1', 1260348443, 'Delta', 'Delta', '21232f297a57a5a743894a0e4a801fc3', 0, 0, 'aneeshtan@gmail.com', 147392577719, '', 1260369193, 0, 0, 'modules.php?name=phpBB3&file=ucp&i=pm&mode=compose&action=post', '', 0, 0, 0, 0, 0, 0, 1, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 1, 'AA0000', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 1, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '3898fc43b1ab8116', 0, 0, 0),
(3, 2, 6, '', 0, '', 1249992299, 'AdsBot [Google]', 'adsbot [google]', '', 1249992299, 0, '', 0, '', 0, 1249992299, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '8afb353693e16201', 0, 0, 0),
(4, 2, 6, '', 0, '', 1249992299, 'Alexa [Bot]', 'alexa [bot]', '', 1249992299, 0, '', 0, '', 0, 1249992299, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'ee92f2cd851914f0', 0, 0, 0),
(5, 2, 6, '', 0, '', 1249992299, 'Alta Vista [Bot]', 'alta vista [bot]', '', 1249992299, 0, '', 0, '', 0, 1249992299, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'b640af1a76c75cee', 0, 0, 0),
(6, 2, 6, '', 0, '', 1249992299, 'Ask Jeeves [Bot]', 'ask jeeves [bot]', '', 1249992299, 0, '', 0, '', 0, 1249992299, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'dfa59f63f44569a2', 0, 0, 0),
(7, 2, 6, '', 0, '', 1249992299, 'Baidu [Spider]', 'baidu [spider]', '', 1249992299, 0, '', 0, '', 0, 1249992299, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'e3caff4855359102', 0, 0, 0),
(8, 2, 6, '', 0, '', 1249992300, 'Exabot [Bot]', 'exabot [bot]', '', 1249992300, 0, '', 0, '', 0, 1249992300, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '8612b875c1b7ef36', 0, 0, 0),
(9, 2, 6, '', 0, '', 1249992300, 'FAST Enterprise [Crawler]', 'fast enterprise [crawler]', '', 1249992300, 0, '', 0, '', 0, 1249992300, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '5aa25173980eb932', 0, 0, 0),
(10, 2, 6, '', 0, '', 1249992300, 'FAST WebCrawler [Crawler]', 'fast webcrawler [crawler]', '', 1249992300, 0, '', 0, '', 0, 1249992300, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '034cd27d3416edff', 0, 0, 0),
(11, 2, 6, '', 0, '', 1249992300, 'Francis [Bot]', 'francis [bot]', '', 1249992300, 0, '', 0, '', 0, 1249992300, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '226f0e830ca05d03', 0, 0, 0),
(12, 2, 6, '', 0, '', 1249992300, 'Gigabot [Bot]', 'gigabot [bot]', '', 1249992300, 0, '', 0, '', 0, 1249992300, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '41d95cc81fa07702', 0, 0, 0),
(13, 2, 6, '', 0, '', 1249992300, 'Google Adsense [Bot]', 'google adsense [bot]', '', 1249992300, 0, '', 0, '', 0, 1249992300, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '0ff9b52d3a8b7ec8', 0, 0, 0),
(14, 2, 6, '', 0, '', 1249992301, 'Google Desktop', 'google desktop', '', 1249992301, 0, '', 0, '', 0, 1249992301, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'dc642628f7aa4728', 0, 0, 0),
(15, 2, 6, '', 0, '', 1249992301, 'Google Feedfetcher', 'google feedfetcher', '', 1249992301, 0, '', 0, '', 0, 1249992301, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'f33b9d6454390ecc', 0, 0, 0),
(16, 2, 6, '', 0, '', 1249992301, 'Google [Bot]', 'google [bot]', '', 1249992301, 0, '', 0, '', 0, 1249992301, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '59f6526c5fbfc9e9', 0, 0, 0),
(17, 2, 6, '', 0, '', 1249992301, 'Heise IT-Markt [Crawler]', 'heise it-markt [crawler]', '', 1249992301, 0, '', 0, '', 0, 1249992301, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'c893ba37c327ad5a', 0, 0, 0),
(18, 2, 6, '', 0, '', 1249992301, 'Heritrix [Crawler]', 'heritrix [crawler]', '', 1249992301, 0, '', 0, '', 0, 1249992301, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'f4797267ff14906a', 0, 0, 0),
(19, 2, 6, '', 0, '', 1249992302, 'IBM Research [Bot]', 'ibm research [bot]', '', 1249992302, 0, '', 0, '', 0, 1249992302, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '3fa5526f77cf9d34', 0, 0, 0),
(20, 2, 6, '', 0, '', 1249992302, 'ICCrawler - ICjobs', 'iccrawler - icjobs', '', 1249992302, 0, '', 0, '', 0, 1249992302, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '1d2e41ab501a6356', 0, 0, 0),
(21, 2, 6, '', 0, '', 1249992302, 'ichiro [Crawler]', 'ichiro [crawler]', '', 1249992302, 0, '', 0, '', 0, 1249992302, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '87d59797d22c048e', 0, 0, 0),
(22, 2, 6, '', 0, '', 1249992302, 'Majestic-12 [Bot]', 'majestic-12 [bot]', '', 1249992302, 0, '', 0, '', 0, 1249992302, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '3021416528b488e4', 0, 0, 0),
(23, 2, 6, '', 0, '', 1249992302, 'Metager [Bot]', 'metager [bot]', '', 1249992302, 0, '', 0, '', 0, 1249992302, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '4d16844dfc67c9e1', 0, 0, 0),
(24, 2, 6, '', 0, '', 1249992302, 'MSN NewsBlogs', 'msn newsblogs', '', 1249992302, 0, '', 0, '', 0, 1249992302, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '3aef303961deab60', 0, 0, 0),
(25, 2, 6, '', 0, '', 1249992303, 'MSN [Bot]', 'msn [bot]', '', 1249992303, 0, '', 0, '', 0, 1249992303, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'b3bce1287bd082e8', 0, 0, 0),
(26, 2, 6, '', 0, '', 1249992303, 'MSNbot Media', 'msnbot media', '', 1249992303, 0, '', 0, '', 0, 1249992303, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '10afde5fa3a3f536', 0, 0, 0),
(27, 2, 6, '', 0, '', 1249992303, 'NG-Search [Bot]', 'ng-search [bot]', '', 1249992303, 0, '', 0, '', 0, 1249992303, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '892caaba90e11b2b', 0, 0, 0),
(28, 2, 6, '', 0, '', 1249992303, 'Nutch [Bot]', 'nutch [bot]', '', 1249992303, 0, '', 0, '', 0, 1249992303, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '16e208d9127ee799', 0, 0, 0),
(29, 2, 6, '', 0, '', 1249992303, 'Nutch/CVS [Bot]', 'nutch/cvs [bot]', '', 1249992303, 0, '', 0, '', 0, 1249992303, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'ab8dfe3973d24777', 0, 0, 0),
(30, 2, 6, '', 0, '', 1249992304, 'OmniExplorer [Bot]', 'omniexplorer [bot]', '', 1249992304, 0, '', 0, '', 0, 1249992304, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '79ea7eb3d74103a4', 0, 0, 0),
(31, 2, 6, '', 0, '', 1249992304, 'Online link [Validator]', 'online link [validator]', '', 1249992304, 0, '', 0, '', 0, 1249992304, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '80166526563a2624', 0, 0, 0),
(32, 2, 6, '', 0, '', 1249992304, 'psbot [Picsearch]', 'psbot [picsearch]', '', 1249992304, 0, '', 0, '', 0, 1249992304, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '8f2e726c6a862522', 0, 0, 0),
(33, 2, 6, '', 0, '', 1249992304, 'Seekport [Bot]', 'seekport [bot]', '', 1249992304, 0, '', 0, '', 0, 1249992304, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '35c45f299e765131', 0, 0, 0),
(34, 2, 6, '', 0, '', 1249992304, 'Sensis [Crawler]', 'sensis [crawler]', '', 1249992304, 0, '', 0, '', 0, 1249992304, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'eb32fb02ade74be5', 0, 0, 0),
(35, 2, 6, '', 0, '', 1249992304, 'SEO Crawler', 'seo crawler', '', 1249992304, 0, '', 0, '', 0, 1249992304, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '0bc6eb5fe7b8ad62', 0, 0, 0),
(36, 2, 6, '', 0, '', 1249992305, 'Seoma [Crawler]', 'seoma [crawler]', '', 1249992305, 0, '', 0, '', 0, 1249992305, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '66c25edf4b979f78', 0, 0, 0),
(37, 2, 6, '', 0, '', 1249992305, 'SEOSearch [Crawler]', 'seosearch [crawler]', '', 1249992305, 0, '', 0, '', 0, 1249992305, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'fcd0c1982cb07794', 0, 0, 0),
(38, 2, 6, '', 0, '', 1249992305, 'Snappy [Bot]', 'snappy [bot]', '', 1249992305, 0, '', 0, '', 0, 1249992305, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '3cfa4bd442478919', 0, 0, 0),
(39, 2, 6, '', 0, '', 1249992305, 'Steeler [Crawler]', 'steeler [crawler]', '', 1249992305, 0, '', 0, '', 0, 1249992305, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'acb47d6319461dd4', 0, 0, 0),
(40, 2, 6, '', 0, '', 1249992305, 'Synoo [Bot]', 'synoo [bot]', '', 1249992305, 0, '', 0, '', 0, 1249992305, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '09726a04b003997d', 0, 0, 0),
(41, 2, 6, '', 0, '', 1249992305, 'Telekom [Bot]', 'telekom [bot]', '', 1249992305, 0, '', 0, '', 0, 1249992305, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'bbbaf925cb213db5', 0, 0, 0),
(42, 2, 6, '', 0, '', 1249992305, 'TurnitinBot [Bot]', 'turnitinbot [bot]', '', 1249992305, 0, '', 0, '', 0, 1249992305, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '4552050951c50480', 0, 0, 0),
(43, 2, 6, '', 0, '', 1249992306, 'Voyager [Bot]', 'voyager [bot]', '', 1249992306, 0, '', 0, '', 0, 1249992306, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'b17141d608c9ad72', 0, 0, 0),
(44, 2, 6, '', 0, '', 1249992306, 'W3 [Sitesearch]', 'w3 [sitesearch]', '', 1249992306, 0, '', 0, '', 0, 1249992306, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'bfa90c362656d5fb', 0, 0, 0),
(45, 2, 6, '', 0, '', 1249992306, 'W3C [Linkcheck]', 'w3c [linkcheck]', '', 1249992306, 0, '', 0, '', 0, 1249992306, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'cc64899a684696a1', 0, 0, 0),
(46, 2, 6, '', 0, '', 1249992306, 'W3C [Validator]', 'w3c [validator]', '', 1249992306, 0, '', 0, '', 0, 1249992306, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '1eacfbd238eb6f9e', 0, 0, 0),
(47, 2, 6, '', 0, '', 1249992306, 'WiseNut [Bot]', 'wisenut [bot]', '', 1249992306, 0, '', 0, '', 0, 1249992306, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '8d49d1e1f25761ad', 0, 0, 0),
(48, 2, 6, '', 0, '', 1249992306, 'YaCy [Bot]', 'yacy [bot]', '', 1249992306, 0, '', 0, '', 0, 1249992306, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '2fd28edc37d482e0', 0, 0, 0),
(49, 2, 6, '', 0, '', 1249992306, 'Yahoo MMCrawler [Bot]', 'yahoo mmcrawler [bot]', '', 1249992306, 0, '', 0, '', 0, 1249992306, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'c43f76ea26ce8ae8', 0, 0, 0),
(50, 2, 6, '', 0, '', 1249992307, 'Yahoo Slurp [Bot]', 'yahoo slurp [bot]', '', 1249992307, 0, '', 0, '', 0, 1249992307, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '5c6605c420043752', 0, 0, 0),
(51, 2, 6, '', 0, '', 1249992307, 'Yahoo [Bot]', 'yahoo [bot]', '', 1249992307, 0, '', 0, '', 0, 1249992307, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'febb502bdd53a5e2', 0, 0, 0),
(52, 2, 6, '', 0, '', 1249992307, 'YahooSeeker [Bot]', 'yahooseeker [bot]', '', 1249992307, 0, '', 0, '', 0, 1249992307, 0, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 0, 'D M d, Y g:i a', 1, 0, '9E8DA7', 0, 0, 0, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 0, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '2f629535d5a304f9', 0, 0, 0),
(55, 0, 2, '00000000006xv29nwg\ni1cjyo000000\nqlc4pi000000', 0, '', 1260369202, 'farshad', 'farshad', '21232f297a57a5a743894a0e4a801fc3', 1260369202, 0, 'info@nukelearn.com', -81540636118, '', 0, 1260369202, 1260369250, '', '', 0, 0, 0, 0, 0, 0, 0, 'persian', '0.00', 1, 'D M d, Y g:i a', 1, 0, '', 0, 0, 1260369250, 0, -3, 0, 0, 't', 'd', 0, 't', 'a', 0, 1, 0, 1, 1, 1, 1, 895, '', 0, 0, 0, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '3028058df59982d1', 0, 0, 0);



CREATE TABLE IF NOT EXISTS `nuke_bb3user_group` (
  `group_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `group_leader` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `user_pending` tinyint(1) unsigned NOT NULL DEFAULT '1',
  KEY `group_id` (`group_id`),
  KEY `user_id` (`user_id`),
  KEY `group_leader` (`group_leader`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_bb3user_group` (`group_id`, `user_id`, `group_leader`, `user_pending`) VALUES
(1, 1, 0, 0),
(2, 2, 0, 0),
(4, 2, 0, 0),
(5, 2, 1, 0),
(6, 3, 0, 0),
(6, 4, 0, 0),
(6, 5, 0, 0),
(6, 6, 0, 0),
(6, 7, 0, 0),
(6, 8, 0, 0),
(6, 9, 0, 0),
(6, 10, 0, 0),
(6, 11, 0, 0),
(6, 12, 0, 0),
(6, 13, 0, 0),
(6, 14, 0, 0),
(6, 15, 0, 0),
(6, 16, 0, 0),
(6, 17, 0, 0),
(6, 18, 0, 0),
(6, 19, 0, 0),
(6, 20, 0, 0),
(6, 21, 0, 0),
(6, 22, 0, 0),
(6, 23, 0, 0),
(6, 24, 0, 0),
(6, 25, 0, 0),
(6, 26, 0, 0),
(6, 27, 0, 0),
(6, 28, 0, 0),
(6, 29, 0, 0),
(6, 30, 0, 0),
(6, 31, 0, 0),
(6, 32, 0, 0),
(6, 33, 0, 0),
(6, 34, 0, 0),
(6, 35, 0, 0),
(6, 36, 0, 0),
(6, 37, 0, 0),
(6, 38, 0, 0),
(6, 39, 0, 0),
(6, 40, 0, 0),
(6, 41, 0, 0),
(6, 42, 0, 0),
(6, 43, 0, 0),
(6, 44, 0, 0),
(6, 45, 0, 0),
(6, 46, 0, 0),
(6, 47, 0, 0),
(6, 48, 0, 0),
(6, 49, 0, 0),
(6, 50, 0, 0),
(6, 51, 0, 0),
(6, 52, 0, 0),
(2, 53, 0, 0),
(2, 53, 0, 0),
(2, 54, 0, 0),
(2, 55, 0, 0);



CREATE TABLE IF NOT EXISTS `nuke_bb3warnings` (
  `warning_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `post_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `log_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `warning_time` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`warning_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_bb3words` (
  `word_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `word` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  `replacement` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT '',
  PRIMARY KEY (`word_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_bb3zebra` (
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `zebra_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `friend` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `foe` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`user_id`,`zebra_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;






CREATE TABLE IF NOT EXISTS `nuke_blocks` (
  `bid` int(10) NOT NULL auto_increment,
  `bkey` varchar(15) collate utf8_bin NOT NULL,
  `title` varchar(60) collate utf8_bin NOT NULL,
  `content` text collate utf8_bin NOT NULL,
  `url` varchar(200) collate utf8_bin NOT NULL,
  `bposition` char(1) collate utf8_bin NOT NULL,
  `weight` int(10) NOT NULL default '1',
  `active` int(1) NOT NULL default '1',
  `refresh` int(10) NOT NULL default '0',
  `time` varchar(14) collate utf8_bin NOT NULL default '0',
  `blanguage` varchar(30) collate utf8_bin NOT NULL,
  `blockfile` varchar(255) collate utf8_bin NOT NULL,
  `view` int(1) NOT NULL default '0',
  `expire` varchar(14) collate utf8_bin NOT NULL default '0',
  `action` char(1) collate utf8_bin NOT NULL,
  `subscription` int(1) NOT NULL default '0',
  PRIMARY KEY  (`bid`),
  KEY `bid` (`bid`),
  KEY `title` (`title`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=28 ;


INSERT INTO `nuke_blocks` (`bid`, `bkey`, `title`, `content`, `url`, `bposition`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`, `expire`, `action`, `subscription`) VALUES
(1, '', 'منو اصلی', '', '', 'l', 1, 1, 0, '', '', 'block-menu.php', 0, '0', 'd', 0),
(18, '', 'به روز رسانی', '', '', 'r', 5, 1, 0, '', 'persian', 'block-RSS_USV.php', 0, '0', 'd', 0),
(3, '', 'جستجو', '', '', 'l', 2, 0, 3600, '', '', 'block-Search.php', 0, '0', 'd', 0),
(17, '', 'اطلاعات سایت ', '', '', 'r', 2, 1, 0, '', '', 'block-Info_Box.php', 0, '0', 'd', 0),
(5, '', 'Random Headlines', '', '', 'l', 3, 0, 3600, '', '', 'block-Random_Headlines.php', 0, '0', 'd', 0),
(6, 'userbox', 'منوی شخصی کاربر', '', '', 'r', 1, 1, 0, '', '', '', 1, '0', 'd', 0),
(7, '', 'Categories Menu', '', '', 'r', 3, 0, 0, '', '', 'block-Categories.php', 0, '0', 'd', 0),
(8, '', 'نظرسنجی', '', '', 'l', 4, 1, 0, '', '', 'block-Survey.php', 0, '0', 'd', 0),
(10, '', 'بهترین مطالب روز', '', '', 'r', 7, 0, 3600, '', '', 'block-Big_Story_of_Today.php', 0, '0', 'd', 0),
(11, '', 'مطالب قبلی', '', '', 'r', 8, 0, 3600, '', '', 'block-Old_Articles.php', 0, '0', 'd', 0),
(13, '', 'پیامهای کوتاه', '', '', 'l', 6, 1, 0, '', '', 'block-Shout_Box.php', 0, '0', 'd', 0),
(14, '', 'ورود مشتریان تبلیغاتی', '', '', 'r', 9, 0, 0, '', '', 'block-INPB_Login.php', 0, '0', 'd', 0),
(15, '', 'لینک به سایت', '', '', 'r', 10, 1, 0, '', '', 'block-CZLinks.php', 0, '0', 'd', 0),
(16, '', 'تقویم جلالی', '', '', 'l', 5, 1, 0, '', 'persian', 'block-Calender.php', 0, '0', 'd', 0),
(19, '', 'تابلوی خبرخوان', '', '', 'r', 6, 1, 0, '', '', 'block-RSS_List.php', 0, '0', 'd', 0),
(20, '', 'اشتراک گذاری', '', '', 'r', 4, 1, 0, '', '', 'block-BookMark.php', 0, '0', 'd', 0),
(21, '', 'تابلوی کلیدواژه ها', '', '', 'l', 7, 0, 0, '', '', 'block-Tag_Cloud.php', 0, '0', 'd', 0),
(22, '', 'جستجوی گوگل آجاکسی', '', '', 'd', 1, 0, 0, '', '', 'block-Ajax_Google_Search.php', 0, '0', 'd', 0),
(26, '', 'آخرین ارسالی های انجمن', '', '', 'c', 1, 1, 3600, '', 'persian', 'block-phpBB3_Forum_Center_NukeLearn.php', 0, '0', 'd', 0);



CREATE TABLE IF NOT EXISTS `nuke_blogs` (
  `bid` int(10) NOT NULL AUTO_INCREMENT,
  `tid` int(10) NOT NULL DEFAULT '0',
  `content` varchar(255) COLLATE utf8_bin NOT NULL,
  `date` varchar(14) COLLATE utf8_bin DEFAULT NULL,
  `sender` int(10) NOT NULL,
  `reciever` int(10) NOT NULL,
  `like` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`bid`),
  KEY `bid` (`bid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_cnbya_config` (
  `config_name` varchar(255) COLLATE utf8_bin NOT NULL,
  `config_value` longtext COLLATE utf8_bin,
  UNIQUE KEY `config_name` (`config_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_cnbya_config` (`config_name`, `config_value`) VALUES
('allowmailchange', '1'),
('allowuserdelete', '0'),
('allowuserreg', '0'),
('allowusertheme', '0'),
('autosuspend', '0'),
('autosuspendmain', '0'),
('bad_mail', 'mysite.com\r\nyoursite.com'),
('bad_nick', 'adm\r\nadmin\r\nanonimo\r\nanonymous\r\nanَnimo\r\ngod\r\nlinux\r\nnobody\r\noperator\r\nroot\r\nstaff\r\nwebmaster'),
('codesize', '4'),
('cookiecheck', '1'),
('cookiecleaner', '1'),
('cookieinactivity', '-'),
('cookiepath', ''),
('cookietimelife', '2592000'),
('coppa', '0'),
('doublecheckemail', '1'),
('emailvalidate', '0'),
('expiring', '86400'),
('nick_max', '20'),
('nick_min', '3'),
('pass_max', '25'),
('pass_min', '3'),
('perpage', '100'),
('requireadmin', '0'),
('sendaddmail', '0'),
('senddeletemail', '0'),
('servermail', '1'),
('tos', '0'),
('tosall', '0'),
('useactivate', '1'),
('usegfxcheck', '3'),
('version', '4.4.1'),
('use_question', '1');



CREATE TABLE IF NOT EXISTS `nuke_cnbya_field` (
  `fid` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT 'field',
  `value` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `size` int(3) DEFAULT NULL,
  `need` int(1) NOT NULL DEFAULT '1',
  `pos` int(3) DEFAULT NULL,
  `public` int(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`fid`),
  KEY `fid` (`fid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_cnbya_tos` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `data` text COLLATE utf8_bin NOT NULL,
  `status` tinyint(4) NOT NULL DEFAULT '0',
  `des` text COLLATE utf8_bin NOT NULL,
  `language` varchar(25) COLLATE utf8_bin NOT NULL,
  `time` text COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=2 ;


INSERT INTO `nuke_cnbya_tos` (`id`, `data`, `status`, `des`, `language`, `time`) VALUES
(1, '<p><font class="content"><b>1. قانون اول</b><br>\r\nشرح قانون اول<br>\r\n<br>\r\n<b>2. قانون دوم</b><br>\r\nشرح قانون دوم<br>\r\n<br>\r\n<b>3. قانون سوم</b><br>\r\nشرح قانون سوم<br>\r\n<br>\r\n<b>4. قانون چهارم</b><br>\r\nشرح قانون چهارم<br>\r\n<br>\r\n<b>5. قانون پنجم</b><br>\r\nشرح قانون پنجم<br>\r\n<br>\r\n<b>6. قانون ششم</b><br>\r\nشرح قانون ششم<br>\r\n<br>\r\n<b>7. قانون هفتم</b><br>\r\nشرح قانون هفتم<br>\r\n<br>\r\n<b>8. قانون هشتم</b><br>\r\nشرح قانون هشتم<br>\r\n<br>\r\n<b>9.قانون نهم</b><br>\r\nشرح قانون نهم<br>\r\n<br>\r\n<b>10. قانون دهم</b><br>\r\nشرح قانون دهم<br>\r\n<br>\r\n<b>11. قانون یازدهم</b><br>\r\nشرح قانون یازدهم<br>\r\n<br>\r\n<b>12. قانون دوازدهم</b><br>\r\nشرح قانون دوازدهم<br>\r\n<br>\r\n<b>13. قانون سیزدهم</b><br>\r\nشرح قانون سیزدهم<br>\r\n </font></p>\r\n', 1, 'قوانین پیشفرض', 'persian', '2005-05-03 00:10');



CREATE TABLE IF NOT EXISTS `nuke_cnbya_value` (
  `vid` int(10) NOT NULL AUTO_INCREMENT,
  `uid` int(10) NOT NULL DEFAULT '0',
  `fid` int(10) NOT NULL DEFAULT '0',
  `value` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`vid`),
  KEY `vid` (`vid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_cnbya_value_temp` (
  `vid` int(10) NOT NULL AUTO_INCREMENT,
  `uid` int(10) NOT NULL DEFAULT '0',
  `fid` int(10) NOT NULL DEFAULT '0',
  `value` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`vid`),
  KEY `vid` (`vid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_comments_moderated` (
  `tid` int(11) NOT NULL AUTO_INCREMENT,
  `pid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `active` int(1) NOT NULL DEFAULT '0',
  `date` datetime DEFAULT NULL,
  `name` varchar(60) COLLATE utf8_bin NOT NULL,
  `email` varchar(60) COLLATE utf8_bin DEFAULT NULL,
  `url` varchar(60) COLLATE utf8_bin DEFAULT NULL,
  `host_name` varchar(60) COLLATE utf8_bin DEFAULT NULL,
  `subject` varchar(85) COLLATE utf8_bin NOT NULL,
  `comment` text COLLATE utf8_bin NOT NULL,
  `score` tinyint(4) NOT NULL DEFAULT '0',
  `reason` tinyint(4) NOT NULL DEFAULT '0',
  `last_moderation_ip` varchar(15) COLLATE utf8_bin DEFAULT '0',
  PRIMARY KEY (`tid`),
  KEY `tid` (`tid`),
  KEY `pid` (`pid`),
  KEY `sid` (`sid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_config` (
  `sitename` varchar(255) COLLATE utf8_bin NOT NULL,
  `nukeurl` varchar(255) COLLATE utf8_bin NOT NULL,
  `site_logo` varchar(255) COLLATE utf8_bin NOT NULL,
  `slogan` varchar(255) COLLATE utf8_bin NOT NULL,
  `startdate` varchar(50) COLLATE utf8_bin NOT NULL,
  `adminmail` varchar(255) COLLATE utf8_bin NOT NULL,
  `anonpost` tinyint(1) NOT NULL DEFAULT '0',
  `Default_Theme` varchar(255) COLLATE utf8_bin NOT NULL,
  `foot1` text COLLATE utf8_bin NOT NULL,
  `foot2` text COLLATE utf8_bin NOT NULL,
  `foot3` text COLLATE utf8_bin NOT NULL,
  `commentlimit` int(9) NOT NULL DEFAULT '4096',
  `anonymous` varchar(255) COLLATE utf8_bin NOT NULL,
  `minpass` tinyint(1) NOT NULL DEFAULT '5',
  `pollcomm` tinyint(1) NOT NULL DEFAULT '1',
  `articlecomm` tinyint(1) NOT NULL DEFAULT '1',
  `broadcast_msg` tinyint(1) NOT NULL DEFAULT '1',
  `my_headlines` tinyint(1) NOT NULL DEFAULT '1',
  `top` int(3) NOT NULL DEFAULT '10',
  `storyhome` int(2) NOT NULL DEFAULT '10',
  `user_news` tinyint(1) NOT NULL DEFAULT '1',
  `oldnum` int(2) NOT NULL DEFAULT '30',
  `ultramode` tinyint(1) NOT NULL DEFAULT '0',
  `loading` tinyint(1) NOT NULL DEFAULT '0',
  `nextg` tinyint(1) NOT NULL DEFAULT '0',
  `banners` tinyint(1) NOT NULL DEFAULT '1',
  `backend_title` varchar(255) COLLATE utf8_bin NOT NULL,
  `backend_language` varchar(10) COLLATE utf8_bin NOT NULL,
  `language` varchar(100) COLLATE utf8_bin NOT NULL,
  `locale` varchar(10) COLLATE utf8_bin NOT NULL,
  `multilingual` tinyint(1) NOT NULL DEFAULT '0',
  `useflags` tinyint(1) NOT NULL DEFAULT '0',
  `notify` tinyint(1) NOT NULL DEFAULT '0',
  `notify_email` varchar(255) COLLATE utf8_bin NOT NULL,
  `notify_subject` varchar(255) COLLATE utf8_bin NOT NULL,
  `notify_message` varchar(255) COLLATE utf8_bin NOT NULL,
  `notify_from` varchar(255) COLLATE utf8_bin NOT NULL,
  `moderate` tinyint(1) NOT NULL DEFAULT '0',
  `admingraphic` tinyint(1) NOT NULL DEFAULT '1',
  `httpref` tinyint(1) NOT NULL DEFAULT '1',
  `httprefmax` int(5) NOT NULL DEFAULT '1000',
  `CensorMode` tinyint(1) NOT NULL DEFAULT '3',
  `CensorReplace` varchar(10) COLLATE utf8_bin NOT NULL,
  `copyright` text COLLATE utf8_bin NOT NULL,
  `USV_Version` varchar(15) COLLATE utf8_bin NOT NULL,
  `support` varchar(30) COLLATE utf8_bin NOT NULL,
  `gfx_chk` tinyint(1) NOT NULL DEFAULT '1',
  `use_question` int(1) NOT NULL DEFAULT '0',
  `codesize` int(1) NOT NULL DEFAULT '4',
  `cache_system` int(1) NOT NULL DEFAULT '0',
  `cache_lifetime` int(1) NOT NULL DEFAULT '120',
  `nuke_editor` int(1) NOT NULL DEFAULT '1',
  `tracking` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`sitename`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_config` (`sitename`, `nukeurl`, `site_logo`, `slogan`, `startdate`, `adminmail`, `anonpost`, `Default_Theme`, `foot1`, `foot2`, `foot3`, `commentlimit`, `anonymous`, `minpass`, `pollcomm`, `articlecomm`, `broadcast_msg`, `my_headlines`, `top`, `storyhome`, `user_news`, `oldnum`, `ultramode`, `loading`, `nextg`, `banners`, `backend_title`, `backend_language`, `language`, `locale`, `multilingual`, `useflags`, `notify`, `notify_email`, `notify_subject`, `notify_message`, `notify_from`, `moderate`, `admingraphic`, `httpref`, `httprefmax`, `CensorMode`, `CensorReplace`, `copyright`, `USV_Version`, `support`, `gfx_chk`, `use_question`, `codesize`, `cache_system`, `cache_lifetime`, `nuke_editor`, `tracking`) VALUES
('Nukelearn USV', '', '', '', '', '', 0, 'USV-classio', '', '', '', 4096, 'کاربر مهمان', 5, 0, 1, 1, 1, 10, 10, 1, 30, 0, 0, 0, 0, 'Nukelearn USV Powered Site', 'persian', 'persian', 'en_US', 1, 1, 1, 'info@nukelearn.com', 'اطلاعیه سایت', 'از سوی سایت اطلاعیه دارید ', 'مدیریت', 0, 1, 1, 1000, 3, '*****', 'Nukelearn USV &copy; 2009-2010 <a href="http://www.nukelearn.com" target="_blank">Nukelearn</a>', '1.1.0', 'info@nukelearn.com', 1, 0, 4, 0, 120, 1, 1);



CREATE TABLE IF NOT EXISTS `nuke_confirm` (
  `confirm_id` char(32) COLLATE utf8_bin NOT NULL,
  `session_id` char(32) COLLATE utf8_bin NOT NULL,
  `code` char(6) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`session_id`,`confirm_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_contact_us` (
  `pid` int(3) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `phone_num` varchar(60) COLLATE utf8_bin DEFAULT NULL,
  `fax_num` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `yahoo_id` varchar(255) COLLATE utf8_bin NOT NULL,
  `gmail_id` varchar(255) COLLATE utf8_bin NOT NULL,
  `dept_name` varchar(255) COLLATE utf8_bin NOT NULL,
  `dept_email` varchar(255) COLLATE utf8_bin NOT NULL,
  `address` text COLLATE utf8_bin NOT NULL,
  `showaddress` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`pid`),
  KEY `pid` (`pid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=5 ;


INSERT INTO `nuke_contact_us` (`pid`, `name`, `phone_num`, `fax_num`, `yahoo_id`, `gmail_id`, `dept_name`, `dept_email`, `address`, `showaddress`) VALUES
(1, 'TEST', '000000000', '', 'YahooID', 'test@gmail.com', 'مدیریت سایت', 'info@site.com', 'Address Info', 0);



CREATE TABLE IF NOT EXISTS `nuke_groups` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `description` text COLLATE utf8_bin NOT NULL,
  `points` int(10) NOT NULL DEFAULT '0',
  `posts` int(8) NOT NULL,
  `members` text COLLATE utf8_bin NOT NULL,
  `point_amount` text COLLATE utf8_bin NOT NULL,
  KEY `id` (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=9 ;



CREATE TABLE IF NOT EXISTS `nuke_groups_ranges` (
  `rid` int(8) NOT NULL AUTO_INCREMENT,
  `gid` int(8) NOT NULL,
  `post_min` int(8) NOT NULL,
  `post_max` int(11) NOT NULL,
  `point_min` int(11) NOT NULL,
  `point_max` int(11) NOT NULL,
  PRIMARY KEY (`rid`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 ;


CREATE TABLE IF NOT EXISTS `nuke_headlines` (
  `hid` int(11) NOT NULL AUTO_INCREMENT,
  `sitename` varchar(30) COLLATE utf8_bin NOT NULL,
  `headlinesurl` varchar(200) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`hid`),
  KEY `hid` (`hid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=13 ;


INSERT INTO `nuke_headlines` (`hid`, `sitename`, `headlinesurl`) VALUES
(1, 'سايت خبري تابناك', 'http://tabnak.ir/rss/allnews.php'),
(2, 'خبرگزاري فارس', 'http://www.farsnews.ir/rsslinks.php'),
(3, 'سايت خبري ايسنا', 'http://isna.ir/Main/newsdata.aspx'),
(4, 'خبرگزاري ايتنا', 'http://www.itna.ir/index.xml'),
(5, 'اخبرا سایت نیوک لرن', 'http://feeds.feedburner.com/nukelearn/news');



CREATE TABLE IF NOT EXISTS `nuke_iptracking` (
  `ipid` int(10) NOT NULL AUTO_INCREMENT,
  `username` varchar(25) DEFAULT NULL,
  `date_time` datetime NOT NULL,
  `ip_address` varchar(15) NOT NULL,
  `hostname` varchar(100) NOT NULL,
  `referer` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `page` varchar(150) NOT NULL,
  `page_title` varchar(150) NOT NULL,
  PRIMARY KEY (`ipid`),
  KEY `ipid` (`ipid`),
  KEY `i1iptracking` (`ip_address`,`hostname`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_jcalendar_events` (
  `eid` smallint(4) NOT NULL AUTO_INCREMENT,
  `title` varchar(256) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `repeat_type` enum('off','daily','weekly','monthly','yearly') CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT 'off',
  `approved` tinyint(1) NOT NULL DEFAULT '0',
  `holiday` enum('yes','no') CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT 'no',
  PRIMARY KEY (`eid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_keywords` (
  `mid` int(10) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL DEFAULT '',
  `keywords` text NOT NULL,
  `description` text NOT NULL,
  PRIMARY KEY (`mid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8  ;





CREATE TABLE IF NOT EXISTS `nuke_keywords_main` (
  `keywords` text NOT NULL,
  `description` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


INSERT INTO `nuke_keywords_main` (`keywords`, `description`) VALUES
('News, نیوک لرن, Nuke, USV NUKE, Downloads, Community, Forum, Bulletin, Board, PHP, MySQL, Survey, Portal, Blog', 'Your slogan here');



CREATE TABLE IF NOT EXISTS `nuke_links_categories` (
  `cid` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(50) COLLATE utf8_bin NOT NULL,
  `cdescription` text COLLATE utf8_bin NOT NULL,
  `parentid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`cid`),
  KEY `cid` (`cid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_links_editorials` (
  `linkid` int(11) NOT NULL DEFAULT '0',
  `adminid` varchar(60) COLLATE utf8_bin NOT NULL,
  `editorialtimestamp` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `editorialtext` text COLLATE utf8_bin NOT NULL,
  `editorialtitle` varchar(100) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`linkid`),
  KEY `linkid` (`linkid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_links_links` (
  `lid` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(100) COLLATE utf8_bin NOT NULL,
  `url` varchar(100) COLLATE utf8_bin NOT NULL,
  `description` text COLLATE utf8_bin NOT NULL,
  `date` datetime DEFAULT NULL,
  `name` varchar(100) COLLATE utf8_bin NOT NULL,
  `email` varchar(100) COLLATE utf8_bin NOT NULL,
  `hits` int(11) NOT NULL DEFAULT '0',
  `submitter` varchar(60) COLLATE utf8_bin NOT NULL,
  `linkratingsummary` double(6,4) NOT NULL DEFAULT '0.0000',
  `totalvotes` int(11) NOT NULL DEFAULT '0',
  `totalcomments` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lid`),
  KEY `lid` (`lid`),
  KEY `cid` (`cid`),
  KEY `sid` (`sid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_links_modrequest` (
  `requestid` int(11) NOT NULL AUTO_INCREMENT,
  `lid` int(11) NOT NULL DEFAULT '0',
  `cid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(100) COLLATE utf8_bin NOT NULL,
  `url` varchar(100) COLLATE utf8_bin NOT NULL,
  `description` text COLLATE utf8_bin NOT NULL,
  `modifysubmitter` varchar(60) COLLATE utf8_bin NOT NULL,
  `brokenlink` int(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`requestid`),
  UNIQUE KEY `requestid` (`requestid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_links_newlink` (
  `lid` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(100) COLLATE utf8_bin NOT NULL,
  `url` varchar(100) COLLATE utf8_bin NOT NULL,
  `description` text COLLATE utf8_bin NOT NULL,
  `name` varchar(100) COLLATE utf8_bin NOT NULL,
  `email` varchar(100) COLLATE utf8_bin NOT NULL,
  `submitter` varchar(60) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`lid`),
  KEY `lid` (`lid`),
  KEY `cid` (`cid`),
  KEY `sid` (`sid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_links_votedata` (
  `ratingdbid` int(11) NOT NULL AUTO_INCREMENT,
  `ratinglid` int(11) NOT NULL DEFAULT '0',
  `ratinguser` varchar(60) COLLATE utf8_bin NOT NULL,
  `rating` int(11) NOT NULL DEFAULT '0',
  `ratinghostname` varchar(60) COLLATE utf8_bin NOT NULL,
  `ratingcomments` text COLLATE utf8_bin NOT NULL,
  `ratingtimestamp` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`ratingdbid`),
  KEY `ratingdbid` (`ratingdbid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_linktous` (
  `l_id` int(11) NOT NULL AUTO_INCREMENT,
  `l_zipurl` varchar(255) COLLATE utf8_bin NOT NULL,
  `l_image` varchar(255) COLLATE utf8_bin NOT NULL,
  `l_mouseover` varchar(255) COLLATE utf8_bin NOT NULL,
  `l_status` int(1) NOT NULL DEFAULT '0',
  `l_size_width` char(3) COLLATE utf8_bin NOT NULL DEFAULT '0',
  `l_size_height` char(3) COLLATE utf8_bin NOT NULL DEFAULT '0',
  `l_hits` bigint(20) NOT NULL DEFAULT '0',
  `l_linktype` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`l_id`),
  KEY `l_id` (`l_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_linktous_config` (
  `config_name` varchar(255) COLLATE utf8_bin NOT NULL,
  `config_value` varchar(255) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`config_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_linktous_config` (`config_name`, `config_value`) VALUES
('path', 'images/links'),
('zippath', 'images/links/zips'),
('respath', 'images/links/res'),
('blktoshowml', '1'),
('blkziportext', '1'),
('blkscrollml', '0'),
('blkscrheightml', '31'),
('blkscrdelayml', '1'),
('blkorderml', '2'),
('blkalphaml', '0'),
('blkactiveres', '1'),
('blktoshowres', '10'),
('blkscrollres', '1'),
('blkscrheightres', '100'),
('blkscrdelayres', '1'),
('blkorderres', '2'),
('blkalphares', '0'),
('modalphaml', '0'),
('modorderbyml', '2'),
('modactiveres', '0'),
('modalphares', '0'),
('modorderbyres', '2');



CREATE TABLE IF NOT EXISTS `nuke_linktous_resources` (
  `r_id` int(11) NOT NULL AUTO_INCREMENT,
  `r_name` varchar(60) COLLATE utf8_bin NOT NULL,
  `r_url` varchar(255) COLLATE utf8_bin NOT NULL,
  `r_image` varchar(255) COLLATE utf8_bin NOT NULL,
  `r_status` int(1) NOT NULL DEFAULT '0',
  `r_size_width` char(3) COLLATE utf8_bin NOT NULL DEFAULT '0',
  `r_size_height` char(3) COLLATE utf8_bin NOT NULL DEFAULT '0',
  `r_hits` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`r_id`),
  KEY `r_id` (`r_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=2 ;


INSERT INTO `nuke_linktous_resources` (`r_id`, `r_name`, `r_url`, `r_image`, `r_status`, `r_size_width`, `r_size_height`, `r_hits`) VALUES
(1, 'Nukelearn Portal', 'http://nukelearn.com/', 'images/links/res/nukelearn_portal.png', 0, '88', '31', 0);



CREATE TABLE IF NOT EXISTS `nuke_main` (
  `main_module` varchar(255) COLLATE utf8_bin NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_main` (`main_module`) VALUES
('News');



CREATE TABLE IF NOT EXISTS `nuke_modules` (
  `mid` int(10) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) COLLATE utf8_bin NOT NULL,
  `custom_title` varchar(255) COLLATE utf8_bin NOT NULL,
  `active` int(1) NOT NULL DEFAULT '0',
  `view` int(1) NOT NULL DEFAULT '0',
  `inmenu` tinyint(1) NOT NULL DEFAULT '1',
  `mod_group` int(10) DEFAULT '0',
  `admins` varchar(255) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`mid`),
  KEY `mid` (`mid`),
  KEY `title` (`title`),
  KEY `custom_title` (`custom_title`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_modules` (`mid`, `title`, `custom_title`, `active`, `view`, `inmenu`, `mod_group`, `admins`) VALUES
(1, 'AvantGo', 'آرشیو ردیفی اخبار', 1, 0, 1, 0, ''),
(4, 'Downloads', 'دریافت فایل', 1, 0, 1, 0, ''),
(7, 'Contact_Plus', 'نظرات و پیشنهادات', 1, 0, 1, 0, ''),
(11, 'News', 'اخبار', 1, 0, 1, 0, ''),
(12, 'Private_Messages', 'پیغام خصوصی', 1, 0, 1, 0, ''),
(13, 'Recommend_Us', 'معرفی به دوستان', 1, 0, 1, 0, ''),
(15, 'Search', 'جستجو', 1, 0, 1, 0, ''),
(17, 'Stories_Archive', 'آرشیو مطالب', 1, 0, 1, 0, ''),
(18, 'Submit_Downloads', 'ارسال فایل', 0, 0, 1, 0, ''),
(19, 'Submit_News', 'ارسال اخبار', 1, 0, 1, 0, ''),
(20, 'Surveys', 'نظرسنجی ها', 1, 0, 1, 0, ''),
(21, 'Top', 'بهترینهای سایت', 1, 0, 1, 0, ''),
(22, 'Topics', 'موضوعات', 1, 0, 1, 0, ''),
(23, 'Web_Links', 'لینکستان', 1, 0, 1, 0, ''),
(26, 'Shout_Box', 'پیامهای سریع', 1, 0, 1, 0, ''),
(27, 'Your_Account', 'صفحه شخصی', 1, 0, 1, 0, ''),
(29, 'mSearch', 'جستجو پیشرفته', 0, 0, 1, 0, ''),
(32, 'Advertising', 'تبلیغات', 1, 0, 1, 0, ''),
(34, 'Link_To_Us', 'لینک به ما', 1, 0, 1, 0, ''),
(35, 'NukeSentinel', 'نگهبان سایت', 1, 0, 1, 0, ''),
(37, 'Site_Map', 'نقشه سايت', 1, 0, 1, 0, ''),
(39, 'phpBB3', 'انجمن های گفتگو', 1, 0, 1, 0, ''),
(42, 'Dynamic_Keywords', 'کلید واژه ها', 0, 0, 1, 0, ''),
(43, 'nukeNAV', 'منوی سایت', 1, 0, 1, 0, ''),
(44, 'jCalendar', 'تقویم جلالی', 1, 0, 1, 0, '');



CREATE TABLE IF NOT EXISTS `nuke_msconfig` (
  `id` varchar(50) COLLATE utf8_bin NOT NULL,
  `value` text COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_msconfig` (`id`, `value`) VALUES
('results-per-page', '5'),
('mSearch-version', '3.0'),
('enable-rss', 'on'),
('use-gsearch', 'on'),
('scope-on-front-page', '');



CREATE TABLE IF NOT EXISTS `nuke_msmodules` (
  `name` text COLLATE utf8_bin NOT NULL,
  `use` text COLLATE utf8_bin NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_nsngd_accesses` (
  `username` varchar(60) COLLATE utf8_bin NOT NULL,
  `downloads` int(11) NOT NULL DEFAULT '0',
  `uploads` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`username`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_nsngd_categories` (
  `cid` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(50) COLLATE utf8_bin NOT NULL,
  `cdescription` text COLLATE utf8_bin NOT NULL,
  `parentid` int(11) NOT NULL DEFAULT '0',
  `whoadd` tinyint(2) NOT NULL DEFAULT '0',
  `uploaddir` varchar(255) COLLATE utf8_bin NOT NULL,
  `canupload` tinyint(2) NOT NULL DEFAULT '0',
  `active` tinyint(2) NOT NULL DEFAULT '1',
  PRIMARY KEY (`cid`),
  KEY `cid` (`cid`),
  KEY `title` (`title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_nsngd_config` (
  `config_name` varchar(255) COLLATE utf8_bin NOT NULL,
  `config_value` text COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`config_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_nsngd_config` (`config_name`, `config_value`) VALUES
('admperpage', '50'),
('blockunregmodify', '0'),
('dateformat', 'D M j G:i:s T Y'),
('mostpopular', '25'),
('mostpopulartrig', '0'),
('perpage', '10'),
('popular', '500'),
('results', '10'),
('show_links_num', '0'),
('usegfxcheck', '0'),
('show_download', '0'),
('version_number', '1.0.3');



CREATE TABLE IF NOT EXISTS `nuke_nsngd_downloads` (
  `lid` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(100) COLLATE utf8_bin NOT NULL,
  `url` varchar(255) COLLATE utf8_bin NOT NULL,
  `description` text COLLATE utf8_bin NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `name` varchar(100) COLLATE utf8_bin NOT NULL,
  `email` varchar(100) COLLATE utf8_bin NOT NULL,
  `hits` int(11) NOT NULL DEFAULT '0',
  `submitter` varchar(60) COLLATE utf8_bin NOT NULL,
  `sub_ip` varchar(16) COLLATE utf8_bin NOT NULL DEFAULT '0.0.0.0',
  `filesize` bigint(20) NOT NULL DEFAULT '0',
  `version` varchar(20) COLLATE utf8_bin NOT NULL,
  `homepage` varchar(255) COLLATE utf8_bin NOT NULL,
  `active` tinyint(2) NOT NULL DEFAULT '1',
  `password` varchar(255) COLLATE utf8_bin NOT NULL,
  `source` varchar(255) COLLATE utf8_bin NOT NULL,
  `tags` varchar(256) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`lid`),
  KEY `lid` (`lid`),
  KEY `cid` (`cid`),
  KEY `sid` (`sid`),
  KEY `title` (`title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_nsngd_extensions` (
  `eid` int(11) NOT NULL AUTO_INCREMENT,
  `ext` varchar(6) COLLATE utf8_bin NOT NULL,
  `file` tinyint(1) NOT NULL DEFAULT '0',
  `image` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`eid`),
  KEY `ext` (`eid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=21 ;


INSERT INTO `nuke_nsngd_extensions` (`eid`, `ext`, `file`, `image`) VALUES
(1, '.ace', 1, 0),
(2, '.arj', 1, 0),
(3, '.bz', 1, 0),
(4, '.bz2', 1, 0),
(5, '.cab', 1, 0),
(6, '.exe', 1, 0),
(7, '.gif', 0, 1),
(8, '.gz', 1, 0),
(9, '.iso', 1, 0),
(10, '.jpeg', 0, 1),
(11, '.jpg', 0, 1),
(12, '.lha', 1, 0),
(13, '.lzh', 1, 0),
(14, '.png', 0, 1),
(15, '.rar', 1, 0),
(16, '.tar', 1, 0),
(17, '.tgz', 1, 0),
(18, '.uue', 1, 0),
(19, '.zip', 1, 0),
(20, '.zoo', 1, 0);



CREATE TABLE IF NOT EXISTS `nuke_nsngd_mods` (
  `rid` int(11) NOT NULL AUTO_INCREMENT,
  `lid` int(11) NOT NULL DEFAULT '0',
  `cid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(100) COLLATE utf8_bin NOT NULL,
  `url` varchar(255) COLLATE utf8_bin NOT NULL,
  `description` text COLLATE utf8_bin NOT NULL,
  `modifier` varchar(60) COLLATE utf8_bin NOT NULL,
  `sub_ip` varchar(16) COLLATE utf8_bin NOT NULL DEFAULT '0.0.0.0',
  `brokendownload` int(3) NOT NULL DEFAULT '0',
  `name` varchar(100) COLLATE utf8_bin NOT NULL,
  `email` varchar(100) COLLATE utf8_bin NOT NULL,
  `filesize` bigint(20) NOT NULL DEFAULT '0',
  `version` varchar(20) COLLATE utf8_bin NOT NULL,
  `homepage` varchar(255) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`rid`),
  UNIQUE KEY `rid` (`rid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_nsngd_new` (
  `lid` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(100) COLLATE utf8_bin NOT NULL,
  `url` varchar(255) COLLATE utf8_bin NOT NULL,
  `description` text COLLATE utf8_bin NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `name` varchar(100) COLLATE utf8_bin NOT NULL,
  `email` varchar(100) COLLATE utf8_bin NOT NULL,
  `submitter` varchar(60) COLLATE utf8_bin NOT NULL,
  `sub_ip` varchar(16) COLLATE utf8_bin NOT NULL DEFAULT '0.0.0.0',
  `filesize` bigint(20) NOT NULL DEFAULT '0',
  `version` varchar(20) COLLATE utf8_bin NOT NULL,
  `homepage` varchar(255) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`lid`),
  KEY `lid` (`lid`),
  KEY `cid` (`cid`),
  KEY `sid` (`sid`),
  KEY `title` (`title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_nsnst_admins` (
  `aid` varchar(25) COLLATE utf8_bin NOT NULL,
  `login` varchar(25) COLLATE utf8_bin NOT NULL,
  `password` varchar(40) COLLATE utf8_bin NOT NULL,
  `password_md5` varchar(60) COLLATE utf8_bin NOT NULL,
  `password_crypt` varchar(60) COLLATE utf8_bin NOT NULL,
  `protected` tinyint(2) NOT NULL DEFAULT '0',
  PRIMARY KEY (`aid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_nsnst_blocked_ips` (
  `ip_addr` varchar(15) COLLATE utf8_bin NOT NULL,
  `ip_long` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id` int(11) NOT NULL DEFAULT '1',
  `username` varchar(60) COLLATE utf8_bin NOT NULL,
  `user_agent` text COLLATE utf8_bin NOT NULL,
  `date` int(20) NOT NULL DEFAULT '0',
  `notes` text COLLATE utf8_bin NOT NULL,
  `reason` tinyint(1) NOT NULL DEFAULT '0',
  `query_string` text COLLATE utf8_bin NOT NULL,
  `get_string` text COLLATE utf8_bin NOT NULL,
  `post_string` text COLLATE utf8_bin NOT NULL,
  `x_forward_for` varchar(32) COLLATE utf8_bin NOT NULL,
  `client_ip` varchar(32) COLLATE utf8_bin NOT NULL,
  `remote_addr` varchar(32) COLLATE utf8_bin NOT NULL,
  `remote_port` varchar(11) COLLATE utf8_bin NOT NULL,
  `request_method` varchar(10) COLLATE utf8_bin NOT NULL,
  `expires` int(20) NOT NULL DEFAULT '0',
  `c2c` char(2) COLLATE utf8_bin NOT NULL DEFAULT '00',
  PRIMARY KEY (`ip_addr`),
  KEY `ip_long` (`ip_long`),
  KEY `c2c` (`c2c`),
  KEY `date` (`date`),
  KEY `expires` (`expires`),
  KEY `reason` (`reason`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_nsnst_blocked_ranges` (
  `ip_lo` int(10) unsigned NOT NULL DEFAULT '0',
  `ip_hi` int(10) unsigned NOT NULL DEFAULT '0',
  `date` int(20) NOT NULL DEFAULT '0',
  `notes` text COLLATE utf8_bin NOT NULL,
  `reason` tinyint(1) NOT NULL DEFAULT '0',
  `expires` int(20) NOT NULL DEFAULT '0',
  `c2c` char(2) COLLATE utf8_bin NOT NULL DEFAULT '00',
  PRIMARY KEY (`ip_lo`,`ip_hi`),
  KEY `c2c` (`c2c`),
  KEY `date` (`date`),
  KEY `expires` (`expires`),
  KEY `reason` (`reason`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_nsnst_blockers` (
  `blocker` int(4) NOT NULL DEFAULT '0',
  `block_name` varchar(20) COLLATE utf8_bin NOT NULL,
  `activate` int(4) NOT NULL DEFAULT '0',
  `block_type` int(4) NOT NULL DEFAULT '0',
  `email_lookup` int(4) NOT NULL DEFAULT '0',
  `forward` varchar(255) COLLATE utf8_bin NOT NULL,
  `reason` varchar(20) COLLATE utf8_bin NOT NULL,
  `template` varchar(255) COLLATE utf8_bin NOT NULL,
  `duration` int(20) NOT NULL DEFAULT '0',
  `htaccess` int(4) NOT NULL DEFAULT '0',
  `list` longtext COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`blocker`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_nsnst_blockers` (`blocker`, `block_name`, `activate`, `block_type`, `email_lookup`, `forward`, `reason`, `template`, `duration`, `htaccess`, `list`) VALUES
(0, 'other', 0, 0, 0, '', 'Abuse-Other', 'abuse_default.tpl', 0, 0, ''),
(1, 'union', 1, 0, 0, '', 'Abuse-Union', 'abuse_union.tpl', 0, 0, ''),
(2, 'clike', 1, 0, 0, '', 'Abuse-CLike', 'abuse_clike.tpl', 0, 0, ''),
(3, 'harvester', 0, 0, 0, '', 'Abuse-Harvest', 'abuse_harvester.tpl', 0, 0, ''),
(4, 'script', 1, 0, 0, '', 'Abuse-Script', 'abuse_script.tpl', 0, 0, ''),
(5, 'author', 1, 0, 0, '', 'Abuse-Author', 'abuse_author.tpl', 0, 0, ''),
(6, 'referer', 0, 0, 0, '', 'Abuse-Referer', 'abuse_referer.tpl', 0, 0, ''),
(7, 'filter', 1, 0, 0, '', 'Abuse-Filter', 'abuse_filter.tpl', 0, 0, ''),
(8, 'request', 0, 0, 0, '', 'Abuse-Request', 'abuse_request.tpl', 0, 0, ''),
(9, 'string', 0, 0, 0, '', 'Abuse-String', 'abuse_string.tpl', 0, 0, ''),
(10, 'admin', 1, 0, 0, '', 'Abuse-Admin', 'abuse_admin.tpl', 0, 0, ''),
(11, 'flood', 0, 0, 0, '', 'Abuse-Flood', 'abuse_flood.tpl', 0, 0, '');



CREATE TABLE IF NOT EXISTS `nuke_nsnst_cidrs` (
  `cidr` int(2) NOT NULL DEFAULT '0',
  `hosts` int(10) NOT NULL DEFAULT '0',
  `mask` varchar(15) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`cidr`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_nsnst_cidrs` (`cidr`, `hosts`, `mask`) VALUES
(1, 2147483647, '127.255.255.255'),
(2, 1073741824, '63.255.255.255'),
(3, 536870912, '31.255.255.255'),
(4, 268435456, '15.255.255.255'),
(5, 134217728, '7.255.255.255'),
(6, 67108864, '3.255.255.255'),
(7, 33554432, '1.255.255.255'),
(8, 16777216, '0.255.255.255'),
(9, 8388608, '0.127.255.255'),
(10, 4194304, '0.63.255.255'),
(11, 2097152, '0.31.255.255'),
(12, 1048576, '0.15.255.255'),
(13, 524288, '0.7.255.255'),
(14, 262144, '0.3.255.255'),
(15, 131072, '0.1.255.255'),
(16, 65536, '0.0.255.255'),
(17, 32768, '0.0.127.255'),
(18, 16384, '0.0.63.255'),
(19, 8192, '0.0.31.255'),
(20, 4096, '0.0.15.255'),
(21, 2048, '0.0.7.255'),
(22, 1024, '0.0.3.255'),
(23, 512, '0.0.1.255'),
(24, 256, '0.0.0.255'),
(25, 128, '0.0.0.127'),
(26, 64, '0.0.0.63'),
(27, 32, '0.0.0.31'),
(28, 16, '0.0.0.15'),
(29, 8, '0.0.0.7'),
(30, 4, '0.0.0.3'),
(31, 2, '0.0.0.1'),
(32, 1, '0.0.0.0');



CREATE TABLE IF NOT EXISTS `nuke_nsnst_config` (
  `config_name` varchar(255) COLLATE utf8_bin NOT NULL,
  `config_value` longtext COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`config_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_nsnst_config` (`config_name`, `config_value`) VALUES
('admin_contact', 'webmaster@yoursite.com'),
('block_perpage', '50'),
('block_sort_column', 'date'),
('block_sort_direction', 'desc'),
('crypt_salt', 'N$'),
('disable_switch', '0'),
('display_link', '3'),
('display_reason', '3'),
('dump_directory', 'cache/'),
('flood_delay', '2'),
('force_nukeurl', '0'),
('ftaccess_path', ''),
('help_switch', '1'),
('htaccess_path', ''),
('http_auth', '0'),
('ip2c_version', '0'),
('list_harvester', '@yahoo.com\r\nalexibot\r\nalligator\r\nanonymiz\r\nasterias\r\nbackdoorbot\r\nblack hole\r\nblackwidow\r\nblowfish\r\nbotalot\r\nbuiltbottough\r\nbullseye\r\nbunnyslippers\r\ncatch\r\ncegbfeieh\r\ncharon\r\ncheesebot\r\ncherrypicker\r\nchinaclaw\r\ncombine\r\ncopyrightcheck\r\ncosmos\r\ncrescent\r\ncurl\r\ndbrowse\r\ndisco\r\ndittospyder\r\ndlman\r\ndnloadmage\r\ndownload\r\ndreampassport\r\ndts agent\r\necatch\r\neirgrabber\r\nerocrawler\r\nexpress webpictures\r\nextractorpro\r\neyenetie\r\nfantombrowser\r\nfantomcrew browser\r\nfileheap\r\nfilehound\r\nflashget\r\nfoobot\r\nfranklin locator\r\nfreshdownload\r\nfscrawler\r\ngamespy_arcade\r\ngetbot\r\ngetright\r\ngetweb\r\ngo!zilla\r\ngo-ahead-got-it\r\ngrab\r\ngrafula\r\ngsa-crawler\r\nharvest\r\nhloader\r\nhmview\r\nhttplib\r\nhttpresume\r\nhttrack\r\nhumanlinks\r\nigetter\r\nimage stripper\r\nimage sucker\r\nindustry program\r\nindy library\r\ninfonavirobot\r\ninstallshield digitalwizard\r\ninterget\r\niria\r\nirvine\r\niupui research bot\r\njbh agent\r\njennybot\r\njetcar\r\njobo\r\njoc\r\nkapere\r\nkenjin spider\r\nkeyword density\r\nlarbin\r\nleechftp\r\nleechget\r\nlexibot\r\nlibweb/clshttp\r\nlibwww-perl\r\nlightningdownload\r\nlincoln state web browser\r\nlinkextractorpro\r\nlinkscan/8.1a.unix\r\nlinkwalker\r\nlwp-trivial\r\nlwp::simple\r\nmac finder\r\nmata hari\r\nmediasearch\r\nmetaproducts\r\nmicrosoft url control\r\nmidown tool\r\nmiixpc\r\nmissauga locate\r\nmissouri college browse\r\nmister pix\r\nmoget\r\nmozilla.*newt\r\nmozilla/3.0 (compatible)\r\nmozilla/3.mozilla/2.01\r\nmsie 4.0 (win95)\r\nmultiblocker browser\r\nmydaemon\r\nmygetright\r\nnabot\r\nnavroad\r\nnearsite\r\nnet vampire\r\nnetants\r\nnetmechanic\r\nnetpumper\r\nnetspider\r\nnewsearchengine\r\nnicerspro\r\nninja\r\nnitro downloader\r\nnpbot\r\noctopus\r\noffline explorer\r\noffline navigator\r\nopenfind\r\npagegrabber\r\npapa foto\r\npavuk\r\npbrowse\r\npcbrowser\r\npeval\r\npompos/\r\nprogram shareware\r\npropowerbot\r\nprowebwalker\r\npsurf\r\npuf\r\npuxarapido\r\nqueryn metasearch\r\nrealdownload\r\nreget\r\nrepomonkey\r\nrsurf\r\nrumours-agent\r\nsakura\r\nscan4mail\r\nsemanticdiscovery\r\nsitesnagger\r\nslysearch\r\nspankbot\r\nspanner \r\nspiderzilla\r\nsq webscanner\r\nstamina\r\nstar downloader\r\nsteeler\r\n\r\nstrip\r\nsuperbot\r\nsuperhttp\r\nsurfbot\r\nsuzuran\r\nswbot\r\nszukacz\r\ntakeout\r\nteleport\r\ntelesoft\r\ntest spider\r\nthe intraformant\r\nthenomad\r\ntighttwatbot\r\ntitan\r\ntocrawl/urldispatcher\r\ntrue_robot\r\ntsurf\r\nturing machine\r\nturingos\r\nurlblaze\r\nurlgetfile\r\nurly warning\r\nutilmind\r\nvci\r\nvoideye\r\nweb image collector\r\nweb sucker\r\nwebauto\r\nwebbandit\r\nwebcapture\r\nwebcollage\r\nwebcopier\r\nwebenhancer\r\nwebfetch\r\nwebgo\r\nwebleacher\r\nwebmasterworldforumbot\r\nwebql\r\nwebreaper\r\nwebsite extractor\r\nwebsite quester\r\nwebster\r\nwebstripper\r\nwebwhacker\r\nwep search\r\nwget\r\nwhizbang\r\nwidow\r\nwildsoft surfer\r\nwww-collector-e\r\nwww.netwu.com\r\nwwwoffle\r\nxaldon\r\nxenu\r\nzeus\r\nziggy\r\nzippy'),
('list_referer', '121hr.com\r\n1st-call.net\r\n1stcool.com\r\n5000n.com\r\n69-xxx.com\r\n9irl.com\r\n9uy.com\r\na-day-at-the-party.com\r\naccessthepeace.com\r\nadult-model-nude-pictures.com\r\nadult-sex-toys-free-porn.com\r\nagnitum.com\r\nalfonssackpfeiffe.com\r\nalongwayfrommars.com\r\nanime-sex-1.com\r\nanorex-sf-stimulant-free.com\r\nantibot.net\r\nantique-tokiwa.com\r\napotheke-heute.com\r\narmada31.com\r\nartark.com\r\nartlilei.com\r\nascendbtg.com\r\naschalaecheck.com\r\nasian-sex-free-sex.com\r\naslowspeeker.com\r\nassasinatedfrogs.com\r\nathirst-for-tranquillity.net\r\naubonpanier.com\r\navalonumc.com\r\nayingba.com\r\nbayofnoreturn.com\r\nbbw4phonesex.com\r\nbeersarenotfree.com\r\nbierikiuetsch.com\r\nbilingualannouncements.com\r\nblack-pussy-toon-clip-anal-lover-single.com\r\nblownapart.com\r\nblueroutes.com\r\nboasex.com\r\nbooksandpages.com\r\nbootyquake.com\r\nbossyhunter.com\r\nboyz-sex.com\r\nbrokersaandpokers.com\r\nbrowserwindowcleaner.com\r\nbudobytes.com\r\nbusiness2fun.com\r\nbuymyshitz.com\r\nbyuntaesex.com\r\ncaniputsomeloveintoyou.com\r\ncartoons.net.ru\r\ncaverunsailing.com\r\ncertainhealth.com\r\nclantea.com\r\nclose-protection-services.com\r\nclubcanino.com\r\nclubstic.com\r\ncobrakai-skf.com\r\ncollegefucktour.co.uk\r\ncommanderspank.com\r\ncoolenabled.com\r\ncrusecountryart.com\r\ncrusingforsex.co.uk\r\ncunt-twat-pussy-juice-clit-licking.com\r\ncustomerhandshaker.com\r\ncyborgrama.com\r\ndarkprofits.co.uk\r\ndatingforme.co.uk\r\ndatingmind.com\r\ndegree.org.ru\r\ndelorentos.com\r\ndiggydigger.com\r\ndinkydonkyaussie.com\r\ndjpritchard.com\r\ndjtop.com\r\ndraufgeschissen.com\r\ndreamerteens.co.uk\r\nebonyarchives.co.uk\r\nebonyplaya.co.uk\r\necobuilder2000.com\r\nemailandemail.com\r\nemedici.net\r\nengine-on-fire.com\r\nerocity.co.uk\r\nesport3.com\r\neteenbabes.com\r\neurofreepages.com\r\neurotexans.com\r\nevolucionweb.com\r\nfakoli.com\r\nfe4ba.com\r\nferienschweden.com\r\nfindly.com\r\nfirsttimeteadrinker.com\r\nfishing.net.ru\r\nflatwonkers.com\r\nflowershopentertainment.com\r\nflymario.com\r\nfree-xxx-pictures-porno-gallery.com\r\nfreebestporn.com\r\nfreefuckingmovies.co.uk\r\nfreexxxstuff.co.uk\r\nfruitologist.net\r\nfruitsandbolts.com\r\nfuck-cumshots-free-midget-movie-clips.com\r\nfuck-michaelmoore.com\r\nfundacep.com\r\ngadless.com\r\ngallapagosrangers.com\r\ngalleries4free.co.uk\r\ngalofu.com\r\ngaypixpost.co.uk\r\ngeomasti.com\r\ngirltime.co.uk\r\nglassrope.com\r\ngodjustblessyouall.com\r\ngoldenageresort.com\r\ngonnabedaddies.com\r\ngranadasexi.com\r\n\r\nguardingtheangels.com\r\nguyprofiles.co.uk\r\nhappy1225.com\r\nhappychappywacky.com\r\nhealth.org.ru\r\nhexplas.com\r\nhighheelsmodels4fun.com\r\nhillsweb.com\r\nhiptuner.com\r\nhistoryintospace.com\r\nhoa-tuoi.com\r\nhomebuyinginatlanta.com\r\nhorizonultra.com\r\nhorseminiature.net\r\nhotkiss.co.uk\r\nhotlivegirls.co.uk\r\nhotmatchup.co.uk\r\nhusler.co.uk\r\niaentertainment.com\r\niamnotsomeone.com\r\niconsofcorruption.com\r\nihavenotrustinyou.com\r\ninformat-systems.com\r\ninteriorproshop.com\r\nintersoftnetworks.com\r\ninthecrib.com\r\ninvestment4cashiers.com\r\niti-trailers.com\r\njackpot-hacker.com\r\njacks-world.com\r\njamesthesailorbasher.com\r\njesuislemonds.com\r\njustanotherdomainname.com\r\nkampelicka.com\r\nkanalrattenarsch.com\r\nkatzasher.com\r\nkerosinjunkie.com\r\nkillasvideo.com\r\nkoenigspisser.com\r\nkontorpara.com\r\nl8t.com\r\nlaestacion101.com\r\nlambuschlamppen.com\r\nlankasex.co.uk\r\nlaser-creations.com\r\nle-tour-du-monde.com\r\nlecraft.com\r\nledo-design.com\r\nleftregistration.com\r\nlekkikoomastas.com\r\nlepommeau.com\r\nlibr-animal.com\r\nlibraries.org.ru\r\nlikewaterlikewind.com\r\nlimbojumpers.com\r\nlink.ru\r\nlockportlinks.com\r\nloiproject.com\r\nlongtermalternatives.com\r\nlottoeco.com\r\nlucalozzi.com\r\nmaki-e-pens.com\r\nmalepayperview.co.uk\r\nmangaxoxo.com\r\nmaps.org.ru\r\nmarcofields.com\r\nmasterofcheese.com\r\nmasteroftheblasterhill.com\r\nmastheadwankers.com\r\nmegafrontier.com\r\nmeinschuppen.com\r\nmercurybar.com\r\nmetapannas.com\r\nmicelebre.com\r\nmidnightlaundries.com\r\nmikeapartment.co.uk\r\nmillenniumchorus.com\r\nmimundial2002.com\r\nminiaturegallerymm.com\r\nmixtaperadio.com\r\nmondialcoral.com\r\nmonja-wakamatsu.com\r\nmonstermonkey.net\r\nmouthfreshners.com\r\nmullensholiday.com\r\nmusilo.com\r\nmyhollowlog.com\r\nmyhomephonenumber.com\r\nmykeyboardisbroken.com\r\nmysofia.net\r\nnaked-cheaters.com\r\nnaked-old-women.com\r\nnastygirls.co.uk\r\nnationclan.net\r\nnatterratter.com\r\nnaughtyadam.com\r\nnestbeschmutzer.com\r\nnetwu.com\r\nnewrealeaseonline.com\r\nnewrealeasesonline.com\r\nnextfrontiersonline.com\r\nnikostaxi.com\r\nnotorious7.com\r\nnrecruiter.com\r\nnursingdepot.com\r\nnustramosse.com\r\nnuturalhicks.com\r\noccaz-auto49.com\r\nocean-db.net\r\noilburnerservice.net\r\nomburo.com\r\noneoz.com\r\nonepageahead.net\r\nonlinewithaline.com\r\norganizate.net\r\nourownweddingsong.com\r\nowen-music.com\r\np-partners.com\r\npaginadeautor.com\r\npakistandutyfree.com\r\npamanderson.co.uk\r\nparentsense.net\r\nparticlewave.net\r\npay-clic.com\r\npay4link.net\r\npcisp.com\r\npersist-pharma.com\r\npeteband.com\r\npetplusindia.com\r\npickabbw.co.uk\r\npicture-oral-position-lesbian.com\r\npl8again.com\r\nplaneting.net\r\npopusky.com\r\nporn-expert.com\r\npromoblitza.com\r\nproproducts-usa.com\r\nptcgzone.com\r\nptporn.com\r\npublishmybong.com\r\nputtingtogether.com\r\nqualifiedcancelations.com\r\nrahost.com\r\nrainbow21.com\r\nrakkashakka.com\r\nrandomfeeding.com\r\nrape-art.com\r\nrd-brains.com\r\nrealestateonthehill.net\r\nrebuscadobot\r\nrequested-stuff.com\r\nretrotrasher.com\r\nricopositive.com\r\nrisorseinrete.com\r\nrotatingcunts.com\r\nrunawayclicks.com\r\nrutalibre.com\r\ns-marche.com\r\nsabrosojazz.com\r\nsamuraidojo.com\r\nsanaldarbe.com\r\nsasseminars.com\r\nschlampenbruzzler.com\r\nsearchmybong.com\r\nseckur.com\r\nsex-asian-porn-interracial-photo.com\r\nsex-porn-fuck-hardcore-movie.com\r\nsexa3.net\r\nsexer.com\r\nsexintention.com\r\nsexnet24.tv\r\nsexomundo.com\r\nsharks.com.ru\r\nshells.com.ru\r\nshop-ecosafe.com\r\nshop-toon-hardcore-fuck-cum-pics.com\r\nsilverfussions.com\r\nsin-city-sex.net\r\nsluisvan.com\r\nsmutshots.com\r\nsnagglersmaggler.com\r\nsomethingtoforgetit.com\r\nsophiesplace.net\r\nsoursushi.com\r\nsouthernxstables.com\r\nspeed467.com\r\nspeedpal4you.com\r\nsporty.org.ru\r\nstopdriving.net\r\nstw.org.ru\r\nsufficientlife.com\r\nsussexboats.net\r\nswinger-party-free-dating-porn-sluts.com\r\nsydneyhay.com\r\nszmjht.com\r\nteninchtrout.com\r\nthebalancedfruits.com\r\ntheendofthesummit.com\r\nthiswillbeit.com\r\nthosethosethose.com\r\nticyclesofindia.com\r\ntits-gay-fagot-black-tits-bigtits-amateur.com\r\ntonius.com\r\ntoohsoft.com\r\ntoolvalley.com\r\ntooporno.net\r\ntoosexual.com\r\ntorngat.com\r\ntour.org.ru\r\ntowneluxury.com\r\ntrafficmogger.com\r\ntriacoach.net\r\ntrottinbob.com\r\ntttframes.com\r\ntvjukebox.net\r\nundercvr.com\r\nunfinished-desires.com\r\nunicornonero.com\r\nunionvillefire.com\r\nupsandowns.com\r\nupthehillanddown.com\r\nvallartavideo.com\r\nvietnamdatingservices.com\r\nvinegarlemonshots.com\r\nvizy.net.ru\r\nvnladiesdatingservices.com\r\nvomitandbusted.com\r\nwalkingthewalking.com\r\nwell-I-am-the-type-of-boy.com\r\nwhales.com.ru\r\nwhincer.net\r\nwhitpagesrippers.com\r\nwhois.sc\r\nwipperrippers.com\r\nwordfilebooklets.com\r\nworld-sexs.com\r\nxsay.com\r\nxxxchyangel.com\r\nxxxx:\r\nxxxzips.com\r\nyouarelostintransit.com\r\nyuppieslovestocks.com\r\nyuzhouhuagong.com\r\nzhaori-food.com\r\nzwiebelbacke.com'),
('list_string', ''),
('lookup_link', 'http://www.DNSstuff.com/tools/whois.ch?ip='),
('page_delay', '5'),
('prevent_dos', '0'),
('proxy_reason', 'admin_proxy_reason.tpl'),
('proxy_switch', '0'),
('santy_protection', '1'),
('self_expire', '0'),
('show_right', '0'),
('site_reason', 'admin_site_reason.tpl'),
('site_switch', '0'),
('staccess_path', ''),
('test_switch', '0'),
('track_active', '0'),
('track_clear', '0'),
('track_max', '604800'),
('track_perpage', '50'),
('track_sort_column', '6'),
('track_sort_direction', 'desc'),
('version_check', '1191745602'),
('version_newest', '2.5.16'),
('version_number', '2.6.01');



CREATE TABLE IF NOT EXISTS `nuke_nsnst_countries` (
  `c2c` char(2) COLLATE utf8_bin NOT NULL,
  `country` varchar(60) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`c2c`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_nsnst_countries` (`c2c`, `country`) VALUES
('00', 'Unknown'),
('01', 'IANA Reserved'),
('02', 'UnAllocated'),
('ac', 'Ascension Island'),
('ad', 'Andorra'),
('ae', 'United Arab Emirates'),
('af', 'Afghanistan'),
('ag', 'Antigua And Barbuda'),
('ai', 'Anguilla'),
('al', 'Albania'),
('am', 'Armenia'),
('an', 'Netherlands Antilles'),
('ao', 'Angola'),
('ap', 'Aripo'),
('aq', 'Antartica'),
('ar', 'Argentina'),
('as', 'Samoa, American'),
('at', 'Austria'),
('au', 'Australia'),
('aw', 'Aruba'),
('az', 'Azerbaijan'),
('ba', 'Bosnia And Herzegovina'),
('bb', 'Barbados'),
('bd', 'Bangladesh'),
('be', 'Belgium'),
('bf', 'Burkina Faso'),
('bg', 'Bulgaria'),
('bh', 'Bahrain'),
('bi', 'Burundi'),
('bj', 'Benin'),
('bm', 'Bermuda'),
('bn', 'Brunei Darussalam'),
('bo', 'Bolivia'),
('br', 'Brazil'),
('bs', 'Bahamas'),
('bt', 'Bhutan'),
('bv', 'Bouvet Island'),
('bw', 'Botswana'),
('by', 'Belarus'),
('bz', 'Belize'),
('ca', 'Canada'),
('cc', 'Cocos Islands'),
('cd', 'Congo, Democratic Republic Of The'),
('cf', 'Central African Republic'),
('cg', 'Congo, People''s Republic Of The'),
('ch', 'Switzerland'),
('ci', 'Cote D''ivoire'),
('ck', 'Cook Islands'),
('cl', 'Chile'),
('cm', 'Cameroon'),
('cn', 'China'),
('co', 'Colombia'),
('cr', 'Costa Rica'),
('cs', 'Czechoslovakia (Former)'),
('cu', 'Cuba'),
('cv', 'Cape Verde'),
('cx', 'Christmas Island'),
('cy', 'Cyprus'),
('cz', 'Czech Republic'),
('de', 'Germany'),
('dj', 'Djibouti'),
('dk', 'Denmark'),
('dm', 'Dominica'),
('do', 'Dominican Republic'),
('dz', 'Algeria'),
('ec', 'Ecuador'),
('ee', 'Estonia'),
('eg', 'Egypt'),
('eh', 'Western Sahara'),
('er', 'Eritrea'),
('es', 'Spain'),
('et', 'Ethiopia'),
('eu', 'European Union'),
('fi', 'Finland'),
('fj', 'Fiji'),
('fk', 'Falkland Islands'),
('fm', 'Micronesia'),
('fo', 'Faroe Islands'),
('fr', 'France'),
('fx', 'France, Metropolitan'),
('ga', 'Gabon'),
('gb', 'United Kingdom'),
('gd', 'Grenada'),
('ge', 'Georgia'),
('gf', 'French Guiana'),
('gg', 'Guernsey'),
('gh', 'Ghana'),
('gi', 'Gibraltar'),
('gl', 'Greenland'),
('gm', 'Gambia'),
('gn', 'Guinea'),
('gp', 'Guadeloupe'),
('gq', 'Equatorial Guinea'),
('gr', 'Greece'),
('gs', 'South Georgia and The South Sandwich Islands'),
('gt', 'Guatemala'),
('gu', 'Guam'),
('gw', 'Guinea-Bissau'),
('gy', 'Guyana'),
('hk', 'Hong Kong'),
('hm', 'Heard and Mc Donald Islands'),
('hn', 'Honduras'),
('hr', 'Croatia'),
('ht', 'Haiti'),
('hu', 'Hungary'),
('id', 'Indonesia'),
('ie', 'Ireland'),
('il', 'Israel'),
('im', 'Isle Of Man'),
('in', 'India'),
('io', 'British Indian Ocean Territory'),
('iq', 'Iraq'),
('ir', 'Iran'),
('is', 'Iceland'),
('it', 'Italy'),
('je', 'Jersey'),
('jm', 'Jamaica'),
('jo', 'Jordan'),
('jp', 'Japan'),
('ke', 'Kenya'),
('kg', 'Kyrgyzstan'),
('kh', 'Cambodia'),
('ki', 'Kiribati'),
('km', 'Comoros'),
('kn', 'Saint Kitts And Nevis'),
('kp', 'Korea, North'),
('kr', 'Korea, South'),
('kw', 'Kuwait'),
('ky', 'Cayman Islands'),
('kz', 'Kazakhstan'),
('la', 'Laos'),
('lb', 'Lebanon'),
('lc', 'Saint Lucia'),
('li', 'Liechtenstein'),
('lk', 'Sri Lanka'),
('lr', 'Liberia'),
('ls', 'Lesotho'),
('lt', 'Lithuania'),
('lu', 'Luxembourg'),
('lv', 'Latvia'),
('ly', 'Libya'),
('ma', 'Morocco'),
('mc', 'Monaco'),
('md', 'Moldova'),
('me', 'Montenegro'),
('mg', 'Madagascar'),
('mh', 'Marshall Islands'),
('mk', 'Macedonia'),
('ml', 'Mali'),
('mm', 'Myanmar'),
('mn', 'Mongolia'),
('mo', 'Macau'),
('mp', 'Northern Mariana Islands'),
('mq', 'Martinique'),
('mr', 'Mauritania'),
('ms', 'Montserrat'),
('mt', 'Malta'),
('mu', 'Mauritius'),
('mv', 'Maldives'),
('mw', 'Malawi'),
('mx', 'Mexico'),
('my', 'Malaysia'),
('mz', 'Mozambique'),
('na', 'Namibia'),
('nc', 'New Caledonia'),
('ne', 'Niger'),
('nf', 'Norfork Island'),
('ng', 'Nigeria'),
('ni', 'Nicaragua'),
('nl', 'Netherlands'),
('no', 'Norway'),
('np', 'Nepal'),
('nr', 'Nauru'),
('nu', 'Niue'),
('nz', 'New Zealand'),
('om', 'Oman'),
('pa', 'Panama'),
('pe', 'Peru'),
('pf', 'French Polynesia'),
('pg', 'Papua New Guinea'),
('ph', 'Philippines'),
('pk', 'Pakistan'),
('pl', 'Poland'),
('pm', 'Saint Pierre and Miquelon'),
('pn', 'Pitcairn'),
('pr', 'Puerto Rico'),
('ps', 'Palestine'),
('pt', 'Portugal'),
('pw', 'Palau'),
('py', 'Paraguay'),
('qa', 'Qatar'),
('re', 'Reunion'),
('ro', 'Romania'),
('rs', 'Serbia'),
('ru', 'Russia'),
('rw', 'Rwanda'),
('sa', 'Saudi Arabia'),
('sb', 'Solomon Islands'),
('sc', 'Seychelles'),
('sd', 'Sudan'),
('se', 'Sweden'),
('sg', 'Singapore'),
('sh', 'Saint Helena'),
('si', 'Slovenia'),
('sj', 'Svalbard and Jan Mayen Islands'),
('sk', 'Slovakia'),
('sl', 'Sierra Leone'),
('sm', 'San Marino'),
('sn', 'Senegal'),
('so', 'Somalia'),
('sr', 'Suriname'),
('st', 'Sao Tome And Principe'),
('su', 'Soviet Union'),
('sv', 'El Salvador'),
('sy', 'Syria'),
('sz', 'Swaziland'),
('tc', 'Turks And Caicos Islands'),
('td', 'Chad'),
('tf', 'French Southern Territories'),
('tg', 'Togo'),
('th', 'Thailand'),
('tj', 'Tajikistan'),
('tk', 'Tokelau'),
('tl', 'Timor-leste'),
('tm', 'Turkmenistan'),
('tn', 'Tunisia'),
('to', 'Tonga'),
('tp', 'East Timor'),
('tr', 'Turkey'),
('tt', 'Trinidad And Tobago'),
('tv', 'Tuvalu'),
('tw', 'Taiwan'),
('tz', 'Tanzania'),
('ua', 'Ukraine'),
('ug', 'Uganda'),
('um', 'United States Minor Outlying Islands'),
('un', 'United Nations'),
('us', 'United States'),
('uy', 'Uruguay'),
('uz', 'Uzbekistan'),
('va', 'Vatican City State'),
('vc', 'Saint Vincent And The Grenadines'),
('ve', 'Venezuela'),
('vg', 'Virgin Islands, British'),
('vi', 'Virgin Islands, American'),
('vn', 'Viet Nam'),
('vu', 'Vanuatu'),
('wf', 'Wallis and Futuna Islands'),
('ws', 'Samoa'),
('ye', 'Yemen'),
('yt', 'Mayotte'),
('yu', 'Yugoslavia'),
('za', 'South Africa'),
('zm', 'Zambia'),
('zw', 'Zimbabwe');



CREATE TABLE IF NOT EXISTS `nuke_nsnst_excluded_ranges` (
  `ip_lo` int(10) unsigned NOT NULL DEFAULT '0',
  `ip_hi` int(10) unsigned NOT NULL DEFAULT '0',
  `date` int(20) NOT NULL DEFAULT '0',
  `notes` text COLLATE utf8_bin NOT NULL,
  `c2c` char(2) COLLATE utf8_bin NOT NULL DEFAULT '00',
  PRIMARY KEY (`ip_lo`,`ip_hi`),
  KEY `c2c` (`c2c`),
  KEY `date` (`date`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_nsnst_excluded_ranges` (`ip_lo`, `ip_hi`, `date`, `notes`, `c2c`) VALUES
(2130706433, 2130706433, 1187087957, 'Admin''s personal ip', '00');



CREATE TABLE IF NOT EXISTS `nuke_nsnst_harvesters` (
  `hid` int(2) NOT NULL AUTO_INCREMENT,
  `harvester` varchar(255) COLLATE utf8_persian_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`harvester`),
  KEY `hid` (`hid`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_persian_ci AUTO_INCREMENT=220 ;


INSERT INTO `nuke_nsnst_harvesters` (`hid`, `harvester`) VALUES
(1, '@yahoo.com'),
(2, 'alexibot'),
(3, 'alligator'),
(4, 'anonymiz'),
(5, 'asterias'),
(6, 'backdoorbot'),
(7, 'black hole'),
(8, 'blackwidow'),
(9, 'blowfish'),
(10, 'botalot'),
(11, 'builtbottough'),
(12, 'bullseye'),
(13, 'bunnyslippers'),
(14, 'catch'),
(15, 'cegbfeieh'),
(16, 'charon'),
(17, 'cheesebot'),
(18, 'cherrypicker'),
(19, 'chinaclaw'),
(20, 'combine'),
(21, 'copyrightcheck'),
(22, 'cosmos'),
(23, 'crescent'),
(24, 'curl'),
(25, 'dbrowse'),
(26, 'disco'),
(27, 'dittospyder'),
(28, 'dlman'),
(29, 'dnloadmage'),
(30, 'download'),
(31, 'dreampassport'),
(32, 'dts agent'),
(33, 'ecatch'),
(34, 'eirgrabber'),
(35, 'erocrawler'),
(36, 'express webpictures'),
(37, 'extractorpro'),
(38, 'eyenetie'),
(39, 'fantombrowser'),
(40, 'fantomcrew browser'),
(41, 'fileheap'),
(42, 'filehound'),
(43, 'flashget'),
(44, 'foobot'),
(45, 'franklin locator'),
(46, 'freshdownload'),
(47, 'fscrawler'),
(48, 'gamespy_arcade'),
(49, 'getbot'),
(50, 'getright'),
(51, 'getweb'),
(52, 'go!zilla'),
(53, 'go-ahead-got-it'),
(54, 'grab'),
(55, 'grafula'),
(56, 'gsa-crawler'),
(57, 'harvest'),
(58, 'hloader'),
(59, 'hmview'),
(60, 'httplib'),
(61, 'httpresume'),
(62, 'httrack'),
(63, 'humanlinks'),
(64, 'igetter'),
(65, 'image stripper'),
(66, 'image sucker'),
(67, 'industry program'),
(68, 'indy library'),
(69, 'infonavirobot'),
(70, 'installshield digitalwizard'),
(71, 'interget'),
(72, 'iria'),
(73, 'irvine'),
(74, 'iupui research bot'),
(75, 'jbh agent'),
(76, 'jennybot'),
(77, 'jetcar'),
(78, 'jobo'),
(79, 'joc'),
(80, 'kapere'),
(81, 'kenjin spider'),
(82, 'keyword density'),
(83, 'larbin'),
(84, 'leechftp'),
(85, 'leechget'),
(86, 'lexibot'),
(87, 'libweb/clshttp'),
(88, 'libwww-perl'),
(89, 'lightningdownload'),
(90, 'lincoln state web browser'),
(91, 'linkextractorpro'),
(92, 'linkscan/8.1a.unix'),
(93, 'linkwalker'),
(94, 'lwp-trivial'),
(95, 'lwp::simple'),
(96, 'mac finder'),
(97, 'mata hari'),
(98, 'mediasearch'),
(99, 'metaproducts'),
(100, 'microsoft url control'),
(101, 'midown tool'),
(102, 'miixpc'),
(103, 'missauga locate'),
(104, 'missouri college browse'),
(105, 'mister pix'),
(106, 'moget'),
(107, 'mozilla.*newt'),
(108, 'mozilla/3.0 (compatible)'),
(109, 'mozilla/3.mozilla/2.01'),
(110, 'msie 4.0 (win95)'),
(111, 'multiblocker browser'),
(112, 'mydaemon'),
(113, 'mygetright'),
(114, 'nabot'),
(115, 'navroad'),
(116, 'nearsite'),
(117, 'net vampire'),
(118, 'netants'),
(119, 'netmechanic'),
(120, 'netpumper'),
(121, 'netspider'),
(122, 'newsearchengine'),
(123, 'nicerspro'),
(124, 'ninja'),
(125, 'nitro downloader'),
(126, 'npbot'),
(127, 'octopus'),
(128, 'offline explorer'),
(129, 'offline navigator'),
(130, 'openfind'),
(131, 'pagegrabber'),
(132, 'papa foto'),
(133, 'pavuk'),
(134, 'pbrowse'),
(135, 'pcbrowser'),
(136, 'peval'),
(137, 'pompos/'),
(138, 'program shareware'),
(139, 'propowerbot'),
(140, 'prowebwalker'),
(141, 'psurf'),
(142, 'puf'),
(143, 'puxarapido'),
(144, 'queryn metasearch'),
(145, 'realdownload'),
(146, 'reget'),
(147, 'repomonkey'),
(148, 'rsurf'),
(149, 'rumours-agent'),
(150, 'sakura'),
(151, 'scan4mail'),
(152, 'semanticdiscovery'),
(153, 'sitesnagger'),
(154, 'slysearch'),
(155, 'spankbot'),
(156, 'spanner '),
(157, 'spiderzilla'),
(158, 'sq webscanner'),
(159, 'stamina'),
(160, 'star downloader'),
(161, 'steeler'),
(162, 'strip'),
(163, 'superbot'),
(164, 'superhttp'),
(165, 'surfbot'),
(166, 'suzuran'),
(167, 'swbot'),
(168, 'szukacz'),
(169, 'takeout'),
(170, 'teleport'),
(171, 'telesoft'),
(172, 'test spider'),
(173, 'the intraformant'),
(174, 'thenomad'),
(175, 'tighttwatbot'),
(176, 'titan'),
(177, 'tocrawl/urldispatcher'),
(178, 'true_robot'),
(179, 'tsurf'),
(180, 'turing machine'),
(181, 'turingos'),
(182, 'urlblaze'),
(183, 'urlgetfile'),
(184, 'urly warning'),
(185, 'utilmind'),
(186, 'vci'),
(187, 'voideye'),
(188, 'web image collector'),
(189, 'web sucker'),
(190, 'webauto'),
(191, 'webbandit'),
(192, 'webcapture'),
(193, 'webcollage'),
(194, 'webcopier'),
(195, 'webenhancer'),
(196, 'webfetch'),
(197, 'webgo'),
(198, 'webleacher'),
(199, 'webmasterworldforumbot'),
(200, 'webql'),
(201, 'webreaper'),
(202, 'website extractor'),
(203, 'website quester'),
(204, 'webster'),
(205, 'webstripper'),
(206, 'webwhacker'),
(207, 'wep search'),
(208, 'wget'),
(209, 'whizbang'),
(210, 'widow'),
(211, 'wildsoft surfer'),
(212, 'www-collector-e'),
(213, 'www.netwu.com'),
(214, 'wwwoffle'),
(215, 'xaldon'),
(216, 'xenu'),
(217, 'zeus'),
(218, 'ziggy'),
(219, 'zippy');



CREATE TABLE IF NOT EXISTS `nuke_nsnst_ip2country` (
  `ip_lo` int(10) unsigned NOT NULL DEFAULT '0',
  `ip_hi` int(10) unsigned NOT NULL DEFAULT '0',
  `date` int(20) NOT NULL DEFAULT '0',
  `c2c` char(2) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`ip_lo`,`ip_hi`),
  KEY `c2c` (`c2c`),
  KEY `date` (`date`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_nsnst_protected_ranges` (
  `ip_lo` int(10) unsigned NOT NULL DEFAULT '0',
  `ip_hi` int(10) unsigned NOT NULL DEFAULT '0',
  `date` int(20) NOT NULL DEFAULT '0',
  `notes` text COLLATE utf8_bin NOT NULL,
  `c2c` char(2) COLLATE utf8_bin NOT NULL DEFAULT '00',
  PRIMARY KEY (`ip_lo`,`ip_hi`),
  KEY `c2c` (`c2c`),
  KEY `date` (`date`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_nsnst_protected_ranges` (`ip_lo`, `ip_hi`, `date`, `notes`, `c2c`) VALUES
(2130706433, 2130706433, 1187087957, 'Admin''s personal ip', '00');



CREATE TABLE IF NOT EXISTS `nuke_nsnst_referers` (
  `rid` int(2) NOT NULL AUTO_INCREMENT,
  `referer` varchar(255) COLLATE utf8_persian_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`referer`),
  KEY `rid` (`rid`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_persian_ci AUTO_INCREMENT=366 ;


INSERT INTO `nuke_nsnst_referers` (`rid`, `referer`) VALUES
(1, '121hr.com'),
(2, '1st-call.net'),
(3, '1stcool.com'),
(4, '5000n.com'),
(5, '69-xxx.com'),
(6, '9irl.com'),
(7, '9uy.com'),
(8, 'a-day-at-the-party.com'),
(9, 'accessthepeace.com'),
(10, 'adult-model-nude-pictures.com'),
(11, 'adult-sex-toys-free-porn.com'),
(12, 'agnitum.com'),
(13, 'alfonssackpfeiffe.com'),
(14, 'alongwayfrommars.com'),
(15, 'anime-sex-1.com'),
(16, 'anorex-sf-stimulant-free.com'),
(17, 'antibot.net'),
(18, 'antique-tokiwa.com'),
(19, 'apotheke-heute.com'),
(20, 'armada31.com'),
(21, 'artark.com'),
(22, 'artlilei.com'),
(23, 'ascendbtg.com'),
(24, 'aschalaecheck.com'),
(25, 'asian-sex-free-sex.com'),
(26, 'aslowspeeker.com'),
(27, 'assasinatedfrogs.com'),
(28, 'athirst-for-tranquillity.net'),
(29, 'aubonpanier.com'),
(30, 'avalonumc.com'),
(31, 'ayingba.com'),
(32, 'bayofnoreturn.com'),
(33, 'bbw4phonesex.com'),
(34, 'beersarenotfree.com'),
(35, 'bierikiuetsch.com'),
(36, 'bilingualannouncements.com'),
(37, 'black-pussy-toon-clip-anal-lover-single.com'),
(38, 'blownapart.com'),
(39, 'blueroutes.com'),
(40, 'boasex.com'),
(41, 'booksandpages.com'),
(42, 'bootyquake.com'),
(43, 'bossyhunter.com'),
(44, 'boyz-sex.com'),
(45, 'brokersaandpokers.com'),
(46, 'browserwindowcleaner.com'),
(47, 'budobytes.com'),
(48, 'business2fun.com'),
(49, 'buymyshitz.com'),
(50, 'byuntaesex.com'),
(51, 'caniputsomeloveintoyou.com'),
(52, 'cartoons.net.ru'),
(53, 'caverunsailing.com'),
(54, 'certainhealth.com'),
(55, 'clantea.com'),
(56, 'close-protection-services.com'),
(57, 'clubcanino.com'),
(58, 'clubstic.com'),
(59, 'cobrakai-skf.com'),
(60, 'collegefucktour.co.uk'),
(61, 'commanderspank.com'),
(62, 'coolenabled.com'),
(63, 'crusecountryart.com'),
(64, 'crusingforsex.co.uk'),
(65, 'cunt-twat-pussy-juice-clit-licking.com'),
(66, 'customerhandshaker.com'),
(67, 'cyborgrama.com'),
(68, 'darkprofits.co.uk'),
(69, 'datingforme.co.uk'),
(70, 'datingmind.com'),
(71, 'degree.org.ru'),
(72, 'delorentos.com'),
(73, 'diggydigger.com'),
(74, 'dinkydonkyaussie.com'),
(75, 'djpritchard.com'),
(76, 'djtop.com'),
(77, 'draufgeschissen.com'),
(78, 'dreamerteens.co.uk'),
(79, 'ebonyarchives.co.uk'),
(80, 'ebonyplaya.co.uk'),
(81, 'ecobuilder2000.com'),
(82, 'emailandemail.com'),
(83, 'emedici.net'),
(84, 'engine-on-fire.com'),
(85, 'erocity.co.uk'),
(86, 'esport3.com'),
(87, 'eteenbabes.com'),
(88, 'eurofreepages.com'),
(89, 'eurotexans.com'),
(90, 'evolucionweb.com'),
(91, 'fakoli.com'),
(92, 'fe4ba.com'),
(93, 'ferienschweden.com'),
(94, 'findly.com'),
(95, 'firsttimeteadrinker.com'),
(96, 'fishing.net.ru'),
(97, 'flatwonkers.com'),
(98, 'flowershopentertainment.com'),
(99, 'flymario.com'),
(100, 'free-xxx-pictures-porno-gallery.com'),
(101, 'freebestporn.com'),
(102, 'freefuckingmovies.co.uk'),
(103, 'freexxxstuff.co.uk'),
(104, 'fruitologist.net'),
(105, 'fruitsandbolts.com'),
(106, 'fuck-cumshots-free-midget-movie-clips.com'),
(107, 'fuck-michaelmoore.com'),
(108, 'fundacep.com'),
(109, 'gadless.com'),
(110, 'gallapagosrangers.com'),
(111, 'galleries4free.co.uk'),
(112, 'galofu.com'),
(113, 'gaypixpost.co.uk'),
(114, 'geomasti.com'),
(115, 'girltime.co.uk'),
(116, 'glassrope.com'),
(117, 'godjustblessyouall.com'),
(118, 'goldenageresort.com'),
(119, 'gonnabedaddies.com'),
(120, 'granadasexi.com'),
(121, 'guardingtheangels.com'),
(122, 'guyprofiles.co.uk'),
(123, 'happy1225.com'),
(124, 'happychappywacky.com'),
(125, 'health.org.ru'),
(126, 'hexplas.com'),
(127, 'highheelsmodels4fun.com'),
(128, 'hillsweb.com'),
(129, 'hiptuner.com'),
(130, 'historyintospace.com'),
(131, 'hoa-tuoi.com'),
(132, 'homebuyinginatlanta.com'),
(133, 'horizonultra.com'),
(134, 'horseminiature.net'),
(135, 'hotkiss.co.uk'),
(136, 'hotlivegirls.co.uk'),
(137, 'hotmatchup.co.uk'),
(138, 'husler.co.uk'),
(139, 'iaentertainment.com'),
(140, 'iamnotsomeone.com'),
(141, 'iconsofcorruption.com'),
(142, 'ihavenotrustinyou.com'),
(143, 'informat-systems.com'),
(144, 'interiorproshop.com'),
(145, 'intersoftnetworks.com'),
(146, 'inthecrib.com'),
(147, 'investment4cashiers.com'),
(148, 'iti-trailers.com'),
(149, 'jackpot-hacker.com'),
(150, 'jacks-world.com'),
(151, 'jamesthesailorbasher.com'),
(152, 'jesuislemonds.com'),
(153, 'justanotherdomainname.com'),
(154, 'kampelicka.com'),
(155, 'kanalrattenarsch.com'),
(156, 'katzasher.com'),
(157, 'kerosinjunkie.com'),
(158, 'killasvideo.com'),
(159, 'koenigspisser.com'),
(160, 'kontorpara.com'),
(161, 'l8t.com'),
(162, 'laestacion101.com'),
(163, 'lambuschlamppen.com'),
(164, 'lankasex.co.uk'),
(165, 'laser-creations.com'),
(166, 'le-tour-du-monde.com'),
(167, 'lecraft.com'),
(168, 'ledo-design.com'),
(169, 'leftregistration.com'),
(170, 'lekkikoomastas.com'),
(171, 'lepommeau.com'),
(172, 'libr-animal.com'),
(173, 'libraries.org.ru'),
(174, 'likewaterlikewind.com'),
(175, 'limbojumpers.com'),
(176, 'link.ru'),
(177, 'lockportlinks.com'),
(178, 'loiproject.com'),
(179, 'longtermalternatives.com'),
(180, 'lottoeco.com'),
(181, 'lucalozzi.com'),
(182, 'maki-e-pens.com'),
(183, 'malepayperview.co.uk'),
(184, 'mangaxoxo.com'),
(185, 'maps.org.ru'),
(186, 'marcofields.com'),
(187, 'masterofcheese.com'),
(188, 'masteroftheblasterhill.com'),
(189, 'mastheadwankers.com'),
(190, 'megafrontier.com'),
(191, 'meinschuppen.com'),
(192, 'mercurybar.com'),
(193, 'metapannas.com'),
(194, 'micelebre.com'),
(195, 'midnightlaundries.com'),
(196, 'mikeapartment.co.uk'),
(197, 'millenniumchorus.com'),
(198, 'mimundial2002.com'),
(199, 'miniaturegallerymm.com'),
(200, 'mixtaperadio.com'),
(201, 'mondialcoral.com'),
(202, 'monja-wakamatsu.com'),
(203, 'monstermonkey.net'),
(204, 'mouthfreshners.com'),
(205, 'mullensholiday.com'),
(206, 'musilo.com'),
(207, 'myhollowlog.com'),
(208, 'myhomephonenumber.com'),
(209, 'mykeyboardisbroken.com'),
(210, 'mysofia.net'),
(211, 'naked-cheaters.com'),
(212, 'naked-old-women.com'),
(213, 'nastygirls.co.uk'),
(214, 'nationclan.net'),
(215, 'natterratter.com'),
(216, 'naughtyadam.com'),
(217, 'nestbeschmutzer.com'),
(218, 'netwu.com'),
(219, 'newrealeaseonline.com'),
(220, 'newrealeasesonline.com'),
(221, 'nextfrontiersonline.com'),
(222, 'nikostaxi.com'),
(223, 'notorious7.com'),
(224, 'nrecruiter.com'),
(225, 'nursingdepot.com'),
(226, 'nustramosse.com'),
(227, 'nuturalhicks.com'),
(228, 'occaz-auto49.com'),
(229, 'ocean-db.net'),
(230, 'oilburnerservice.net'),
(231, 'omburo.com'),
(232, 'oneoz.com'),
(233, 'onepageahead.net'),
(234, 'onlinewithaline.com'),
(235, 'organizate.net'),
(236, 'ourownweddingsong.com'),
(237, 'owen-music.com'),
(238, 'p-partners.com'),
(239, 'paginadeautor.com'),
(240, 'pakistandutyfree.com'),
(241, 'pamanderson.co.uk'),
(242, 'parentsense.net'),
(243, 'particlewave.net'),
(244, 'pay-clic.com'),
(245, 'pay4link.net'),
(246, 'pcisp.com'),
(247, 'persist-pharma.com'),
(248, 'peteband.com'),
(249, 'petplusindia.com'),
(250, 'pickabbw.co.uk'),
(251, 'picture-oral-position-lesbian.com'),
(252, 'pl8again.com'),
(253, 'planeting.net'),
(254, 'popusky.com'),
(255, 'porn-expert.com'),
(256, 'promoblitza.com'),
(257, 'proproducts-usa.com'),
(258, 'ptcgzone.com'),
(259, 'ptporn.com'),
(260, 'publishmybong.com'),
(261, 'puttingtogether.com'),
(262, 'qualifiedcancelations.com'),
(263, 'rahost.com'),
(264, 'rainbow21.com'),
(265, 'rakkashakka.com'),
(266, 'randomfeeding.com'),
(267, 'rape-art.com'),
(268, 'rd-brains.com'),
(269, 'realestateonthehill.net'),
(270, 'rebuscadobot'),
(271, 'requested-stuff.com'),
(272, 'retrotrasher.com'),
(273, 'ricopositive.com'),
(274, 'risorseinrete.com'),
(275, 'rotatingcunts.com'),
(276, 'runawayclicks.com'),
(277, 'rutalibre.com'),
(278, 's-marche.com'),
(279, 'sabrosojazz.com'),
(280, 'samuraidojo.com'),
(281, 'sanaldarbe.com'),
(282, 'sasseminars.com'),
(283, 'schlampenbruzzler.com'),
(284, 'searchmybong.com'),
(285, 'seckur.com'),
(286, 'sex-asian-porn-interracial-photo.com'),
(287, 'sex-porn-fuck-hardcore-movie.com'),
(288, 'sexa3.net'),
(289, 'sexer.com'),
(290, 'sexintention.com'),
(291, 'sexnet24.tv'),
(292, 'sexomundo.com'),
(293, 'sharks.com.ru'),
(294, 'shells.com.ru'),
(295, 'shop-ecosafe.com'),
(296, 'shop-toon-hardcore-fuck-cum-pics.com'),
(297, 'silverfussions.com'),
(298, 'sin-city-sex.net'),
(299, 'sluisvan.com'),
(300, 'smutshots.com'),
(301, 'snagglersmaggler.com'),
(302, 'somethingtoforgetit.com'),
(303, 'sophiesplace.net'),
(304, 'soursushi.com'),
(305, 'southernxstables.com'),
(306, 'speed467.com'),
(307, 'speedpal4you.com'),
(308, 'sporty.org.ru'),
(309, 'stopdriving.net'),
(310, 'stw.org.ru'),
(311, 'sufficientlife.com'),
(312, 'sussexboats.net'),
(313, 'swinger-party-free-dating-porn-sluts.com'),
(314, 'sydneyhay.com'),
(315, 'szmjht.com'),
(316, 'teninchtrout.com'),
(317, 'thebalancedfruits.com'),
(318, 'theendofthesummit.com'),
(319, 'thiswillbeit.com'),
(320, 'thosethosethose.com'),
(321, 'ticyclesofindia.com'),
(322, 'tits-gay-fagot-black-tits-bigtits-amateur.com'),
(323, 'tonius.com'),
(324, 'toohsoft.com'),
(325, 'toolvalley.com'),
(326, 'tooporno.net'),
(327, 'toosexual.com'),
(328, 'torngat.com'),
(329, 'tour.org.ru'),
(330, 'towneluxury.com'),
(331, 'trafficmogger.com'),
(332, 'triacoach.net'),
(333, 'trottinbob.com'),
(334, 'tttframes.com'),
(335, 'tvjukebox.net'),
(336, 'undercvr.com'),
(337, 'unfinished-desires.com'),
(338, 'unicornonero.com'),
(339, 'unionvillefire.com'),
(340, 'upsandowns.com'),
(341, 'upthehillanddown.com'),
(342, 'vallartavideo.com'),
(343, 'vietnamdatingservices.com'),
(344, 'vinegarlemonshots.com'),
(345, 'vizy.net.ru'),
(346, 'vnladiesdatingservices.com'),
(347, 'vomitandbusted.com'),
(348, 'walkingthewalking.com'),
(349, 'well-I-am-the-type-of-boy.com'),
(350, 'whales.com.ru'),
(351, 'whincer.net'),
(352, 'whitpagesrippers.com'),
(353, 'whois.sc'),
(354, 'wipperrippers.com'),
(355, 'wordfilebooklets.com'),
(356, 'world-sexs.com'),
(357, 'xsay.com'),
(358, 'xxxchyangel.com'),
(359, 'xxxx:'),
(360, 'xxxzips.com'),
(361, 'youarelostintransit.com'),
(362, 'yuppieslovestocks.com'),
(363, 'yuzhouhuagong.com'),
(364, 'zhaori-food.com'),
(365, 'zwiebelbacke.com');



CREATE TABLE IF NOT EXISTS `nuke_nsnst_strings` (
  `sid` int(2) NOT NULL AUTO_INCREMENT,
  `string` varchar(255) COLLATE utf8_persian_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`string`),
  KEY `sid` (`sid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_persian_ci AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_nsnst_tracked_ips` (
  `tid` int(10) NOT NULL AUTO_INCREMENT,
  `ip_addr` varchar(15) COLLATE utf8_bin NOT NULL,
  `ip_long` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id` int(11) NOT NULL DEFAULT '1',
  `username` varchar(60) COLLATE utf8_bin NOT NULL,
  `user_agent` text COLLATE utf8_bin NOT NULL,
  `refered_from` text COLLATE utf8_bin NOT NULL,
  `date` int(20) NOT NULL DEFAULT '0',
  `page` text COLLATE utf8_bin NOT NULL,
  `x_forward_for` varchar(32) COLLATE utf8_bin NOT NULL,
  `client_ip` varchar(32) COLLATE utf8_bin NOT NULL,
  `remote_addr` varchar(32) COLLATE utf8_bin NOT NULL,
  `remote_port` varchar(11) COLLATE utf8_bin NOT NULL,
  `request_method` varchar(10) COLLATE utf8_bin NOT NULL,
  `c2c` char(2) COLLATE utf8_bin NOT NULL DEFAULT '00',
  PRIMARY KEY (`tid`),
  KEY `ip_addr` (`ip_addr`),
  KEY `ip_long` (`ip_long`),
  KEY `user_id` (`user_id`),
  KEY `username` (`username`),
  KEY `date` (`date`),
  KEY `c2c` (`c2c`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_pollcomments` (
  `tid` int(11) NOT NULL AUTO_INCREMENT,
  `pid` int(11) NOT NULL DEFAULT '0',
  `pollID` int(11) NOT NULL DEFAULT '0',
  `date` datetime DEFAULT NULL,
  `name` varchar(60) COLLATE utf8_bin NOT NULL,
  `email` varchar(60) COLLATE utf8_bin DEFAULT NULL,
  `url` varchar(60) COLLATE utf8_bin DEFAULT NULL,
  `host_name` varchar(60) COLLATE utf8_bin DEFAULT NULL,
  `subject` varchar(60) COLLATE utf8_bin NOT NULL,
  `comment` text COLLATE utf8_bin NOT NULL,
  `score` tinyint(4) NOT NULL DEFAULT '0',
  `reason` tinyint(4) NOT NULL DEFAULT '0',
  `last_moderation_ip` varchar(15) COLLATE utf8_bin DEFAULT '0',
  PRIMARY KEY (`tid`),
  KEY `tid` (`tid`),
  KEY `pid` (`pid`),
  KEY `pollID` (`pollID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_pollcomments_moderated` (
  `tid` int(11) NOT NULL AUTO_INCREMENT,
  `pid` int(11) NOT NULL DEFAULT '0',
  `pollID` int(11) NOT NULL DEFAULT '0',
  `date` datetime DEFAULT NULL,
  `name` varchar(60) COLLATE utf8_bin NOT NULL,
  `email` varchar(60) COLLATE utf8_bin DEFAULT NULL,
  `url` varchar(60) COLLATE utf8_bin DEFAULT NULL,
  `host_name` varchar(60) COLLATE utf8_bin DEFAULT NULL,
  `subject` varchar(60) COLLATE utf8_bin NOT NULL,
  `comment` text COLLATE utf8_bin NOT NULL,
  `score` tinyint(4) NOT NULL DEFAULT '0',
  `reason` tinyint(4) NOT NULL DEFAULT '0',
  `last_moderation_ip` varchar(15) COLLATE utf8_bin DEFAULT '0',
  PRIMARY KEY (`tid`),
  KEY `tid` (`tid`),
  KEY `pid` (`pid`),
  KEY `pollID` (`pollID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_poll_check` (
  `ip` varchar(20) COLLATE utf8_bin NOT NULL,
  `time` varchar(14) COLLATE utf8_bin NOT NULL,
  `pollID` int(10) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;





CREATE TABLE IF NOT EXISTS `nuke_poll_data` (
  `pollID` int(11) NOT NULL DEFAULT '0',
  `optionText` char(50) COLLATE utf8_bin NOT NULL,
  `optionCount` int(11) NOT NULL DEFAULT '0',
  `voteID` int(11) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_poll_data` (`pollID`, `optionText`, `optionCount`, `voteID`) VALUES
(1, 'معمولی', 0, 1),
(1, 'متوسط', 0, 2),
(1, 'خوب', 0, 3),
(1, 'عالی', 0, 4),
(1, '', 0, 5),
(1, '', 0, 6),
(1, '', 0, 7),
(1, '', 0, 8),
(1, '', 0, 9),
(1, '', 0, 10),
(1, '', 0, 11),
(1, '', 0, 12);



CREATE TABLE IF NOT EXISTS `nuke_poll_desc` (
  `pollID` int(11) NOT NULL AUTO_INCREMENT,
  `pollTitle` varchar(100) COLLATE utf8_bin NOT NULL,
  `timeStamp` int(11) NOT NULL DEFAULT '0',
  `voters` mediumint(9) NOT NULL DEFAULT '0',
  `planguage` varchar(30) COLLATE utf8_bin NOT NULL,
  `artid` int(10) NOT NULL DEFAULT '0',
  `comments` int(11) DEFAULT '0',
  `active` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`pollID`),
  KEY `pollID` (`pollID`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=2 ;


INSERT INTO `nuke_poll_desc` (`pollID`, `pollTitle`, `timeStamp`, `voters`, `planguage`, `artid`, `comments`, `active`) VALUES
(1, 'پرتال نیوک لرن را چگونه ارزیابی می کنید ؟', 961405160, 0, 'persian', 0, 0, 1);



CREATE TABLE IF NOT EXISTS `nuke_public_messages` (
  `mid` int(10) NOT NULL AUTO_INCREMENT,
  `content` varchar(255) COLLATE utf8_bin NOT NULL,
  `date` varchar(14) COLLATE utf8_bin DEFAULT NULL,
  `who` varchar(25) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`mid`),
  KEY `mid` (`mid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_quotes` (
  `qid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `quote` text COLLATE utf8_bin,
  PRIMARY KEY (`qid`),
  KEY `qid` (`qid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_ratings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `rating_id` int(11) NOT NULL DEFAULT '0',
  `rating_num` int(11) NOT NULL DEFAULT '0',
  `section` int(1) NOT NULL DEFAULT '0',
  `ip` varchar(25) COLLATE utf8_bin NOT NULL,
  `voter` varchar(256) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_related` (
  `rid` int(11) NOT NULL AUTO_INCREMENT,
  `tid` int(11) NOT NULL DEFAULT '0',
  `name` varchar(30) COLLATE utf8_bin NOT NULL,
  `url` varchar(200) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`rid`),
  KEY `rid` (`rid`),
  KEY `tid` (`tid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_session` (
  `session_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `session_user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `session_last_visit` int(11) unsigned NOT NULL DEFAULT '0',
  `session_start` int(11) unsigned NOT NULL DEFAULT '0',
  `session_time` int(11) unsigned NOT NULL DEFAULT '0',
  `session_ip` varchar(40) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `session_browser` varchar(150) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `session_page` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `session_admin` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`session_id`),
  KEY `session_time` (`session_time`),
  KEY `session_user_id` (`session_user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;





CREATE TABLE IF NOT EXISTS `nuke_shoutbox_censor` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `text` varchar(30) COLLATE utf8_bin NOT NULL,
  `replacement` varchar(30) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_shoutbox_conf` (
  `id` int(9) NOT NULL,
  `color1` varchar(20) COLLATE utf8_bin NOT NULL,
  `color2` varchar(20) COLLATE utf8_bin NOT NULL,
  `date` varchar(5) COLLATE utf8_bin NOT NULL,
  `time` varchar(5) COLLATE utf8_bin NOT NULL,
  `number` varchar(5) COLLATE utf8_bin NOT NULL,
  `ipblock` varchar(5) COLLATE utf8_bin NOT NULL,
  `nameblock` varchar(5) COLLATE utf8_bin NOT NULL,
  `censor` varchar(5) COLLATE utf8_bin NOT NULL,
  `tablewidth` varchar(3) COLLATE utf8_bin NOT NULL,
  `urlonoff` varchar(5) COLLATE utf8_bin NOT NULL,
  `delyourlastpost` varchar(5) COLLATE utf8_bin NOT NULL,
  `anonymouspost` varchar(5) COLLATE utf8_bin NOT NULL,
  `height` varchar(5) COLLATE utf8_bin NOT NULL,
  `themecolors` varchar(5) COLLATE utf8_bin NOT NULL,
  `textWidth` varchar(4) COLLATE utf8_bin NOT NULL,
  `nameWidth` varchar(4) COLLATE utf8_bin NOT NULL,
  `smiliesPerRow` varchar(4) COLLATE utf8_bin NOT NULL,
  `reversePosts` varchar(4) COLLATE utf8_bin NOT NULL,
  `timeOffset` varchar(10) COLLATE utf8_bin NOT NULL,
  `urlanononoff` varchar(10) COLLATE utf8_bin NOT NULL,
  `pointspershout` varchar(5) COLLATE utf8_bin NOT NULL,
  `shoutsperpage` varchar(5) COLLATE utf8_bin NOT NULL,
  `serverTimezone` varchar(5) COLLATE utf8_bin NOT NULL,
  `blockxxx` varchar(5) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_shoutbox_conf` (`id`, `color1`, `color2`, `date`, `time`, `number`, `ipblock`, `nameblock`, `censor`, `tablewidth`, `urlonoff`, `delyourlastpost`, `anonymouspost`, `height`, `themecolors`, `textWidth`, `nameWidth`, `smiliesPerRow`, `reversePosts`, `timeOffset`, `urlanononoff`, `pointspershout`, `shoutsperpage`, `serverTimezone`, `blockxxx`) VALUES
(1, '#EBEBEB', '#FFFFFF', 'yes', 'yes', '10', 'yes', 'yes', 'yes', '150', 'yes', 'yes', 'yes', '150', 'no', '20', '10', '7', 'no', '0', 'no', '0', '25', '-6', 'yes');



CREATE TABLE IF NOT EXISTS `nuke_shoutbox_date` (
  `id` int(5) NOT NULL,
  `date` varchar(10) COLLATE utf8_bin NOT NULL,
  `time` varchar(10) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_shoutbox_date` (`id`, `date`, `time`) VALUES
(1, 'd-m-Y', 'g:i:a');



CREATE TABLE IF NOT EXISTS `nuke_shoutbox_emoticons` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `text` varchar(20) COLLATE utf8_bin NOT NULL,
  `image` varchar(70) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=45 ;


INSERT INTO `nuke_shoutbox_emoticons` (`id`, `text`, `image`) VALUES
(1, ':confused:', '<img src=images/blocks/shout_box/confused.gif>'),
(2, ':sigh:', '<img src=images/blocks/shout_box/sigh.gif>'),
(3, ':sleep:', '<img src=images/blocks/shout_box/sleep.gif>'),
(4, ':upset:', '<img src=images/blocks/shout_box/upset.gif>'),
(5, ':none:', '<img src=images/blocks/shout_box/none.gif>'),
(6, ':eek:', '<img src=images/blocks/shout_box/bigeek.gif>'),
(7, ':rolleyes:', '<img src=images/blocks/shout_box/rolleyes.gif>'),
(8, ':mad:', '<img src=images/blocks/shout_box/mad.gif>'),
(9, ':yes:', '<img src=images/blocks/shout_box/yes.gif>'),
(10, ':no:', '<img src=images/blocks/shout_box/no.gif>'),
(11, ':shy:', '<img src=images/blocks/shout_box/shy.gif>'),
(12, ':laugh:', '<img src=images/blocks/shout_box/laugh.gif>'),
(13, ':dead:', '<img src=images/blocks/shout_box/dead.gif>'),
(14, ':cry:', '<img src=images/blocks/shout_box/cry.gif>'),
(15, ':)', '<img src=images/blocks/shout_box/smile.gif>'),
(16, ':(', '<img src=images/blocks/shout_box/sad.gif>'),
(17, ';)', '<img src=images/blocks/shout_box/smilewinkgrin.gif>'),
(18, ':|', '<img src=images/blocks/shout_box/none.gif>'),
(19, ':-)', '<img src=images/blocks/shout_box/smile.gif>'),
(20, ':-(', '<img src=images/blocks/shout_box/sad.gif>'),
(21, ';-)', '<img src=images/blocks/shout_box/smilewinkgrin.gif>'),
(22, ':-|', '<img src=images/blocks/shout_box/none.gif>'),
(23, ':0', '<img src=images/blocks/shout_box/bigeek.gif>'),
(24, 'B)', '<img src=images/blocks/shout_box/cool.gif>'),
(25, ':D', '<img src=images/blocks/shout_box/biggrin.gif>'),
(26, ':P', '<img src=images/blocks/shout_box/bigrazz.gif>'),
(27, ':B', '<img src=images/blocks/shout_box/bigrazz.gif>'),
(28, 'B-)', '<img src=images/blocks/shout_box/cool.gif>'),
(29, ':-D', '<img src=images/blocks/shout_box/biggrin.gif>'),
(30, ':-P', '<img src=images/blocks/shout_box/bigrazz.gif>'),
(31, ':O', '<img src=images/blocks/shout_box/bigeek.gif>'),
(32, 'b)', '<img src=images/blocks/shout_box/cool.gif>'),
(33, ':d', '<img src=images/blocks/shout_box/biggrin.gif>'),
(34, ':p', '<img src=images/blocks/shout_box/bigrazz.gif>'),
(35, ':b', '<img src=images/blocks/shout_box/bigrazz.gif>'),
(36, 'b-)', '<img src=images/blocks/shout_box/cool.gif>'),
(37, ':-d', '<img src=images/blocks/shout_box/biggrin.gif>'),
(38, ':-p', '<img src=images/blocks/shout_box/bigrazz.gif>'),
(39, ':-b', '<img src=images/blocks/shout_box/bigrazz.gif>'),
(40, ':o', '<img src=images/blocks/shout_box/bigeek.gif>'),
(41, 'o_O', '<img src=images/blocks/shout_box/bigeek.gif>'),
(42, 'O_o', '<img src=images/blocks/shout_box/bigeek.gif>'),
(43, 'o_o', '<img src=images/blocks/shout_box/bigeek.gif>'),
(44, 'O_O', '<img src=images/blocks/shout_box/bigeek.gif>');



CREATE TABLE IF NOT EXISTS `nuke_shoutbox_ipblock` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_shoutbox_manage_count` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `admin` varchar(25) COLLATE utf8_bin NOT NULL,
  `aCount` varchar(5) COLLATE utf8_bin NOT NULL DEFAULT '10',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=4 ;


INSERT INTO `nuke_shoutbox_manage_count` (`id`, `admin`, `aCount`) VALUES
(1, 'admin', '10'),
(2, 'nariman', '10'),
(3, 'Delta', '10');



CREATE TABLE IF NOT EXISTS `nuke_shoutbox_nameblock` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_shoutbox_shouts` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) COLLATE utf8_bin NOT NULL,
  `comment` text COLLATE utf8_bin NOT NULL,
  `date` varchar(10) COLLATE utf8_bin NOT NULL,
  `time` varchar(10) COLLATE utf8_bin NOT NULL,
  `ip` varchar(39) COLLATE utf8_bin DEFAULT NULL,
  `timestamp` varchar(20) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=2 ;


INSERT INTO `nuke_shoutbox_shouts` (`id`, `name`, `comment`, `date`, `time`, `ip`, `timestamp`) VALUES
(1, 'Nukelearn', 'گروه نیوک لرن افتتاح سایت شما را تبریک می گوید', '20-3-09', '24:00', 'noip', '1204475977');



CREATE TABLE IF NOT EXISTS `nuke_shoutbox_sticky` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) COLLATE utf8_bin NOT NULL,
  `comment` text COLLATE utf8_bin NOT NULL,
  `timestamp` varchar(20) COLLATE utf8_bin NOT NULL,
  `stickySlot` varchar(5) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_shoutbox_themes` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `themeName` varchar(50) COLLATE utf8_bin DEFAULT NULL,
  `blockColor1` varchar(20) COLLATE utf8_bin DEFAULT NULL,
  `blockColor2` varchar(20) COLLATE utf8_bin DEFAULT NULL,
  `border` varchar(20) COLLATE utf8_bin DEFAULT NULL,
  `menuColor1` varchar(20) COLLATE utf8_bin DEFAULT NULL,
  `menuColor2` varchar(20) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=6 ;


INSERT INTO `nuke_shoutbox_themes` (`id`, `themeName`, `blockColor1`, `blockColor2`, `border`, `menuColor1`, `menuColor2`) VALUES
(4, 'USV-Gold', '#EBEBEB', '#FFFFFF', '#BBBBBB', '#EBEBEB', '#FFFFFF'),
(5, 'USV-classio', '#EBEBEB', '#FFFFFF', '#BBBBBB', '#EBEBEB', '#FFFFFF');



CREATE TABLE IF NOT EXISTS `nuke_shoutbox_theme_images` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `themeName` varchar(50) COLLATE utf8_bin DEFAULT NULL,
  `blockArrowColor` varchar(50) COLLATE utf8_bin NOT NULL,
  `blockBackgroundImage` varchar(50) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=3 ;


INSERT INTO `nuke_shoutbox_theme_images` (`id`, `themeName`, `blockArrowColor`, `blockBackgroundImage`) VALUES
(1, 'USV-Gold', 'Black.gif', ''),
(2, 'USV-classio', 'Black.gif', '');



CREATE TABLE IF NOT EXISTS `nuke_shoutbox_version` (
  `id` int(5) NOT NULL,
  `version` varchar(10) COLLATE utf8_bin NOT NULL,
  `datechecked` varchar(2) COLLATE utf8_bin NOT NULL,
  `versionreported` varchar(10) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_shoutbox_version` (`id`, `version`, `datechecked`, `versionreported`) VALUES
(1, '8.5', '1', '8.5');



CREATE TABLE IF NOT EXISTS `nuke_sitemap_config` (
  `config_name` varchar(255) COLLATE utf8_bin NOT NULL,
  `config_value` text COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`config_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


INSERT INTO `nuke_sitemap_config` (`config_name`, `config_value`) VALUES
('match_theme', '0'),
('use_sommaire', '0'),
('use_gt', '1'),
('show_google_block', '0'),
('show_gentime', '1'),
('show_news', '1'),
('show_fna', '0'),
('show_forum_cat', '1'),
('show_forums', '1'),
('show_forum_topics', '1'),
('show_kb', '0'),
('show_downloads', '1'),
('show_weblinks', '1'),
('show_faq', '1'),
('show_content', '0'),
('show_reviews', '0'),
('show_tutorials', '0'),
('show_projects', '0'),
('show_supporters', '0'),
('show_shouts', '0'),
('show_coppermine', '0'),
('show_spchat', '0'),
('show_arcade', '0'),
('show_rss', '1'),
('limit_news', '50'),
('limit_fna', '50'),
('limit_forum_topics', '100'),
('limit_kb', '100'),
('limit_downloads', '100'),
('limit_weblinks', '50'),
('limit_content', '20'),
('limit_reviews', '20'),
('limit_tutorials', '20'),
('limit_projects', '20'),
('limit_supporters', '20'),
('limit_shouts', '50'),
('limit_coppermine_pics', '50'),
('limit_arcade', '100'),
('site_logo', 'logo.gif'),
('site_logo_path', 'images/'),
('site_google_logo_height', '50'),
('site_google_logo_width', '425'),
('site_google_header', '#ffffff'),
('site_google_bg', '#ffffff'),
('google_logo', 'google.gif'),
('google_logo_path', 'images/powered/'),
('sitemap_version', '2.0.0');



CREATE TABLE IF NOT EXISTS `nuke_squestions` (
  `qid` int(2) NOT NULL AUTO_INCREMENT,
  `question` varchar(256) COLLATE utf8_bin NOT NULL,
  `answer` varchar(256) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`qid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=2 ;


INSERT INTO `nuke_squestions` (`qid`, `question`, `answer`) VALUES
(1, '2+2 = ', '4');



CREATE TABLE IF NOT EXISTS `nuke_stories` (
  `sid` int(11) NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `aid` varchar(30) COLLATE utf8_bin NOT NULL,
  `title` varchar(80) COLLATE utf8_bin DEFAULT NULL,
  `time` datetime DEFAULT NULL,
  `hometext` text COLLATE utf8_bin,
  `bodytext` text COLLATE utf8_bin NOT NULL,
  `newsref` varchar(100) COLLATE utf8_bin DEFAULT NULL,
  `newsreflink` varchar(200) COLLATE utf8_bin DEFAULT NULL,
  `comments` int(11) NOT NULL DEFAULT '0',
  `counter` mediumint(8) NOT NULL DEFAULT '0',
  `topic` int(3) NOT NULL DEFAULT '1',
  `informant` varchar(25) COLLATE utf8_bin NOT NULL,
  `notes` text COLLATE utf8_bin NOT NULL,
  `ihome` int(1) NOT NULL DEFAULT '0',
  `alanguage` varchar(30) COLLATE utf8_bin NOT NULL,
  `acomm` int(1) NOT NULL DEFAULT '0',
  `hotnews` int(1) NOT NULL DEFAULT '0',
  `haspoll` int(1) NOT NULL DEFAULT '0',
  `pollID` int(10) NOT NULL DEFAULT '0',
  `associated` text COLLATE utf8_bin NOT NULL,
  `tags` varchar(255) COLLATE utf8_bin NOT NULL,
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  `section` varchar(15) COLLATE utf8_bin NOT NULL DEFAULT 'news',
  PRIMARY KEY (`sid`),
  KEY `sid` (`sid`),
  KEY `catid` (`catid`),
  KEY `counter` (`counter`),
  KEY `topic` (`topic`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=2 ;


INSERT INTO `nuke_stories` (`sid`, `catid`, `aid`, `title`, `time`, `hometext`, `bodytext`, `newsref`, `newsreflink`, `comments`, `counter`, `topic`, `informant`, `notes`, `ihome`, `alanguage`, `acomm`, `hotnews`, `haspoll`, `pollID`, `associated`, `tags`, `approved`, `section`) VALUES
(1, 0, 'admin', 'نسخه 1.1.0 USV پرتال نیوک لرن', '2010-04-16 05:12:39', '<p>\r\n	سیستم&nbsp; مدیریت محتوا نیوک لرن&nbsp; توسط گروه&nbsp;&nbsp;<a href="www.nukelearn.com">Nukelearn.com</a>&nbsp;توسعه داده شده است&nbsp;&nbsp; و درحقیقت نسخه تکمیل شده و پیشرفته ای از&nbsp; پرتال معروف<a href="http://www.irannuke.com/">&nbsp;ایران نیوک&nbsp;</a>&nbsp;می باشد. در این پروژه تمام تلاش ما بر آن بوده که&nbsp; بر روی سبک کردن&nbsp; و ایمن سازی بسته ی نرم افزاری پرتال کار کنیم&nbsp;&nbsp; .</p>\r\n<div style="text-align: center;">\r\n	<img alt="" src="images/powered/NukelearnUSV.png" /></div>\r\n<p>\r\n	<br />\r\n	پرتال نیوک لرن در نسخه 1.1.0 نیز تغییرات خوبی را در خود جای داده است :</p>\r\n<p>\r\n	- مد نمایش خطاهای صفحه</p>\r\n<p>\r\n	- اصلاح کلاس خوراک ساز (Rss Class )</p>\r\n<p>\r\n	- افزوده شدن سیستم رهگیری و بررسی بازدیدکنندگان ( امکان تعلیق کاربر - مسدود کردن IP- مشاهده مشخصات)</p>\r\n<p>\r\n	- افزوده شدن کلاس جدید Session برای امنیت بیشتر</p>\r\n<p>\r\n	- تغییر لینک های Seo&nbsp; بخش خبر برای بالا بردن ضریب نفوذ در موتورهای جستجو</p>\r\n<p>\r\n	- ویرایش و نسخه جدید مدیریت نظرسنجی ها</p>\r\n<p>\r\n	-ویرایش و نسخه حدید مدیریت تبلیغات</p>\r\n<p>\r\n	- اطلاح و سازگاری برای نسخه حدید PHP 5.3.2</p>\r\n<p>\r\n	- افزوده شدن تقویم جلالی ( با امکان افزودن رویداد )</p>\r\n<p>\r\n	و ده ها تغییر دیگر که در راستای حل مشکلات قبلی صورت گرفته است&nbsp;</p>\r\n<p>\r\n	<br />\r\n	امیدواریم شما هم این تغییرات را به صورت محسوس&nbsp; درک کنید .<br />\r\n	<br />\r\n	هدف ما کمک رسانی به شما هم میهن گرامی و ارجمند است و امیدواریم که این برنامه مورد قبول شما قرار گیرد. خواهشمندیم در صورت برخورد با هر اشکال امنیتی در این برنامه و یا اگر پیشنهادی در بهینه سازی آن دارید با ما در تماس باشید .<br />\r\n	<br />\r\n	شاد و پیروز باشید!<br />\r\n	<br />\r\n	گروه توسعه نیوک لرن</p>\r\n', '', 'نیوک لرن', 'http://www.nukelearn.com', 0, 4, 1, 'admin', '', 0, 'persian', 0, 1, 0, 0, '1-', ' ', 1, 'message'),




CREATE TABLE IF NOT EXISTS `nuke_stories_cat` (
  `catid` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(20) COLLATE utf8_bin NOT NULL,
  `counter` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`catid`),
  KEY `catid` (`catid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_tags` (
  `tid` int(5) NOT NULL AUTO_INCREMENT,
  `tag` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `slug` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `count` int(6) NOT NULL,
  PRIMARY KEY (`tid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;





CREATE TABLE IF NOT EXISTS `nuke_topics` (
  `topicid` int(3) NOT NULL AUTO_INCREMENT,
  `topicname` varchar(20) COLLATE utf8_bin DEFAULT NULL,
  `topicimage` varchar(100) COLLATE utf8_bin DEFAULT NULL,
  `topictext` varchar(40) COLLATE utf8_bin DEFAULT NULL,
  `counter` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`topicid`),
  KEY `topicid` (`topicid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=3 ;


INSERT INTO `nuke_topics` (`topicid`, `topicname`, `topicimage`, `topictext`, `counter`) VALUES
(1, 'نیوک لرن', 'AllTopics.gif', 'نیوک لرن', 0),
(2, 'سرگرمی', 'Groups.png', 'مطالب تفریحی و زیبا از سراسر وب', 0);



CREATE TABLE IF NOT EXISTS `nuke_users` (
  `user_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(60) COLLATE utf8_bin DEFAULT NULL,
  `username` varchar(25) COLLATE utf8_bin DEFAULT NULL,
  `user_email` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `femail` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `user_website` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `user_avatar` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `user_regdate` varchar(20) COLLATE utf8_bin DEFAULT NULL,
  `user_icq` varchar(15) COLLATE utf8_bin DEFAULT NULL,
  `user_occ` varchar(100) COLLATE utf8_bin DEFAULT NULL,
  `user_from` varchar(100) COLLATE utf8_bin DEFAULT NULL,
  `user_from_flag` varchar(25) COLLATE utf8_bin DEFAULT NULL,
  `user_interests` varchar(150) COLLATE utf8_bin DEFAULT NULL,
  `user_sig` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `user_viewemail` tinyint(2) DEFAULT NULL,
  `user_theme` int(3) DEFAULT NULL,
  `user_aim` varchar(18) COLLATE utf8_bin DEFAULT NULL,
  `user_yim` varchar(25) COLLATE utf8_bin DEFAULT NULL,
  `user_msnm` varchar(25) COLLATE utf8_bin DEFAULT NULL,
  `user_password` varchar(40) COLLATE utf8_bin DEFAULT NULL,
  `storynum` tinyint(4) NOT NULL DEFAULT '10',
  `umode` varchar(10) COLLATE utf8_bin DEFAULT NULL,
  `uorder` tinyint(1) NOT NULL DEFAULT '0',
  `thold` tinyint(1) NOT NULL DEFAULT '0',
  `noscore` tinyint(1) NOT NULL DEFAULT '0',
  `bio` tinytext COLLATE utf8_bin,
  `ublockon` tinyint(1) NOT NULL DEFAULT '0',
  `ublock` tinytext COLLATE utf8_bin,
  `theme` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `commentmax` int(11) NOT NULL DEFAULT '4096',
  `counter` int(11) NOT NULL DEFAULT '0',
  `newsletter` int(1) NOT NULL DEFAULT '0',
  `user_posts` int(10) NOT NULL DEFAULT '0',
  `user_attachsig` int(2) NOT NULL DEFAULT '0',
  `user_rank` int(10) NOT NULL DEFAULT '0',
  `user_level` int(10) NOT NULL DEFAULT '1',
  `broadcast` tinyint(1) NOT NULL DEFAULT '1',
  `popmeson` tinyint(1) NOT NULL DEFAULT '0',
  `user_active` tinyint(1) DEFAULT '1',
  `user_session_time` int(11) NOT NULL DEFAULT '0',
  `user_session_page` smallint(5) NOT NULL DEFAULT '0',
  `user_lastvisit` int(11) NOT NULL DEFAULT '0',
  `user_timezone` tinyint(4) NOT NULL DEFAULT '10',
  `user_style` tinyint(4) DEFAULT NULL,
  `user_lang` varchar(255) COLLATE utf8_bin NOT NULL DEFAULT 'persian',
  `user_dateformat` varchar(14) COLLATE utf8_bin NOT NULL DEFAULT 'D M d, Y g:i a',
  `user_new_privmsg` smallint(5) unsigned NOT NULL DEFAULT '0',
  `user_unread_privmsg` smallint(5) unsigned NOT NULL DEFAULT '0',
  `user_last_privmsg` int(11) NOT NULL DEFAULT '0',
  `user_emailtime` int(11) DEFAULT NULL,
  `user_allowhtml` tinyint(1) DEFAULT '1',
  `user_allowbbcode` tinyint(1) DEFAULT '1',
  `user_allowsmile` tinyint(1) DEFAULT '1',
  `user_allowavatar` tinyint(1) NOT NULL DEFAULT '1',
  `user_allow_pm` tinyint(1) NOT NULL DEFAULT '1',
  `user_allow_viewonline` tinyint(1) NOT NULL DEFAULT '1',
  `user_notify` tinyint(1) NOT NULL DEFAULT '0',
  `user_notify_pm` tinyint(1) NOT NULL DEFAULT '0',
  `user_notify_donation` tinyint(1) NOT NULL DEFAULT '0',
  `user_popup_pm` tinyint(1) NOT NULL DEFAULT '0',
  `user_avatar_type` tinyint(4) NOT NULL DEFAULT '3',
  `user_sig_bbcode_uid` varchar(10) COLLATE utf8_bin DEFAULT NULL,
  `user_actkey` varchar(32) COLLATE utf8_bin DEFAULT NULL,
  `user_newpasswd` varchar(32) COLLATE utf8_bin DEFAULT NULL,
  `points` int(10) DEFAULT '0',
  `last_ip` varchar(15) COLLATE utf8_bin NOT NULL DEFAULT '0',
  `agreedtos` tinyint(1) NOT NULL DEFAULT '0',
  `user_points` int(11) NOT NULL DEFAULT '0',
  `user_group_cp` int(11) NOT NULL DEFAULT '2',
  `user_group_list_cp` varchar(100) COLLATE utf8_bin NOT NULL DEFAULT '2',
  `user_active_cp` enum('YES','NO') COLLATE utf8_bin NOT NULL DEFAULT 'YES',
  `admin_allow_points` tinyint(1) NOT NULL DEFAULT '1',
  `karma` tinyint(1) DEFAULT '0',
  `user_level2` smallint(6) NOT NULL DEFAULT '2',
  `user_allowemails` tinyint(1) NOT NULL DEFAULT '1',
  `user_invisible` tinyint(1) NOT NULL DEFAULT '0',
  `user_lastaction` int(11) NOT NULL DEFAULT '0',
  `user_location` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `user_comments` smallint(6) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`user_id`),
  KEY `uid` (`user_id`),
  KEY `uname` (`username`),
  KEY `user_session_time` (`user_session_time`),
  KEY `karma` (`karma`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=2 ;


INSERT INTO `nuke_users` (`user_id`, `name`, `username`, `user_email`, `femail`, `user_website`, `user_avatar`, `user_regdate`, `user_icq`, `user_occ`, `user_from`, `user_from_flag`, `user_interests`, `user_sig`, `user_viewemail`, `user_theme`, `user_aim`, `user_yim`, `user_msnm`, `user_password`, `storynum`, `umode`, `uorder`, `thold`, `noscore`, `bio`, `ublockon`, `ublock`, `theme`, `commentmax`, `counter`, `newsletter`, `user_posts`, `user_attachsig`, `user_rank`, `user_level`, `broadcast`, `popmeson`, `user_active`, `user_session_time`, `user_session_page`, `user_lastvisit`, `user_timezone`, `user_style`, `user_lang`, `user_dateformat`, `user_new_privmsg`, `user_unread_privmsg`, `user_last_privmsg`, `user_emailtime`, `user_allowhtml`, `user_allowbbcode`, `user_allowsmile`, `user_allowavatar`, `user_allow_pm`, `user_allow_viewonline`, `user_notify`, `user_notify_pm`, `user_notify_donation`, `user_popup_pm`, `user_avatar_type`, `user_sig_bbcode_uid`, `user_actkey`, `user_newpasswd`, `points`, `last_ip`, `agreedtos`, `user_points`, `user_group_cp`, `user_group_list_cp`, `user_active_cp`, `admin_allow_points`, `karma`, `user_level2`, `user_allowemails`, `user_invisible`, `user_lastaction`, `user_location`, `user_comments`) VALUES
(1, '', 'Anonymous', '', '', '', 'blank.gif', 'Nov 10, 2000', '', '', '', NULL, '', '', 0, 0, '', '', '', '2a2e0edbc27feb9a93c00956949630df', 10, '', 0, 0, 0, '', 0, '', '', 4096, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 10, NULL, 'persian', 'D M d, Y g:i a', 0, 0, 0, NULL, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 3, NULL, NULL, NULL, 0, '0', 0, 0, 3, '3', 'YES', 1, 0, 2, 1, 0, 0, '0', 0);



CREATE TABLE IF NOT EXISTS `nuke_users_temp` (
  `user_id` int(10) NOT NULL AUTO_INCREMENT,
  `username` varchar(25) COLLATE utf8_bin NOT NULL,
  `realname` varchar(255) COLLATE utf8_bin NOT NULL,
  `user_email` varchar(255) COLLATE utf8_bin NOT NULL,
  `user_password` varchar(40) COLLATE utf8_bin NOT NULL,
  `user_regdate` varchar(20) COLLATE utf8_bin NOT NULL,
  `check_num` varchar(50) COLLATE utf8_bin NOT NULL,
  `time` varchar(14) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;



CREATE TABLE IF NOT EXISTS `nuke_users_temp` (
  `user_id` int(10) NOT NULL AUTO_INCREMENT,
  `username` varchar(25) COLLATE utf8_bin NOT NULL,
  `realname` varchar(255) COLLATE utf8_bin NOT NULL,
  `user_email` varchar(255) COLLATE utf8_bin NOT NULL,
  `user_password` varchar(40) COLLATE utf8_bin NOT NULL,
  `user_regdate` varchar(20) COLLATE utf8_bin NOT NULL,
  `check_num` varchar(50) COLLATE utf8_bin NOT NULL,
  `time` varchar(14) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;



COMMIT;
